@echo off
setlocal

NET SESSION >nul 2>&1
IF %ERRORLEVEL% EQU 0 (
    ECHO Administrator Privileges Detected! OK! 
) ELSE (
   echo ######## ########  ########   #######  ########  
   echo ##       ##     ## ##     ## ##     ## ##     ## 
   echo ##       ##     ## ##     ## ##     ## ##     ## 
   echo ######   ########  ########  ##     ## ########  
   echo ##       ##   ##   ##   ##   ##     ## ##   ##   
   echo ##       ##    ##  ##    ##  ##     ## ##    ##  
   echo ######## ##     ## ##     ##  #######  ##     ## 
   echo.
   echo.
   echo ####### ERROR: ADMINISTRATOR PRIVILEGES REQUIRED #########
   echo This script must be run as administrator to work properly!  
   echo If you're seeing this after clicking on a start menu icon, then right click on the shortcut and select "Run As Administrator".
   echo ##########################################################
   echo.
   PAUSE
   EXIT /B 1
)


for /f "tokens=1-7 delims=:/-, " %%i in ('echo exit^|cmd /q /k"prompt $d $t"') do (
   for /f "tokens=2-4 delims=/-,() skip=1" %%a in ('echo.^|date') do (
      set dow=%%i
      set %%a=%%j
      set %%b=%%k
      set %%c=%%l
      set hh=%%m
      set min=%%n
      set ss=%%o
   )
)

IF "%targetapp%"=="" (set targetapp=C:\Program Files\1To1Service\iService) 

cd /d %~dp0
echo %cd%

for /F "tokens=*" %%I in (deployiservice.cfg) do set %%I
set deploydate=%yy%.%mm%.%dd% %hh%.%min%.%ss%
set iservicesetup=%cd%\iservicesetupfiles
set previousdeploy=%archiveroot%\previousdeploy\
set currentsetup=%archiveroot%\currentsetup\


IF NOT EXIST %iservicesetup%\iServiceSetup.exe (
  echo iService installer file not found, exiting.
  pause
  cls
  exit
  )
 
color fc
echo !!WARNING!!
echo !!WARNING!! Be sure to backup existing iService 
echo !!WARNING!! databases before proceeding
echo !!WARNING!! 
:PROMPT
SET /P AREYOUSURE=Are you sure you want to continue(Y/[N])?
IF /I "%AREYOUSURE%" NEQ "Y" GOTO END
 
echo.>"%cd%\DeployLog %deploydate%.txt"

echo ========= Started Script %dow% %yy%-%mm%-%dd% %hh%:%min%:%ss% ==========|wtee -a "%cd%\deploylog %deploydate%.txt"
IF NOT EXIST %archiveroot% (
  mkdir "%archiveroot%" >> "%cd%\deploylog %deploydate%.txt"
  )


echo Uninstalling previous version of iService..|wtee -a "%cd%\deploylog %deploydate%.txt"
wmic product "iService" uninstall >> "%cd%\deploylog %deploydate%.txt"

echo Backing up miscellaneous leftover iService files..|wtee -a "%cd%\deploylog %deploydate%.txt"
mkdir "%archiveroot%\%deploydate%\Main" >> "%cd%\deploylog %deploydate%.txt"
robocopy "%targetapp%" "%archiveroot%\%deploydate%\Main\\" /E >> "%cd%\deploylog %deploydate%.txt"

echo Cleaning up previous iService mailpopper log files..|wtee -a "%cd%\deploylog %deploydate%.txt"
del /q "%targetapp%\*.log" >> "%cd%\deploylog %deploydate%.txt" 2>&1

echo Backing up previous website..|wtee -a "%cd%\deploylog %deploydate%.txt"
mkdir "%archiveroot%\%deploydate%\Website" >> "%cd%\deploylog %deploydate%.txt"
robocopy "%targetwebsite%\\" "%archiveroot%\%deploydate%\Website\\" /E >> "%cd%\deploylog %deploydate%.txt"

echo Cleaning up previous website..|wtee -a "%cd%\deploylog %deploydate%.txt"
rmdir /s /q "%targetwebsite%" >> "%cd%\deploylog %deploydate%.txt" 2>&1

echo Installing new iService version..|wtee -a "%cd%\deploylog %deploydate%.txt"
%iservicesetup%\iServiceSetup.exe /v"TARGETDIR=\"%targetapp%\" /qr /norestart /Lwe+ \"%cd%\\deploylog %deploydate%.txt\""

echo Restoring iService Mailpopper configuration..|wtee -a "%cd%\deploylog %deploydate%.txt"
copy "%archiveroot%\%deploydate%\Main\iService.MailPopper.config" "%targetapp%" >> "%cd%\deploylog %deploydate%.txt"

echo Copying new website..|wtee -a "%cd%\deploylog %deploydate%.txt"
robocopy "%iservicesetup%\Website\\" "%targetwebsite%\\" *.* /E >> "%cd%\deploylog %deploydate%.txt"
echo Restoring web.config..|wtee -a "%cd%\deploylog %deploydate%.txt"
copy "%archiveroot%\%deploydate%\Website\web.config" "%targetwebsite%\" >> "%cd%\deploylog %deploydate%.txt"

echo Setting access permissions for worker pool..|wtee -a "%cd%\deploylog %deploydate%.txt"
ICACLS "%targetwebsite%" /grant "IIS AppPool\%workerpoolname%":F /T >> "%cd%\deploylog %deploydate%.txt" 2>&1

echo Starting iService Management Console.. 
echo Click the Update tab to begin updating database to version %isversion%.  Close Management Console after done to continue deploy..
start /wait "%targetapp%\iServiceManagementConsole.exe" "%targetapp%\iServiceManagementConsole.exe" >> "%cd%\deploylog %deploydate%.txt"

echo Moving previous setup files to deploy archives..|wtee -a "%cd%\deploylog %deploydate%.txt"
IF EXIST %currentsetup% (
 robocopy %currentsetup% "%archiveroot%\%deploydate%\iserviceSetupFiles\\" /E >> "%cd%\deploylog %deploydate%.txt"
 rmdir /s /q "%currentsetup%" >> "%cd%\deploylog %deploydate%.txt"
 )

echo Backing up current setup files..|wtee -a "%cd%\deploylog %deploydate%.txt"
robocopy %iservicesetup% %currentsetup%  /E >> "%cd%\deploylog %deploydate%.txt"

 
echo Changing symlink to this previous version for rollback purposes..|wtee -a "%cd%\deploylog %deploydate%.txt"
IF EXIST %previousdeploy% (
  rmdir %previousdeploy% >> "%cd%\deploylog %deploydate%.txt"
  )
mklink /D %previousdeploy% "%archiveroot%\%deploydate%\\" >> "%cd%\deploylog %deploydate%.txt"

explorer "%targetapp%"

echo Done. Log file and old deployment archived to %archiveroot%\%deploydate%\|wtee -a "%cd%\deploylog %deploydate%.txt"

pause
:END
endlocal
