(function ()
{
  'use strict';

  var app = angular.module('iService.common', []);
  app.directive('contactSearchFields', function () {
    return {
      restrict: 'E',
      replace: true,
      scope: {
        searchFields: '='
        // searchFields = [ group ]
        // group = { fields: [ field ] }
        // field = { where: string, fieldID: string, searchString: string }
        // where = 'anywhere' | 'entire' | 'start' | 'end'
      },
      templateUrl: 'contact-search-fields.html',
      controller: 'ControllerContactSearchFields'
    };
  });
  app.controller('ControllerContactSearchFields', ['$scope', 'iService.api.serial', 'iService.contactsearchfields', ControllerContactSearchFields]);
  function ControllerContactSearchFields($scope, API, contactsearchfields) {
    $scope.contactsearchfields = contactsearchfields;
    $scope.NewFieldGroup = function (where, id, str) {
      return iservice.searchfields.NewFieldGroup($scope.searchFields, where, id, str);
    }
    $scope.DeleteField = function (whichGroup, whichField) {
      return iservice.searchfields.DeleteField($scope.searchFields, whichGroup, whichField);
    }
    $scope.MergeGroup = function (firstGroup) {
      return iservice.searchfields.MergeGroup($scope.searchFields, firstGroup);
    }
    $scope.SplitGroup = function (whichGroup, afterField) {
      return iservice.searchfields.SplitGroup($scope.searchFields, whichGroup, afterField);
    }
  }
})();