function htmlEscape(str)
{
  return String(str).replace(/&/g, '&amp;').replace(/"/g, '&quot;').replace(/'/g, '&#39;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/\//g, '&#x2F;');
}

if (!Array.prototype.remove) {
  //from https://stackoverflow.com/questions/3396088/how-do-i-remove-an-object-from-an-array-with-javascript
  Array.prototype.remove = function (v)
  {
    var index;

    if((index = this.indexOf(v)) !== -1)
    {
      this.splice(index, 1);

      return true;
    }

    return false;
  };
}
if (!Array.prototype.find) {
  //from https://tc39.github.io/ecma262/#sec-array.prototype.find
  Object.defineProperty(Array.prototype, 'find', {
    value: function (predicate) {
      // 1. Let O be ? ToObject(this value).
      if (this == null) {
        throw TypeError('"this" is null or not defined');
      }

      var o = Object(this);

      // 2. Let len be ? ToLength(? Get(O, "length")).
      var len = o.length >>> 0;

      // 3. If IsCallable(predicate) is false, throw a TypeError exception.
      if (typeof predicate !== 'function') {
        throw TypeError('predicate must be a function');
      }

      // 4. If thisArg was supplied, let T be thisArg; else let T be undefined.
      var thisArg = arguments[1];

      // 5. Let k be 0.
      var k = 0;

      // 6. Repeat, while k < len
      while (k < len) {
        // a. Let Pk be ! ToString(k).
        // b. Let kValue be ? Get(O, Pk).
        // c. Let testResult be ToBoolean(? Call(predicate, T,  kValue, k, O )).
        // d. If testResult is true, return kValue.
        var kValue = o[k];
        if (predicate.call(thisArg, kValue, k, o)) {
          return kValue;
        }
        // e. Increase k by 1.
        k++;
      }

      // 7. Return undefined.
      return undefined;
    },
    configurable: true,
    writable: true
  });
}

(function ()
{
  'use strict';

  window.addEventListener('load', function ()
  {
    // The service worker is always registered, but the push permission is asked only when the user request
    // it from the ui
    if(/*iservice.loggedIn.isLoggedIn && */navigator.serviceWorker && window.PushManager)
    {
      navigator.serviceWorker.register(rootPath + 'js/serviceWorker.js', { scope: '/' })
        .then(function (registration)
        {
          //console.log('Service worker registered successfully');
          //if(registration.pushManager)
          //{
          //  // TODO: Use registration.pushManager.getSubscription to determine if we have previously subscribed
          //  // before attempting new subscription
          //  registration.pushManager.subscribe({
          //    userVisibleOnly: true,
          //    applicationServerKey: ''
          //  }).then(function (subscription)
          //  {
          //    //subscription.
          //  });
          //}
        }).catch(function (e)
        {
          console.error('Error during service worker registration:', e);
        });
    }
  });
})();

function validateEmail(email) {
  const re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
  return re.test(String(email).toLowerCase());
}
function validURL(str) {
  var pattern = new RegExp('^(https?:\\/\\/)?' + // protocol
    '((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.)+[a-z]{2,}|' + // domain name
    '((\\d{1,3}\\.){3}\\d{1,3}))' + // OR ip (v4) address
    '(\\:\\d+)?(\\/[-a-z\\d%_.~+]*)*' + // port and path
    '(\\?[;&a-z\\d%_.~+=-]*)?' + // query string
    '(\\#[-a-z\\d_]*)?$', 'i'); // fragment locator
  return !!pattern.test(str);
}
function validateProtocol(link) {
  console.log(link)
  if (link.indexOf("http://") == 0 || link.indexOf("https://") == 0) {
    return true;
  }
  return false;
}

function FindConfig(topicID, config){
  return FindArray(config, function (topic) {
    if (topic.requestTopicID == topicID) return topic;
    if (topic.pendingTopicID == topicID) return topic;
  });
}

function getPropOrder(propID, topicID, config){
  var config = config;
  var order;
  var propertyOrder = config.propertiesOrder;
  if (propertyOrder) {
    for (var i = 0; i < propertyOrder.length; i++) {
      if (propertyOrder[i].id == propID) {
        order = propertyOrder[i].order;
        break;
      }
    }
  }
  return order;
}
function ClassName(str) {
  str = str.toLowerCase();
  var name = '';
  for (var i = 0; i < str.length; i++) {
    var c = str.charAt(i);
    if (c == ' ') name += '-';
    else if (c >= 'a' && c <= 'z') name += c;
    else if (c >= '0' && c <= '9') name += c;
  }
  return name;
}
function ForKeys(obj, func) {
  var names = Object.keys(obj);
  for (var i = 0; i < names.length; i++) {
    var item = obj[names[i]];
    var name = names[i];
    func(item, name);
  } 
}
function ForArray(arr, func) {
  if (!arr) return;
  for (var i = 0; i < arr.length; i++) {
    var item = arr[i];
    var ret = func(item, i);
    if (ret === false) return;
  }
}
function KeyCount(obj) {
  var count = 0;
  ForKeys(obj, function (item) {
    if (item) count = count + 1;
  });
  return count;
}
function FindArray(arr, func) {
  if (!arr) return null;
  for (var i = 0; i < arr.length; i++) {
    var item = arr[i];
    var ret = func(item, i);
    if (ret) {
      return ret;
    }
  }
  return null;
}
function TransformArray(arr, func) {
  if (!arr) return [];
  var arrnew = [];
  ForArray(arr, function (el) {
    arrnew.push(func(el));
  });
  return arrnew;
}
function RemoveFromArrayInPlace(arr, func) {
  //func = takes (item, index), returns true if item should be removed
  var start = arr.length;
  var num = 0;
  for (var i = arr.length - 1; i >= 0; i--) {
    if (func(arr[i], i)) {
      start = i;
      num++;
    }
    else if (num > 0) {
      arr.splice(start, num);
      num = 0;
    }
  }
  if (num > 0) arr.splice(start, num);
}

var openid = {};
(function (openid) {
  openid.Ready = function ($scope, $http, idPrefix) {
    if (!window.hello) return;
    hello.on('auth.login', function (auth) {
      var token = auth.authResponse.id_token;
      if (!token) {
        hello.logout(auth.network);
        return;
      }
      $scope.LoginRunning = iservice.OpenIDRegister($http, token, auth.network, function (data) {
        ProcessLogin(data, $scope);
      }, idPrefix);
    });
  }
  //common
  openid.Logout = function () {
    if (!window.hello) return;
    hello.logout('windows');
    hello.logout('google');
  }
  function ProcessLogin(data, $scope) {
    if (data.errors && data.errors.length) return;
    if (iservice.loggedIn.contactID == data.loggedIn.contactID) return;
    $scope.LoginRunning = function () { return true; }
    window.location.reload();
  }
})(openid);

var websync = {};
(function (websync) {
  websync.FeedbackObject = function ($scope) {
    var feedback = {};
    feedback.$scope = $scope;
    feedback.Message = function (msg, memberName, oppositeName) {
      $scope.$apply(function () {
        feedback[memberName] = msg;
        feedback[oppositeName] = undefined;
      });
    };
    feedback.Status = function () {
      return feedback.success ? 'success' : (feedback.failure ? 'failure' : 'off');
    };
    return feedback;
  };
  var client = null;
  var channels = {};
  function ChatInit() {
    if (client != null) return;
    client = new fm.websync.client(rootPath + 'websync.ashx');
    client.setDisableWebSockets(true);
    client.connect({
      onSuccess: function (e) {
        ForKeys(channels, function (channel, channelName) { ForKeys(channel.receives, function (receive) {
          if (!receive.feedback) return;
          receive.feedback.Message('Client connect success.', 'success', 'failure');
        });});
      },
      onFailure: function (e) { 
        ForKeys(channels, function (channel, channelName) { ForKeys(channel.receives, function (receive) {
          if (!receive.feedback) return;
          receive.feedback.Message('Client connect failure.', 'failure', 'success');
        });});
      },
      onStreamFailure: function (e) { }
    });
  };
  websync.ClientFeedback = function (feedback) {
    feedback.channelName = 'Client Connection';
    channels['none'] = { receives: { '1': { feedback: feedback } } };
  }
  function UnsubImpl(channelName, channel, token) { 
    return function () {
      var receive = channel.receives[token];
      if (receive) {
        if (receive.feedback) {
          receive.feedback.success = receive.feedback.failure = null;
        }
        delete channel.receives[token];
      }
      if (Object.keys(channel.receives).length < 1) { 
        delete channels[channelName]; 
        ChatInit(); 
        client.unsubscribe({ channel: channelName }); 
      } 
    } 
  }
  function Receive(channel, e) {
    ForKeys(channel.receives, function (receive) {
      if (receive.feedback) {
        receive.feedback.$scope.$apply(function () {
          receive.onReceive(e);
        });
      }
      else {
        receive.onReceive(e);
      }
    });
  }
  function SuccessFailure(channel, memberName, oppositeName) {
    ForKeys(channel.receives, function (receive) {
      if (!receive.feedback) return;
      receive.feedback.Message(channel[memberName], memberName, oppositeName);
    });
  }
  websync.subscribe = function (channelName, onReceive, feedback) {
    var channel = channels[channelName];
    var firstTime = !channel;
    if (firstTime) { 
      channel = { index: 1, receives: {} }; 
      channels[channelName] = channel; 
    }
    if (feedback) feedback.channelName = channelName;
    var token = channel.index + '';
    channel.receives[token] = {
      onReceive: onReceive,
      feedback: feedback,
      success: channel.success,
      failure: channel.failure
    };
    channel.index++;
    if (firstTime) {
      ChatInit();
      $.cookie.json = false;
      client.subscribe({
        channel: channelName,
        meta: { sid: $.cookie('sid') },
        onSuccess: function (e) { 
          channel.success = "Subscribe success: " + channelName;
          SuccessFailure(channel, 'success', 'failure');
        },
        onFailure: function (e) {
          channel.failure = "Subscribe failure: " + channelName + ": " + e.getException().message;
          SuccessFailure(channel, 'failure', 'success');
        },
        onReceive: function (e) { 
          Receive(channel, e);
        }
      });
    }
    return UnsubImpl(channelName, channel, token);
  };
})(websync);

function HourMinSec(totalSeconds) {
  function twoDigits(val) {
    return (val < 10) ? '0' + val : val; 
  }
  if (totalSeconds < 0) totalSeconds = -totalSeconds;
  if (totalSeconds > 35999999) totalSeconds = 35999999;
  var hours = Math.floor(totalSeconds / 3600);
  var minutes = Math.floor((totalSeconds - hours * 3600) / 60);
  var seconds = Math.floor(totalSeconds - hours * 3600 - minutes * 60);
  return (hours > 0) ? (hours + ':' + twoDigits(minutes) + ':' + twoDigits(seconds)) :
                       (minutes + ':' + twoDigits(seconds)); 
}

function TableRemoveItem(arr, idFieldName, id) {
  for (var i = 0; i < arr.length; i++) {
    if (arr[i][idFieldName] == id) {
      var item = arr[i];
      arr.splice(i, 1);
      return item;
    }
  }
}
function TableReplaceInsertItem(arr, idFieldName, item) {
  for (var i = 0; i < arr.length; i++) {
    if (arr[i][idFieldName] == item[idFieldName]) {
      arr[i] = item;
      return;
    }
  }
  arr.push(item);
}
function TableExtendItem(arr, idFieldName, item) {
  for (var i = 0; i < arr.length; i++) {
    if (arr[i][idFieldName] == item[idFieldName]) {
      angular.extend(arr[i], item);
      return;
    }
  }
}
function UpdateTable(list, updatedItem, idFieldName) { 
  if (updatedItem.isDeleted === undefined) updatedItem.isDeleted = false; 
  for (var i = 0, len = list.length; i < len; i++) { 
    if (list[i][idFieldName] == updatedItem[idFieldName]) { 
      if (updatedItem.isDeleted == true) { 
        list.splice(i, 1); 
        return false; 
      } 
      else { 
        list[i] = updatedItem; 
        return true; 
      } 
    } 
  } 
  if (updatedItem.isDeleted == false) list.push(updatedItem); 
  return false; 
}
function LookupTable(list, id, idFieldName) {
  if (!list) return null;
  for (var i = 0, len = list.length; i < len; i++) { 
    if (list[i][idFieldName] == id) { 
      return list[i]; 
    } 
  } 
  return null; 
}
function SetTableClass(list, selectedID, idFieldName, classEven, classOdd, classSelected) { 
  for (var i = 0, len = list.length; i < len; i++) { 
    if (list[i][idFieldName] == selectedID) { 
      list[i].classs = classSelected; 
    } 
    else if (i % 2 == 0) { 
      list[i].classs = classEven; 
    } 
    else { 
      list[i].classs = classOdd; 
    } 
  } 
}

function Running(func) { return func && func(); }

function saveSelection() { if (window.getSelection) { sel = window.getSelection(); if (sel.getRangeAt && sel.rangeCount) { return sel.getRangeAt(0); } } else if (document.selection && document.selection.createRange) { return document.selection.createRange(); } return null; }
function restoreSelection(range) { if (range) { if (window.getSelection) { sel = window.getSelection(); sel.removeAllRanges(); sel.addRange(range); } else if (document.selection && range.select) { range.select(); } } }
function isOrContains(node, container) { while (node) { if (node === container) { return true; } node = node.parentNode; } return false; }
function elementContainsSelection(el) { var sel; if (window.getSelection) { sel = window.getSelection(); if (sel.rangeCount > 0) { for (var i = 0; i < sel.rangeCount; ++i) { if (!isOrContains(sel.getRangeAt(i).commonAncestorContainer, el)) { return false; } } return true; } } else if ((sel = document.selection) && sel.type != "Control") { return isOrContains(sel.createRange().parentElement(), el); } return false; }
function pasteHtmlAtCaret(html, el) { if (elementContainsSelection(el) == false) return; var sel, range, selectPastedContent = false; if (window.getSelection) { sel = window.getSelection(); if (sel.getRangeAt && sel.rangeCount) { range = sel.getRangeAt(0); range.deleteContents(); var el = document.createElement("div"); el.innerHTML = html; var frag = document.createDocumentFragment(), node, lastNode; while ((node = el.firstChild)) { lastNode = frag.appendChild(node); } var firstNode = frag.firstChild; range.insertNode(frag); if (lastNode) { range = range.cloneRange(); range.setStartAfter(lastNode); if (selectPastedContent) { range.setStartBefore(firstNode); } else { range.collapse(true); } sel.removeAllRanges(); sel.addRange(range); } } } else if ((sel = document.selection) && sel.type != "Control") { var originalRange = sel.createRange(); originalRange.collapse(true); sel.createRange().pasteHTML(html); } }
function insertIntoTextarea(textarea, text) { if (document.selection) { textarea.focus(); sel = document.selection.createRange(); sel.text = text; } else if (textarea.selectionStart || textarea.selectionStart == '0') { var startPos = textarea.selectionStart; var endPos = textarea.selectionEnd; textarea.value = textarea.value.substring(0, startPos) + text + textarea.value.substring(endPos, textarea.value.length); textarea.selectionStart = startPos + text.length; textarea.selectionEnd = startPos + text.length; } else { textarea.value += text; } } 

function SortFunction(fields) {
  function SortCompare(left, right) {
    for (var i = 0, len = fields.length; i < len; i++) {
      var column = fields[i].column == 'status' && left.currentStatus && right.currentStatus ? 'currentStatus' : fields[i].column, 
          l = left[column], 
          r = right[column];
      var lStr = (typeof l == 'string' || l instanceof String), 
          rStr = (typeof r == 'string' || r instanceof String);
      var lEmpty = (l === undefined || l === null || (lStr && l.length < 1));
      var rEmpty = (r === undefined || r === null || (rStr && r.length < 1));
      if (lEmpty && rEmpty) continue;
      if (lEmpty) return (fields[i].ascend) ? -1 : 1;
      if (rEmpty) return (fields[i].ascend) ? 1 : -1;
      if (lStr) { l = l.toLowerCase(); }
      if (rStr) { r = r.toLowerCase(); }
      if (lStr && rStr) {
        if (fields[i].ascend) return l.localeCompare(r, undefined, { numeric: true });
        return r.localeCompare(l, undefined, { numeric: true });
      }
      if (l < r) return (fields[i].ascend) ? -1 : 1;
      if (r < l) return (fields[i].ascend) ? 1 : -1;
    }
    return 0;
  }
  return SortCompare;
}
function SortSimple(sortField, sortOrder) {
  return SortFunction([{ column: sortField, ascend: sortOrder == -1}]); 
}
function BreakWord(str) {
  if (!str) return '';
  var out = '';
  for (var j = 0, len = 0; j < str.length; j++, len++) {
    var c = str[j];
    out += c;
    if (c == ' ') {
      len = 0;
    }
    else if (len == 15 || c == '.' || c == '@' || c == '-' || c == '\\' || c == '/' || c == '\n') {
      out += '\u200B';
      len = 0;
    }
  }
  return out;
}
function PrintValues(values, type) {
  values = values || [];
  var out = '';
  var separator = '';
  values.forEach(function (value) {
    out += separator;
    separator = ' \n';
    if (value.description) out += '(' + value.description + ') ';
    if (type == 'date') {
      out += moment(value.valueDate).format('YYYY-MM-DD');
    } else if (type == 'datetime') {
      out += moment(value.valueDatetime).format('YYYY-MM-DD hh:mm:ss A');
    } else {
      out += value.value;
    }
  });
  return out;
}
function PrinterPropertyValues() {
  return PrintValues;
}
function DefinitionType(def) {
  if (!def) return null;
  if (def.isDate) return 'date';
  if (def.type == 'datetime') return 'datetime';
  return null;
}
function PrinterInboxProperty(intProperties, propID) {
  return function (inboxproperties) {
    if (!inboxproperties.forID) {
      inboxproperties.forID = {};
      inboxproperties.forEach(function (prop) {
        inboxproperties.forID[prop.propertyID] = prop;
      });
    }
    var prop = inboxproperties.forID[propID];
    if (!prop) return '';
    var def = intProperties.get(propID);
    return PrintValues(prop.values, DefinitionType(def));
  }
}
function PrinterContactProperty(contactProperties, propID) {
  return function (propertysummary) {
    if (!propertysummary.forID) {
      propertysummary.forID = {};
      propertysummary.forEach(function (prop) {
        propertysummary.forID[prop.propertyID] = prop;
      });
    }
    var prop = propertysummary.forID[propID];
    if (!prop) return '';
    var def = contactProperties.get(propID);
    return PrintValues(prop.values, DefinitionType(def));
  }
}
function ExporterContactProperty(contactProperties, propID) {
  return function (propertysummary) {
    if (!propertysummary.forID) {
      propertysummary.forID = {};
      propertysummary.forEach(function (prop) {
        propertysummary.forID[prop.propertyID] = prop;
      });
    }
    var prop = propertysummary.forID[propID];
    if (!prop) return '';
    if (!prop.values || !prop.values.length) return '';
    var def = contactProperties.get(propID);
    return Values(prop.values);
    function Value(value) {
      if (def.isDate) return value.valueDate;
      if (def.isInteger) return value.valueInteger;
      if (def.isNumber) return value.valueNumber;
      return value.value;
    }
    function SingleValue(value) {
      var val = Value(value);
      if (def.hasDescriptions) {
        return '(' + value.description + ') ' + val;
      }
      return val;
    }
    function Values(values) {
      if (!def.allowMultiple) {
        return SingleValue(values[0]);
      }
      var lines = '';
      values.forEach(function (value, i) {
        var val = SingleValue(value);
        if (i > 0) {
          lines += '\n';
        }
        lines += val;
      });
      return lines;
    }
  }
}
function ExporterInboxProperty(intProperties, propID) {
  return function (inboxproperties) {
    if (!inboxproperties.forID) {
      inboxproperties.forID = {};
      inboxproperties.forEach(function (prop) {
        inboxproperties.forID[prop.propertyID] = prop;
      });
    }
    var prop = inboxproperties.forID[propID];
    if (!prop) return '';
    if (!prop.values || !prop.values.length) return '';
    var def = intProperties.get(propID);
    return Values(prop.values);
    function Value(value) {
      if (def.isDate) return value.valueDate;
      if (def.isInteger) return value.valueInteger;
      if (def.isNumber) return value.valueNumber;
      return value.value;
    }
    function SingleValue(value) {
      var val = Value(value);
      if (def.hasDescriptions) {
        return '(' + value.description + ') ' + val;
      }
      return val;
    }
    function Values(values) {
      if (!def.allowMultiple) {
        return SingleValue(values[0]);
      }
      var lines = '';
      values.forEach(function (value, i) {
        var val = SingleValue(value);
        if (i > 0) {
          lines += '\n';
        }
        lines += val;
      });
      return lines;
    }
  }
}
function PrinterInboxProperties(intProperties) {
  return function (inboxproperties) {
    var out = '';
    if (inboxproperties && inboxproperties.length) {
      inboxproperties.forEach(function (prop) {
        var def = intProperties.get(prop.propertyID);
        var name = def ? def.name : prop.propertyID;
        out += name + ': ';
        out += PrintValues(prop.values, DefinitionType(def));
        out += '\n';
      });
    }
    return out;
  }
}
function PrinterName(objService) {
  return function (objID) {
    var obj = objService.get(objID);
    if (!obj) return '';
    return obj.name;
  }
}
function PrinterNameWithSegment(objService, segments) {
  return function (objID) {
    if (!objID) return '';
    var obj = objService.get(objID);
    if (!obj) return '#' + objID;
    var objName = obj.name;
    var segment = segments.get(obj.segmentID);
    if (!segment) return objName;
    return '(' + segment.name + ') ' + objName;
  }
}
function PrintUtcDate(date) {
  if (!date || date == '') return '';
  return moment(date).format('YYYY-MM-DD hh:mm:ss A');
}

(function ($) {
  $.extend({
    playSound: function () {
      return $('<audio autoplay><source src="' + rootPath + arguments[0] + '.mp3" type="audio/mpeg"><source src="' + rootPath + arguments[0] + '.ogg" type="audio/ogg"></audio>').appendTo('body');
    }
  });
})(jQuery);

function InstallControllerSort($scope, initial, rowsName) {
  if (!rowsName) rowsName = 'rows';
  $scope.sort = [].concat(initial);
  $scope[rowsName] = [];
  $scope.Rows = function () { return $scope[rowsName]; }
  $scope.SortDirectionClass = function (column) { 
    return (!$scope.sort || $scope.sort[0].column != column) ? 'none' : ($scope.sort[0].ascend ? 'sort-direction-ascend' : 'sort-direction-descend'); 
  }
  $scope.SortClick = function (column, descend) { 
    if ($scope.sort[0].column == column) { 
      $scope.sort[0].ascend = !$scope.sort[0].ascend; 
    } 
    else { 
      for (var i = 0, len = $scope.sort.length; i < len; i++) { 
        if ($scope.sort[i].column == column) { 
          $scope.sort.splice(i, 1); 
          break; 
        } 
      }
      $scope.sort.splice(0, 0, { column: column, ascend: !descend }); 
    } 
    $scope.Resort(); 
  }
  $scope.NewRows = function (rows) {
    $scope[rowsName] = rows;
    $scope.Resort();
  }
  $scope.Resort = function () { 
    $scope[rowsName].sort(SortFunction($scope.sort));
  }
}

function InstallControllerSortTree($scope, initial, idName, parentName) {
  InstallControllerSort($scope, initial);
  var root = { id: '', children: [] };
  $scope.NewRows = function (rows) {
    var nodes = {};
    root = { id: '', children: [] };
    nodes[root.id] = root;
    for (var i = 0; i < rows.length; i++) {
      var row = rows[i];
      var id = row[idName];
      nodes[id] = row;
      row.children = [];
      row.collapsed = false;
    }
    for (var i = 0; i < rows.length; i++) {
      var row = rows[i];
      var parentID = row[parentName];
      var parent = nodes[parentID];
      parent.children.push(row);
    }
    $scope.Resort();
  }
  $scope.Resort = function () {
    ResortTree(root);
    $scope.rows = [];
    FlattenTree(root);
  }
  $scope.Expand = function (row) {
    if (!row.children) return;
    row.collapsed = !row.collapsed;
    $scope.rows = [];
    FlattenTree(root);
  };
  $scope.ExpanderClass = function (row) {
    if (!row.children || !row.children.length) return 'no-children';
    if (row.collapsed) return 'list-expand';
    return 'list-contract';
  }
  function ResortTree(tree) {
    tree.children.sort(SortFunction($scope.sort));
    for (var i = 0; i < tree.children.length; i++) {
      ResortTree(tree.children[i]);
    }
  }
  function FlattenTree(tree) {
    for (var i = 0; i < tree.children.length; i++) {
      var child = tree.children[i];
      $scope.rows.push(child);
      if (!child.collapsed) {
        FlattenTree(child);
      }
    }
  }
}

function InstallControllerPicker($scope, $http, allowPasteFunc) {
  $scope.EditorID = function (id) {
    $scope.pasteTarget = id;
  }
  $scope.PasteStockText = function (stock, pasteTarget) {
    if (allowPasteFunc && !allowPasteFunc()) return;
    if (stock.bodyHtml !== undefined) {
      CKEDITOR.instances[pasteTarget].insertHtml(stock.bodyHtml);
      return;
    }
    $scope.StockLoadRunning = iservice.StockResponseGet($http, stock.id, function (data) {
      CKEDITOR.instances[pasteTarget].insertHtml(data.bodyHtml);
    });
  }
  $scope.PasteVariable = function (variable, pasteTarget) {
    if (allowPasteFunc && !allowPasteFunc()) return;
    if (!variable.text) return;
    CKEDITOR.instances[pasteTarget].insertHtml(variable.text, 'text');
  }
}

function InstallControllerSortPaged($scope, initial, countPerPage) {
  $scope.sort = [].concat(initial);
  $scope.rows = [];
  $scope.pageRows = [];
  $scope.Rows = function () { 
    return $scope.pageRows; 
  }
  $scope.curPage = 1;
  $scope.SortDirectionClass = function (column) { 
    return (!$scope.sort || $scope.sort[0].column != column) ? 'none' : ($scope.sort[0].ascend ? 'sort-direction-ascend' : 'sort-direction-descend'); 
  }
  $scope.SortClick = function (column) { 
    if ($scope.sort[0].column == column) { 
      $scope.sort[0].ascend = !$scope.sort[0].ascend; 
    } 
    else { 
      for (var i = 0, len = $scope.sort.length; i < len; i++) { 
        if ($scope.sort[i].column == column) { 
          $scope.sort.splice(i, 1); 
          break; 
        } 
      } 
      $scope.sort.splice(0, 0, { column: column, ascend: true }); 
    } 
    $scope.Resort(); 
    $scope.SelectPage($scope.curPage);
  }
  $scope.SelectPage = function (num) { 
    $scope.curPage = num; 
    $scope.pageRows = []; 
    for (var i = 0, src = (num - 1) * countPerPage; i < countPerPage && src < $scope.rows.length; i++, src++) { 
      $scope.pageRows.push($scope.rows[src]); 
    }

    var firstItem = $scope.curPage - 1;
    firstItem = firstItem * 10;
    var lastItem = Math.min(firstItem + 10, $scope.rows.length);
    $scope.entriesData = $scope.rows.length ? 'Showing ' + (firstItem + 1) + ' to ' + (lastItem) + ' of ' + ($scope.rows.length) + ' entries' : '';
  }
  $scope.NewRows = function (rows) { 
    $scope.rows = rows; 
    $scope.pageNums = [1]; 
    for (var page = 2, total = countPerPage; total < $scope.rows.length; page++, total += countPerPage) { 
      $scope.pageNums.push(page); 
    } 
    $scope.Resort(); 
    $scope.SelectPage(1); 
  }
  $scope.Resort = function () { 
    $scope.rows.sort(SortFunction($scope.sort)); 
  }
  $scope.PageLinkClass = function (num) { 
    return (num == $scope.curPage) ? '' : 'nglink'; 
  }
  $scope.Remove = function (pred) {
    var rows = [];
    ForArray($scope.rows, function (row) {
      if (!pred(row)) {
        rows.push(row);
      }
    });
    $scope.rows = rows;
    $scope.pageNums = [1];
    for (var page = 2, total = countPerPage; total < $scope.rows.length; page++, total += countPerPage) {
      $scope.pageNums.push(page);
    }
    if ($scope.curPage > $scope.pageNums.length) {
      $scope.curPage = $scope.pageNums.length;
    }
    $scope.SelectPage($scope.curPage);
  }
}
function HasTag(data, name) {
  if (data.tagMap) {
    return data.tagMap[name];
  }
  data.tagMap = {};
  ForArray(data.tags, function (tag) {
    data.tagMap[tag] = true;
  });
  return HasTag(data, name);
}

function ParseLocation() {
  var pairs = window.location.search.substring(1).split("&");
  var obj = {};
  var pair;
  var i;
 
  for (i in pairs) {
    if (pairs[i] === "" || typeof pairs[i] === 'function') continue;
    pair = pairs[i].split("=");
    obj[decodeURIComponent(pair[0])] = decodeURIComponent(pair[1]);
  }
  return obj; 
};
function ChangeLocation(query) {
  var url = window.location.href;
  url = url.split('?')[0];
  var separator = '?';
  
  ForKeys(query, function (part, name) {
    url += separator + encodeURIComponent(name) + '=' + encodeURIComponent(part);
    separator = '&';
  });
  window.location = url; 
}

var managemessage = {};
(function (managemessage) {

})(managemessage);

var iservice = {};
(function (iservice) {
  iservice.statuses = {
    'Unassigned': { isOpen: true, label: 'Open' },
    'Queued': { isOpen: true, label: 'Open' },
    'Ignored': { isOpen: false, label: 'Ignored' },
    'Resolved': { isOpen: false, label: 'Resolved' },
    'Pending': { isOpen: true, label: 'Pending' },
    'ResolvedArchived': { isOpen: false, label: 'Resolved' },
    'ChatWaiting': { isOpen: true, label: 'ChatWaiting' },
    'ChatInProgress': { isOpen: true, label: 'ChatInProgress' },
    'Unsent': { isOpen: true, label: 'Unsent' },
    'PrivateNote': { isOpen: false, label: 'Resolved' },
    'PublicNote': { isOpen: false, label: 'Resolved' },
    'Sent': { isOpen: false, label: 'Resolved' },
    'SentWaitingReply': { isOpen: false, label: 'Resolved' },
    'SentArchived': { isOpen: false, label: 'Resolved' },
    isOpen: function (s) {
      var status = iservice.statuses[s];
      if (!status || status.isOpen === undefined) return false;
      return status.isOpen;
    },
    label: function (s) {
      var status = iservice.statuses[s];
      if (!status || status.isOpen === undefined) return 'Resolved';
      return status.label;
    }
  };
  iservice.types = {
    'Customer Email': { isAnswer: false, isQuestion: true, isNotification: false, label: 'Customer Email' },
    'Private Email': { isAnswer: false, isQuestion: true, isNotification: false, label: 'Private Email' },
    'Agent Response': { isAnswer: true, isQuestion: false, isNotification: false, label: 'Agent Response' },
    'Agent Email': { isAnswer: true, isQuestion: false, isNotification: false, label: 'Agent Email' },
    'Alert': { isAnswer: false, isQuestion: false, isNotification: true, label: 'Alert' },
    'Agent Notification': { isAnswer: false, isQuestion: false, isNotification: true, label: 'Agent Notification' },
    'External Agent Notification': { isAnswer: false, isQuestion: false, isNotification: true, label: 'External Agent Notification' },
    'Password Reset': { isAnswer: false, isQuestion: false, isNotification: true, label: 'Password Reset' },
    'Message Acknowledgment': { isAnswer: false, isQuestion: false, isNotification: true, label: 'Message Acknowledgment' },
    'Secure Notification': { isAnswer: false, isQuestion: false, isNotification: true, label: 'Secure Notification' },
    'Customer Ticket': { isAnswer: false, isQuestion: true, isNotification: false, label: 'Customer Ticket' },
    'Agent Ticket': { isAnswer: false, isQuestion: true, isNotification: false, label: 'Agent Ticket' },
    'Unsent Response': { isAnswer: true, isQuestion: false, isNotification: false, label: 'Unsent Response' },
    'Secure Email': { isAnswer: true, isQuestion: false, isNotification: false, label: 'Secure Email' },
    'Secure Response': { isAnswer: true, isQuestion: false, isNotification: false, label: 'Secure Response' },
    'Private Note': { isAnswer: true, isQuestion: false, isNotification: false, label: 'Private Note' },
    'Note': { isAnswer: true, isQuestion: false, isNotification: false, label: 'Note' },
    'Find Answer Article': { isAnswer: false, isQuestion: false, isNotification: false, label: 'Find Answer Article' },
    'Contact Creation': { isAnswer: false, isQuestion: false, isNotification: true, label: 'Contact Creation' },
    'Resolve Note': { isAnswer: true, isQuestion: false, isNotification: false, label: 'Resolve Note' },
    'Mass Mailing Article Update': { isQuestion: false, isNotification: true, label: 'Mass Mailing Article Update' },
    'Mass Mailing': { isAnswer: true, isQuestion: false, isNotification: false, label: 'Mass Mailing' },
    'Chat': { isAnswer: false, isQuestion: true, isNotification: false, label: 'Chat' },
    isNotification: function (t) {
      var type = iservice.types[t];
      if (!type || type.isNotification === undefined) return false;
      return type.isNotification;
    },
    isQuestion: function (t) {
      var type = iservice.types[t];
      if (!type || type.isNotification === undefined) return false;
      return type.isQuestion;
    },
    isAnswer: function (t) {
      var type = iservice.types[t];
      if (!type || type.isNotification === undefined) return false;
      return type.isAnswer;
    }
  };
  iservice.types['Auto Response'] = iservice.types['Message Acknowledgment'];
  iservice.types['Find Answer'] = iservice.types['Find Answer Article'];
  iservice.types['Notification'] = iservice.types['Secure Notification'];
  iservice.types['Ticket'] = iservice.types['Agent Ticket'];
  iservice.types['Ask A Question'] = iservice.types['Customer Ticket'];

  iservice.SuperviseObject = function ($timeout, recountFunc, interactionsConfig, topicsConfig, columns, plugins) {
    interactionsConfig = interactionsConfig || {};
    interactionsConfig.filterFunc = interactionsConfig.filterFunc || function () { return true; };
    topicsConfig = topicsConfig || {};
    topicsConfig.sort = topicsConfig.sort || { column: 'name', ascend: true };
    topicsConfig.selectFunc = topicsConfig.selectFunc || function () { };
    columns = columns || [];

    function Show(message) { return interactionsConfig.filterFunc(message); }
    var topicList = {
      selectedAll: false,
      selectedIDs: [],
      roots: []
    };
    var topicByID = {};
    var supervisor = {
      update: 0,
      topicList: topicList,
      topicByID: topicByID,
      messagesAll: [],
      messagesShown: []
    };
    InstallControllerSortTree(topicList, topicsConfig.sort, 'id', 'parentID');
    var interactionByID = {};
    var haveTopics = false;
    var resortTimeout;
    supervisor.Start = function (interactions, topics) {
      if (topics && topics.length) {
        haveTopics = true;
        topicList.NewRows(topics);
        ForArray(topics, function (topic) {
          if (topic.properties) iservice.SanitizePropertyGroups(topic.properties);
          topic.messagesAll = [];
          topic.messagesShown = [];
          topicByID[topic.id] = topic;
          if (topic.parentID == '') {
            topicList.roots.push(topic);
          }
          else {
            topic.indent = topic.prefix.replace(/\./g, '&nbsp;');
          }
        });
      }
      else {
        haveTopics = false;
      }
      iservice.SanitizeHistoryRows(interactions);
      ForArray(interactions, function (message) {
        message.plugin = plugins.FindPlugin(message);
        BreakWords(message);
        interactionByID[message.id] = message;
        if (haveTopics) {
          var topic = topicByID[message.topicID];
          if (topic) {
            topic.messagesAll.push(message);
            if (Show(message)) topic.messagesShown.push(message);

            supervisor.messagesAll.push(message);
            if (Show(message)) supervisor.messagesShown.push(message);
          }
        }
        else {
          supervisor.messagesAll.push(message);
          if (Show(message)) supervisor.messagesShown.push(message);
        }

      });
      if (haveTopics) {
        RecountMessages();
        topicList.Resort();
      }
      supervisor.GetMessage = function (id) {
        return interactionByID[id];
      }
      supervisor.update++;
    }
    supervisor.CreateMessageReceive = function (keepFunc, updateFunc, removingFunc) {
      function MessageReceive(msg) {
        var message = msg.getData();
        if (message.inboxUpdate != null) {
          MessageStatusUpdate(message.inboxUpdate);
        }
      }
      function MessageStatusUpdate(update) {
        var keep = keepFunc(update);
        var interaction = interactionByID[update.id];
        if (interaction && keep) {
          BreakWords(update);
          UpdateMessage(interaction, update);
          if (updateFunc) updateFunc(interaction, update);
          supervisor.update++;
        }
        else if (interaction && !keep) {
          RemoveMessage(interaction);
          if (removingFunc) removingFunc(interaction);
          supervisor.update++;
        }
        else if (keep) {
          BreakWords(update)
          InsertMessage(update);
          if (updateFunc) updateFunc(interaction);
          supervisor.update++;
        }
      }
      function UpdateMessage(interaction, update) {
        var oldTopic = topicByID[interaction.topicID];
        var newTopic = topicByID[update.topicID];
        var selected = interaction.selected;
        angular.extend(interaction, update);
        interaction.selected = selected;
        interaction.plugin = plugins.FindPlugin(interaction);
        if (haveTopics && oldTopic !== newTopic) {
          TableRemoveItem(oldTopic.messagesAll, 'id', interaction.id);
          TableRemoveItem(oldTopic.messagesShown, 'id', interaction.id);
          newTopic.messagesAll.push(interaction);
          if (Show(interaction)) newTopic.messagesShown.push(interaction);
          if (oldTopic.selected != newTopic.selected) {
            if (newTopic.selected) {
              supervisor.messagesAll.push(interaction);
              if (Show(interaction)) supervisor.messagesShown.push(interaction);
            }
            else {
              TableRemoveItem(supervisor.messagesAll, 'id', interaction.id);
              TableRemoveItem(supervisor.messagesShown, 'id', interaction.id);
            }
          }
        }
        RecountMessages();
      }
      function RemoveMessage(interaction) {
        if (haveTopics) {
          var topic = topicByID[interaction.topicID];
          TableRemoveItem(topic.messagesAll, 'id', interaction.id);
          TableRemoveItem(topic.messagesShown, 'id', interaction.id);
        }
        delete interactionByID[interaction.id];
        TableRemoveItem(supervisor.messagesAll, 'id', interaction.id);
        TableRemoveItem(supervisor.messagesShown, 'id', interaction.id);
        RecountMessages();
      }
      function InsertMessage(message) {
        message.plugin = plugins.FindPlugin(message);
        interactionByID[message.id] = message;
        var topic = topicByID[message.topicID];
        if (topic) {
          topic.messagesAll.push(message);
          if (Show(message)) topic.messagesShown.push(message);
        }
        if (!haveTopics || (topic && topic.selected)) {
          supervisor.messagesAll.push(message);
          if (Show(message)) supervisor.messagesShown.push(message);
        }
        RecountMessages();
      }
      return MessageReceive;
    }
    supervisor.RefilterMessages = function () {
      if (haveTopics) topicList.rows.forEach(function (topic) {
        topic.messagesShown.splice(0, topic.messagesShown.length);
        topic.messagesAll.forEach(function (message) {
          if (Show(message)) topic.messagesShown.push(message);
        });
      });
      supervisor.messagesShown.splice(0, supervisor.messagesShown.length);
      supervisor.messagesAll.forEach(function (message) {
        if (Show(message)) supervisor.messagesShown.push(message);
      });
      supervisor.update++;
    }
    function RecountMessages() {
      if (resortTimeout) {
        $timeout.cancel(resortTimeout);
      }
      resortTimeout = $timeout(function () {
        resortTimeout = null;
        if (!haveTopics) {
          if (recountFunc) recountFunc();
          return;
        }
        if (recountFunc) {
          ForArray(topicList.rows, function (topic) {
            recountFunc(topic);
          });
        }
      }, 200);
    }
    function BreakWords(row) {
      columns.forEach(function (column) {
        var value = row[column.varGet || column.var];
        if (column.printFunc) {
          value = column.printFunc(value, row);
          row[column.var + 'P'] = value;
        }
        if (column.split) {
          value = BreakWord(value);
          row[column.var + 'B'] = value;
        }
      });
    }
    function MakeSelectedTopicIDs() {
      topicList.selectedIDs = [];
      topicList.rows.forEach(function (row) {
        if (row.selected) topicList.selectedIDs.push(row.id);
      });
      var notSelected = 0;
      topicList.rows.forEach(function (topic) {
        if (topicList.onlyMine && !topic.currentAgent) return;
        if (topic.selected) return;
        notSelected++;
      });
      topicList.selectedAll = topicList.selectedIDs.length > 0 && notSelected == 0;
    }
    topicList.ToggleSkill = function (onlyMine) {
      topicList.onlyMine = onlyMine;
      supervisor.messagesAll.splice(0, supervisor.messagesAll.length);
      supervisor.messagesShown.splice(0, supervisor.messagesShown.length);
      topicList.rows.forEach(function (topic) {
        topic.selected = topic.selected && (!onlyMine || topic.currentAgent);
        if (!topic.selected) return;

        topic.messagesAll.forEach(function (message) {
          supervisor.messagesAll.push(message);
        });
        topic.messagesShown.forEach(function (message) {
          supervisor.messagesShown.push(message);
        });
      });

      MakeSelectedTopicIDs();
      supervisor.update++;
    }
    topicList.SelectAllClick = function (onlyMine) {
      topicList.onlyMine = onlyMine;
      supervisor.messagesAll.splice(0, supervisor.messagesAll.length);
      supervisor.messagesShown.splice(0, supervisor.messagesShown.length);
      topicList.rows.forEach(function (topic) {
        topic.selected = topicList.selectedAll && (!onlyMine || topic.currentAgent);
        if (!topic.selected) return;

        topic.messagesAll.forEach(function (message) {
          supervisor.messagesAll.push(message);
        });
        topic.messagesShown.forEach(function (message) {
          supervisor.messagesShown.push(message);
        });
      });

      MakeSelectedTopicIDs();
      supervisor.update++;
    }
    topicList.SelectRowClick = function (topic) {
      RemoveFromArrayInPlace(supervisor.messagesAll, function (message) {
        return topic.id == message.topicID;
      });
      RemoveFromArrayInPlace(supervisor.messagesShown, function (message) {
        return topic.id == message.topicID;
      });
      if (topic.selected) {
        topic.messagesAll.forEach(function (message) {
          supervisor.messagesAll.push(message);
        });
        topic.messagesShown.forEach(function (message) {
          supervisor.messagesShown.push(message);
        });
      }
      MakeSelectedTopicIDs();
      topicsConfig.selectFunc(topic);
      supervisor.update++;
    }
    supervisor.segmentChannels = [];
    supervisor.SubscribeChats = function ($scope, keepFunc, updateFunc, removingFunc) {
      ForArray(iservice.loggedIn.accessibleSegments, function (segmentID) {
        var feedback = websync.FeedbackObject($scope);
        supervisor.segmentChannels.push(feedback);
        feedback.Unsubscribe = websync.subscribe('/supervisechats/' + iservice.loggedIn.tenantID + '/' + segmentID, supervisor.CreateMessageReceive(keepFunc, updateFunc, removingFunc), feedback);
      })
    };
    supervisor.SubscribeMessages = function ($scope, keepFunc, updateFunc, removingFunc) {
      ForArray(iservice.loggedIn.accessibleSegments, function (segmentID) {
        var feedback = websync.FeedbackObject($scope);
        supervisor.segmentChannels.push(feedback);
        feedback.Unsubscribe = websync.subscribe('/managemsg/' + iservice.loggedIn.tenantID + '/' + segmentID, supervisor.CreateMessageReceive(keepFunc, updateFunc, removingFunc), feedback);
      })
    };
    supervisor.WebsyncCleanup = function () {
      ForArray(supervisor.segmentChannels, function (feedback) {
        if (feedback.Unsubscribe) {
          feedback.Unsubscribe();
          feedback.Unsubscribe = null;
        }
      });
      supervisor.segmentChannels = [];
    }
    supervisor.$destroy = function () {
      if (resortTimeout) $timeout.cancel(resortTimeout);
    }
    return supervisor;
  }
  function removeParam(key, sourceURL) {
    var rtn = sourceURL.split("?")[0],
      param,
      params_arr = [],
      queryString = (sourceURL.indexOf("?") !== -1) ? sourceURL.split("?")[1] : "";
    
    if (queryString !== "") {
      params_arr = queryString.split("&");

      for (var i = params_arr.length - 1; i >= 0; i -= 1) {
       
        param = params_arr[i].split("=")[0];
        
        if (param === key) {
          params_arr.splice(i, 1);
        }
      }
     
      rtn = rtn + "?" + params_arr.join("&");
    }
    return rtn;
  }
  iservice.TableViewer = function ($scope, $timeout, config) {
    /* config { itemsFunc, watchFunc (optional array), columns, startSort, exportName (optional), selectFunc }
     * columns { name, var, visible, split, ascend, printFunc }
    */
    var itemsFunc = config.itemsFunc;
    var watchFuncs = config.watchFuncs || [];
    if (watchFuncs.length < 1) watchFuncs.push(function () { return 0; });
    var columns = config.columns;
    var viewer = {};

    if (config.pastDayValue) {
      viewer.pastDayValue = config.pastDayValue;
    }    
    if (config.showPastField) {
      viewer.showPastField = config.showPastField;
    }
    viewer.showButtons = true;
    if (config.showButtons == false) {
      viewer.showButtons = config.showButtons;
    } 
    viewer.showCustomSearch = false;
    if (config.showCustomSearch == true) {
      viewer.showCustomSearch = config.showCustomSearch;
    }    
    viewer.pageSize = config.pageSize || 50;
    viewer.filterString = '';
    viewer.currentPage = 0;
    viewer.pageLabels = [];
    viewer.columns = columns;
    viewer.columnPicker = {};
    viewer.selectedIDs = [];
    viewer.selectedAll = false;
    columns.forEach(function (column) {
      column.ascend = (column.ascend === false ? false : true);
      column.visible = (column.visible === false ? false : true);
      viewer.columnPicker[column.var] = column;
    });
    var sortOrder = [{ column: config.startSort, ascend: viewer.columnPicker[config.startSort].ascend }];
    var sortFunc = SortFunction(sortOrder);
    var allItems = [];
    viewer.filteredItems = [];
    var curItems = [];
    viewer.Items = function () {
      return curItems;
    }
    var infoStr = '';
    viewer.InfoStr = function () {
      return infoStr;
    }
    viewer.ShowPage = function (page) {
      if (page.link == false) return;
      viewer.currentPage = page.num;
      UpdatePage();
    }
    viewer.SortClick = function (name) {
      var getName = name;
      if (viewer.columnPicker[name].printFunc) {
        getName = name + 'P';
      }
      if (viewer.columnPicker[name].sortRaw) {
        getName = name;
      }
      if (sortOrder[0].column == getName) {
        sortOrder[0].ascend = !sortOrder[0].ascend;
      }
      else {
        for (var i = 0, len = sortOrder.length; i < len; i++) {
          if (sortOrder[i].column == getName) {
            sortOrder.splice(i, 1);
            break;
          }
        }
        sortOrder.splice(0, 0, { column: getName, ascend: viewer.columnPicker[name].ascend });
      }
      SortFilteredItems();
    }
    viewer.SelectRowClick = function () {
      viewer.selectedIDs = [];
      viewer.Items().forEach(function (row) {
        if (row.selected) viewer.selectedIDs.push(row.id);
      });
      viewer.selectedAll = viewer.selectedIDs.length > 0 && viewer.selectedIDs.length == viewer.Items().length;
      if (config.selectFunc) config.selectFunc(viewer.selectedIDs);
    }
    viewer.SelectAllClick = function () {
      viewer.Items().forEach(function (row) {
        row.selected = viewer.selectedAll;
      });
      viewer.SelectRowClick();
    }
    function GetAllItems() {
      allItems = itemsFunc() || [];
      allItems.forEach(function (row) {
        viewer.BreakWords(row);
      });
      FilterItems();
    }
    function FilterItems() {
      viewer.filteredItems = allItems;
      var search = viewer.filterString.trim().toLowerCase();
      if (search && search.length > 0) {
        viewer.filteredItems = [];
        allItems.forEach(function (row) {
          function CheckColumn(column) {
            var value = column.customVar ? row[column.customVar] : row[column.var];
            if (column.printFunc) value = row[column.var + 'P'];
            if (typeof value === 'string' || value instanceof String) {
              value = value.toLowerCase();
              return value.indexOf(search) != -1;
            }
          }
          if (viewer.columns.find(CheckColumn)) {
            viewer.filteredItems.push(row);
          }
        });
      }
      viewer.SelectRowClick();
      SortFilteredItems();
    }
    function SortFilteredItems() {
      viewer.filteredItems.sort(sortFunc);
      UpdatePage();
    }
    function MakeLabel(num, link) {
      viewer.pageLabels.push({ num: num, link: link });
    }
    function UpdatePage() {
      var numPages = Math.max(Math.trunc((viewer.filteredItems.length - 1) / viewer.pageSize) + 1, 1);
      viewer.currentPage = Math.max(Math.min(viewer.currentPage, numPages - 1), 0);
      viewer.pageLabels = [];
      var gapBefore = false, gapAfter = false;
      for (var i = 0; i < numPages; i++) {
        if (i < viewer.currentPage) {
          if (i == 0) { MakeLabel(i, true); continue; }
          else if (i < viewer.currentPage - 2) {
            if (!gapBefore) {
              MakeLabel('...', false);
              gapBefore = true;
              continue;
            }
          }
          else { MakeLabel(i, true); continue; }
        }
        else if (i == viewer.currentPage) { MakeLabel(i, true); continue; }
        else {
          if (i <= viewer.currentPage + 2) { MakeLabel(i, true); continue; }
          else if (i < numPages - 1) {
            if (!gapAfter) {
              MakeLabel('...', false);
              gapAfter = true;
              continue;
            }
          }
          else { MakeLabel(i, true); continue; }
        }
      }
      var firstItem = viewer.currentPage * viewer.pageSize;
      var lastItem = Math.min(firstItem + viewer.pageSize, viewer.filteredItems.length);
      curItems = [];
      for (var i = firstItem; i < lastItem; i++) {
        curItems.push(viewer.filteredItems[i]);
      }
      infoStr = viewer.filteredItems.length ? 'Showing ' + (firstItem + 1) + ' to ' + (lastItem) + ' of ' + (viewer.filteredItems.length) + ' entries' : '';
    }
    var filterTimeout;
    function TriggerFilter() {
      if (filterTimeout) {
        $timeout.cancel(filterTimeout);
      }
      filterTimeout = $timeout(function () {
        filterTimeout = null;
        FilterItems();
      }, 200);
    }
    watchFuncs.forEach(function (watchFunc) {
      $scope.$watch(watchFunc, GetAllItems);
    });
    $scope.$watch(function () { return viewer.pageSize; }, UpdatePage);
    $scope.$watch(function () { return viewer.filterString; }, TriggerFilter);
    viewer.PaginateClass = function (page) {
      if (page.num == viewer.currentPage) return 'active';
    }
    viewer.SortIconClass = function (name) {
      var getName = name;
      if (viewer.columnPicker[name].printFunc) {
        getName = name + 'P';
      }
      var primary = sortOrder.length > 0 && sortOrder[0].column == getName;
      if (!primary) return 'glyphicon glyphicon-sort opacity-30';
      var descend = !sortOrder[0].ascend;
      return 'glyphicon glyphicon-sort-by-attributes' + (descend ? '-alt' : '');
    }
    viewer.CanExport = function () {
      return config.exportName;
    }
    viewer.ExportExcel = function () {
      if (!config.exportName) return;
      var exp = {
        filename: config.exportName,
        sheet: { data: [] }
      };
      var headerRow = [];
      columns.forEach(function (column) {
        if (!column.visible) return;
        headerRow.push({ value: column.name, type: 'string' });
      });
      exp.sheet.data.push(headerRow);
      viewer.filteredItems.forEach(function (row) {
        var rowCells = [];
        columns.forEach(function (column) {
          if (!column.visible) return;
          var value = row[column.varGet || column.var];
          if (column.exportFunc) {
            value = value ? column.exportFunc(value, row) : '';
          }
          else if (column.printFunc) {
            value = row[column.var + 'P'];
            value = (typeof value === 'string' || value instanceof String) ? value : '';
          }
          if (value) {
            if (column.exportType == 'date') {
              var days = moment(value).diff(moment('1899-12-31'), 'days') + 1;
              value = '' + days;
            }
            else if (column.exportType == 'timestamp') {
              var seconds = moment(value).diff(moment(value).startOf('day'), 'seconds');
              var days = moment(value).diff(moment('1899-12-31'), 'days') + 1;
              value = '' + (days + seconds / (24 * 60 * 60));
            }
          }
          rowCells.push({ value: value, type: (column.exportType ? column.exportType : 'string') });
        });
        exp.sheet.data.push(rowCells);
      });
      zipcelx(exp);
    }
    viewer.BreakWords = function (row) {
      if (!row) {
        var rows = itemsFunc();
        if (rows) rows.forEach(function (row) {
          viewer.BreakWords(row);
        });
        return;
      }
      columns.forEach(function (column) {
        var value = row[column.varGet || column.var];
        if (column.printFunc) {
          value = column.printFunc(value, row);
          row[column.var + 'P'] = value;
        }
        if (column.split) {
          value = BreakWord(value);
          row[column.var + 'B'] = value;
        }
      });
    }
    var picker = false;
    viewer.PickerOpen = function () {
      return picker;
    }
    viewer.PickerToggle = function () {
      picker = !picker;
    }
    viewer.PickerClass = function (column) {
      return viewer.columnPicker[column.var].visible ? 'active' : '';
    }
    viewer.ColumnPickerClick = function (column) {
      var url = window.location.hash;
      
      viewer.columnPicker[column.var].visible = !viewer.columnPicker[column.var].visible;
      if (viewer.columnPicker[column.var].visible) {
        if (typeof column.queryString != 'undefined') {
          if (window.location.href.indexOf('&' + column.queryString + '=') == -1) {
            window.location.hash = url + '&' + column.queryString + '=' + column.var;
          }
        }
      } else {
        if (window.location.href.indexOf('&' + column.queryString + '=') > 0) {
          window.location.hash = removeParam(column.queryString, window.location.hash);
        }
      }
    }
    viewer.$destroy = function () {
      if (filterTimeout) $timeout.cancel(filterTimeout);
    }
    return viewer;
  }
  iservice.searchfields = {
    // searchFields = [ group ]
    // group = { fields: [ field ], hide: bool }
    // field = { where: string, fieldID: string, searchString: string }
    // where = 'anywhere' | 'entire' | 'start' | 'end'
    NewSearch: function (where, id, str) {
      var search = [];
      iservice.searchfields.NewFieldGroup(search, where, id, str);
      return search;
    },
    NewFieldGroup: function (searchFields, where, id, str) {
      where = where || 'anywhere';
      id = id || 'all';
      str = str || '';
      var group = { fields: [{ where: where, fieldID: id, searchString: str }] };
      searchFields.push(group);
      return group;
    },
    DeleteField: function (searchFields, whichGroup, whichField) {
      searchFields.forEach(function (group) {
        if (group == whichGroup) {
          RemoveFromArrayInPlace(group.fields, function (field) {
            return field == whichField;
          });
        }
      });
      RemoveFromArrayInPlace(searchFields, function (group) {
        return group.fields.length < 1;
      });
    },
    MergeGroup: function (searchFields, firstGroup) {
      for (var i = 0; i < searchFields.length; i++) {
        var group = searchFields[i];
        if (group == firstGroup) {
          var next = (i + 1 < searchFields.length) ? searchFields[i + 1] : null;
          if (!next) return;
          next.fields.forEach(function (field) {
            group.fields.push(field);
          });
          RemoveFromArrayInPlace(searchFields, function (group) {
            return group == next;
          });
          return;
        }
      }
    },
    SplitGroup: function (searchFields, whichGroup, afterField) {
      for (var i = 0; i < searchFields.length; i++) {
        var group = searchFields[i];
        if (group != whichGroup) continue;
        for (var j = 0; j < group.fields.length; j++) {
          var field = group.fields[j];
          if (field != afterField) continue;
          var newGroup = { fields: [] };
          for (var k = j + 1; k < group.fields.length; k++) {
            field = group.fields[k];
            newGroup.fields.push(field);
          }
          group.fields.splice(j + 1, group.fields.length);
          if (newGroup.fields.length > 0) {
            searchFields.splice(i + 1, 0, newGroup);
          }
          break;
        }
        break;
      }
    }
  }
  iservice.selectui = {};
  iservice.plugins = {
    MakeMatchStatus: function (status) { 
      return function (inboxRow) {
        return inboxRow.status == status;
      };
    },
    MakeMatchType: function (type) { 
      return function (inboxRow) {
        return inboxRow.type == type;
      };
    },
    MakeMatchTopicID: function (topicID) {
      return function (inboxRow) {
        return inboxRow.topicID == topicID;
      };
    },
    MakeMatchProperty: function (propertyID, propertyValue) {
      return function (inboxRow) {
        if (inboxRow.properties) {
          var prop = LookupTable(inboxRow.properties, propertyID, 'propertyID');
          if (!prop) return false;
          return LookupTable(prop.values, propertyValue, 'value');
        }
        else if (inboxRow.propertyGroups) {
          var found = false;
          ForArray(inboxRow.propertyGroups, function (group) {
            ForArray(group.properties, function (property) {
              if (property.propertyID != propertyID) return;
              ForArray(property.values, function (value) {
                if (value.value == propertyValue) {
                  found = true;
                  return false;
                }
              });
              if (found) return false;
            });
            if (found) return false;
          });
          return found;
        }
      };
    },
    FindPlugin: function (interaction) {
      var best = null;
      ForKeys(iservice.plugins, function (plugin) {
        if (!plugin.func) return;
        if (best != null && best.priority > plugin.priority) return;
        if (!plugin.func(interaction)) return;
        best = plugin;
      });
      if (!best) best = iservice.plugins.normal;
      return best;
    }
  }
  var plugins = iservice.plugins;
  plugins.normal = {
    priority: 0,
    func: function (interaction) { return true; },
    detailsPanel: 'interaction-view.html',
    answerPanel: 'interaction-action-answer.html'
  };
  plugins.myinbox = {
    priority: 100,
    func: iservice.plugins.MakeMatchStatus('Queued'),
    detailsPanel: 'interaction-view.html',
    answerPanel: 'interaction-action-answer.html',
    inboxName: 'myinbox',
    myQueueTab: rootPath + 'f/myqueue-answer',
    answerController: 'ControllerMessageQueueMyQueueDetails'
  };
  plugins.waiting = {
    priority: 100,
    func: iservice.plugins.MakeMatchStatus('SentWaitingReply'),
    detailsPanel: 'interaction-view.html',
    answerPanel: 'interaction-action-answer.html',
    inboxName: 'waiting',
    myQueueTab: rootPath + 'f/myqueue-answer',
    answerController: 'ControllerMessageQueueMyQueueDetails'
  };
  plugins.approve = {
    priority: 100,
    func: iservice.plugins.MakeMatchStatus('Pending'),
    detailsPanel: 'interaction-view.html',
    answerPanel: 'interaction-action-answer.html',
    inboxName: 'approve',
    myQueueTab: rootPath + 'f/myqueue-answer',
    answerController: 'ControllerMessageQueueMyQueueDetails'
  };
  plugins.chat = {
    priority: 100,
    func: iservice.plugins.MakeMatchStatus('ChatInProgress'),
    detailsPanel: 'interaction-view.html',
    answerPanel: '',
    inboxName: 'chats',
    myQueueTab: ''
  };
  iservice.MessageDetailsUrl = function (data) {
    if (!data.details) return plugins.normal.detailsPanel;
    var plugin = iservice.plugins.FindPlugin(data.details);
    if (!plugin) return plugins.normal.detailsPanel;
    if (!plugin.detailsPanel) return plugins.normal.detailsPanel;
    return plugin.detailsPanel;
  }
  
  iservice.tenant = {};
  iservice.accessRights = {};
  iservice.loggedIn = {};

  function GetSegment(id) {
    return AddToContainer(iservice.tenant, { id: id }, 'segments', 'id');
  }
  iservice.tenant.AddSegment = function (seg) {
    AddObject(seg, 'segments', 'id');
  }
  iservice.tenant.AddMailbox = function (mailbox) {
    AddObjectSegment(mailbox, 'mailboxes', 'id', 'segmentID', 'segmentName');
    mailbox.nameWithSeg = '(' + mailbox.segmentName + ') ' + mailbox.name;
  }
  iservice.tenant.AddTopic = function (topic) {
    AddObjectSegment(topic, 'topics', 'id', 'segmentID', 'segmentName');
  }
  iservice.tenant.AddAutoResponse = function (autoResponse) {
    AddObjectSegment(autoResponse, 'autoResponses', 'id', 'segmentID', 'segmentName');
    autoResponse.nameWithSeg = '(' + autoResponse.segmentName + ') ' + autoResponse.name;
  }
  iservice.tenant.AddExternalNotify = function (externalNotify) {
    AddObjectSegment(externalNotify, 'externalNotify', 'id', 'segmentID', 'segmentName');
    externalNotify.nameWithSeg = '(' + externalNotify.segmentName + ') ' + externalNotify.name;
  }
  iservice.tenant.AddContactProperty = function (property) {
    AddObjectSegment(property, 'contactProperties', 'id', 'segmentID', 'segmentName');
    property.nameWithSeg = '(' + property.segmentName + ') ' + property.name;
  }
  iservice.tenant.AddInteractionProperty = function (property) {
    AddObjectSegment(property, 'intProperties', 'id', 'segmentID', 'segmentName');
    property.nameWithSeg = '(' + property.segmentName + ') ' + property.name;
  }
  iservice.tenant.AddFilter = function (filter) {
    AddObjectSegment(filter, 'filters', 'id', 'segmentID', 'segmentName');
    filter.nameWithSeg = '(' + filter.segmentName + ') ' + filter.name;
  }
  iservice.tenant.AddMailbox = function (mailbox) {
    AddObjectSegment(mailbox, 'mailboxes', 'id', 'segmentID', 'segmentName');
    mailbox.nameWithSeg = '(' + mailbox.segmentName + ') ' + mailbox.name;
  }
  iservice.tenant.AddForm = function (form) {
    if (form) form.idNum = +form.id;
    AddObject(form, 'forms', 'id');
  }
  iservice.tenant.AddFormBuiltin = function (form) {
    AddObject(form, 'formsbuiltin', 'id');
  }
  iservice.tenant.ResetForms = function () {
    iservice.tenant.formsLoaded = false;
    iservice.tenant.forms = null;
  }
  iservice.tenant.AddDepartment = function (department) {
    AddObject(department, 'departments', 'id');
  }
  iservice.tenant.AddWebsite = function (website) {
    if (website) website.idNum = +website.id;
    AddObject(website, 'websites', 'id');
  }
  iservice.tenant.ResetWebsites = function () {
    iservice.tenant.websitesLoaded = false;
    iservice.tenant.websites = null;
  }
  iservice.tenant.AddAgent = function (agent) {
    AddObject(agent, 'agents', 'id');
  }
  function AddToContainer(container, obj, listName, idName) {
    if (!container[listName]) container[listName] = { list: [], map: {} };
    var id = obj[idName];
    if (!id || !id.length) return;
    var existing = container[listName].map[id];
    if (!existing) {
      container[listName].list.push(obj);
      container[listName].map[id] = obj;
      return obj;
    }
    else {
      ForKeys(obj, function (item, name) {
        existing[name] = item;
      });
      return existing;
    }
  }
  function AddObject(obj, listName, idName) {
    AddToContainer(iservice.tenant, obj, listName, idName);
  }
  function AddObjectSegment(obj, listName, idName, segmentIDName) {
    AddObject(obj, listName, idName);
    var segment = GetSegment(obj[segmentIDName]);
    if (segment) {
      AddToContainer(segment, obj, listName, idName);
    }
  }
  iservice.AdminList = function ($http, serviceName, types, callback, idPrefix) {
    var willReturn = {};
    var typesList = '';
    for (var i = 0; i < types.length; i++) {
      var type = types[i];
      if (type == 'segments' && iservice.tenant.segmentsLoaded) { willReturn.segments = iservice.tenant.segments.list; continue; }
      if (type == 'forms' && iservice.tenant.formsLoaded) { willReturn.forms = iservice.tenant.forms.list; continue; }
      if (type == 'formsbuiltin' && iservice.tenant.formsbuiltinLoaded) { willReturn.formsbuiltin = iservice.tenant.formsbuiltin.list; continue; }
      if (type == 'websites' && iservice.tenant.websitesLoaded) { willReturn.websites = iservice.tenant.websites.list; continue; }
      if (type == 'contactProperties' && iservice.tenant.contactPropertiesLoaded) { willReturn.contactProperties = iservice.tenant.contactProperties.list; continue; }
      if (type == 'intProperties' && iservice.tenant.intPropertiesLoaded) { willReturn.intProperties = iservice.tenant.intProperties.list; continue; }
      if (type == 'topics' && iservice.tenant.topicsLoaded) { willReturn.topics = iservice.tenant.topics.list; continue; }
      if (type == 'filters' && iservice.tenant.filtersLoaded) { willReturn.filters = iservice.tenant.filters.list; continue; }
      if (type == 'departments' && iservice.tenant.departmentsLoaded) { willReturn.departments = iservice.tenant.departments.list; continue; }
      if (type == 'autoResponses' && iservice.tenant.autoResponsesLoaded) { willReturn.autoResponses = iservice.tenant.autoResponses.list; continue; }
      if (type == 'externalNotify' && iservice.tenant.externalNotifyLoaded) { willReturn.externalNotify = iservice.tenant.externalNotify.list; continue; }
      if (type == 'mailboxes' && iservice.tenant.mailboxesLoaded) { willReturn.mailboxes = iservice.tenant.mailboxes.list; continue; }
      if (type == 'agents' && iservice.tenant.agentsLoaded) { willReturn.agents = iservice.tenant.agents.list; continue; }
      typesList += ',' + type;
    }
    if (!typesList.length) { callback(willReturn); return function () { return false; } }
    typesList += ',';
    return ServicePost($http, idPrefix, serviceName, 'webapp-api-admin?api=lists', { types: typesList }, function (data) {
      if (data.segments) { for (var i = 0; i < data.segments.length; i++) { iservice.tenant.segmentsLoaded = true; iservice.tenant.AddSegment(data.segments[i]); } willReturn.segments = iservice.tenant.segments ? iservice.tenant.segments.list : []; }
      if (data.forms) { for (var i = 0; i < data.forms.length; i++) { iservice.tenant.formsLoaded = true; iservice.tenant.AddForm(data.forms[i]); } willReturn.forms = iservice.tenant.forms ? iservice.tenant.forms.list : []; }
      if (data.formsbuiltin) { for (var i = 0; i < data.formsbuiltin.length; i++) { iservice.tenant.formsbuiltinLoaded = true; iservice.tenant.AddFormBuiltin(data.formsbuiltin[i]); } willReturn.formsbuiltin = iservice.tenant.formsbuiltin ? iservice.tenant.formsbuiltin.list : []; }
      if (data.websites) { for (var i = 0; i < data.websites.length; i++) { iservice.tenant.websitesLoaded = true; iservice.tenant.AddWebsite(data.websites[i]); } willReturn.websites = iservice.tenant.websites ? iservice.tenant.websites.list : []; }
      if (data.contactProperties) { for (var i = 0; i < data.contactProperties.length; i++) { iservice.tenant.contactPropertiesLoaded = true; iservice.tenant.AddContactProperty(data.contactProperties[i]); } willReturn.contactProperties = iservice.tenant.contactProperties ? iservice.tenant.contactProperties.list : []; }
      if (data.intProperties) { for (var i = 0; i < data.intProperties.length; i++) { iservice.tenant.intPropertiesLoaded = true; iservice.tenant.AddInteractionProperty(data.intProperties[i]); } willReturn.intProperties = iservice.tenant.intProperties ? iservice.tenant.intProperties.list : []; }
      if (data.topics) { for (var i = 0; i < data.topics.length; i++) { iservice.tenant.topicsLoaded = true; iservice.tenant.AddTopic(data.topics[i]); } willReturn.topics = iservice.tenant.topics ? iservice.tenant.topics.list : []; }
      if (data.filters) { for (var i = 0; i < data.filters.length; i++) { iservice.tenant.filtersLoaded = true; iservice.tenant.AddFilter(data.filters[i]); } willReturn.filters = iservice.tenant.filters ? iservice.tenant.filters.list : []; }
      if (data.departments) { for (var i = 0; i < data.departments.length; i++) { iservice.tenant.departmentsLoaded = true; iservice.tenant.AddDepartment(data.departments[i]); } willReturn.departments = iservice.tenant.departments ? iservice.tenant.departments.list : []; }
      if (data.autoResponses) { for (var i = 0; i < data.autoResponses.length; i++) { iservice.tenant.autoResponsesLoaded = true; iservice.tenant.AddAutoResponse(data.autoResponses[i]); } willReturn.autoResponses = iservice.tenant.autoResponses ? iservice.tenant.autoResponses.list : []; }
      if (data.externalNotify) { for (var i = 0; i < data.externalNotify.length; i++) { iservice.tenant.externalNotifyLoaded = true; iservice.tenant.AddExternalNotify(data.externalNotify[i]); } willReturn.externalNotify = iservice.tenant.externalNotify ? iservice.tenant.externalNotify.list : []; }
      if (data.mailboxes) { for (var i = 0; i < data.mailboxes.length; i++) { iservice.tenant.mailboxesLoaded = true; iservice.tenant.AddMailbox(data.mailboxes[i]); } willReturn.mailboxes = iservice.tenant.mailboxes ? iservice.tenant.mailboxes.list : []; }
      if (data.agents) { for (var i = 0; i < data.agents.length; i++) { iservice.tenant.agentsLoaded = true; iservice.tenant.AddAgent(data.agents[i]); } willReturn.agents = iservice.tenant.agents ? iservice.tenant.agents.list : []; }
      callback(willReturn);
    });
  };

  iservice.ProcessLogin = function (loggedIn) {
    iservice.loggedIn = loggedIn;
    iservice.accessRights = {};
    for (var i = 0, len = loggedIn.accessRights.length; i < len; i++) {
      iservice.accessRights[loggedIn.accessRights[i]] = true;
    }
  }
  iservice.SanitizeMSJsonDate = function (str) {
    if (str instanceof Date) return str;
    var ms = parseInt(str.replace('/Date(', '').replace(')/', ''));
    return new Date(ms);
  }
  iservice.SetPropertyValue = function (groups, propertyName, value) {
    if (!groups) return;
    groups.forEach(function (group) {
      group.properties.forEach(function (property) {
        if (property.name == propertyName) property.values = [{ value: value }];
      });
    });
  }
  function hasValue(obj, key, value) {
    return obj.hasOwnProperty(key) && obj[key] === value;
  }
  iservice.SanitizePropertyGroups = function (groups) {
    if (!groups) return;
    for (var g = 0; g < groups.length; g++) for (var p = 0; p < groups[g].properties.length; p++) { 
      var property = groups[g].properties[p];
      if (property.className) continue;
      property.className = 'property-' + ClassName(property.name);
      if (property.valueChoices && property.valueChoices.length) {
        var choiceList = [];
        
        for (var i = 0; i < property.valueChoices.length; i++) {
          if (typeof property.valueChoices[i] == 'string') {
            choiceList.push({ name: property.valueChoices[i], value: property.valueChoices[i] });
          }
        }
        if (choiceList.length > 0) {
          property.valueChoices = choiceList;
        }
      }
      if (!property.isReadOnly) {
        var propObj = property.valueChoices;
        var checkAlreadyExists = propObj.some(function (data) { return hasValue(data, "name", '-- select a value --'); });

        //check if this option is not exists already then add
        if (!checkAlreadyExists) {
          if (property.valueChoices.length) property.valueChoices.push({ name: '-- select a value --', value: '' }); 
        }        
        if (property.values.length == 0) { 
          var value = { 'description': null, 'value': '', valueDate: null, valueDatetime: null }; 
          if (property.descriptionChoices.length) value.description = property.descriptionChoices[0]; 
          property.values.push(value); 
        } 
      } 
      for (var v = 0; v < property.values.length; v++) { 
        var value = property.values[v]; 
        if (value.valueDateUtc) {
          value.valueDate = moment(value.valueDateUtc).toDate();
        } 
        if (value.valueDatetimeUtc) {
          value.valueDatetime = moment(value.valueDatetimeUtc).toDate();
        }
      }
    } 
    return groups;
  }
  iservice.SanitizeHistoryRows = function (rows) {
    if (!rows) return;
    for (var i = 0; i < rows.length; i++) {
      iservice.SanitizeHistoryRow(rows[i]);
    }
  }
  iservice.SanitizeHistoryRow = function (row) {
    if (row.date) row.dateObj = new Date(row.date);
    if (row.properties) {
      ForArray(row.properties, function (property) {
        ForArray(property.values, function (value) {
          if (value.valueDateUtc) {
            value.valueDate = moment(value.valueDateUtc).toDate();
          }
        });
      });
    }
  }
  var genericMimeType = 'fa-file-o';
  var fileNameRegex = /.+\.(\w+)$/g;
  function getFileExtensionIcon(fileName, type)
  {
    if (!type) {
      fileName = fileName.split('(');
      fileName = fileName[0].trim();
    }
    var match = fileNameRegex.exec(fileName);
    if(!match)
      return genericMimeType;

    var extension = match[1];

    switch(extension)
    {
      case 'xls':
      case 'xlsx':
        return 'fa-file-excel-o';

      case 'pdf':
        return 'fa-file-pdf-o';

      case 'wav':
      case 'mpeg':
      case 'mp3':
      case 'ogg':
        return 'fa-file-audio-o';

      case 'doc':
      case 'docx':
        return 'fa-file-word-o';

      case 'zip':
      case '7z':
      case 'rar':
        return 'fa-file-archive-o';

      case 'gif':
      case 'png':
      case 'jpeg':
      case 'jpg':
      case 'bmp':
      case 'svg':
      case 'webp':
      case 'ico':
        return 'fa-file-image-o';

      case 'txt':
      case 'html':
      case 'css':
      case 'js':
      case 'md':
        return 'fa-file-text-o';

      case 'webm':
      case 'mp4':
      case 'avi':
        return 'fa-file-video-o';

      case 'ppt':
      case 'pptx':
        return 'fa-file-powerpoint-o';
    }

    return genericMimeType;
  }
  iservice.AttachmentIcons = function (attachments) {
    if (!attachments || !attachments.length) return;
    attachments.forEach(function (attachment) {
      attachment.iconClass = attachment.type ? getFileExtensionIcon(attachment.name, attachment.type) : getFileExtensionIcon(attachment.name, null);
    });
  }
  iservice.SanitizeHistoryDetails = function (details) {
    if (details.date) details.dateObj = new Date(details.date);
    if (details.interactionProperties) iservice.SanitizePropertyGroups(details.interactionProperties);
    if (details.caseProperties) iservice.SanitizePropertyGroups(details.caseProperties);
    if (details.statusAudit) for (var i = 0, len = details.statusAudit.length; i < len; i++) {
      details.statusAudit[i].timeStamp = iservice.SanitizeMSJsonDate(details.statusAudit[i].timeStamp);
    }
    if (details.attachments && details.bodyHtml) iservice.SanitizeInlineImageAttachments(details, 'bodyHtml', details.attachments);
    if (details.attachments) iservice.AttachmentIcons(details.attachments);
  }
  iservice.SanitizeInlineImageAttachments = function (hasBodyHtml, bodyVar, attachments, guid) {
    if (!attachments) return;
    if (!hasBodyHtml.removedInlineAttachments) hasBodyHtml.removedInlineAttachments = [];
    for (var i = 0; i < attachments.length; i++) {
      var attach = attachments[i];
      var idParam = guid ? 'guid=' + guid : 'interactionID=' + attach.interactionID;
      var oldSrc = 'src="cid:' + attach.contentID + '"';
      var newSrc = 'src="' + rootPath + 'File.aspx?' + idParam + '&amp;fileID=' + attach.attachmentID + '"';
      if (hasBodyHtml[bodyVar].lastIndexOf(oldSrc) !== -1) {
        hasBodyHtml[bodyVar] = hasBodyHtml[bodyVar].replace(oldSrc, newSrc);
      }
      if (hasBodyHtml[bodyVar].lastIndexOf(newSrc) !== -1) {
        attach.isInline = true;
        hasBodyHtml.removedInlineAttachments.push(attach);
      }
    }
  }
  iservice.HaveDownloadableAttachments = function (details) {
    if (details.attachments.haveDownloadable !== undefined) return details.attachments.haveDownloadable;
    for (var i = 0; i < details.attachments.length; i++) {
      var attach = details.attachments[i];
      if (attach.attachmentID == 'email') continue;
      if (attach.isInline === true) continue;
      details.attachments.haveDownloadable = true;
      return true;
    }
    details.attachments.haveDownloadable = false;
    return false;
  }
  iservice.RemoveInlineImageAttachmentsForFA = function (attachments) {
    if (!attachments) return;
    if (attachments.length) {
      attachments = attachments.filter(function (x) {
        return x.contentID == null
      });
    }
    return attachments;
  }
  iservice.ReplaceInlineImageRefrences = function (hasBodyHtml, bodyVar, guid) {
    if (!hasBodyHtml.removedInlineAttachments) return;
    for (var i = 0; i < hasBodyHtml.removedInlineAttachments.length; i++) {
      var attach = hasBodyHtml.removedInlineAttachments[i];
      var oldSrc = 'src="cid:' + attach.contentID + '"';
      var idParam = guid ? 'guid=' + guid : 'interactionID=' + attach.interactionID;
      var newSrc = 'src="' + rootPath + 'File.aspx?' + idParam + '&amp;fileID=' + attach.attachmentID + '"';
      if (hasBodyHtml[bodyVar].lastIndexOf(newSrc) !== -1) {
        hasBodyHtml[bodyVar] = hasBodyHtml[bodyVar].replace(newSrc, oldSrc);
      }
    }
  }
  iservice.CollectItemIDs = function (items, idName, checkedName) {
    var ids = [];
    for (var i = 0; i < items.length; i++) {
      var item = items[i];
      if (!checkedName || item[checkedName]) ids.push(item[idName]);
    }
    return ids;
  }
  iservice.FindProp = function (segments, name) {
    for (var i = 0; i < segments.length; i++) {
      for (var j = 0; j < segments[i].properties.length; j++) {
        var prop = segments[i].properties[j];
        if (prop.name == name) return prop;
      }
    }
  }
  iservice.CollectProperties = function (groups) {
    var properties = [];
    for (var g = 0; g < groups.length; g++) for (var p = 0; p < groups[g].properties.length; p++) { 
      var source = groups[g].properties[p];
      if (source.isReadOnly) continue;
      var prop = { propertyID: source.propertyID,propertyName: source.name, values: [] }; 
      properties.push(prop);
     
      for (var v = 0; v < source.values.length; v++) { 
        var val = source.values[v]; 
        var value;
        if (source.isDate) {
          if (!val.valueDate) continue; 
          var off = moment(val.valueDate).utcOffset();
          value = { valueDateUtc: moment(val.valueDate).add(off, 'm').toISOString() };
        }
        else if (source.isDatetime) {
          if (!val.valueDatetime) continue;
          value = { valueDatetimeUtc: val.valueDatetime.toISOString() };
        }
        else if (source.isInteger) {
          if (!val.hasOwnProperty('valueInt')) continue;
          if (val.valueInt === undefined || val.valueInt === null) continue;
          value = { value: '', valueInt: val.valueInt };
        }
        else if (source.isNumber) {
          if (!val.hasOwnProperty('valueNumber')) continue;
          if (val.valueNumber === undefined || val.valueNumber === null) continue;
          value = { value: '', valueNumber: val.valueNumber };
        }
        else {
          if (!val.value || val.value.length < 1) continue;
          value = { value: val.value };
        }
        if (source.hasDescriptions) { 
          value.description = val.description; 
        } 
        prop.values.push(value); 
      } 
    }
    return properties; 
  }
  iservice.CountProperties = function (groups) {
    if (!groups) return 0;
    var total = 0;
    for (var g = 0; g < groups.length; g++) total += groups[g].properties.length;
    return total;
  }
  iservice.CollectLogins = function (groups) { 
    var logins = []; 
    for (var g = 0; g < groups.length; g++) if (groups[g].logins) for (var l = 0; l < groups[g].logins.length; l++) { 
      var source = groups[g].logins[l]; 
      if (!source.name) continue;
      logins.push(source);
    } 
    return logins; 
  }
  iservice.PropertyValueString = function (property) {
    if (!property) return '';
    if (property.values.length < 1) return '';
    var value = property.values[0];
    if (property.isDate) {
      var date = value.valueDate;
      if (!date) return '';
      return moment(date).format('YYYY-MM-DD');
    }
    if (property.isInteger) return '' + value.valueInt;
    if (property.isNumber) return '' + value.valueNumber;
    if (property.valueChoices.length) return value.value;
    return value.value.trim();
  }
  iservice.PropertyValueNumber = function (property) {
    if (!property) return 0;
    if (property.values.length < 1) return 0;
    var value = property.values[0];
    if (property.isInteger) return value.valueInt ? value.valueInt : 0;
    if (property.isNumber) return value.valueNumber ? value.valueNumber : 0;
    return 0;
  }
  iservice.PropertyValueExists = function (property) {
    if (!property) return false;
    if (property.values.length < 1) return false;
    var value = property.values[0];
    if (property.isDate) {
      var date = value.valueDate;
      return date ? true : false;
    }
    if (property.isDatetime) {
      var datetime = value.valueDatetime;
      return datetime ? true : false;
    }
    if (property.isInteger) return value.valueInt == null || value.valueInt == undefined ? false : true;
    if (property.isNumber) return value.valueNumber == null || value.valueNumber == undefined ? false : true;
    if (property.valueChoices.length) return value.value.length > 0;
    return value.value.trim().length > 0;
  }

  iservice.CanModifyLogins = function (groups) {
    for (var i = 0; i < groups.length; i++) if (groups[i].logins && groups[i].logins.length && groups[i].canModifyLogins) return true;
    return false;
  }
  function IncludeProperties(answerData, label, groups, memberName) {
    if (!groups || !groups.length) return;
    iservice.SanitizePropertyGroups(groups);
    answerData.propertySections.push({ label: label, groups: groups, memberName: memberName }); 
  }
  iservice.SanitizeAnswerData = function (details, answer, answerData, guid) {
    if (details.date) details.dateObj = new Date(details.date);
    answerData.propertySections = [];
    answer.caseProperties = null;
    answer.interactionProperties = null;
    answer.responseProperties = null;
    answer.leaveOpen = null;
    answer.expectReply = null;
    answer.supressSubjectRef = null;
    answer.notificationID = null;
    IncludeProperties(answerData, 'Case Properties (#' + details.threadID + ')', details.caseProperties, 'threadProperties');
    IncludeProperties(answerData, details.type + ' Properties (#' + details.id + ')', details.interactionProperties, 'messageProperties');
    IncludeProperties(answerData, 'Answer Properties', details.responseProperties, 'answerProperties');
    answer.bodyHtml = details.responseHtml;
    iservice.AttachmentIcons(details.attachments);
    iservice.AttachmentIcons(details.responseAttachments);
    iservice.SanitizeInlineImageAttachments(answer, 'bodyHtml', details.attachments, guid);
    iservice.SanitizeInlineImageAttachments(answer, 'bodyHtml', details.responseAttachments, guid);
    answer.bodyHtml = answer.bodyHtml.replace(/\r\n/g, '\n');
    answer.subject = details.responseSubject;
    answer.mailboxID = details.defaultMailboxID;
    answer.note = details.note;
    answerData.responseAttachments = details.responseAttachments;
    answer.attachments = [];
    if (details.responseAttachments) details.responseAttachments.forEach(function (attach) {
      answer.attachments.push(attach.attachmentID);
    });
    details.countNonInlineAttachments = 0;
    if (details.attachments) details.attachments.forEach(function (attach) {
      if (!attach.isInline) details.countNonInlineAttachments++;
    });
  }
  iservice.WebsiteGetPlaceholder = function (website, name) {
    var value = null;
    ForArray(website.placeholders, function (placeholder) {
      if (placeholder.name == name) {
        value = placeholder.value;
        return false;
      }
    });
    return value;
  }
  iservice.UserErrors = function (data) {
    var errors = [];
    if (!data || !data.errors || !data.errors.length) return errors;
    ForArray(data.errors, function (error, i) {
      var details = null;
      if (data && data.errorDetails && data.errorDetails.length > i) {
        details = data.errorDetails[i];
      }
      errors.push(details ? { msg: error, details: details } : error);
    });
    return errors;
  }
  iservice.FindPropertyValue = function (sections, id) {
    var value = '';
    ForArray(sections, function (section) {
      ForArray(section.groups, function (group) {
        ForArray(group.properties, function (property) {
          if (property.propertyID == id) value = property.values[0].value;
        });
      });
    });
    return value;
  }
  iservice.MessagesContainer = function ($scope) {
    $scope.messages = {
      names: ['saveErrors', 'saveSuccess', 'createErrors', 'createSuccess', 'deleteErrors', 'deleteSuccess', 'toggleErrors', 'toggleSuccess'],
      Clear: function () {
        $scope.messages.names.forEach(function (name) {
          $scope.messages[name] = null;
        });
      }
    };
  }

  var promises = {};
  var promiseIndex = 0;
  function ServicePost($http, idPrefix, actionName, url, params, callback, suppressErrors)
  {
    params.__TZO__ = jstz.determine_timezone().offset();
    params._pageAction = (idPrefix ? idPrefix + '/' : '') + actionName;
    params._pageName = iservice.pageName;
    var promiseName = actionName + promiseIndex;
    var us = promises[promiseName];
    promiseIndex = promiseIndex + 1;
    if (us === undefined) {
      us = {
        Running: function () {
          return us.promise;
        }
      };
      promises[promiseName] = us;
    }
    if (!us.promise) {
      us.promise = $http.post(rootPath + 'f/' + url, params).then(function (angularHttpResponse)
      {
        if (!suppressErrors) iservice.UserErrors(angularHttpResponse.data);
        callback && callback(angularHttpResponse.data);
      }).finally(function () {
        us.promise = null;
      });
    }
    us.Running.actionName = actionName + ': ' + idPrefix;
    return us.Running;
  }
  iservice.ServicePost = ServicePost;
  function ServiceSubmit($scope, idPrefix, actionName, url, params, callback, suppressErrors)
  {
    var promiseName = idPrefix + promiseIndex
    var us = promises[promiseName];
    promiseIndex = promiseIndex + 1;
    if (us === undefined) {
      us = {
        Running: function () {
          return !!us.callback;
        }
      };
      promises[promiseName] = us;
    }
    if (!us.callback) {
      us.callback = callback;
      var body = $('body');
      var uploads = $('input[type="file"][id^="'+idPrefix+'"]');
      var form = document.createElement('form');
      var iframe = document.createElement('iframe');
      form.name = idPrefix + 'form';
      iframe.name = idPrefix + 'postFrame';
      form.id = form.name;
      form.method = 'POST';
      form.action = rootPath + 'f/' + url;
      form.target = iframe.name;
      form.enctype = 'multipart/form-data';
      form = $(form);
      iframe = $(iframe);
      form.hide().appendTo(body);
      iframe.hide().appendTo(body);
      uploads.each(function () {
        var us = $(this);
        us.clone().insertAfter(us);
        us.appendTo(form);
      });
      if (!params) params = {};
      params._pageAction = (idPrefix ? idPrefix + '/' : '') + actionName;
      params._pageName = iservice.pageName;
      params.callback = promiseName;
      ForKeys(params, function (value, name) {
        var input = document.createElement('input');
        input.type = 'hidden';
        input.name = name;
        if (typeof value === 'string' || value instanceof String) input.value = value;
        else if (typeof value === 'boolean') input.value = '' + value;
        else input.value = angular.toJson(value);
        $(input).appendTo(form);
      });
      postDoneCallbacks[promiseName] = function (data) {
        $scope.$apply(function () {
          if (!suppressErrors) iservice.UserErrors(data);
          us.callback = null;
          form.remove();
          callback(data);
        });
      };
      form[0].submit();
    }
    us.Running.actionName = actionName + ': ' + idPrefix;
    return us.Running;
  }
  iservice.ServiceSubmit = ServiceSubmit;
  iservice.HaveRight = function (name) { return iservice.accessRights[name]; }
  iservice.HaveSegment = function (segmentID) {
    if (iservice.loggedIn.accessibleSegments.includes(segmentID)) return true;
    return false;
  }
  iservice.LoggedIn = function ($http, callback, idPrefix) { return ServicePost($http, idPrefix, 'LoggedIn', 'webapp-api-login?api=loggedin', { }, callback); };
  iservice.Logout = function ($http, callback, idPrefix) { return ServicePost($http, idPrefix, 'Logout', 'webapp-api-login?api=logout', {}, callback); };
  iservice.Login = function ($http, emailAddress, password, callback, idPrefix) { return ServicePost($http, idPrefix, 'Login', 'webapp-api-login?api=login', { emailAddress: emailAddress, password: password }, callback); };
  iservice.LoginAgent = function ($http, callback, idPrefix) { return ServicePost($http, idPrefix, 'Login', 'webapp-api-login?api=agentlogin', { }, callback); };
  iservice.LoginRegister = function ($http, inputs, callback, idPrefix) { return ServicePost($http, idPrefix, 'LoginRegister', 'webapp-api-login?api=register', inputs, callback); };
  iservice.OpenIDRegister = function ($http, idToken, provider, callback, idPrefix) { return ServicePost($http, idPrefix, 'OpenIDRegister', 'webapp-api-login?api=registeropenid', { token: idToken, provider: provider }, callback); };
  iservice.ChatToggleAvail = function ($http, idPrefix) { return ServicePost($http, idPrefix, 'ChatToggleAvail', 'webapp-api-agentchat?api=toggleavail', {}, function () { }); };
  iservice.ChatAnswer = function ($http, idPrefix) { return ServicePost($http, idPrefix, 'ChatAnswer', 'webapp-api-agentchat?api=answer', {}, function () { }); };
  iservice.ChatEnd = function ($http, activeChatID, callback, idPrefix) { return ServicePost($http, idPrefix, 'ChatEnd', 'webapp-api-agentchat?api=end', { interactionID: activeChatID }, callback); };
  iservice.ChatUnqueue = function ($http, interactionID, callback, idPrefix) { return ServicePost($http, idPrefix, 'ChatUnqueue', 'webapp-api-agentchat?api=forward&mode=unqueue', { interactionID: interactionID }, callback); };
  iservice.ChatAssignTo = function ($http, interactionID, contactID, callback, idPrefix) { return ServicePost($http, idPrefix, 'ChatAssignTo', 'webapp-api-agentchat?api=forward&mode=assign', { interactionID: interactionID, assignToID: contactID }, callback); };
  iservice.ChatAgentList = function ($http, interactionID, callback, idPrefix) { return ServicePost($http, idPrefix, 'ChatAgentList', 'webapp-api-agentchat?api=agentlist', { interactionID: interactionID }, callback); };
  iservice.ChatTopicList = function ($http, callback, idPrefix) { return ServicePost($http, idPrefix, 'ChatTopicList', 'webapp-api-agentchat?api=topiclist', {}, callback); };
  iservice.ChatChangeTopic = function ($http, interactionID, topicID, callback, idPrefix) { return ServicePost($http, idPrefix, 'ChatChangeTopic', 'webapp-api-agentchat?api=forward&mode=topic', { interactionID: interactionID, topicID: topicID }, callback); };
  iservice.ChatSend = function ($http, interactionID, messageHtml, callback, idPrefix) { return ServicePost($http, idPrefix, 'ChatSend', 'webapp-api-agentchat?api=send', { interactionID: interactionID, message: messageHtml }, callback); };
  iservice.UserChatIsAvailable = function ($http, topicID, callback, idPrefix) { return ServicePost($http, idPrefix, 'UserChatIsAvailable', 'webapp-api-userchat?api=isavail', { topicID: topicID }, callback); };
  iservice.UserChatAskAQuestion = function ($http, email, properties, subject, body, topicID, callback, idPrefix) { return ServicePost($http, idPrefix, 'UserChatAskAQuestion', 'webapp-api-userchat?api=aaq', { email: email, properties: properties, subject: subject, body: body, topicID: topicID }, callback); };
  iservice.UserChatStart = function ($http, email, properties, subject, body, topicID, callback, idPrefix) { return ServicePost($http, idPrefix, 'UserChatStart', 'webapp-api-userchat?api=start', { email: email, properties: properties, subject: subject, body: body, topicID: topicID }, callback); };
  iservice.UserChatSend = function ($http, chatGuid, message, callback, idPrefix) { return ServicePost($http, idPrefix, 'UserChatSend', 'webapp-api-userchat?api=send', { chatGuid: chatGuid, message: message }, callback); };
  iservice.UserChatKeepAlive = function ($http, chatGuid, callback, idPrefix) { return ServicePost($http, idPrefix, 'UserChatKeepAlive', 'webapp-api-userchat?api=keepalive', { chatGuid: chatGuid }, callback); };
  iservice.UserChatEnd = function ($http, chatGuid, callback, idPrefix) { return ServicePost($http, idPrefix, 'UserChatEnd', 'webapp-api-userchat?api=end', { chatGuid: chatGuid }, callback); };
  iservice.ContactSearch = function ($http, fields, callback, idPrefix) { return ServicePost($http, idPrefix, 'ContactSearch', 'webapp-api-custinfo?api=search', { fields: fields }, callback); };
  iservice.MessageSearch = function ($http, fields, pageNum, perPage, sort, callback, idPrefix) { return ServicePost($http, idPrefix, 'MessageSearch', 'webapp-api-mq-search?api=search', { fields: fields, pageNum: pageNum, perPage: perPage, sort: sort }, callback); };
  iservice.ManageChatDetails = function ($http, chatID, customerID, callback, idPrefix) { return ServicePost($http, idPrefix, 'ManageChatDeatils', 'webapp-api-mq-managechats?api=details', { chatID: chatID, customerID: customerID }, callback); };
  iservice.ManageChatAgentList = function ($http, chatID, callback, idPrefix) { return ServicePost($http, idPrefix, 'ManageChatAgentList', 'webapp-api-mq-managechats?api=agentlist', { chatID: chatID }, callback); };
  iservice.ManageChatAgentSummary = function ($http, search, callback, idPrefix) { return ServicePost($http, idPrefix, 'ManageChatAgentSummary', 'webapp-api-mq-managechats?api=agentsummary', { fields: search }, callback); };
  iservice.MyQueueInboxes = function ($http, callback, idPrefix) { return ServicePost($http, idPrefix, 'MyQueueInboxes', 'webapp-api-mq-myqueue?api=inboxes', {}, callback); };
  iservice.MyQueueGetNext = function ($http, callback, idPrefix) { return ServicePost($http, idPrefix, 'MyQueueGetNext', 'webapp-api-mq-myqueue?api=getnext', {}, callback); };
  iservice.MyQueueGetApprove = function ($http, callback, idPrefix) { return ServicePost($http, idPrefix, 'MyQueueGetApprove', 'webapp-api-mq-myqueue?api=getapprove', {}, callback); };
  iservice.MyQueueDetails = function ($http, interactionID, customerID, segmentID, callback, idPrefix) { return ServicePost($http, idPrefix, 'MyQueueDetails', 'webapp-api-mq-myqueue?api=details', { interactionID: interactionID, customerID: customerID, segmentID: segmentID }, callback); };
  iservice.GetThis = function ($http, interactionID, customerID, segmentID, callback, idPrefix) { return ServicePost($http, idPrefix, 'GetThis', 'webapp-api-mq-myqueue?api=getthis', { interactionID: interactionID, interactionIDs: [interactionID], customerID: customerID, segmentID: segmentID, answer: { isMassUpdate: true, reassignAgentID: iservice.loggedIn.contactID } }, callback); };
  iservice.Assign = function ($scope, idPrefix, interactionIDs, answer, callback) { return ServiceSubmit($scope, idPrefix, 'Assign', 'webapp-api-mq-myqueue?api=assign', { interactionIDs: interactionIDs, answer: answer }, callback); };
  iservice.MyQueueThread = function ($http, threadID, callback, idPrefix) { return ServicePost($http, idPrefix, 'MyQueueThread', 'webapp-api-mq-myqueue?api=thread', { threadID: threadID }, callback); };
  iservice.MyQueueAgents = function ($http, interactionID, callback, idPrefix) { return ServicePost($http, idPrefix, 'MyQueueAgents', 'webapp-api-mq-myqueue?api=agents', { interactionID: interactionID }, callback); };
  iservice.MyQueueForwardMailboxes = function ($http, callback, idPrefix) { return ServicePost($http, idPrefix, 'MyQueueForwardMailboxes', 'webapp-api-mq-myqueue?api=forwardmailboxes', { }, callback); };
  iservice.HistoryThreads = function ($http, contactID, callback, idPrefix) { return ServicePost($http, idPrefix, 'HistoryThreads', 'webapp-api-history?api=threads', { contactID: contactID }, callback); };
  iservice.HistoryChildren = function ($http, threadID, callback, idPrefix) { return ServicePost($http, idPrefix, 'HistoryChildren', 'webapp-api-history?api=children', { threadID: threadID }, callback); };
  iservice.HistorySMS = function ($http, threadID, callback, idPrefix) { return ServicePost($http, idPrefix, 'HistoryChildren', 'webapp-api-sms', { threadID: threadID }, callback); };
  iservice.HistoryDetails = function ($http, interactionID, callback, idPrefix) { return ServicePost($http, idPrefix, 'HistoryDetails', 'webapp-api-history?api=details', { interactionID: interactionID }, callback); };
  iservice.HistoryPropertySet = function ($http, interactionID, values, caseValues, callback, idPrefix) { return ServicePost($http, idPrefix, 'HistoryPropertySet', 'webapp-api-history?api=propertyset', { interactionID: interactionID, values: values, caseValues: caseValues }, callback); };
  iservice.HistoryStartAgentEmail = function ($http, interactionID, topicID, segmentID, customerID, callback, idPrefix) { return ServicePost($http, idPrefix, 'HistoryStartAgentEmail', 'webapp-api-history?api=startagentemail', { topicID: topicID, interactionID: interactionID, segmentID: segmentID, customerID: customerID }, callback); };
  iservice.HistoryStartNote = function ($http, interactionID, topicID, segmentID, callback, idPrefix) { return ServicePost($http, idPrefix, 'HistoryStartNote', 'webapp-api-history?api=startnote', { interactionID: interactionID, segmentID: segmentID, topicID: topicID }, callback); };
  iservice.HistoryStartForwardEmail = function ($http, interactionID, segmentID, callback, idPrefix) { return ServicePost($http, idPrefix, 'HistoryStartForwardEmail', 'webapp-api-history?api=startforwardemail', { interactionID: interactionID, segmentID: segmentID }, callback); };
  iservice.CustInfoNewContact = function ($http, details, membership, callback, idPrefix) { return ServicePost($http, idPrefix, 'CustInfoNewContact', 'webapp-api-custinfo?api=newcontact', { details: details, membership: membership }, callback); };
  iservice.CustInfoDetails = function ($http, contactID, callback, idPrefix) { return ServicePost($http, idPrefix, 'CustInfoDetails', 'webapp-api-custinfo?api=details', { contactID: contactID }, callback); };
  iservice.CustInfoSetDetails = function ($http, contactID, details, membership, callback, idPrefix) { return ServicePost($http, idPrefix, 'CustInfoSetDetails', 'webapp-api-custinfo?api=setdetails', { contactID: contactID, details: details, membership: membership }, callback); };
  iservice.CustInfoGetSubscriptions = function ($http, contactID, callback, idPrefix) { return ServicePost($http, idPrefix, 'CustInfoSubscriptions', 'webapp-api-custinfo?api=subscriptions', { contactID: contactID }, callback); };
  iservice.CustInfoSetSubscriptions = function ($http, contactID, subscriptions, callback, idPrefix) { return ServicePost($http, idPrefix, 'CustInfoSubscriptions', 'webapp-api-custinfo?api=setsubscriptions', { contactID: contactID, subscriptions: subscriptions }, callback); };
  iservice.CustInfoStartAgentEmail = function ($http, topicID, callback, idPrefix) { return ServicePost($http, idPrefix, 'CustInfoStartAgentEmail', 'webapp-api-custinfo?api=startagentemail', { topicID: topicID }, callback); };
  iservice.AgentEmailSend = function ($scope, idPrefix, details, callback) { return ServiceSubmit($scope, idPrefix, 'AgentEmailSend', 'webapp-api-custinfo?api=createemail', { details: details }, callback); };
  iservice.ForwardEmailSend = function ($scope, idPrefix, email, details, callback) { return ServiceSubmit($scope, idPrefix, 'ForwardEmailSend', 'webapp-api-custinfo?api=forwardemail', { details: details, email: email }, callback); };
  iservice.TicketCreate = function ($scope, idPrefix, details, callback) { return ServiceSubmit($scope, idPrefix, 'TicketCreate', 'webapp-api-custinfo?api=createticket', { details: details }, callback); };
  iservice.NoteCreate = function ($scope, idPrefix, details, callback) { return ServiceSubmit($scope, idPrefix, 'NoteCreate', 'webapp-api-custinfo?api=createnote', { details: details }, callback); };
  iservice.ContactNoteCreate = function ($scope, idPrefix, contactID, properties, details, callback) { return ServiceSubmit($scope, idPrefix, 'ContactNoteCreate', 'webapp-api-custinfo?api=contactnote', { contactID: contactID, properties: properties, details: details }, callback); };
  iservice.SaveResolve = function ($scope, idPrefix, interactionIDs, answer, questionID, callback) { return ServiceSubmit($scope, idPrefix, 'SaveResolve', 'webapp-api-mq-myqueue?api=saveresolve', { interactionIDs: interactionIDs, answer: answer }, callback); };
  iservice.Unqueue = function ($scope, idPrefix, interactionIDs, answer, questionID, callback) { return ServiceSubmit($scope, idPrefix, 'Unqueue', 'webapp-api-mq-myqueue?api=unqueue', { interactionIDs: interactionIDs, answer: answer }, callback); };
  iservice.ChangeTopic = function ($scope, idPrefix, interactionIDs, answer, questionID, callback) { return ServiceSubmit($scope, idPrefix, 'ChangeTopic', 'webapp-api-mq-myqueue?api=changetopic', { interactionIDs: interactionIDs, answer: answer, interactionID: questionID }, callback); };
  iservice.MarkSpam = function ($scope, idPrefix, interactionIDs, answer, questionID, callback) { return ServiceSubmit($scope, idPrefix, 'MarkSpam', 'webapp-api-mq-myqueue?api=markspam', { interactionIDs: interactionIDs, answer: answer }, callback); };
  iservice.QAReject = function ($scope, idPrefix, interactionIDs, answer, questionID, callback) { return ServiceSubmit($scope, idPrefix, 'QAReject', 'webapp-api-mq-myqueue?api=qareject', { interactionIDs: interactionIDs, answer: answer }, callback); };
  iservice.SaveDraft = function ($scope, idPrefix, interactionIDs, answer, questionID, callback) { return ServiceSubmit($scope, idPrefix, 'SaveDraft', 'webapp-api-mq-myqueue?api=savedraft', { interactionIDs: interactionIDs, answer: answer, interactionID: questionID  }, callback); };
  iservice.AutoSave = function ($http, answer, questionID, callback, idPrefix) { return ServicePost($http, idPrefix, 'AutoSave', 'webapp-api-mq-myqueue?api=autosave', { answer: answer, interactionID: questionID, interactionIDs: [questionID] }, callback, true); };
  iservice.Assign = function ($scope, idPrefix, interactionIDs, answer, questionID, callback) { return ServiceSubmit($scope, idPrefix, 'Assign', 'webapp-api-mq-myqueue?api=assign', { interactionIDs: interactionIDs, answer: answer }, callback); };
  iservice.SaveNote = function ($scope, idPrefix, interactionIDs, answer, questionID, callback) { return ServiceSubmit($scope, idPrefix, 'SaveNote', 'webapp-api-mq-myqueue?api=savenote', { interactionIDs: interactionIDs, answer: answer, interactionID: questionID, public: answer.isPublic }, callback); };
  iservice.Send = function ($scope, idPrefix, interactionIDs, answer, questionID, callback) { return ServiceSubmit($scope, idPrefix, 'Send', 'webapp-api-mq-myqueue?api=send', { interactionIDs: interactionIDs, answer: answer }, callback); };
  iservice.SendLeaveOpen = function ($scope, idPrefix, interactionIDs, answer, questionID, callback) { return ServiceSubmit($scope, idPrefix, 'SendLeaveOpen', 'webapp-api-mq-myqueue?api=sendleaveopen', { interactionIDs: interactionIDs, answer: answer, interactionID: questionID, public: answer.isPublic }, callback); };
  iservice.ChangeSegment = function ($scope, idPrefix, interactionIDs, answer, questionID, callback) { return ServiceSubmit($scope, idPrefix, 'ChangeSegment', 'webapp-api-mq-myqueue?api=changesegment', { interactionIDs: interactionIDs, answer: answer }, callback); };
  iservice.ForwardExternal = function ($scope, idPrefix, interactionIDs, answer, questionID, callback) { return ServiceSubmit($scope, idPrefix, 'ForwardExternal', 'webapp-api-mq-myqueue?api=forwardexternal', { interactionIDs: interactionIDs, answer: answer }, callback); };
  iservice.ManageMessageTopics = function ($http, fields, callback, idPrefix) { return ServicePost($http, idPrefix, 'ManageMessageTopics', 'webapp-api-mq-managemessage?api=topics', { fields: fields, pageNum: 0, perPage: 2500, sort: null }, callback); };
  iservice.ManageMessageAgents = function ($http, topicID, callback, idPrefix) { return ServicePost($http, idPrefix, 'ManageMessageAgents', 'webapp-api-mq-managemessage?api=agents', { topicID: topicID }, callback); };
  iservice.AdminFormCreate = function ($http, details, callback, idPrefix) { return ServicePost($http, idPrefix, 'AdminFormCreate', 'webapp-api-admin?api=forms&mode=new', { details: details }, callback); };
  iservice.AdminFormDetails = function ($http, formID, callback, idPrefix) { return ServicePost($http, idPrefix, 'AdminFormDetails', 'webapp-api-admin?api=formdetails', { formID: formID }, callback); };
  iservice.AdminFormModify = function ($http, formID, details, callback, idPrefix) { return ServicePost($http, idPrefix, 'AdminFormModify', 'webapp-api-admin?api=forms&mode=modify', { formID: formID, details: details }, callback); };
  iservice.AdminFormDeleteEffects = function ($http, formID, callback, idPrefix) { return ServicePost($http, idPrefix, 'AdminFormDeleteEffects', 'webapp-api-admin?api=formeffects', { formID: formID }, callback); };
  iservice.AdminFormDeleteConfirm = function ($http, formID, callback, idPrefix) { return ServicePost($http, idPrefix, 'AdminFormDeleteConfirm', 'webapp-api-admin?api=forms&mode=delete', { formID: formID }, callback); };
  iservice.AdminWebsiteCreate = function ($http, details, callback, idPrefix) { return ServicePost($http, idPrefix, 'AdminWebsiteCreate', 'webapp-api-admin?api=websites&mode=new', { details: details }, callback); };
  iservice.AdminWebsiteDetails = function ($http, websiteID, callback, idPrefix) { return ServicePost($http, idPrefix, 'AdminWebsiteDetails', 'webapp-api-admin?api=websitedetails', { websiteID: websiteID }, callback); };
  iservice.AdminWebsiteModify = function ($http, websiteID, details, callback, idPrefix) { return ServicePost($http, idPrefix, 'AdminWebsiteModify', 'webapp-api-admin?api=websites&mode=modify', { websiteID: websiteID, details: details }, callback); };
  iservice.AdminWebsiteDeleteConfirm = function ($http, websiteID, callback, idPrefix) { return ServicePost($http, idPrefix, 'AdminWebsiteDeleteConfirm', 'webapp-api-admin?api=websites&mode=delete', { websiteID: websiteID }, callback); };
  iservice.AdminOpenIDDetails = function ($http, callback, idPrefix) { return ServicePost($http, idPrefix, 'AdminOpenIDDetails', 'webapp-api-admin?api=openiddetails', { }, callback); };
  iservice.AdminOpenIDSet = function ($http, details, callback, idPrefix) { return ServicePost($http, idPrefix, 'AdminOpenIDSet', 'webapp-api-admin?api=openidset', { details: details }, callback); };
  iservice.StockResponsesGetAll = function ($http, callback, idPrefix) { return ServicePost($http, idPrefix, 'StockResponsesGetAll', 'webapp-api-mq-myqueue?api=allstock', { }, callback); };
  iservice.StockResponsesGet = function ($http, segmentID, callback, idPrefix) { return ServicePost($http, idPrefix, 'StockResponsesGet', 'dotnetapp-json-stockresponses', { segmentID: segmentID }, callback); };
  iservice.StockResponseGet = function ($http, stockID, callback, idPrefix) { return ServicePost($http, idPrefix, 'StockResponseGet', 'webapp-api-mq-myqueue?api=stock', { stockID: stockID }, callback); };
  iservice.PasswordResetSend = function ($http, emailAddress, resetUrl, callback, idPrefix) { return ServicePost($http, idPrefix, 'PasswordResetSend', 'webapp-api-login?api=resetSend', { emailAddress: emailAddress, resetUrl: resetUrl }, callback); };
  iservice.FindAnswerTopics = function ($http, callback, idPrefix) { return ServicePost($http, idPrefix, 'FindAnswerTopics', 'webapp-api-findanswer?api=topics', { }, callback); };
  iservice.FindAnswerArticles = function ($http, topicID, searchString, recursive, pageNum, perPage, sort, callback, idPrefix) { return ServicePost($http, idPrefix, 'FindAnswerArticles', 'webapp-api-findanswer?api=articles', { topicID: topicID, searchString: searchString, recursive: recursive, pageNum: pageNum, perPage: perPage, sort: sort }, callback); };
  iservice.FindAnswerDetails = function ($http, articleID, callback, idPrefix) { return ServicePost($http, idPrefix, 'FindAnswerDetails', 'webapp-api-findanswer?api=details', { articleID: articleID }, callback); };
  iservice.FindAnswerTopicProperties = function ($http, topicID, callback, idPrefix) { return ServicePost($http, idPrefix, 'FindAnswerTopicProperties', 'webapp-api-findanswer?api=properties', { topicID: topicID }, callback); };
  iservice.FindAnswerAAQSubmit = function ($http, destEmail, details, callback, idPrefix) { return ServicePost($http, idPrefix, 'FindAnswerAAQSubmit', 'webapp-api-findanswer?api=aaq', { destEmail: destEmail, details: details }, callback); };
  iservice.FindAnswerAAQSubmitContact = function ($http, destEmail, details, properties, callback, idPrefix) { return ServicePost($http, idPrefix, 'FindAnswerAAQSubmit', 'webapp-api-findanswer?api=aaq', { destEmail: destEmail, details: details, properties: properties }, callback); };
  iservice.FindAnswerHistoryThreads = function ($http, callback, idPrefix) { return ServicePost($http, idPrefix, 'FindAnswerHistoryThreads', 'webapp-api-findanswer?api=threads', { }, callback); };
  iservice.FindAnswerHistoryChildren = function ($http, threadID, callback, idPrefix) { return ServicePost($http, idPrefix, 'FindAnswerHistoryChildren', 'webapp-api-findanswer?api=children', { threadID: threadID }, callback); };
  iservice.FindAnswerHistoryDetails = function ($http, interactionID, callback, idPrefix) { return ServicePost($http, idPrefix, 'FindAnswerHistoryDetails', 'webapp-api-findanswer?api=historydetails', { interactionID: interactionID }, callback); };
  iservice.FindAnswerMyDetails = function ($http, callback, idPrefix) { return ServicePost($http, idPrefix, 'FindAnswerMyDetails', 'webapp-api-findanswer?api=mydetails', { }, callback); };
  iservice.FindAnswerMyDetailsSet = function ($http, details, callback, idPrefix) { return ServicePost($http, idPrefix, 'FindAnswerMyDetailsSet', 'webapp-api-findanswer?api=mydetailsset', { details: details }, callback); };
  iservice.FindAnswerMySubscriptions = function ($http, callback, idPrefix) { return ServicePost($http, idPrefix, 'FindAnswerMySubscriptions', 'webapp-api-findanswer?api=mysubscriptions', { }, callback); };
  iservice.FindAnswerMySubscriptionsSet = function ($http, subscriptions, callback, idPrefix) { return ServicePost($http, idPrefix, 'FindAnswerMySubscriptionsSet', 'webapp-api-findanswer?api=mysubscriptionsset', { subscriptions: subscriptions }, callback); };

})(iservice);
