﻿var creditmemo = window.creditmemo || {};
(function (creditmemo) {
  var plugins = iservice.Plugins();
  creditmemo.Init = function (config, data) {
    function copystr(name) { config[name] = (data && data[name]) ? data[name] : ''; }
    function copyarr(name) { config[name] = (data && data[name]) ? data[name] : []; }
    copystr('topicIDPreApproval');
    copystr('topicIDFinalApproval');
    copystr('topicIDApproved');
    copystr('propertyIDProNumber');
    copystr('propertyIDAmount');
    copystr('propertyIDDate');
    copystr('propertyIDBillerName');
    copystr('propertyIDBillerCode');
    copystr('propertyIDType');
    copystr('propertyIDCategory');
    copystr('propertyIDDescription');
    copystr('propertyIDApproved');
    copystr('propertyIDApproverName');
    copystr('subjectTicket');
    copystr('stockIDTicket');
    copystr('subjectEmailApprover');
    copystr('stockIDEmailApprover');
    copystr('subjectEmailSubmitter');
    copystr('stockIDEmailSubmitter');
    copystr('subjectApproveNote');
    copystr('stockIDApproveNote');
    copystr('subjectRejectAnswer');
    copystr('stockIDRejectAnswer');
    copystr('subjectProNote');
    copystr('stockIDProNote');
    copyarr('agentListOpsUnder5k');
    copyarr('agentListOpsUnder25k');
    copyarr('agentListOpsOver25k');
    copyarr('agentListFinance');
    copyarr('agentListFinanceManager');
  }

  function InstallPlugin() {
    var plugin = {
      priority: 100,
      func: function (data) {
        if (data.status != 'Unassigned' && data.status != 'Queued') return false;
        if (!data.tags['Credit Memo']) return false;
        if (data.topicID == iservice.config.creditMemo.topicIDPreApproval) return true;
        if (data.topicID == iservice.config.creditMemo.topicIDFinalApproval) return true;
        return false;
      },
      detailsComponent: 'interaction-view',
      answerComponent: 'credit-memo-approve',
      inboxComponent: 'messageQueueMyInbox',
      noMassUpdate: true
    };
    if (!plugins.creditmemo) {
      plugins.creditmemo = plugin;
      plugins.list.push(plugin);
    }
  }
  function CheckConfig() {
    if (!iservice.config.creditMemo.topicIDPreApproval) return 'Pre-Approval topic ID not configured.';
    if (!iservice.config.creditMemo.topicIDFinalApproval) return 'Final Approval topic ID not configured.';
    if (!iservice.config.creditMemo.topicIDApproved) return 'Approved topic ID not configured.';
    if (!iservice.config.creditMemo.propertyIDProNumber) return 'PRO number property ID not configured.';
    if (!iservice.config.creditMemo.propertyIDAmount) return 'Credit amount property ID not configured.';
    if (!iservice.config.creditMemo.propertyIDDate) return 'Date property ID not configured.';
    if (!iservice.config.creditMemo.propertyIDBillerName) return 'Biller name property ID not configured.';
    if (!iservice.config.creditMemo.propertyIDBillerCode) return 'Biller code property ID not configured.';
    if (!iservice.config.creditMemo.propertyIDType) return 'Shipment type property ID not configured.';
    if (!iservice.config.creditMemo.propertyIDCategory) return 'Reason category property ID not configured.';
    if (!iservice.config.creditMemo.propertyIDDescription) return 'Reason description property ID not configured.';
    if (!iservice.config.creditMemo.propertyIDApproved) return 'Approved property ID not configured.';
    if (!iservice.config.creditMemo.propertyIDApproverName) return 'Approver Name property ID not configured.';
    if (iservice.config.creditMemo.agentListOpsUnder5k.length < 1) return 'Approver lists not configured.';
    if (iservice.config.creditMemo.agentListOpsUnder25k.length < 1) return 'Approver lists not configured.';
    if (iservice.config.creditMemo.agentListOpsOver25k.length < 1) return 'Approver lists not configured.';
    if (iservice.config.creditMemo.agentListFinance.length < 1) return 'Approver lists not configured.';
    if (iservice.config.creditMemo.agentListFinanceManager.length < 1) return 'Approver lists not configured.';
    if (!iservice.config.creditMemo.stockIDTicket) return 'Stock response ID not configured.';
    if (!iservice.config.creditMemo.stockIDEmailApprover) return 'Stock response ID not configured.';
    if (!iservice.config.creditMemo.stockIDEmailSubmitter) return 'Stock response ID not configured.';
    if (!iservice.config.creditMemo.stockIDApproveNote) return 'Stock response ID not configured.';
    if (!iservice.config.creditMemo.stockIDRejectAnswer) return 'Stock response ID not configured.';
    if (!iservice.config.creditMemo.stockIDProNote) return 'Stock response ID not configured.';
    if (!iservice.config.creditMemo.subjectTicket) return 'Subject line not configured';
    if (!iservice.config.creditMemo.subjectEmailApprover) return 'Subject line not configured';
    if (!iservice.config.creditMemo.subjectEmailSubmitter) return 'Subject line not configured';
    if (!iservice.config.creditMemo.subjectApproveNote) return 'Subject line not configured';
    if (!iservice.config.creditMemo.subjectRejectAnswer) return 'Subject line not configured';
    if (!iservice.config.creditMemo.subjectProNote) return 'Subject line not configured';
    return false;
  }

  creditmemo.installed = iservice.config.creditMemo && CheckConfig() == false;
  if (creditmemo.installed) InstallPlugin(plugins);

})(creditmemo);

var iservice = window.iservice || {};
(function (iservice) {
  iservice.components = iservice.components || {};

  iservice.components.creditMemoAdmin = {
    name: 'credit-memo-admin',
    template: '#credit-memo-admin',
    route() {
      return {
        path: iservice.formPath + '/admin/credit-memo-admin', priority: 300,
        myformsUrl: iservice.formPath + '/admin/credit-memo-admin', myformsLinkLabel: 'Credit Memo Admin', myformsLinkClass: 'fa icon-c icon-memo-admin',
        canAccess() {
          return iservice.HaveRight('Tab.Admin.Forms');
        },
        meta: { title: "iService | Credit Memo Admin" }
      }
    },
    setup(props) {
      var plugins = iservice.Plugins();
      var creditMemoAdminData = Vue.reactive({ loading: true });
      var formActions = Vue.reactive({ Save: Function, errors: [], success: '' });
      creditMemoAdminData.loading = false;

      var intProperties = iservice.IntPropertyData();
      var topics = iservice.TopicData();
      var agents = iservice.AgentData();
      var stockresponses = iservice.StockResponsesData();
      var segments = iservice.SegmentData();

      var featureConfig = Vue.reactive({ loading: true, config: {} });
      creditmemo.Init(featureConfig.config);
      iservice.API('webapp-api-admin?api=configuration', null, { application: 'agentapp', name: 'creditMemo' }).then(data => {
        if (data.items.length > 0) {
          creditmemo.Init(featureConfig.config, data.items[0].data);
        }
      }).catch(errors => {
        featureConfig.errors = errors;
      }).finally(() => {
        featureConfig.loading = false;
      });

      var topicGroups = Vue.computed(() => {
        var groups = [];
        if (!segments.loaded || !topics.loaded) {
          segments.Load(); topics.Load();
        }
        segments.list.forEach(segment => {
          var group = Vue.reactive({ label: segment.name, options: [] });
          topics.inSegment(segment.id).forEach(topic => {
            group.options.push({ name: topic.name, value: topic.id, level: Math.min(2, topic.depth) });
          });
          group.options.sort((l, r) => { return topics.TreeSortCompare(l.value, r.value); });
          if (group.options.length < 1) return;
          groups.push(group);
        });
        return groups;
      });
      var propertyList = Vue.computed(() => {
        var list = [];
        if (!intProperties.loaded) {
          intProperties.Load();
        }
        intProperties.list.forEach(prop => {
          list.push({ name: prop.name, id: prop.id });
        });
        return list;
      });
      var stockList = Vue.computed(() => {
        var list = [];
        if (!stockresponses.loaded) {
          stockresponses.Load();
        }
        stockresponses.list.forEach(stock => {
          list.push({ name: stock.name, id: stock.id });
        });
        return list;
      });
      var agentList = Vue.computed(() => {
        var list = [];
        if (!agents.loaded) {
          agents.Load();
        }
        agents.list.forEach(agent => {
          list.push({ displayname: agent.displayname, email: agent.email, id: agent.id });
        });
        return list;
      });

      Vue.watchEffect(() => {
        if (!agents.loaded) return;
        featureConfig.config.agentListOpsUnder5k = featureConfig.config.agentListOpsUnder5k.filter(agents.get);
        featureConfig.config.agentListOpsUnder25k = featureConfig.config.agentListOpsUnder25k.filter(agents.get);
        featureConfig.config.agentListOpsOver25k = featureConfig.config.agentListOpsOver25k.filter(agents.get);
        featureConfig.config.agentListFinance = featureConfig.config.agentListFinance.filter(agents.get);
        featureConfig.config.agentListFinanceManager = featureConfig.config.agentListFinanceManager.filter(agents.get);
      });

      formActions.Save = function () {
        if (formActions.working) return;
        formActions.working = true;
        var json = JSON.stringify(featureConfig.config);
        iservice.API('webapp-api-admin?api=configurationsave', null, { application: 'agentapp', items: [{ name: 'creditMemo', websiteID: '', data: json }] }).then(data => {
          iservice.SuccessMessage('Configuration saved.');
        }).catch(errors => {
          formActions.errors = errors;
        }).finally(() => {
          formActions.working = false;
        });
      }

      return { creditMemoAdminData, topicGroups, propertyList, stockList, agentList, featureConfig, formActions };
    }
  }
  iservice.components.creditMemoSubmit = {
    name: 'vueapp-credit-memo-submit',
    template: '#vueapp-credit-memo-submit',
    route() {
      return {
        path: iservice.formPath + '/submit-credit-memo', priority: 200,
        menuLinkLabel: 'Submit Credit Memo', menuLinkClass: 'fa icon-c icon-memo-admin',
        canAccess() {
          return iservice.config.creditMemo;
        },
        meta: { title: "iService | Submit Credit Memo" }
      }
    },
    setup() {

      var selectedID = Vue.ref(null);
      function onReset(id) {
        selectedID.value = id ? id : (selectedID.value + 1);
      }
      var creditMemoList = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });
      onReset(1);
      return { creditMemoList, onReset }
    }
  };
  iservice.components.creditMemoSubmitOnce = {
    name: 'vueapp-credit-memo-submit-once',
    template: '#vueapp-credit-memo-submit-once',
    emits: ['onReset'],
    setup() {
      var loggedIn = iservice.LoggedInData();
      var topics = iservice.TopicData();
      var proList = Vue.reactive([]);
      var pros = Vue.computed(() => {
        return proList;
      });
      var fields = Vue.reactive({
        propertyProNumber: null,
        propertyProNumberNew: null,
        propertyBillerName: null,
        propertyAmount: null,
        propertyDate: null,
        propertyBillerCode: null,
        propertyType: null,
        propertyCategory: null,
        propertyDescription: null,
        propertyApproved: null,
        approver: null
      });
      var scope = Vue.reactive({
        loading: false,
        agentMap: null,
        userEmail: null,
        configErrors: false,
        accessError: false,
        pros: [],
        approvers: [],
        errors: null,
        success: null,
        existing: null,
        searching: null,
        submitting: null,
        ticketID: null,
        existingPro: null,
        searchUrl: null,
        stage: null,
        isLoaded: false
      });
      var feautureCaseProps = Vue.reactive({});
      var feautureAnswerProps = Vue.reactive({});
      var properties = {};
      var formFeatures = Vue.reactive({});

      
      Vue.watchEffect(() => {
        if (!topics.loaded) {
          topics.Load(); return;
        }
        var topic = topics.get(iservice.config.creditMemo.topicIDPreApproval);
        let shown = iservice.HaveRight('Tab.Top.MessageQueue') && iservice.config.creditMemo;
        if (topic) {
          var segmentID = topic.segmentID;
          shown = loggedIn.accessibleSegments.includes(segmentID);
        } else {
          shown = false;
        }
        if (!shown) {
          scope.accessError = { errors: ['You don\'t have the required segment access to submit this form.Please check with your iService administrator if you think you should have access to this page.'], success: null };
        } 
      });

      formFeatures.MakeApproverList = function () {
        var max;
        proList.forEach((pro, i) => {
          if (!formFeatures.getProItemValue("propertyAmount", i)) return;
          var amount = formFeatures.getProItemValue("propertyAmount", i);
          if (max == undefined || amount > max) max = amount;
        });
        if (max == undefined) return;
        let approvers = formFeatures.GetApproverList(max);
        scope.approvers = [];
        approvers.forEach(approver => {
          let index = scope.approvers.findIndex(x => x.label == approver.group);
          if (index >= 0) {
            if (!scope.approvers[index].options.find(x => x.value == approver.id)) {
              scope.approvers[index].options.push({ name: approver.option, value: approver.id, level: index });
            }
          } else {
            var group = { label: approver.group, options: [{ name: approver.option, value: approver.id, level: scope.approvers.length }] };
            scope.approvers.push(group);
          }
        });
      }
      formFeatures.GetApproverList = function (amount) {
        var approvers = [];
        if (amount < 5000) {
          Array.prototype.push.apply(approvers, formFeatures.ApproverList(iservice.config.creditMemo.agentListOpsUnder5k, 'Ops < $5000'));
        }
        else if (amount < 25000) {
          Array.prototype.push.apply(approvers, formFeatures.ApproverList(iservice.config.creditMemo.agentListOpsUnder25k, 'Ops < $25000'));
        }
        else if (amount >= 25000) {
          Array.prototype.push.apply(approvers, formFeatures.ApproverList(iservice.config.creditMemo.agentListOpsOver25k, 'Ops >= $25000'));
        }
        Array.prototype.push.apply(approvers, formFeatures.ApproverList(iservice.config.creditMemo.agentListFinance, 'Finance'));
        return approvers;
      }
      formFeatures.ApproverList = function (ids, group) {
        var approvers = [];
        ids.forEach((id) => {
          var agent = scope.agentMap[id];
          if (!agent) return;
          approvers.push({ id: id, group: group, option: agent.option });
        });
        return approvers;
      }
      formFeatures.CheckProperties = function () {
        fields.propertyProNumber = feautureCaseProps.propMap[iservice.config.creditMemo.propertyIDProNumber] || feautureAnswerProps.propMap[iservice.config.creditMemo.propertyIDProNumber];
        if (!fields.propertyProNumber) return ["PRO number property not configured on credit memo topic, contact iService administrator."];

        fields.propertyBillerName = feautureCaseProps.propMap[iservice.config.creditMemo.propertyIDBillerName] || feautureAnswerProps.propMap[iservice.config.creditMemo.propertyIDBillerName];
        if (!fields.propertyBillerName) return ["Biller name property not configured on credit memo topic, contact iService administrator."];

        fields.propertyAmount = feautureCaseProps.propMap[iservice.config.creditMemo.propertyIDAmount] || feautureAnswerProps.propMap[iservice.config.creditMemo.propertyIDAmount];
        if (!fields.propertyAmount) return ["Credit amount property not configured on credit memo topic, contact iService administrator."];
        fields.propertyDate = feautureCaseProps.propMap[iservice.config.creditMemo.propertyIDDate] || feautureAnswerProps.propMap[iservice.config.creditMemo.propertyIDDate];
        if (!fields.propertyDate) return ["Date property not configured on credit memo topic, contact iService administrator."];

        fields.propertyBillerCode = feautureCaseProps.propMap[iservice.config.creditMemo.propertyIDBillerCode] || feautureAnswerProps.propMap[iservice.config.creditMemo.propertyIDBillerCode];
        if (!fields.propertyBillerCode) return ["Biller code property not configured on credit memo topic, contact iService administrator."];
        fields.propertyType = feautureCaseProps.propMap[iservice.config.creditMemo.propertyIDType] || feautureAnswerProps.propMap[iservice.config.creditMemo.propertyIDType];
        if (!fields.propertyType) return ["Shipment type property not configured on credit memo topic, contact iService administrator."];
        fields.propertyCategory = feautureCaseProps.propMap[iservice.config.creditMemo.propertyIDCategory] || feautureAnswerProps.propMap[iservice.config.creditMemo.propertyIDCategory];
        if (!fields.propertyCategory) return ["Reason category property not configured on credit memo topic, contact iService administrator."];
        fields.propertyDescription = feautureCaseProps.propMap[iservice.config.creditMemo.propertyIDDescription] || feautureAnswerProps.propMap[iservice.config.creditMemo.propertyIDDescription];
        if (!fields.propertyDescription) return ["Reason description property not configured on credit memo topic, contact iService administrator."];
        fields.propertyApproved = feautureCaseProps.propMap[iservice.config.creditMemo.propertyIDApproved] || feautureAnswerProps.propMap[iservice.config.creditMemo.propertyIDApproved];
        if (!fields.propertyApproved) return ["Approved property not configured on credit memo topic, contact iService administrator."];
        return false;
      }
      formFeatures.AddPro = function () {
        let proNumber = fields.propertyProNumberNew;
        if (!proNumber) {
          scope.errors = ['Must enter a PRO number'];
        }
        proList.forEach((row) => {
          let existing = row.propertyProNumber.value;
          if (existing == proNumber) {
            scope.errors = ['That PRO number is already entered above.'];
          }
        });
        if (scope.errors) return;
        let param = { groups: [] };
        param.groups.push({ fields: [{ where: 'entire', fieldID: iservice.config.creditMemo.propertyIDProNumber, searchString: proNumber }] });
        param.groups.push({ fields: [{ where: 'anywhere', fieldID: '->threads', searchString: '' }] });

        iservice.API('webapp-api-creditmemo?api=search', null, { fields: param, pageNum: 0, perPage: 1, sort: null }).then(data => {
          scope.errors = data.errors;
          if (data.errors && data.errors.length > 0) {
            return;
          }
          scope.existing = null;
          if (data.interactions && data.interactions.length > 0) {
            scope.existingPro = proNumber;
            scope.existing = data.interactions[0];
            scope.existing.dateObj = moment(String(scope.existing.date)).format('YYYY-MM-DD h:mm:ss A')
            return;
          }
          let pro = {
            propertyProNumber: { "value": fields.propertyProNumberNew, "isReadOnly": true },
            propertyAmount: { "value": "", "isReadOnly": false },
            propertyDate: { "value": "", "isReadOnly": false }
          };
          proList.push(pro);
          formFeatures.MakeApproverList();
          fields.propertyProNumberNew = null;
        });
      }
      formFeatures.RemovePro = function (index) {
        proList.splice(index, 1);
        formFeatures.MakeApproverList();
      }
      formFeatures.ApproveTopic = (agentID) => {
        if (iservice.config.creditMemo.agentListFinance.includes(agentID)) return iservice.config.creditMemo.topicIDPreApproval;
        return iservice.config.creditMemo.topicIDFinalApproval;
      }
      formFeatures.makeProListWithValue = function (pro) {
        let list = [];
        for (const [key, value] of Object.entries(pro)) {
          let item = {};
          item["propertyID"] = fields[key].def.propertyID;
          if (key == "propertyProNumber") {
            item["values"] = [{ "value": value.value }];
          } else if (key == "propertyAmount") {
            item["values"] = [{ "value": "", "valueNumber": value.value }];
          } else if (key == "propertyDate") {
            item["values"] = [{ "value": "", "valueDateUtc": value.value }];
          }
          list.push(item);
        }
        return list;
      }
      formFeatures.getProItemValue = function (field, index) {
        if (field == "propertyAmount") {
          return proList[index][field].value;
        } else if (field == "propertyDate") {
          return proList[index][field].value ? new Date(proList[index][field].value).toLocaleDateString('en-CA') : null;
        } else if (field == "propertyProNumber") {
          return proList[index][field].value;
        }
      }
      
      formFeatures.SubmitRequest = function () {
        if (scope.submitting || scope.ticketID) return;

        formFeatures.checkValidation();
        if (scope.errors.length > 0) return;

        var topicID = formFeatures.ApproveTopic(fields.approver);
        var approverID = fields.approver;
        var params = {
          approverName: scope.agentMap[approverID].name,
          submitterName: loggedIn.contactName,
          ticket: {},
          emailApprover: {},
          emailSubmitter: {}
        };
        params.ticket = {
          contactID: loggedIn.contactID,
          destEmail: scope.userEmail,
          topicID: topicID,
          tags: ['Credit Memo'],
          subject: iservice.config.creditMemo.subjectTicket,
          bodyHtml: "$" + "stock -id'" + iservice.config.creditMemo.stockIDTicket + "'$",
          assignToAgentID: approverID,
          properties: feautureAnswerProps.out,
          caseProperties: feautureCaseProps.out,
          action: 5
        };
        params.emailApprover = {
          contactID: approverID,
          destEmail: scope.agentMap[approverID].email,
          topicID: topicID,
          subject: iservice.config.creditMemo.subjectEmailApprover,
          bodyHtml: "$" + "stock -id'" + iservice.config.creditMemo.stockIDEmailApprover + "'$",
          action: 1
        };
        params.emailSubmitter = {
          contactID: loggedIn.contactID,
          destEmail: scope.userEmail,
          topicID: topicID,
          subject: iservice.config.creditMemo.subjectEmailSubmitter,
          bodyHtml: "$" + "stock -id'" + iservice.config.creditMemo.stockIDEmailSubmitter + "'$",
          action: 1
        };

        proList.forEach((pro, i) => {
          var proNumber = formFeatures.getProItemValue("propertyProNumber", i);
          var amount = formFeatures.getProItemValue("propertyAmount", i);
          var date = formFeatures.getProItemValue("propertyDate", i);

          params['submitnote' + i] = {
            contactID: loggedIn.contactID,
            topicID: topicID,
            tags: ['Credit Memo PRO'],
            subject: iservice.config.creditMemo.subjectProNote,
            bodyHtml: "$" + "stock -id'" + iservice.config.creditMemo.stockIDProNote + "'$",
            properties: formFeatures.makeProListWithValue(pro)
          };
          params['pronumber' + i] = proNumber;
          params['proamount' + i] = amount;
          params['prodate' + i] = date;
        });

        scope.loading = true;
        scope.submitting = iservice.API('webapp-api-creditmemo?api=submit', null, params).then(data => {
          scope.errors = data.errors;
          if (data.errors && data.errors.length > 0) {
            return;
          }
          scope.stage = 'done';
          //iservice.SuccessMessage('Your credit memo request has been sent to the selected Approver.');
          scope.ticketID = data.ticketID;
          scope.searchUrl = rootPath + 'messagequeue#/search?w1=entire&f1=' + fields.propertyProNumber.def.propertyID + '&t1=' + proList[0].propertyProNumber.value + '&op1=and&w2=anywhere&f2=->threads&t2=';
          fields.propertyProNumber.def.isReadOnly = true;
          fields.propertyAmount.def.isReadOnly = true;
          fields.propertyDate.def.isReadOnly = true;
          fields.propertyBillerName.def.isReadOnly = true;
          fields.propertyBillerCode.def.isReadOnly = true;
          fields.propertyType.def.isReadOnly = true;
          fields.propertyCategory.def.isReadOnly = true;
          fields.propertyDescription.def.isReadOnly = true;
          proList.forEach(function (pro) {
            pro.propertyProNumber.isReadOnly = true;
            pro.propertyAmount.isReadOnly = true;
            pro.propertyDate.isReadOnly = true;
          });
        }, null).catch(errors => {
          scope.errors = errors;
        }).finally(() => {
          scope.loading = false;
          scope.submitting = null;
        });
      }
      formFeatures.findProperties = function () {
        iservice.EditableProperties(feautureCaseProps, properties.case);
        iservice.EditableProperties(feautureAnswerProps, properties.answer);

        feautureCaseProps.props.forEach(prop => {
          prop.def.isRequired = true;
        });
        feautureAnswerProps.props.forEach(prop => {
          prop.def.isRequired = true;
        });
        var configPropertyErrors = { "errors": formFeatures.CheckProperties() || null, "success": null };
        if (configPropertyErrors.errors) {
          scope.configErrors = configPropertyErrors;
        }
      }
      if (iservice.config.creditMemo) {
        scope.loading = true;
        iservice.API('webapp-api-creditmemo?api=start', null, { topicID: iservice.config.creditMemo.topicIDFinalApproval, agentID: loggedIn.contactID }).then(data => {
          scope.loading = false;
          scope.userEmail = data.userEmail;
          scope.agentMap = data.agentMap;
          function AgentSortFunc(l, r) {
            if (!data.agentMap[l]) return 1;
            if (!data.agentMap[r]) return -1;
            var nameL = '' + data.agentMap[l].option;
            var nameR = '' + data.agentMap[r].option;
            return nameL.localeCompare(nameR);
          }
          iservice.config.creditMemo.agentListOpsUnder5k.sort(AgentSortFunc);
          iservice.config.creditMemo.agentListOpsUnder25k.sort(AgentSortFunc);
          iservice.config.creditMemo.agentListOpsOver25k.sort(AgentSortFunc);
          iservice.config.creditMemo.agentListFinance.sort(AgentSortFunc);

          properties["answer"] = data.properties.answer;
          properties["case"] = data.properties.case;
          formFeatures.findProperties();
          scope.isLoaded = true;
        }).catch(errors => {
          scope.errors = errors;
        });
      } else {
        scope.configErrors = { "errors": ["Credit memo not configured, contact iService administrator."], "success": null };
      }
      var selectApprover = Vue.ref(null);
      var propertyProNumberNew = Vue.ref(null);
      formFeatures.checkValidation = function () {
        scope.errors = [];
        let setFocus = false;
        if (!fields.propertyBillerName.firstValue) {
          fields.propertyBillerName.focusMe = true;
          fields.propertyBillerName.firstValue = "test";
          scope.errors.push("Please enter Biller Company Name.");
          setFocus = true;
        }
        if (!fields.propertyBillerCode.firstValue) {
          fields.propertyBillerCode.focusMe = !setFocus;
          scope.errors.push("Please enter Biller Code.");
          setFocus = true;
        }
        if (!fields.propertyType.firstValue) {
          fields.propertyType.focusMe = !setFocus;
          scope.errors.push("Please enter Shipment Type .");
          setFocus = true;
        }
        if (!fields.propertyCategory.firstValue) {
          fields.propertyCategory.focusMe = !setFocus;
          scope.errors.push("Please enter Reason Category.");
          setFocus = true;
        }
        if (!fields.propertyDescription.firstValue) {
          fields.propertyDescription.focusMe = !setFocus;
          scope.errors.push("Please enter Reason Description.");
          setFocus = true;
        }
        if (proList.length == 0) {
          if (!setFocus) { propertyProNumberNew.value.focus(); }
          scope.errors.push("Must add at least one PRO number.");
          setFocus = true;
        }
        if (!fields.approver) {
          scope.errors.push("Please select Approver.");
          setFocus = true;
        }
        for (var i = 0; i < proList.length; i++) {
          if (!formFeatures.getProItemValue("propertyAmount", i)) {
            scope.errors.push("Please enter Credit Memo Amount.");
          }
          if (!formFeatures.getProItemValue("propertyDate", i)) {
            scope.errors.push("Please enter Delivery Date.");
          }
        }
        formFeatures.hasRequiredErrors = scope.errors.length > 0;
      }

      return { fields, config: iservice.config.creditMemo, scope, loggedIn, proList, properties, pros, formFeatures, selectApprover, propertyProNumberNew }
    }
  }
  iservice.components.creditMemoAnswerMenuForward = {
    name: 'credit-memo-answer-menu-forward',
    template: '#credit-memo-answer-menu-forward',
    props: ['params'],
    setup(props) {
      var loggedIn = iservice.LoggedInData();
      var agents = iservice.AgentData();
      var feature = Vue.computed(() => { return props.params; });

      var reassignStage = Vue.ref('closed');
      var reassignOptions = Vue.ref([]);
      Vue.watchEffect(() => {
        reassignOptions.value.length = 0;
        reassignOptions.loading = true;
        if (!agents.loaded) {
          agents.Load(); return;
        }
        reassignOptions.loading = false;
        var agentIDs = iservice.HaveRight('Tab.MessageQueue.Supervise') ? agents.forSegment(feature.value.interaction.segmentID) : agents.forInteraction(feature.value.interaction.id);
        agentIDs.forEach(agentID => {
          if (agentID == loggedIn.contactID) return;
          var agent = agents.get(agentID);
          if (agent) {
            var name = agent.name || agent.email || ('Agent ' + agent.id);
            var option = {
              id: agentID,
              name: name,
              email: agent.email,
              search: agent.name + '\n' + agent.email,
              disabled: !agent.isLoggedIn && agent.doEmpty,
              isaway: !agent.isLoggedIn && !agent.doEmpty
            };
            reassignOptions.value.push(option);
          }
        });
        reassignOptions.value.sort((l, r) => {
          return l.name.localeCompare(r.name);
        });
      });
      function ReassignStart() {
        if (reassignStage.value == 'open') {
          reassignStage.value = 'closed';
        }
        else if (reassignStage.value == 'closed') {
          reassignStage.value = 'open';
        }
      }

      return { feature, ReassignStart, reassignStage, reassignOptions };
    }
  };
  iservice.components.creditMemoAnswer = {
    name: 'credit-memo-answer',
    template: '#credit-memo-answer',
    route() {
      return {
        path: iservice.formPath + '/credit-memo-approval/:id?', priority: 200,
        canAccess() {
          return iservice.config.creditMemo;
        },
        meta: { title: "iService | Approve Credit Memo" }
      }
    },
    setup(props, context) {
      var router = VueRouter.useRouter();
      var interactions = iservice.InteractionData();
      var loggedIn = iservice.LoggedInData();
      var interaction = Vue.reactive({});
      var details = Vue.reactive({});
      var formFeatures = Vue.reactive({ errors:null, success: null});
      var featureCaseProps = Vue.reactive({});
      var id = router.currentRoute.value.query.id;
      var stage = "";
      var component = Vue.computed(() => { if (stage != '') { return [stage]; } else { return [] } });
      formFeatures.details = Vue.computed(() => { return details; });

      function load() {
        if (id) {
          iservice.API("webapp-api-mq-myqueue?api=details2", null, { interactionID: id, segmentID: "" }, null).then(data => {
            interactions.add(data.details);
            interactions.add(data.thread);
            data.thread.children.forEach(child => {
              interactions.add(child);
            });
            initialise(data);
            formFeatures.isHeader = true;
          }).catch(errors => {
            formFeatures.errors = errors;
          }).finally(() => {
          });
        }
      }
      function initialise(data) {
        interaction = interactions.get(data.details.id);
        iservice.EditableProperties(featureCaseProps, interaction.caseProps);
        formFeatures.propertyApproverName = featureCaseProps.propMap[iservice.config.creditMemo.propertyIDApproverName];
        if (formFeatures.propertyApproverName) {
          formFeatures.propertyApproverName.def.isReadOnly = true;
          formFeatures.propertyApproverName.values = formFeatures.propertyApproverName.values.filter((val) => {
            return val.value.length > 0;
          });
          formFeatures.Approvals = formFeatures.propertyApproverName.values.length > 0;
        }
        
        formFeatures.cmBodyHtml = data.details.bodyHtml;
        var isCM = data.details.tags.includes('Credit Memo');
        var isMine = data.details.assignedToID == loggedIn.contactID;
        var assigned = data.details.status == 'Queued';
        var unassigned = data.details.status == 'Unassigned';
        var resolved = !assigned && !unassigned;
        var approved = data.details.topicID == iservice.config.creditMemo.topicIDApproved;
        details = data;
        if (isCM && isMine && !approved) {
          stage = 'answer';
        } else {
          if (!isCM) { stage = 'notcreditmemo'; }
          else if (resolved) { stage = 'resolved'; }
          else if (approved) { stage = 'approved'; }
          else if (assigned) { stage = 'someoneelse'; }
          else { stage = 'unassigned'; }
        }
        formFeatures.loaded = true;
      }

      load();

      return { details, formFeatures, interaction, stage, component, id, featureCaseProps }
    }
  };
  iservice.components.creditMemoApprove = {
    name: 'credit-memo-approve',
    template: '#credit-memo-approve',
    props: ['itemid', 'load', 'cancelable', 'data', 'forwardable'],
    emits: ['cancel'],
    setup(props, context) {
      var interactions = iservice.InteractionData();
      var loggedIn = iservice.LoggedInData();
      var agents = iservice.AgentData();
      var interaction = interactions.get(props.itemid);
      var agentEmail = GetEmail(loggedIn.logins);
      if (!agents.loaded) {
        agents.Load();
      }
      function Cancel() {
        context.emit('cancel');
      }
      function GetEmail(logins) {
        if (!logins || logins.length < 1) return '';
        function FindType(type) {
          return logins.find(function (item) {
            return item.type == type;
          });
        }
        var login = FindType("Email") || FindType("Bounced") || logins[0];
        return login.name;
      }
      var formFeatures = Vue.reactive({
        configErrors: false,
        proList: [],
        creditMemoStage: '',
        approvers: [],
        errors: null,
        success: null,
        forwardable: (props.forwardable != undefined) ? props.forwardable : true
      });
      var fields = Vue.reactive({
        propertyProNumber: null,
        propertyProNumberNew: null,
        propertyBillerName: null,
        propertyAmount: null,
        propertyDate: null,
        propertyBillerCode: null,
        propertyType: null,
        propertyCategory: null,
        propertyDescription: null,
        propertyApproved: null,
        propertyApproverName: null,
        finalApproverID: interaction.assignedToID,
        rejectionReason: null
      });
      var anchorForward = Vue.ref(null);
      var questionDetails = Vue.ref(props.data.details);
      var answerDetails = Vue.ref(props.data.thread);

      var answer = Vue.reactive({
        subject: interaction.subject,
        destEmail: interaction.fromAddress,
        bodyHtml: interaction.bodyHtml,
        supressSubjectRef: false,
        changeTopicID: interaction.topicID,
        reassignAgentID: fields.finalApproverID,
        contactID: fields.finalApproverID,
        topicID: interaction.topicID,
        inResponseToID: interaction.id,
        action: 1
      });

      var featureCaseProps = Vue.reactive({});
      iservice.EditableProperties(featureCaseProps, interaction.caseProps, out => { answer.threadProperties = out; });
      var featureAnswerProps = Vue.reactive({ responseProps: [] });
      iservice.CopyProps(featureAnswerProps.responseProps, questionDetails.value.responseProperties);
      iservice.EditableProperties(featureAnswerProps, featureAnswerProps.responseProps, out => { answer.answerProperties = out; });

      var featureForwardMenu = Vue.reactive({ interaction });
      Vue.watchEffect(() => { answer.reassignAgentID = featureForwardMenu.reassignAgentID; });
      featureForwardMenu.Open = function () {
        featureForwardMenu.Close = iservice.components.popupHolder.Open(anchorForward, 'credit-memo-answer-menu-forward', true, featureForwardMenu);
      }
      featureForwardMenu.ReassignAgent = function (e) {
        if (featureForwardMenu.Close) featureForwardMenu.Close();
        featureAction.SubmitAnswer('webapp-api-mq-myqueue?api=assign', e, 'Reassigned.', false, true);
      }
      featureForwardMenu.UnassignQuestion = function (e) {
        if (featureForwardMenu.Close) featureForwardMenu.Close();
        featureAction.SubmitAnswer('webapp-api-mq-myqueue?api=unqueue', e, 'Unqueued.', false, true);
      }

      Vue.watchEffect(() => {
        if (answerDetails.value && answerDetails.value.children && answerDetails.value.children.length > 0) {
          answerDetails.value.children.forEach(child => {
            if (!child.tags.includes('Credit Memo PRO')) return;
            var pro = { propertyMap: {} };

            child.properties.forEach(function (group) {
              group.properties.forEach(function (property) {
                if (property.isDate) {
                  property.values[0].valueDate = moment(property.values[0].valueDateUtc).toDate();
                }
                pro.propertyMap[property.propertyID] = property;
              });
            });
            let proItem = {
              propertyProNumber: { "value": pro.propertyMap[iservice.config.creditMemo.propertyIDProNumber].values[0].value, "isReadOnly": true },
              propertyAmount: { "value": pro.propertyMap[iservice.config.creditMemo.propertyIDAmount].values[0].value, "isReadOnly": true },
              propertyDate: { "value": pro.propertyMap[iservice.config.creditMemo.propertyIDDate].values[0].valueDate, "isReadOnly": true }
            };
            formFeatures.proList.push(proItem);
          });
        }
      });
      Vue.watchEffect(() => {
        if (interaction.topicID == iservice.config.creditMemo.topicIDPreApproval) {
          formFeatures.creditMemoStage = 'pre';
          var approverIDs = {};
          iservice.config.creditMemo.agentListFinanceManager.forEach(function (id) {
            approverIDs[id] = id;
          });
          formFeatures.approvers = agents.list.filter(function (agent) {
            return approverIDs[agent.id];
          });
        }
        else if (interaction.topicID == iservice.config.creditMemo.topicIDFinalApproval) {
          formFeatures.creditMemoStage = 'final';
        }
        else if (interaction.topicID == iservice.config.creditMemo.topicIDApproved) {
          formFeatures.creditMemoStage = 'approved';
        }
        else {
          formFeatures.creditMemoStage = 'error';
        }
      });
      Vue.watchEffect(() => { answer.threadProperties = featureCaseProps.out; });
      Vue.watchEffect(() => { answer.answerProperties = featureAnswerProps.out; });
      Vue.watchEffect(() => { answer.reassignAgentID = fields.finalApproverID; });
      Vue.watchEffect(() => { answer.contactID = fields.finalApproverID; });
      function CheckProperties() {
        fields.propertyProNumber = featureCaseProps.propMap[iservice.config.creditMemo.propertyIDProNumber] || featureAnswerProps.propMap[iservice.config.creditMemo.propertyIDProNumber];
        if (!fields.propertyProNumber) return ["PRO number property not configured on credit memo topic, contact iService administrator."];
        fields.propertyProNumber.def.isReadOnly = true;
        fields.propertyBillerName = featureCaseProps.propMap[iservice.config.creditMemo.propertyIDBillerName] || featureAnswerProps.propMap[iservice.config.creditMemo.propertyIDBillerName];
        if (!fields.propertyBillerName) return ["Biller name property not configured on credit memo topic, contact iService administrator."];
        fields.propertyBillerName.def.isReadOnly = true;
        fields.propertyAmount = featureCaseProps.propMap[iservice.config.creditMemo.propertyIDAmount] || featureAnswerProps.propMap[iservice.config.creditMemo.propertyIDAmount];
        if (!fields.propertyAmount) return ["Credit amount property not configured on credit memo topic, contact iService administrator."];
        fields.propertyAmount.def.isReadOnly = true;
        fields.propertyDate = featureCaseProps.propMap[iservice.config.creditMemo.propertyIDDate] || featureAnswerProps.propMap[iservice.config.creditMemo.propertyIDDate];
        if (!fields.propertyDate) return ["Date property not configured on credit memo topic, contact iService administrator."];
        fields.propertyDate.def.isReadOnly = true;
        fields.propertyBillerCode = featureCaseProps.propMap[iservice.config.creditMemo.propertyIDBillerCode] || featureAnswerProps.propMap[iservice.config.creditMemo.propertyIDBillerCode];
        if (!fields.propertyBillerCode) return ["Biller code property not configured on credit memo topic, contact iService administrator."];
        fields.propertyBillerCode.def.isReadOnly = true;
        fields.propertyType = featureCaseProps.propMap[iservice.config.creditMemo.propertyIDType] || featureAnswerProps.propMap[iservice.config.creditMemo.propertyIDType];
        if (!fields.propertyType) return ["Shipment type property not configured on credit memo topic, contact iService administrator."];
        fields.propertyType.def.isReadOnly = true;
        fields.propertyCategory = featureCaseProps.propMap[iservice.config.creditMemo.propertyIDCategory] || featureAnswerProps.propMap[iservice.config.creditMemo.propertyIDCategory];
        if (!fields.propertyCategory) return ["Reason category property not configured on credit memo topic, contact iService administrator."];
        fields.propertyCategory.def.isReadOnly = true;
        fields.propertyDescription = featureCaseProps.propMap[iservice.config.creditMemo.propertyIDDescription] || featureAnswerProps.propMap[iservice.config.creditMemo.propertyIDDescription];
        if (!fields.propertyDescription) return ["Reason description property not configured on credit memo topic, contact iService administrator."];
        fields.propertyDescription.def.isReadOnly = true;
        fields.propertyApproved = featureCaseProps.propMap[iservice.config.creditMemo.propertyIDApproved] || featureAnswerProps.propMap[iservice.config.creditMemo.propertyIDApproved];
        if (!fields.propertyApproved) return ["Approved property not configured on credit memo topic, contact iService administrator."];
        fields.propertyApproved.def.isReadOnly = true;
        fields.propertyApproverName = featureCaseProps.propMap[iservice.config.creditMemo.propertyIDApproverName] || featureAnswerProps.propMap[iservice.config.creditMemo.propertyIDApproverName];
        if (fields.propertyApproverName) fields.propertyApproverName.def.isReadOnly = true;
        formFeatures.loaded = true;
        return false;
      }

      formFeatures.errors = CheckProperties() || null;

      var featureAction = Vue.reactive({});
      featureAction.Preapprove = function (url, e, param) {
        if (featureAction.working) return;
        featureAction.working = true;
        formFeatures.errors = formFeatures.success = null;
        let emailApprover = Object.assign({}, param);
        emailApprover.subject = iservice.config.creditMemo.subjectEmailApprover;
        emailApprover.bodyHtml = "$" + "stock -id'" + iservice.config.creditMemo.stockIDEmailApprover + "'$";
        emailApprover.destEmail = agents.get(fields.finalApproverID) && agents.get(fields.finalApproverID).email;
        iservice.API(url, e, { interactionID: interaction.id, interactionIDs: [interaction.id], emailApprover: emailApprover, changetopic: param, reassign: param }, null).then(data => {
          if (data.errors && data.errors.length > 0) {
            formFeatures.errors = data.errors;
            return;
          }
          iservice.SuccessMessage('You have pre-approved this credit memo.');
        }).catch(errors => {
          formFeatures.errors = errors;
        }).finally(() => {
          featureAction.working = false;
          Cancel();
        });
      }
      featureAction.Approve = function (url, e, param) {
        if (featureAction.working) return;
        featureAction.working = true;
        formFeatures.errors = formFeatures.success = null;
        let savenote = param;
        savenote.bodyHtml = "$" + "stock -id'" + iservice.config.creditMemo.stockIDApproveNote + "'$";
        savenote.subject = iservice.config.creditMemo.subjectApproveNote;
        savenote.destEmail = agents.get(fields.finalApproverID) && agents.get(fields.finalApproverID).email;
        iservice.API(url, e, { interactionID: interaction.id, interactionIDs: [interaction.id], savenote: savenote, changetopic: param, unqueue: param }, null).then(data => {
          if (data.errors && data.errors.length > 0) {
            formFeatures.errors = data.errors;
            return;
          }
          iservice.SuccessMessage('You have approved this credit memo.');
        }).catch(errors => {
          formFeatures.errors = errors;
        }).finally(() => {
          featureAction.working = false;
          Cancel();
        });
      }
      featureAction.Reject = function (url, e, param) {
        if (featureAction.working) return;
        featureAction.working = true;
        formFeatures.errors = formFeatures.success = null;
        param.rejectionReason = fields.rejectionReason;
        param.bodyHtml = "$" + "stock -id'" + iservice.config.creditMemo.stockIDRejectAnswer + "'$";
        param.subject = iservice.config.creditMemo.subjectRejectAnswer;
        iservice.API(url, e, { interactionID: interaction.id, interactionIDs: [interaction.id], send: param }, null).then(data => {
          if (data.errors && data.errors.length > 0) {
            formFeatures.errors = data.errors;
            return;
          }
          iservice.SuccessMessage('You have rejected this credit memo.');
        }).catch(errors => {
          formFeatures.errors = errors;
        }).finally(() => {
          featureAction.working = false;
        });
      }
      featureAction.SubmitAnswer = function (url, e, successMessage, doReset, removeOnSuccess = false) {
        if (featureAction.working) return;
        featureAction.working = true;
        formFeatures.errors = formFeatures.success = null;
        answer.mailboxID = questionDetails.value.defaultMailboxID;
        answer.destEmail = questionDetails.value.fromAddress;
        answer.destCC = '';
        answer.destBCC = '';
        answer.responseNote = questionDetails.value.note;

        iservice.API(url, e, { interactionID: interaction.id, interactionIDs: [interaction.id], answer }, null).then(data => {
          interactions.add(data.thread.row);
          interactions.add(data.thread.details);
          interactions.add(data.question.row);
          interactions.add(data.question.details);
          interactions.add(data.response.row);
          interactions.add(data.response.details);
          if (data.details) {
            props.data.details = data.details;
            questionDetails.value = props.data.details;
          }
          iservice.SuccessMessage(successMessage);
          if (removeOnSuccess) {
            iservice.data.mq.numCanGet = data.numCanGet;
            iservice.data.mq.numCanApprove = data.numCanApprove;
          }
        }).catch(errors => {
          formFeatures.errors = errors;
        }).finally(() => {
          featureAction.working = false;
        });
      }

      var featureApproveMenu = Vue.reactive({});
      featureApproveMenu.PreApprove = function (e) {
        formFeatures.btnDisabled = true;
        formFeatures.errors = null;
        if (!fields.finalApproverID) {
          formFeatures.errors = ['Must choose final approver.'];
          return;
        }
        answer.changeTopicID = iservice.config.creditMemo.topicIDFinalApproval;
        let value = featureCaseProps.propMap[fields.propertyApproverName.def.propertyID].values[0] || {};
        value["description"] = "Pre-Approved";
        value["value"] = agentEmail;
        setTimeout(function () {
          featureAction.Preapprove('webapp-api-creditmemo?api=pre', e, answer);
        }, 0);
      }
      featureApproveMenu.Approve = function (e) {
        formFeatures.btnDisabled = true;
        answer.changeTopicID = iservice.config.creditMemo.topicIDApproved;
        let value = { description: "Approved", value: agentEmail };
        featureCaseProps.propMap[fields.propertyApproverName.def.propertyID].values.push(value);
        featureCaseProps.propMap[fields.propertyApproved.def.propertyID].values[0].value = 'True';
        setTimeout(function () {
          featureAction.Approve('webapp-api-creditmemo?api=final', e, answer);
        }, 0);
      }
      featureApproveMenu.Reject = function (e) {
        if (!featureApproveMenu.rejecting) {
          featureApproveMenu.rejecting = true;
          return;
        }
        formFeatures.btnDisabled = true;
        let value = { description: "Rejected", value: agentEmail };
        featureCaseProps.propMap[fields.propertyApproverName.def.propertyID].values.push(value);
        featureCaseProps.propMap[fields.propertyApproved.def.propertyID].values[0].value = 'False';
        setTimeout(function () {
          featureAction.Reject('webapp-api-creditmemo?api=reject', e, answer);
        }, 0);
      }

      return { formFeatures, fields, answer, questionDetails, answerDetails, featureCaseProps, featureAnswerProps, featureAction, agents, featureApproveMenu, featureForwardMenu, anchorForward, Cancel }
    }
  };

})(iservice);