﻿var iservice = window.iservice || {};
(function (iservice) {
  iservice.components = iservice.components || {};

  iservice.components.PreviewDialer = {
    name: 'preview-dialer',
    template: '#preview-dialer',
    route() { return { path: iservice.formPath + '/previewdialer', priority: 200, meta: { title: "iService | Preview Dialer" } } },
    props: [],
    setup(props) {
      var loggedIn = iservice.LoggedInData();
      var formFeatures = Vue.reactive({ errors: [] });
      formFeatures.membership = [];
      var interactions = iservice.InteractionData();

      function ParseLocation() {
        var pairs = window.location.search.substring(1).split("&");
        var obj = {};
        var pair;
        var i;

        for (i in pairs) {
          if (pairs[i] === "" || typeof pairs[i] === 'function') continue;
          pair = pairs[i].split("=");
          obj[decodeURIComponent(pair[0])] = decodeURIComponent(pair[1]);
        }
        return obj;
      };
      var query = ParseLocation();
      var contactID = query['contactID'];

      var topicID = query['topicID'];
      var stockID = query['stockID'];
      var contactIds = JSON.parse(localStorage.getItem('previewDialerContacts')); //get searched contact ids from local storage
      if (!iservice.previewdialer) iservice.previewdialer = {};
      if (!iservice.previewdialer.note) iservice.previewdialer.note = {};
      if (!iservice.previewdialer.note.properties) iservice.previewdialer.note.properties = [];
      formFeatures.getIntIconClass = iservice.interactionTypeClasses;
      formFeatures.getTypeLabels = iservice.interactionTypeLabels;
      formFeatures.closereason = 'Open';
      formFeatures.classinfocontent = [];
      formFeatures.classscriptcontent = [];
      formFeatures.classhistorytcontent = [];
      formFeatures.classnotecontent = [];
      formFeatures.classdetailcontent = [];
      var noteProps = Vue.reactive({});
      formFeatures.note = iservice.previewdialer.note;
      iservice.EditableProperties(noteProps, iservice.previewdialer.note.properties);
      formFeatures.note.body = '';
      formFeatures.contactId = contactID;
      formFeatures.previewdilaerUrl = rootPath + 'f/vueapp-previewdialer?topicID=' + topicID + '&contactID=' + contactID + '&stockID=' + stockID;
      formFeatures.showPrev = false;
      formFeatures.showNext = true;
      var contactidindex = contactIds.indexOf(contactID);


      if (contactIds.length == 1) {
        formFeatures.showNext = false;
      }
      var lastindex = contactIds.length - 1;
      if (lastindex == contactidindex) {
        formFeatures.showNext = false;
        formFeatures.showPrev = true;
      }
      if (contactidindex == 0) {
        formFeatures.showPrev = false;
      } else {
        formFeatures.showPrev = true;
      }
      formFeatures.segmentLists = [];
      function SegmentData() {
        formFeatures.segmentLists = [];
        if (!iservice.tenant.segments) return;
        for (var s = 0; s < iservice.tenant.segments.list.length; s++) {
          var segment = iservice.tenant.segments.list[s];
          if (!segment.hidden)
            formFeatures.segmentLists.push({ id: segment.id, name: segment.name, hidden: segment.hidden });
        }
      }
      iservice.AdminList(['segments'], function (data) {
        SegmentData();
      });
      formFeatures.getNextContact = function () {

        if (contactidindex >= 0 && contactidindex < contactIds.length - 1) {
          var nextItem = contactIds[contactidindex + 1];
          if (!nextItem) return;
          window.location.href = iservice.formPath + '/previewdialer?topicID=' + topicID + '&contactID=' + nextItem + '&stockID=' + stockID;
        }
      }
      formFeatures.getPrevContact = function () {
        if (contactidindex >= 0) {
          var prevItem = contactIds[contactidindex - 1]
          if (!prevItem) return;
          window.location.href = iservice.formPath + '/previewdialer?topicID=' + topicID + '&contactID=' + prevItem + '&stockID=' + stockID;
        }
      }
      formFeatures.scriptContent = '';
      //get stock response details
      iservice.API('webapp-api-admin?api=stockresponsedetails', null, { stockID: stockID }, null).then(function (result) {
        formFeatures.scriptContent = result.details.bodyHtml;
      });
      iservice.AdminList(['topics', 'contactProperties'], function (data) {
        formFeatures.adminLoaded = true;
        formFeatures.toggleContactInfo = function () {
          if (formFeatures.classinfocontent.indexOf('classinfocontent') == -1) {
            formFeatures.classinfocontent.push('classinfocontent');
          } else {
            formFeatures.classinfocontent.pop('classinfocontent');
          }
        };
        formFeatures.toggleScript = function () {
          if (formFeatures.classscriptcontent.indexOf('classscriptcontent') == -1) {
            formFeatures.classscriptcontent.push('classscriptcontent');
          } else {
            formFeatures.classscriptcontent.pop('classscriptcontent');
          }
        };
        formFeatures.toggleContactHistory = function () {
          if (formFeatures.classhistorytcontent.indexOf('classhistorytcontent') == -1) {
            formFeatures.classhistorytcontent.push('classhistorytcontent');
          } else {
            formFeatures.classhistorytcontent.pop('classhistorytcontent');
          }
        };
        formFeatures.toggleContactNote = function () {
          if (formFeatures.classnotecontent.indexOf('classnotecontent') == -1) {
            formFeatures.classnotecontent.push('classnotecontent');
          } else {
            formFeatures.classnotecontent.pop('classnotecontent');
          }
        };
        formFeatures.toggleDetail = function () {
          if (formFeatures.classdetailcontent.indexOf('classdetailcontent') == -1) {
            formFeatures.classdetailcontent.push('classdetailcontent');
          } else {
            formFeatures.classdetailcontent.pop('classdetailcontent');
          }
        };
        for (var i = 0; i < data.topics.length; i++) {
          var topic = data.topics[i];
          if (topic.id == topicID) {
            formFeatures.noteTopic = topic;
          }
        }
      });
      formFeatures.CreateNote = function (subject) {
        if (!formFeatures.noteTopic) return;
        var properties = noteProps.out;
        var details = {
          contactID: contactID,
          topicID: formFeatures.noteTopic.id,
          segmentID: formFeatures.noteTopic.segmentID,
          subject: subject,
          body: formFeatures.note.body
        };
        iservice.API('webapp-api-custinfo?api=contactnote', null, { contactID: contactID, properties: properties, details: details }, null).then(function (data) {
          iservice.SuccessMessage('Note created successfuly');
          // iservice.SanitizeHistoryRow(data.row);
          interactions.add(data.row);
          IDs.push(data.row.id);
          formFeatures.note.body = '';
          formFeatures.closereason = 'Open';
          formFeatures.nextcalldate = undefined;
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      var columns = [
        Vue.reactive({
          name: 'expand', hidable: false,
          filterText: function () { },
          componentHead: 'iservice-table-head-empty', componentCell: 'iservice-table-cell-expand', shown: true, tdClass: 'expand-td'
        }),
        Vue.reactive({
          name: 'Subject', label: 'Subject',
          filterText: iservice.tables.SimpleFilterTextFunc(interactions, 'subjectBare'),
          componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
        }),
        Vue.reactive({
          name: 'Type', label: 'Type',
          filterText: iservice.tables.SimpleFilterTextFunc(interactions, 'type'),
          componentHead: 'iservice-table-head-sortable-label', componentCell: 'interaction-type-display', shown: true
        }),
        /*Vue.reactive({
          name: 'Properties', label: 'Properties',
          filterText: iservice.tables.SimpleFilterTextFunc(interactions, 'company'),
          componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
        }),*/
        Vue.reactive({
          name: 'Date', label: 'Date',
          sortIncreasing: false,
          filterText: iservice.tables.DateFilterTextFunc(interactions, 'date'),
          sortText: iservice.tables.DateSortTextFunc(interactions, 'date'),
          componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
        })];
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        componentExpanded: 'previewdialer-loader',
        filterLabel: 'Filter History',
        emptyMessage: 'No history',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Date',
        columns: columns,
        exportName: "Contact History"
      });
      var IDs = Vue.reactive([]);
      tableConfig.searching = true;
      iservice.API('webapp-api-mq-search?api=search', null, {
        fields: {
          groups: [{
            fields: [{
              where: 'entire',
              fieldID: 'ownerid',
              searchString: contactID
            }]
          }]
        },
        pageNum: 0,
        perPage: 2500
      }).then(function (data) {

        var interactionsData = data.interactions.filter(filterNotificationInteraction);

        interactionsData.forEach(function (interaction) {
          interactions.add(interaction);
          IDs.push(interaction.id);
        });

        tableConfig.searching = false;
      });
      function filterNotificationInteraction(row) {
        if (row.type == 'Auto Response') row.type = 'Message Acknowledgment';
        if (row.type == 'Find Answer') row.type = 'Knowledge Base Article';
        if (row.type == 'Notification') row.type = 'Secure Notification';
        if (row.type == 'Ticket') row.type = 'Agent Ticket';
        if (row.type == 'Ask A Question') row.type = 'Customer Ticket';
        return !iservice.types.IsNotification(row.type);
      }
      formFeatures.load = true;
      return { formFeatures, loggedIn, tableConfig, IDs  }
    }
  }
  iservice.components.PreviewDialerLoader = {
    name: 'previewdialer-loader',
    template: '#previewdialer-loader',
    props: ['itemid'],
    setup(props) {
      var interactions = iservice.InteractionData();
      var loading = Vue.ref(true);
      iservice.API('webapp-api-history?api=details', null, { interactionID: props.itemid }).then(data => {
        interactions.add(data);
        if (data.history && data.history.length) {
          data.history.forEach(item => {
            interactions.add(item);
          });
        }
      }).catch(errors => {

      }).finally(() => {
        loading.value = false;
      });

      var viewComponent = 'previewdialer-view';
      return { loading, viewComponent }
    }
  }
  iservice.components.PreviewDialerView = {
    name: 'previewdialer-view',
    template: '#previewdialer-view',
    props: ['itemid'],
    setup(props) {
      var interactions = iservice.InteractionData();
      var interaction = Vue.computed(function () {
        return interactions.get(props.itemid);
      });
      return { interaction }
    }
  }
})(iservice);