﻿export function directiveNotDatatableControls()
{

  return {
    restrict: 'E',
    transclude: true,
    scope: {
      viewer: '='
    },
    template: `
      <div class="notdatatable form-inline" iservice-id-prefix="'TableControls'">
        <div class="table-controls table-columns" ng-if="viewer.showButtons">
          <div class="btn-group">
            <button ng-if="viewer.CanExport()" iservice-id="ExportExcel" class="btn btn-default" type="button" ng-click="viewer.ExportExcel()"><span>Excel</span></button>
            <button iservice-id="Visibility" class="btn btn-default button-columns" type="button" ng-click="viewer.PickerToggle()"><span>Column visibility</span></button>
            <div class="column-picker" ng-show="viewer.PickerOpen()">
              <div iservice-id-prefix="'Column'" ng-repeat="column in viewer.columns" ng-class="viewer.PickerClass(column)" ng-click="viewer.ColumnPickerClick(column)">
                <a href="" iservice-id="Link">{{ viewer.columnPicker[column.var].name }}</a>
              </div>
            </div>
          </div>
        </div>
        <div class="table-controls table-pagesize table-columns">
          <label>Show <select iservice-id="PageSize" ng-model="viewer.pageSize" class="form-control input-xs" ng-options="+(unit) as unit for unit in [5, 10, 25, 50, 100, 250, 500, 1000]"></select> entries</label>
        </div>
        <div class="table-controls table-pagesize" ng-if="viewer.showPastField">
          <label>Show past <input type="text" ng-model="viewer.pastDayValue" class="form-control input-xs" style="width: 50px;" /> days</label>
        </div>
        <div class="table-controls table-filter" ng-if="!viewer.showCustomSearch">
          <ng-transclude></ng-transclude><input iservice-id="Filter" ng-model="viewer.filterString" type="search" class="form-control" placeholder="">
        </div>
        <div class="table-controls table-filter" ng-if="viewer.showCustomSearch">
          <ng-transclude></ng-transclude>
          <div class="input-group search-mail">
						<input iservice-id="Filter" ng-model="viewer.filterString" type="search" class="form-control" placeholder="">
						<span class="input-group-addon"><i class="fa fa-search"></i></span>
					</div>
        </div>
      </div>`,
    replace: true
  };
}

export function directiveNotDatatableInfo() {

  return {
    restrict: 'E',
    transclude: true,
    scope: {
      viewer: '='
    },
    template: `
    <div iservice-id-prefix="'TableInfo'">
      <div class="notdatatable table-info" ng-if="!viewer.InfoStr()" iservice-id="NoItems"><ng-transclude></ng-transclude></div>
      <div class="notdatatable table-info" ng-if="viewer.InfoStr()" iservice-id="ItemsInfo">{{ viewer.InfoStr() }}</div>
      <div class="notdatatable table-pagination text-right" ng-if="viewer.pageLabels.length > 0">
        <ul class="pagination">
          <li><a ng-click="viewer.ShowPage({ num: viewer.currentPage - 1 })" href="" iservice-id="NavPrev">Previous</a></li>
          <li iservice-id-prefix="'NavPage'" ng-class="viewer.PaginateClass(page)" ng-repeat="page in viewer.pageLabels"><a ng-show="page.link" iservice-id="Link" ng-click="viewer.ShowPage(page)" href="">{{ page.num + 1 }}</a><a ng-hide="page.link" iservice-id="Link" href="">...</a></li>
          <li><a ng-click="viewer.ShowPage({ num: viewer.currentPage + 1 })" href="" iservice-id="NavNext">Next</a></li>
        </ul>
      </div>
    </div>`,
    replace: true
  };
}