﻿export function FactoryPlugins() {
  var normal = {
    priority: 0,
    func: function (interaction) { return true; },
    detailsPanel: 'interaction-view.html',
    answerPanel: 'interaction-operation-answer.html'
  };
  var pending = {
    priority: 10,
    func: function (interaction) { return interaction.status == 'Pending'; },
    detailsPanel: 'interaction-view.html',
    answerPanel: 'interaction-operation-answer.html',
    noMassUpdate: false
  };
  var quotePending = {
    priority: 20,
    func: function (interaction) {
      if (interaction.status != 'Unassigned' && interaction.status != 'Queued') return false;
      return HasTag(interaction, 'Pending Quote') ? true : false;
    },
    detailsPanel: 'quotepending-view.html',
    answerPanel: 'quotepending-answer.html',
    noMassUpdate: false
  };
  var plugins = [normal, pending, quotePending];
  
  var service = {
    normal: normal,
    pending: pending,
    quotePending: quotePending,
    plugins: plugins,
    window: window,
    FindPlugin: function (interaction) {
      if (!interaction) return normal;
      var best = null;
      plugins.forEach(function (plugin) {
        if (!plugin.func) return;
        if (best != null && best.priority > plugin.priority) return;
        if (!plugin.func(interaction)) return;
        best = plugin;
      });
      if (!best) best = normal;
      return best;
    }
  }
  return service;
}
FactoryPlugins.$inject = [];
