﻿/// <reference path="iservice.customerinfo.js" />
var iservice = window.iservice || {};
(function (iservice) {
  iservice.components = iservice.components || {};

  iservice.components.adminSmtpout = {
    name: 'vueapp-admin-smtpout',
    template: '#vueapp-admin-smtpout',
    route() { return { path: iservice.formPath + '/admin/smtpout', priority: 300 } },
    setup(props) {

      return {  };
    }
  };
  iservice.components.adminAgents = {
    name: 'vueapp-admin-agents',
    template: '#vueapp-admin-agents',
    route() { return { path: iservice.formPath + '/admin/agent/:id?/:tab?/:stockid?', priority: 300, meta: { title: "iService | Agents" } } },
    setup(props) {

      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });

      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.Agents');
      var segments = iservice.SegmentData();
      var agents = iservice.AgentData();
      var usertypes = iservice.UserTypesData();
      var departments = iservice.DepartmentsData();
      var skills = iservice.SkillData();

      if (!segments.loaded) {
        segments.Load();
      }
      if (!agents.loaded) {
        agents.Load();
      }
      if (!usertypes.loaded) {
        usertypes.Load();
      }
      if (!departments.loaded) {
        departments.Load();
      }
      if (!skills.loaded) {
        skills.Load();
      }
      var usertypeList = Vue.computed(function () {
        if (!usertypes.loaded) {
          usertypes.Load();
        }
        var types = [];
        usertypes.list.forEach(function (usertype) {
          types.push(usertype);
        })
        return types;
      })
      var agentsInfo = Vue.reactive({});
      var isUserLoggedIn = Vue.computed(function () {
        if (!agents.loaded) {
          agents.Load();
        }
        var loggedIn = false;
        var agent = agents.get(formFeatures.details.id);

        if (agent && agent.isLoggedIn) loggedIn = true;
        return loggedIn;
      })
      var isUserAvailable = Vue.computed(function () {
        if (!agents.loaded) {
          agents.Load();
        }
        var isAvailable = false;
        var agent = agents.get(formFeatures.details.id);

        if (agent && agent.isAvailable) isAvailable = true;
        return isAvailable;
      })
      function ShowCount(agentsMax, agentsNum, agentsMaxChat, agentsChat) {
        agentsInfo.agentsMax = agentsMax;
        agentsInfo.agentsNum = agentsNum;
        if (agentsInfo.agentsMax == 0) {
          agentsInfo.agentsPercent = null;
        }
        else {
          agentsInfo.agentsPercent = Math.round(100 * agentsInfo.agentsNum / agentsInfo.agentsMax) + '%';
        }
        agentsInfo.agentsMaxChat = agentsMaxChat;
        agentsInfo.agentsChat = agentsChat;
        if (agentsInfo.agentsMaxChat == 0) {
          agentsInfo.agentsChatPercent = null;
        }
        else {
          agentsInfo.agentsChatPercent = Math.round(100 * agentsInfo.agentsChat / agentsInfo.agentsMaxChat) + '%';
        }
      }
      Vue.watchEffect(function () {
        if (agents.data)
          ShowCount(agents.data.agentsMax, agents.data.agentsNum, agents.data.agentsMaxChat, agents.data.agentsChat)
      })
     
      var ListCollapsed = Vue.reactive({ isListCollapsed: true })
      ListCollapsed.Toggle = function () {
        return ListCollapsed.isListCollapsed = !ListCollapsed.isListCollapsed;
      }
      var LicenseToggle = Vue.reactive({ isLicenseToggle: true })
      LicenseToggle.Toggle = function () {
        return LicenseToggle.isLicenseToggle = !LicenseToggle.isLicenseToggle;
      }
      var SegmentToggle = Vue.reactive({ isSegmentToggle: true })
      SegmentToggle.Toggle = function () {
        return SegmentToggle.isSegmentToggle = !SegmentToggle.isSegmentToggle;
      }
      var featureTabs = Vue.reactive({ tab: 'details' });
      featureTabs.TabClass = function (tab) { return { 'active': tab == featureTabs.tab } }
      featureTabs.TabClick = function (tab) {
        featureTabs.tab = tab;
        if (tab == 'contact' || tab == 'stock') {
          router.push({ params: { tab: tab, stockid: '' } });
        } else {
          router.push({ params: { tab: "", stockid: ''  } });
        }
      }

      var router = VueRouter.useRouter();

      formFeatures.details = {
        windowsLoginName: '',
        userTypeID: '',
        segmentIDs: [],
        departmentIDs: [],
        skillIDs: []
      }
      var selectedID = Vue.ref(null);
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;

        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            windowsLoginName: '',
            userTypeID: '',
            segmentIDs: [],
            departmentIDs: [],
            skillIDs: [],
            emailAddress: '',
            password: ''
          }
          formFeatures.alreadyExists = false;
          formFeatures.step1 = true;
          formFeatures.step2 = false;
          formFeatures.step3 = false;
          formFeatures.step4 = false;
          formFeatures.showUsertype = false;
          formFeatures.showPassword = false;
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }
      Vue.watchEffect(function () {
        if (!segments.list.length) return;
        formFeatures.segmentOptions = segments.list.filter(function (segment) {
          return !segment.hidden;
        })
      })

      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(agents, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Email', label: 'Email',
            filterText: iservice.tables.SimpleFilterTextFunc(agents, 'email'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Full Name', label: 'Full Name',
            filterText: iservice.tables.SimpleFilterTextFunc(agents, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Windows Login Name', label: 'Windows Login Name',
            filterText: iservice.tables.SimpleFilterTextFunc(agents, 'windowsLoginName'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'User Type', label: 'User Type',
            filterText: iservice.tables.SimpleFilterUserTypeFunc(agents, 'typeID'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-user-type', shown: true
          }),
          Vue.reactive({
            name: 'Segment Access', label: 'Segment Access',
            filterText: iservice.tables.SimpleFilterTextFunc(agents, 'segments'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Skills', label: 'Skills',
            filterText: iservice.tables.SimpleFilterTextFunc(agents, 'skills'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Department Membership', label: 'Department Membership',
            filterText: iservice.tables.SimpleFilterTextFunc(agents, 'departments'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Receive Notifications', label: 'Receive Notifications',
            Save: ReceiveToggle,
            filterText: iservice.tables.SimpleFilterTextFunc(agents, 'doReceive'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-receive-notification-toggle', shown: false
          }),
          Vue.reactive({
            name: 'Logged In', label: 'Logged In',
            filterText: iservice.tables.SimpleFilterTextFunc(agents, 'isLoggedIn'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-logged-in', shown: true
          }),
          Vue.reactive({
            name: 'Chat Available', label: 'Chat Available',
            filterText: iservice.tables.SimpleFilterTextFunc(agents, 'isAvailable'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-chat-available', shown: true
          }),
          Vue.reactive({
            name: 'Last Activity', label: 'Last Activity',
            filterText: iservice.tables.DateFilterTextFunc(agents, 'activity'), sortText: iservice.tables.DateSortTextFunc(agents, 'activity'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Empty Inbox', label: 'Empty Inbox',
            Save: EmptyToggle,
            filterText: iservice.tables.SimpleFilterTextFunc(agents, 'doEmpty'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-empty-inbox-toggle', shown: false
          }),
          Vue.reactive({
            name: 'Inactivity Timeout', label: 'Inactivity Timeout',
            filterText: iservice.tables.SimpleFilterTextFunc(agents, 'timeout'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-inactivity', shown: false
          })];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Agents',
        emptyMessage: 'No agents',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Email',
        columns: tableColumns.value,
        exportName: "Agents"
      });
      var IDs = Vue.reactive([]);
      var itemsProcessed = 0;
      tableConfig.searching = true;
      var loaded = false;
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!agents.list.length) return;
        if (formFeatures.shownToggleRunning) return;
        if (loaded) return;
        agents.list.forEach(function (agent) {
          var id = agent.id;
          agents.add(agent);
          IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == agents.list.length) {
            tableConfig.searching = false;
            loaded = true;
          }
        });
      });
      formFeatures.CanModifyLogins = function (groups) {
        for (var i = 0; i < groups.length; i++) if (groups[i].logins && groups[i].logins.length && groups[i].canModifyLogins) return true;
        return false;
      }
      formFeatures.CollectLogins = function (groups) {
        var logins = [];
        for (var g = 0; g < groups.length; g++) if (groups[g].logins) for (var l = 0; l < groups[g].logins.length; l++) {
          var source = groups[g].logins[l];
          if (!source.name) continue;
          logins.push(source);
        }
        return logins;
      }
      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { id } });
      });
      formFeatures.custInfoProps = {}
      formFeatures.Save = function () {
        iservice.SetPropertyValue(formFeatures.settings, 'Receive Notifications', (formFeatures.details.doReceive) ? 'True' : 'False');
        iservice.SetPropertyValue(formFeatures.settings, 'Empty Inbox When Logged Out', (formFeatures.details.doEmpty) ? 'True' : 'False');
        iservice.SetPropertyValue(formFeatures.settings, 'Inactivity Timeout Minutes', formFeatures.details.timeout);
        iservice.SetPropertyValue(formFeatures.settings, 'Notification Address', formFeatures.settingNotficationAddress[0].def.values[0].value);
        var settings = []
        formFeatures.props = [];

        var settingProps = {}
        var globalProps = [];
        formFeatures.settings.forEach(function (segment, key) {
          if (segment.name == 'Global')
            globalProps.push(segment);
        })
        iservice.EditableProperties(settingProps, globalProps);
        formFeatures.settings.forEach(function (segment, key) {
          formFeatures.props = settingProps.out;
          segment.propertiesLeft.forEach(function (prop) {
            formFeatures.props.push({ propertyID: prop.def.propertyID, values: [{ value: prop.firstValue }] });
          });
          segment.propertiesRight.forEach(function (prop) {
            formFeatures.props.push({ propertyID: prop.def.propertyID, values: [{ value: prop.def.firstValue }] });
          });
          segment.properties.forEach(function (property) {
            formFeatures.props.forEach(function (prop) {
              if (prop.propertyID == property.propertyID) {
                if (prop.values[0] && !prop.values[0].value) prop.values = [];
                settings.push(prop);
              }
            })
          })
        });
        var custProps = [];
        //remove agents settings properties from custinfo properties
        formFeatures.custinfo.properties.forEach(function (segment) {
          segment.properties.forEach(function (item) {
            if (item.name !== 'Receive Notifications' && item.name !== 'Empty Inbox When Logged Out' && item.name !== 'Inactivity Timeout Minutes' && item.name !== 'Notification Address') {
              custProps.push(item);
            }
          })
        });
        iservice.EditableProperties(formFeatures.custInfoProps, custProps);
        var custinfo = {
          properties: formFeatures.custInfoProps.out,
          setLogins: formFeatures.CanModifyLogins(formFeatures.custinfo.properties),
          logins: formFeatures.CollectLogins(formFeatures.custinfo.properties)
        };
        iservice.API('webapp-api-admin?api=agentmodify&mode=modify', null, { agentID: selectedID.value, details: formFeatures.details, settings: settings, custinfo: custinfo, membership: formFeatures.custinfo.membership }).then(function (result) {
          agents.add(result.row);
          iservice.SuccessMessage('Agent updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      var contactDetails = Vue.reactive({})
      formFeatures.settingsProps = {};
      formFeatures.settings = [];
      formFeatures.propertiesLeft = {}
      formFeatures.propertiesRight = {}
      formFeatures.settingReceiveNotifications = {};
      formFeatures.settingNotficationAddress = {};
      formFeatures.settingEmptyInboxWhenLoggedOut = {};
      formFeatures.settingInactivityTimeoutMinutes = {};
      
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.id) {
          formFeatures.ShowDeleteButton = true;
          iservice.API('webapp-api-admin?api=agentdetails', null, { agentID: router.currentRoute.value.params.id }).then(function (result) {
            if (router.currentRoute.value.params.tab && router.currentRoute.value.params.tab == 'contact') {
              featureTabs.tab = 'contact';
            }
            if (router.currentRoute.value.params.tab && router.currentRoute.value.params.tab == 'stock') {
              featureTabs.tab = 'stock';
            }
            contactDetails.contactId = router.currentRoute.value.params.id
            selectedID.value = router.currentRoute.value.params.id;
            formFeatures.ChangeState('details');
            formFeatures.details = result.details;
            formFeatures.settings = result.settings;
            formFeatures.custinfo = result.custinfo;
          
            result.settings.forEach(function (segment, key) {
              
              formFeatures.settingsProps[key] = {}
              segment.propertiesLeft = []
              segment.propertiesRight = []
              iservice.EditableProperties(formFeatures.settingsProps[key], segment.properties);
            
              var properties = formFeatures.settingsProps[key].props.filter(function (prop, ind) {
                if (!prop.def.values.length)
                  prop.def.values.push(Vue.reactive({ value: '', valueNumber: null, valueInt: null, valueDate: null, valueDatetime: null }));
                if (prop.def.name == 'Receive Notifications') {
                  formFeatures.settingReceiveNotifications[key] = prop; return false;
                }
                if (prop.def.name == 'Notification Address') {
                  formFeatures.settingNotficationAddress[key] = prop; return false;
                }
                if (prop.def.name == 'Empty Inbox When Logged Out') {
                  formFeatures.settingEmptyInboxWhenLoggedOut[key] = prop; return false;
                }
                if (prop.def.name == 'Inactivity Timeout Minutes') {
                  formFeatures.settingInactivityTimeoutMinutes[key] = prop; return false;
                }
                return true;
              });
              var totalHeight = properties.reduce(function (prev, property) {
                return (property.def.values.length ? property.def.values.length: 1 * (property.def.isMultiLine ? 2 : 1)) + prev;
              }, 0);
              var leftHeight = 0;
              properties.forEach(function (property) {
                if (leftHeight < totalHeight / 2) {
                  segment.propertiesLeft.push(property);
                }
                else {
                  segment.propertiesRight.push(property);
                }
                leftHeight += property.def.values.length * (property.def.isMultiLine ? 2 : 1);
              });
              
            });
            formFeatures.details.activityAgo = moment(result.details.activity).fromNow();
          }).then(function (result) {

          }).catch(function (errors) {

          }).finally(function () {

          });
        }
      });

      function ReceiveToggle(agent) {
        agent.shownRunning = true;
        var settings = Vue.reactive({});
        var custinfo = {
          properties: []
        };
        iservice.API('webapp-api-admin?api=agentdetails', null, { agentID: agent.id }).then(function (result) {
          iservice.SetPropertyValue(result.settings, 'Receive Notifications', (agent.doReceive) ? 'True' : 'False');
          result.details.doReceive = agent.doReceive ? 'True' : 'False';
          iservice.EditableProperties(settings, result.settings);
          return iservice.API('webapp-api-admin?api=agentmodify&mode=modify', null, { agentID: agent.id, details: result.details, settings: settings.out, custinfo: custinfo, membership: formFeatures.custinfo.membership }).then(function (result) {
            agents.add(result.details);
            iservice.SuccessMessage('Agent updated successfully.');
            formFeatures.details.doReceive = agent.doReceive;
          }).catch(function (errors) {
            formFeatures.errors = errors;
          });
        }).catch(function (errors) {
        }).finally(function () {
          agent.shownRunning = false;
        });
      }
      function EmptyToggle(agent) {
        agent.shownRunning = true;
        var settings = Vue.reactive({});
        var custinfo = {
          properties: []
        };
        iservice.API('webapp-api-admin?api=agentdetails', null, { agentID: agent.id }).then(function (result) {
          iservice.SetPropertyValue(result.settings, 'Empty Inbox When Logged Out', (agent.doEmpty)  ? 'True' : 'False');
          result.details.doReceive = agent.doReceive ? 'True' : 'False';
          iservice.EditableProperties(settings, result.settings);
          return iservice.API('webapp-api-admin?api=agentmodify&mode=modify', null, { agentID: agent.id, details: result.details, settings: settings.out, custinfo: custinfo, membership: formFeatures.custinfo.membership }).then(function (result) {
            agents.add(result.details);
            iservice.SuccessMessage('Agent updated successfully.');
            formFeatures.details.doEmpty = agent.doEmpty;
          }).catch(function (errors) {
            formFeatures.errors = errors;
          });
        }).catch(function (errors) {
        }).finally(function () {
          agent.shownRunning = false;
        });
      }
      formFeatures.error = {};
      formFeatures.Create = function () {
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;
        if (!formFeatures.details.userTypeID) {
          formFeatures.errors.push({ msg: 'Please select agent user type.', details: { description: '' } });
          formFeatures.error.userType = true;
        }
        if (formFeatures.errors.length) return;
        iservice.API('webapp-api-admin?api=agents&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          agents.add(result.row);
          IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Agent added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        iservice.API('webapp-api-admin?api=agentdetails', null, { agentID: selectedID.value }).then(function (result) {
          result.details.userTypeID = 2;
          iservice.API('webapp-api-admin?api=agentmodify&mode=modify', null, { agentID: selectedID.value, details: result.details, settings: [], custinfo: { properties: [] }, membership: result.custinfo.membership }).then(function (response) {
            formFeatures.ChangeState('cancel');
            formFeatures.ShowDeleteButton = false;
            const index = IDs.indexOf(selectedID.value);
            if (index > -1) {
              IDs.splice(index, 1);
            }
            selectedID.value = '';
            var id = '';
            router.push({ params: { id } })
            ShowCount(agents.data.agentsMax, response.agentsNum, agents.data.agentsMaxChat, response.agentsChat)
            iservice.SuccessMessage('Agent removed successfully.');
          }).catch(function (errors) {
            formFeatures.errors = errors;
            agent.removeRunning = false;
          });
        });
      }
      formFeatures.alreadyExists = false;
      formFeatures.showUsertype = false;
      formFeatures.showPassword = false;
      formFeatures.step1 = true;
      formFeatures.checkUserExists = function () {
        formFeatures.errors = [];
        formFeatures.step1 = true;
        formFeatures.step2 = false;
        formFeatures.step3 = false;
        formFeatures.step4 = false;
        if (!formFeatures.details.emailAddress) {
          formFeatures.errors.push({ msg: 'Please enter email address or login.', details: { description: '' } });
          formFeatures.error.emailAddress = true;
        }
        if (formFeatures.errors.length) return;
        iservice.API('webapp-api-custinfo?api=search', null, {
          fields: {
            groups: [
              {
                fields: [{
                  where: 'anywhere',
                  fieldID: 'login',
                  searchString: formFeatures.details.emailAddress
                }]
              }
            ]
          }
        }).then(function (result) {
          if (result.resultCount > 0) {
            formFeatures.showUsertype = false;
            formFeatures.alreadyExists = true;
            formFeatures.step1 = false;
            formFeatures.step2 = true;
          } else {
            formFeatures.alreadyExists = false;
            formFeatures.showPassword = true;
            formFeatures.showUsertype = false;
            formFeatures.step1 = false;
            formFeatures.step2 = false;
            formFeatures.step4 = true;
          }
        }).catch(function (errors) {

        });

      }
      formFeatures.Continue = function (idPrefix, details) {
        formFeatures.step1 = false;
        formFeatures.step2 = false;
        formFeatures.step3 = true;
        formFeatures.step4 = false;
        formFeatures.showUsertype = true;
      }
      formFeatures.ContinueNext = function () {
        formFeatures.errors = [];
        if (!formFeatures.details.password) {
          formFeatures.errors.push({ msg: 'Please enter password.', details: { description: '' } });
          formFeatures.error.password = true;
        }
        if (formFeatures.details.password && formFeatures.details.password.length < 4) {
          formFeatures.errors.push({ msg: 'Password must be atleast 4 characters.', details: { description: '' } });
          formFeatures.error.passwordlength = true;
        }
        if (formFeatures.errors.length) return;
        formFeatures.step1 = false;
        formFeatures.step2 = false;
        formFeatures.step3 = true;
        formFeatures.step4 = false;
        formFeatures.showUsertype = true;
      }
      formFeatures.CancelNewUser = function () {
        formFeatures.ChangeState('cancel');
        formFeatures.alreadyExists = false;
        formFeatures.showUsertype = false;
        formFeatures.showPassword = false;
        formFeatures.step1 = true;
        formFeatures.step2 = false;
        formFeatures.step3 = false;
        formFeatures.step4 = false;
      }

      formFeatures.Logout = function () {
        iservice.API('webapp-api-admin?api=agents&mode=logout', null, { agentID: selectedID.value }).then(function (result) {
          iservice.SuccessMessage('Agent logged out successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }

      return { formFeatures, ListCollapsed, LicenseToggle, segments, departments, skills, usertypeList, tableConfig, IDs, Select, selectedIDs, selectedID, featureTabs, agentsInfo, contactDetails, SegmentToggle, ReceiveToggle, EmptyToggle, isUserLoggedIn, isUserAvailable };
    }
  };
  iservice.components.adminAgentStocks = {
    name: 'admin-agent-stocks',
    template: '#admin-agent-stocks',
   // route() { return { path: iservice.formPath + '/admin/agent/:id?/:tab?/:stockid?', priority: 300 } },
    props: ["contactID", "stocksList", "load"],
    setup(props) {

      var featureLoad = Vue.reactive({ loaded: false, working: false });
      Vue.watchEffect(() => {
        if (!props.load || featureLoad.loaded || featureLoad.working) return;
        featureLoad.working = true;
      });

      //table list collapse toggle
      var ListCollapsed = Vue.reactive({ isListCollapsed: true })
      ListCollapsed.Toggle = function () {
        return ListCollapsed.isListCollapsed = !ListCollapsed.isListCollapsed;
      }

      //router object declartion
      var router = VueRouter.useRouter();

      //form data and features object decralation
      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });

      formFeatures.details = {
        name: '',
        description: '',
        bodyHtml: ''
      }
      var selectedID = Vue.ref(null);
      //table row select callback
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { stockid: id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      //form state change on different actions
      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;

        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { stockid : id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            name: '',
            description: '',
            bodyHtml: ''
          }
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }
      //page access have right 
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.Agents');

      //load stock resposnes 
      var stockresponses = iservice.StockResponsesData();
     
      if (!stockresponses.loaded) {
        stockresponses.Load();
      }

      //table columns declaration
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(stockresponses, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            filterText: iservice.tables.SimpleFilterTextFunc(stockresponses, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Description', label: 'Description',
            filterText: iservice.tables.SimpleFilterTextFunc(stockresponses, 'description'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });

      //table configuration
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Stock Responses',
        emptyMessage: 'No stock responses',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Agent Stock Responses"
      });

      //table data ids array
      formFeatures.IDs = [];
      var itemsProcessed = 0;

      //load table records by pushing ids 
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!stockresponses.list.length) return;
        if (formFeatures.deleteStart) return;
        formFeatures.IDs = [];
        if (formFeatures.IDs.length) return;
        tableConfig.searching = true;
        if (!props.stocksList) return;
        props.stocksList.forEach(function (stockresponse) {
          var id = stockresponse.id;
          stockresponses.add(stockresponse);
          formFeatures.IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == stockresponses.list.length) {
            tableConfig.searching = false;
          }
        });
        tableConfig.searching = false;
      });

      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { stockid: id } });
      })

      //update record
      formFeatures.Save = function () {
        formFeatures.details.contactID = props.contactID;
        iservice.API('webapp-api-admin?api=stockresponses&mode=modify', null, { stockID: selectedID.value, details: formFeatures.details }).then(function (result) {
          stockresponses.add(result.row);
          iservice.SuccessMessage('Stock response updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      //check route params change effect and load details
      Vue.watchEffect(() => {
        
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.stockid) {
          formFeatures.ShowDeleteButton = true;
          iservice.API('webapp-api-admin?api=stockresponsedetails', null, { stockID: router.currentRoute.value.params.stockid }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.stockid;
            formFeatures.ChangeState('details');
            formFeatures.details = result.details;
          }).then(function (result) {

          }).catch(function (errors) {

          }).finally(function () {

          });
        } else {
          selectedID.value = '';
          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          formFeatures.ShowNew = false;
          formFeatures.ShowDetails = false;
        }
      });
      formFeatures.error = {};

      //create new record
      formFeatures.Create = function () {
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;
        if (!formFeatures.details.name) {
          formFeatures.errors.push({ msg: 'Please enter stock name.', details: { description: '' } });
          formFeatures.error.name = true;
        }
        if (!formFeatures.details.bodyHtml) {
          formFeatures.errors.push({ msg: 'Please enter Body.', details: { description: '' } });
          formFeatures.error.bodyHtml = true;
        }
        if (formFeatures.errors.length) return;
        formFeatures.details.contactID = props.contactID;
        iservice.API('webapp-api-admin?api=stockresponses&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          stockresponses.add(result.row);
          formFeatures.IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Stock response added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }

      //delete record
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        iservice.API('webapp-api-admin?api=stockresponses&mode=delete', null, { stockID: selectedID.value }).then(function (result) {

          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = formFeatures.IDs.indexOf(selectedID.value);
          if (index > -1) {
            formFeatures.IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { stockid: id } })
          iservice.SuccessMessage('Stock response deleted successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {

        });
      }
      return { formFeatures, ListCollapsed, tableConfig, Select, selectedIDs, selectedID, featureLoad };
    }
  };

  //admin segment component
  iservice.components.adminSegments = {
    name: 'vueapp-admin-segment',
    template: '#vueapp-admin-segment',
    route() { return { path: iservice.formPath + '/admin/segment/:id?/:tab?/:tabid?', priority: 300, meta: { title: "iService | Segment" } } },
    setup(props) {
      //declare router object
      var router = VueRouter.useRouter();

      //declare form data object and features object
      var formFeatures = Vue.reactive({ errors: [], success: '', HaveSegments: false });

      var featureTabs = Vue.reactive({ tab: 'details' });
      featureTabs.TabClass = function (tab) { return { 'active': tab == featureTabs.tab } }
      featureTabs.TabClick = function (tab, name = '') {
        featureTabs.tab = tab;
        router.push({ params: { tab: name, tabid: '' } });
      }
      Vue.watchEffect(function () {
        switch (router.currentRoute.value.params.tab) {
          case 'interaction-properties': featureTabs.tab = 'interaction-properties'; break;
          case 'contact-properties': featureTabs.tab = 'contact-properties'; break;
          case 'mailboxes': featureTabs.tab = 'mailboxes'; break;
          case 'notifications': featureTabs.tab = 'notifications'; break;
          case 'stock-responses': featureTabs.tab = 'stock-responses'; break;
          case 'topics': featureTabs.tab = 'topics'; break;
          case 'filters': featureTabs.tab = 'filters'; break;
          case 'filter-groups': featureTabs.tab = 'filters'; break;
          default: featureTabs.tab = 'details'
        }
      });

      formFeatures.details = {};
      formFeatures.parentSegments = [{ id: '1', name: '-- None --' }];

      //if have right to access page
      formFeatures.HaveSegments = iservice.HaveRight('Tab.Admin.Segments');
      featureTabs.HaveDetails = iservice.HaveRight('Tab.Segments.Details');
      featureTabs.HaveIntProps = iservice.HaveRight('Tab.Admin.InteractionProperties');
      featureTabs.HaveContactProps = iservice.HaveRight('Tab.Admin.ContactProperties');
      featureTabs.HaveNotifications = iservice.HaveRight('Tab.Segments.Topics');
      featureTabs.HaveMailboxes = iservice.HaveRight('Tab.Segments.Mailboxes');
      featureTabs.HaveTopics = iservice.HaveRight('Tab.Segments.Topics');
      featureTabs.HaveFilters = iservice.HaveRight('Tab.Segments.Filters');

      //load segments
      var segments = iservice.SegmentData();

      //load servicelevels
      var servicelevels = iservice.ServiceLevelData();

      //load mailboxes
      var mailboxes = iservice.MailboxData();

      var autoResponses = iservice.AutoResponseData();

      if (!segments.loaded) {
        segments.Load(); //if not loaded then load
      }

      if (!servicelevels.loaded) {
        servicelevels.Load(); //if not loaded then load
      }
      if (!mailboxes.loaded) {
        mailboxes.Load(); //if not loaded then load
      }

      var levels = Vue.reactive([{ id: '', name: '-- None --', minutes: '', intPropertyID: '', intPropertyValue: '', contactPropertyID: '', contactPropertyValue: '' }]);
      formFeatures.servicelevels = Vue.computed(function () {
        if (!servicelevels.list.length) return;
        servicelevels.list.forEach(function (level) {
          levels.push(level);
        });
        return levels;
      });

      formFeatures.mailboxes = Vue.computed(function () {
        var mailboxData = [{ value: '', name: '-- None --', email: '', search: '-- None --' }];
        if (!mailboxes.list.length) return;
        mailboxes.inSegment(router.currentRoute.value.params.id).forEach(mailbox => {
          var option = {
            value: mailbox.id,
            name: mailbox.name,
            label: mailbox.segmentName + ' -- ' + mailbox.name,
            email: mailbox.replyTo,
            search: mailbox.name + '\n' + mailbox.replyTo
          };
          mailboxData.push(option);
        });
        return mailboxData;
      })

      function GetValidParents(segment) {
        formFeatures.parentSegments = [{ id: '1', name: '-- None --' }];
        var parentForID = {};
        segments.list.forEach(function (segment) {
          parentForID[segment.id] = segment.parentID;
        });
        var invalidParents = {};
        invalidParents[segment.id] = true;
        segments.list.forEach(function (segment) {
          var id = segment.id;
          while (id) {
            if (invalidParents[id]) break;
            id = parentForID[id];
          }
          if (id) invalidParents[segment.id] = true;
        });
        segments.list.forEach(function (segment) {
          if (segment.id == '1' || invalidParents[segment.id]) return;
          formFeatures.parentSegments.push(segment);
        });
      }
   
      formFeatures.Heading = 'Segment Settings';
      Vue.watchEffect(function () {
        autoResponses.Load();
        segments.Load();
        var urlID = router.currentRoute.value.params.id;
        var currentSegment = segments.get(urlID);
        formFeatures.isStandard = currentSegment?.isStandard;
        if (urlID)
          GetValidParents(urlID);
        formFeatures.Heading = currentSegment ? currentSegment.name + ' Settings' : 'Segment Settings';
      });
      var emptyObj = { id: '', name: '-- None --', segmentID: '', segmentName: '', option: '', lists: '' };
      var responsesAck = Vue.reactive([emptyObj]);
      var responsesCreate = Vue.reactive([emptyObj]);
      var responsesAgent = Vue.reactive([emptyObj]);
      var responsesArticle = Vue.reactive([emptyObj]);
      formFeatures.responsesCreate = Vue.computed(function () {
        if (!autoResponses.list.length) return;
        autoResponses.inSegment(router.currentRoute.value.params.id).some(function (response) {
          if (response.listNames.includes('accountcreation')) {
            responsesCreate.push(response);
          }
        });
        return responsesCreate;
      });
      formFeatures.responsesAck = Vue.computed(function () {
        if (!autoResponses.list.length) return;
        autoResponses.inSegment(router.currentRoute.value.params.id).some(function (response) {
          if (response.listNames.includes('topicautoresponse')) {
            responsesAck.push(response);
          }
        });
        return responsesAck;
      });
      formFeatures.responsesAgent = Vue.computed(function () {
        if (!autoResponses.list.length) return;
        autoResponses.inSegment(router.currentRoute.value.params.id).some(function (response) {
          if (response.listNames.includes('agentnotification')) {
            responsesAgent.push(response);
          }
        });
        return responsesAgent;
      });
      formFeatures.responsesArticle = Vue.computed(function () {
        if (!autoResponses.list.length) return;
        autoResponses.inSegment(router.currentRoute.value.params.id).some(function (response) {
          if (response.listNames.includes('articlenotification')) {
            responsesArticle.push(response);
          }
        });
        return responsesArticle;
      });
      
      //update record
      formFeatures.Save = function () {
        iservice.API('webapp-api-admin?api=segments&mode=modify', null, { segmentID: router.currentRoute.value.params.id, details: formFeatures.details }).then(function (result) {
          iservice.SuccessMessage('Segment updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      Vue.watchEffect(() => {
        if (router.currentRoute.value.params.id && !router.currentRoute.value.params.tab) {
          iservice.API('webapp-api-admin?api=segmentdetails', null, { segmentID: router.currentRoute.value.params.id }).then(function (result) {
            formFeatures.details = result.details;
          }).catch(function (errors) {

          }).finally(function () {

          });
        }
      });


      return { formFeatures, segments, featureTabs, servicelevels};
    }
  };
  iservice.components.adminSegmentIntProps = {
    name: 'vueapp-segment-intproperties',
    template: '#vueapp-segment-intproperties',
    props: ["load"],
    setup(props) {

      var featureLoad = Vue.reactive({ loaded: false, working: false });
      Vue.watchEffect(() => {
        if (!props.load || featureLoad.loaded || featureLoad.working) return;
        featureLoad.working = true;
      });

      //router object declartion
      var router = VueRouter.useRouter();

      //form data and features object decralation
      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });

      formFeatures.details = {}

      formFeatures.details.effects = {}
      var selectedID = Vue.ref(null);
      //table row select callback
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { tabid: id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      //form state change on different actions
      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;

        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { tabid: id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {}
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }
      //page access have right 
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.InteractionProperties');

      //load interaction properties 
      var intProperties = iservice.IntPropertyData();
      var propertytypes = iservice.PropertyTypeData();

      //table columns declaration
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            var: 'id',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(intProperties, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            var: 'name',
            filterText: iservice.tables.SimpleFilterTextFunc(intProperties, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Type', label: 'Type',
            var: 'purpose',
            filterText: iservice.tables.SimpleFilterTextFunc(intProperties, 'purpose'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Value Type', label: 'Value Type',
            var: 'type',
            filterText: iservice.tables.SimpleFilterTextFunc(intProperties, 'type'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-intproperty-type', shown: true
          }),
          Vue.reactive({
            name: 'Required', label: 'Required',
            var: 'isRequired',
            Save: ToggleSave,
            filterText: iservice.tables.SimpleFilterTextFunc(intProperties, 'isRequired'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-intproperty-toggle', shown: true
          }),
          Vue.reactive({
            name: 'Shared', label: 'Shared',
            var: 'isShared',
            Save: ToggleSave,
            filterText: iservice.tables.SimpleFilterTextFunc(intProperties, 'isShared'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-intproperty-toggle', shown: true
          }),
          Vue.reactive({
            name: 'Multi Line', label: 'Multi Line',
            var: 'isMultiLine',
            Save: ToggleSave,
            filterText: iservice.tables.SimpleFilterTextFunc(intProperties, 'isMultiLine'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-intproperty-toggle', shown: false
          }),
          Vue.reactive({
            name: 'Allow Multiple', label: 'Allow Multiple',
            var: 'allowMultiple',
            Save: ToggleSave,
            filterText: iservice.tables.SimpleFilterTextFunc(intProperties, 'allowMultiple'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-intproperty-toggle', shown: false
          }),
          Vue.reactive({
            name: 'Has Description', label: 'Has Description',
            var: 'hasDescriptions',
            Save: ToggleSave,
            filterText: iservice.tables.SimpleFilterTextFunc(intProperties, 'hasDescriptions'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-intproperty-toggle', shown: false
          }),
          Vue.reactive({
            name: 'Customer Viewable', label: 'Customer Viewable',
            var: 'isViewable',
            Save: ToggleSave,
            filterText: iservice.tables.SimpleFilterTextFunc(intProperties, 'isViewable'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-intproperty-toggle', shown: false
          }),
          Vue.reactive({
            name: 'Customer Editable', label: 'Customer Editable',
            var: 'isEditable',
            Save: ToggleSave,
            filterText: iservice.tables.SimpleFilterTextFunc(intProperties, 'isEditable'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-intproperty-toggle', shown: false
          })];

        return columns;
      });

      //table configuration
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Properties',
        emptyMessage: 'No interaction properties',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Segment Interaction Properties"
      });
      formFeatures.routeSegmentID = Vue.computed(function () {
        return router.currentRoute.value.params.id;
      });
      Vue.watchEffect(function () {

        
        if (featureLoad.loaded || !featureLoad.working) return;
        if (!intProperties.loaded) {
          intProperties.Load();
        }
        if (!propertytypes.loaded) {
          propertytypes.Load();
        }
      });
      formFeatures.propertytypes = [
        { name: 'Answer', value: 'Answer' },
        { name: 'Case', value: 'Case' },
        { name: 'Question', value: 'Question' },
        { name: 'Knowledge Base', value: 'Knowledge Base' }
      ];
      formFeatures.types = Vue.computed(function () {
        if (!propertytypes.list) return;
        var propertytypesData = [];
        propertytypes.list.forEach(function (propertyType) {
          propertytypesData.push(propertyType);
        })
        return propertytypesData;
      })
      

      //table data ids array
      formFeatures.IDs = [];
      var itemsProcessed = 0;
      tableConfig.searching = true;
      //load table records by pushing ids 
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!intProperties.list.length) return;
        if (formFeatures.deleteStart) return;
        formFeatures.IDs = [];
      
        intProperties.inSegment(formFeatures.routeSegmentID).forEach(function (intprop) {
          var id = intprop.id;
          formFeatures.IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == intProperties.inSegment(formFeatures.routeSegmentID).length) {
            tableConfig.searching = false;
          }
        });
        if (!intProperties.inSegment(formFeatures.routeSegmentID).length) tableConfig.searching = false;
      });

      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { tabid: id } });
      })

      //update record
      formFeatures.Save = function () {
        formFeatures.details.isOwnerViewable = formFeatures.details.isViewable;
        formFeatures.details.isOwnerEditable = formFeatures.details.isEditable;
        iservice.API('webapp-api-admin?api=intproperties&mode=modify', null, { propertyID: selectedID.value, details: formFeatures.details }).then(function (result) {
          intProperties.add(result.row);
          iservice.SuccessMessage('Interaction Property updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      Vue.watchEffect(() => {
        if (router.currentRoute.value.params.tab != 'interaction-properties') formFeatures.ShowNew = false;
      })
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.tabid && router.currentRoute.value.params.tab == 'interaction-properties') {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=intpropertiesdetails', null, { propertyID: router.currentRoute.value.params.tabid }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.tabid;
            result.details.isViewable = result.details.isOwnerViewable;
            result.details.isEditable = result.details.isOwnerEditable;
            formFeatures.details = result.details;
            iservice.API('webapp-api-admin?api=intpropertyeffects', null, { propertyID: router.currentRoute.value.params.tabid }).then(function (result) {
              formFeatures.details.effects = result.effects;
              formFeatures.loading = false;
            }).catch(function (errors) {

            }).finally(function () {

            });
            formFeatures.ChangeState('details');
          }).then(function (result) {

          }).catch(function (errors) {

          }).finally(function () {

          });
        } else {
          selectedID.value = '';
          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          formFeatures.ShowNew = false;
          formFeatures.ShowDetails = false;
        }
      });
      formFeatures.error = {};


      function ToggleSave(intproperty, action) {
        intproperty.shownRunning = true;
        iservice.API('webapp-api-admin?api=intpropertiesdetails', null, { propertyID: intproperty.id }).then(function (result) {
          if (action == 'isRequired')
            result.details.isRequired = intproperty.isRequired;
          if (action == 'isShared')
            result.details.isShared = intproperty.isShared;
          if (action == 'isMultiLine')
            result.details.isMultiLine = intproperty.isMultiLine;
          if (action == 'allowMultiple')
            result.details.allowMultiple = intproperty.allowMultiple;
          if (action == 'hasDescriptions')
            result.details.hasDescriptions = intproperty.hasDescriptions;
          if (action == 'isViewable')
            result.details.isViewable = intproperty.isViewable;
          if (action == 'isEditable')
            result.details.isEditable = intproperty.isEditable;
          return iservice.API('webapp-api-admin?api=intproperties&mode=modify', null, { propertyID: intproperty.id, details: result.details }).then(function (response) {
            if (action == 'isRequired')
              formFeatures.details.isRequired = intproperty.isRequired;
            if (action == 'isShared')
              formFeatures.details.isShared = intproperty.isShared;
            if (action == 'isMultiLine')
              formFeatures.details.isMultiLine = intproperty.isMultiLine;
            if (action == 'allowMultiple')
              formFeatures.details.allowMultiple = intproperty.allowMultiple;
            if (action == 'hasDescriptions')
              formFeatures.details.hasDescriptions = intproperty.hasDescriptions;
            if (action == 'isViewable')
              formFeatures.details.isViewable = intproperty.isViewable;
            if (action == 'isEditable')
              formFeatures.details.isEditable = intproperty.isEditable;
          }).then(function (result) {
            iservice.SuccessMessage('Interaction Property updated.');
          });
        }).catch(function (errors) {

        }).finally(function () {
          intproperty.shownRunning = false;
        });

      }
      //create new record
      formFeatures.Create = function () {
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;
        if (!formFeatures.details.name) {
          formFeatures.errors.push({ msg: 'Please enter property name.', details: { description: '' } });
          formFeatures.error.name = true;
        }
        if (!formFeatures.details.purpose) {
          formFeatures.errors.push({ msg: 'Please select property type.', details: { description: '' } });
          formFeatures.error.purpose = true;
        }
        if (!formFeatures.details.type) {
          formFeatures.errors.push({ msg: 'Please select property value type.', details: { description: '' } });
          formFeatures.error.type = true;
        }
        if (formFeatures.details.hasDescriptions) {
          if (!formFeatures.details.typeDescription) {
            formFeatures.errors.push({ msg: 'Please select property description type.', details: { description: '' } });
            formFeatures.error.typeDescription = true;
          }
        }
        if (formFeatures.errors.length) return;
        formFeatures.details.segmentID = formFeatures.routeSegmentID;
        formFeatures.details.isOwnerViewable = formFeatures.details.isViewable;
        formFeatures.details.isOwnerEditable = formFeatures.details.isEditable;
        iservice.API('webapp-api-admin?api=intproperties&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          intProperties.add(result.row);
          formFeatures.IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Interaction property added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }

      //delete record
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        iservice.API('webapp-api-admin?api=intproperties&mode=delete', null, { propertyID: selectedID.value }).then(function (result) {

          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = formFeatures.IDs.indexOf(selectedID.value);
          if (index > -1) {
            formFeatures.IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { tabid: id } })
          iservice.SuccessMessage('Interaction property deleted successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {

        });
      }
      var groupBy = function (xs, key) {
        return xs.reduce(function (rv, x) {
          (rv[x[key]] = rv[x[key]] || []).push(x);
          return rv;
        }, {});
      };
      return { formFeatures, tableConfig, Select, selectedIDs, selectedID, featureLoad, groupBy };
    }
  };
  iservice.components.adminSegmentContactProps = {
    name: 'vueapp-segment-contactproperties',
    template: '#vueapp-segment-contactproperties',
    props: ["load"],
    setup(props) {

      var featureLoad = Vue.reactive({ loaded: false, working: false });
      Vue.watchEffect(() => {
        if (!props.load || featureLoad.loaded || featureLoad.working) return;
        featureLoad.working = true;
      });

      //router object declartion
      var router = VueRouter.useRouter();

      //form data and features object decralation
      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });

      formFeatures.details = {}

      formFeatures.details.effects = {}
      var selectedID = Vue.ref(null);
      //table row select callback
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { tabid: id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      //form state change on different actions
      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;

        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { tabid: id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {}
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }
      //page access have right 
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.ContactProperties');

      //load contact properties 
      var contactProperties = iservice.ContactPropertyData();
      var propertytypes = iservice.PropertyTypeData();

      //table columns declaration
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            var: 'id',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(contactProperties, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            var: 'name',
            filterText: iservice.tables.SimpleFilterTextFunc(contactProperties, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Type', label: 'Type',
            var: 'purpose',
            filterText: iservice.tables.SimpleFilterTextFunc(contactProperties, 'purpose'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Value Type', label: 'Value Type',
            var: 'type',
            filterText: iservice.tables.SimpleFilterTextFunc(contactProperties, 'type'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contactproperty-type', shown: true
          }),
          Vue.reactive({
            name: 'Shared', label: 'Shared',
            var: 'isShared',
            Save: ToggleSave,
            filterText: iservice.tables.SimpleFilterTextFunc(contactProperties, 'isShared'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contactproperty-toggle', shown: true
          }),
          Vue.reactive({
            name: 'Multi Line', label: 'Multi Line',
            var: 'isMultiLine',
            Save: ToggleSave,
            filterText: iservice.tables.SimpleFilterTextFunc(contactProperties, 'isMultiLine'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contactproperty-toggle', shown: false
          }),
          Vue.reactive({
            name: 'Allow Multiple', label: 'Allow Multiple',
            var: 'allowMultiple',
            Save: ToggleSave,
            filterText: iservice.tables.SimpleFilterTextFunc(contactProperties, 'allowMultiple'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contactproperty-toggle', shown: false
          }),
          Vue.reactive({
            name: 'Has Description', label: 'Has Description',
            var: 'hasDescriptions',
            Save: ToggleSave,
            filterText: iservice.tables.SimpleFilterTextFunc(contactProperties, 'hasDescriptions'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contactproperty-toggle', shown: false
          }),
          Vue.reactive({
            name: 'Customer Viewable', label: 'Customer Viewable',
            var: 'isViewable',
            Save: ToggleSave,
            filterText: iservice.tables.SimpleFilterTextFunc(contactProperties, 'isViewable'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contactproperty-toggle', shown: false
          }),
          Vue.reactive({
            name: 'Customer Editable', label: 'Customer Editable',
            var: 'isEditable',
            Save: ToggleSave,
            filterText: iservice.tables.SimpleFilterTextFunc(contactProperties, 'isEditable'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contactproperty-toggle', shown: false
          })];

        return columns;
      });

      //table configuration
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Properties',
        emptyMessage: 'No contact properties',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Segment Contact Properties"
      });

      Vue.watchEffect(function () {
        if (featureLoad.loaded || !featureLoad.working) return;
        if (!contactProperties.loaded) {
          contactProperties.Load();
        }
        if (!propertytypes.loaded) {
          propertytypes.Load();
        }
      });
      formFeatures.propertytypes = [
        { name: 'Agent', value: 'Agent' },
        { name: 'Contact', value: 'Contact' }
      ];
      formFeatures.types = Vue.computed(function () {
        if (!propertytypes.list) return;
        var propertytypesData = [];
        propertytypes.list.forEach(function (propertyType) {
          propertytypesData.push(propertyType);
        })
        return propertytypesData;
      })
      formFeatures.routeSegmentID = Vue.computed(function () {
        return router.currentRoute.value.params.id;
      });

      //table data ids array
      formFeatures.IDs = [];
      var itemsProcessed = 0;
      tableConfig.searching = true;

      //load table records by pushing ids 
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!contactProperties.list.length) return;
        if (formFeatures.deleteStart) return;
        formFeatures.IDs = []
        contactProperties.inSegment(formFeatures.routeSegmentID).forEach(function (intprop) {
          var id = intprop.id;
          contactProperties.add(intprop);
          formFeatures.IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == contactProperties.inSegment(formFeatures.routeSegmentID).length) {
            tableConfig.searching = false;
          }
        });
        if (!contactProperties.inSegment(formFeatures.routeSegmentID).length) tableConfig.searching = false;
      });

      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { tabid: id } });
      })

      //update record
      formFeatures.Save = function () {
        formFeatures.details.isOwnerViewable = formFeatures.details.isViewable;
        formFeatures.details.isOwnerEditable = formFeatures.details.isEditable;
        iservice.API('webapp-api-admin?api=contactproperties&mode=modify', null, { propertyID: selectedID.value, details: formFeatures.details }).then(function (result) {
          contactProperties.add(result.row);
          iservice.SuccessMessage('Contact Property updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      Vue.watchEffect(() => {
        if (router.currentRoute.value.params.tab != 'contact-properties') formFeatures.ShowNew = false;
      })
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.tabid && router.currentRoute.value.params.tab == 'contact-properties') {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=contactpropertiesdetails', null, { propertyID: router.currentRoute.value.params.tabid }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.tabid;
            result.details.isViewable = result.details.isOwnerViewable;
            result.details.isEditable = result.details.isOwnerEditable;
            formFeatures.details = result.details;
            
            iservice.API('webapp-api-custinfo?api=search', null, {
              fields: {
                groups: [{
                  fields: [{
                    where: 'anywhere',
                    fieldID: router.currentRoute.value.params.tabid,
                    searchString: ''
                  }]
                }]
              }
            }).then(function (data) {
              formFeatures.numContacts = data.resultCount;
            }).catch(function (errors) {

            })
            iservice.API('webapp-api-admin?api=contactpropertyeffects', null, { propertyID: router.currentRoute.value.params.tabid }).then(function (result) {
              formFeatures.details.effects = result.effects;
              formFeatures.loading = false;
            }).catch(function (errors) {

            }).finally(function () {

            });
            formFeatures.ChangeState('details');
          }).then(function (result) {

          }).catch(function (errors) {

          }).finally(function () {

          });
        } else {
          selectedID.value = '';
          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          formFeatures.ShowNew = false;
          formFeatures.ShowDetails = false;
        }
      });
      formFeatures.error = {};


      function ToggleSave(contactproperty, action) {
        contactproperty.shownRunning = true;
        iservice.API('webapp-api-admin?api=contactpropertiesdetails', null, { propertyID: contactproperty.id }).then(function (result) {
          if (action == 'isShared')
            result.details.isShared = contactproperty.isShared;
          if (action == 'isMultiLine')
            result.details.isMultiLine = contactproperty.isMultiLine;
          if (action == 'allowMultiple')
            result.details.allowMultiple = contactproperty.allowMultiple;
          if (action == 'hasDescriptions')
            result.details.hasDescriptions = contactproperty.hasDescriptions;
          if (action == 'isViewable')
            result.details.isViewable = contactproperty.isViewable;
          if (action == 'isEditable')
            result.details.isEditable = contactproperty.isEditable;
          return iservice.API('webapp-api-admin?api=contactproperties&mode=modify', null, { propertyID: contactproperty.id, details: result.details }).then(function (response) {
            if (action == 'isShared')
              formFeatures.details.isShared = contactproperty.isShared;
            if (action == 'isMultiLine')
              formFeatures.details.isMultiLine = contactproperty.isMultiLine;
            if (action == 'allowMultiple')
              formFeatures.details.allowMultiple = contactproperty.allowMultiple;
            if (action == 'hasDescriptions')
              formFeatures.details.hasDescriptions = contactproperty.hasDescriptions;
            if (action == 'isViewable')
              formFeatures.details.isViewable = contactproperty.isViewable;
            if (action == 'isEditable')
              formFeatures.details.isEditable = contactproperty.isEditable;
          }).then(function (result) {
            iservice.SuccessMessage('Contact Property updated.');
          });
        }).catch(function (errors) {

        }).finally(function () {
          contactproperty.shownRunning = false;
        });

      }

      //create new record
      formFeatures.Create = function () {
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;
        if (!formFeatures.details.name) {
          formFeatures.errors.push({ msg: 'Please enter property name.', details: { description: '' } });
          formFeatures.error.name = true;
        }
        if (!formFeatures.details.purpose) {
          formFeatures.errors.push({ msg: 'Please select property type.', details: { description: '' } });
          formFeatures.error.purpose = true;
        }
        if (!formFeatures.details.type) {
          formFeatures.errors.push({ msg: 'Please select property value type.', details: { description: '' } });
          formFeatures.error.type = true;
        }
        if (formFeatures.details.hasDescriptions) {
          if (!formFeatures.details.typeDescription) {
            formFeatures.errors.push({ msg: 'Please select property description type.', details: { description: '' } });
            formFeatures.error.typeDescription = true;
          }
        }
        if (formFeatures.errors.length) return;
        formFeatures.details.segmentID = formFeatures.routeSegmentID;
        formFeatures.details.isOwnerViewable = formFeatures.details.isViewable;
        formFeatures.details.isOwnerEditable = formFeatures.details.isEditable;
        iservice.API('webapp-api-admin?api=contactproperties&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          contactProperties.add(result.row);
          formFeatures.IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Contact property added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }

      //delete record
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        iservice.API('webapp-api-admin?api=contactproperties&mode=delete', null, { propertyID: selectedID.value }).then(function (result) {

          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = formFeatures.IDs.indexOf(selectedID.value);
          if (index > -1) {
            formFeatures.IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { tabid: id } })
          iservice.SuccessMessage('Contact property deleted successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {

        });
      }
      return { formFeatures, tableConfig, Select, selectedIDs, selectedID, featureLoad };
    }
  };
  iservice.components.adminSegmentNotifications = {
    name: 'vueapp-segment-notifications',
    template: '#vueapp-segment-notifications',
    props: ["load"],
    setup(props) {
      var featureLoad = Vue.reactive({ loaded: false, working: false });
      Vue.watchEffect(() => {
        if (!props.load || featureLoad.loaded || featureLoad.working) return;
        featureLoad.working = true;
      });


      //router object declartion
      var router = VueRouter.useRouter();

      //form data and features object decralation
      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });
      formFeatures.notificationtypes = iservice.notificationtypes;
      formFeatures.details = {}

      //page access have right 
      formFeatures.haveRight = iservice.HaveRight('Tab.Segments.Topics');

      formFeatures.details.effects = {}
      var selectedID = Vue.ref(null);
      //table row select callback
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { tabid: id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      //form state change on different actions
      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;
        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { tabid: id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = { }
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }

      //load stock responses
      var notifications = iservice.AutoResponseData();
      var topics = iservice.TopicData();
      //table columns declaration
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(notifications, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Name', label: 'Notification Name',
            filterText: iservice.tables.SimpleFilterTextFunc(notifications, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Subject', label: 'Subject',
            filterText: iservice.tables.SimpleFilterTextFunc(notifications, 'subject'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Description', label: 'Description',
            filterText: iservice.tables.SimpleFilterTextFunc(notifications, 'description'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Notification Type', label: 'Notification Type',
            filterText: iservice.tables.SimpleFilterTextNotificationTypeFunc(notifications, 'listNames'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-notification-types', shown: true
          }),
          Vue.reactive({
            name: 'UseNoReply', label: 'Use No Reply',
            filterText: iservice.tables.SimpleFilterTextFunc(notifications, 'noReply'),
            Save: ToggleSave,
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-use-no-reply-toggle', shown: true
          })];

        return columns;
      });

      //table configuration
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Notifications',
        emptyMessage: 'No notifications',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Segment Notifications"
      });

      Vue.watchEffect(function () {
        if (featureLoad.loaded || !featureLoad.working) return;
        if (!notifications.loaded || !topics.loaded) {
          notifications.Load(); topics.Load();
        }
      });

      formFeatures.routeSegmentID = Vue.computed(function () {
        return router.currentRoute.value.params.id;
      })

      //table data ids array
      formFeatures.IDs = [];
      var itemsProcessed = 0;
      tableConfig.searching = true;

      //load table records by pushing ids 
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!notifications.list.length) return;
        if (formFeatures.deleteStart) return;
        formFeatures.IDs = []
        notifications.inSegment(formFeatures.routeSegmentID).forEach(function (notification) {
          var id = notification.id;
          notifications.add(notification);
          formFeatures.IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == notifications.inSegment(formFeatures.routeSegmentID).length) {
            tableConfig.searching = false;
          }
        });
        if (!notifications.inSegment(formFeatures.routeSegmentID).length) tableConfig.searching = false;
      });

      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { tabid: id } });
      })

      //update record
      formFeatures.Save = function () {
        var listNames = [];
        listNames.push(formFeatures.details.type);
        formFeatures.details.listNames = listNames;
        iservice.API('webapp-api-admin?api=notifications&mode=modify', null, { notificationID: selectedID.value, details: formFeatures.details }).then(function (result) {
          notifications.add(result.row);
          iservice.SuccessMessage('Notification updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      function ToggleSave(notification) {
        notification.shownRunning = true;
        iservice.API('webapp-api-admin?api=notificationdetails', null, { notificationID: notification.id }).then(function (result) {
          result.details.noReply = notification.noReply;
          return iservice.API('webapp-api-admin?api=notifications&mode=modify', null, { notificationID: notification.id, details: result.details }).then(function (result) {
            notifications.add(result.details);
            formFeatures.details.noReply = notification.noReply;
            iservice.SuccessMessage('Notification updated successfully.');
          }).catch(function (errors) {

          }).finally(function () {
            notification.shownRunning = false;
          });
        }).catch(function (errors) {
        }).finally(function () {
          filter.shownRunning = false;
        });
      }
      Vue.watchEffect(() => {
        if (router.currentRoute.value.params.tab != 'notifications') formFeatures.ShowNew = false;
      });

      formFeatures.segments = Vue.computed(function () {
        if (!topics.loaded) {
          topics.Load();
        }
        if (!topics.list.length) return [];
        var segmentByID = {};
        var segments = [];
        var istopic = formFeatures.details && formFeatures.details.effects && formFeatures.details.effects.topics.length;
        if (istopic) {
          formFeatures.details.effects.topics.forEach(function (topic) {
            var segment = segmentByID[topic.segmentID];
            if (!segment) {
              segment = { id: topic.segmentID, name: topic.segmentName, topics: [], topicByID: {} };
              segmentByID[topic.segmentID] = segment;
              segments.push(segment);
            }
            if (!segment.topicByID[topic.topicID]) {
              var getTopic = topics.get(topic.parentID);
              let obj = { id: topic.topicID, name: topic.name, parentName: topic.parentID ? getTopic.name : '' }
              segment.topicByID[topic.topicID] = obj;
              segment.topics.push(obj);
            }
          });
          segments.sort(function (l, r) {
            return l.name.localeCompare(r.name);
          });
          segments.forEach(function (segment) {
            segment.topics.sort(function (l, r) {
              return l.name.localeCompare(r.name);
            });
          });
        }
        return segments;
      })
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.tabid && router.currentRoute.value.params.tab == 'notifications') {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=notificationdetails', null, { notificationID: router.currentRoute.value.params.tabid }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.tabid;
            formFeatures.details = result.details;
            formFeatures.details.type = result.details.listNames[0];
            formFeatures.ChangeState('details');

            formFeatures.loading = false;
          }).then(function (result) {

          }).catch(function (errors) {

          }).finally(function () {

          });
        } else {
          selectedID.value = '';
          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          formFeatures.ShowNew = false;
          formFeatures.ShowDetails = false;
        }
      });
      formFeatures.error = {};

      //create new record
      formFeatures.Create = function () {
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;
        if (!formFeatures.details.name) {
          formFeatures.errors.push({ msg: 'Please enter name.', details: { description: '' } });
          formFeatures.error.name = true;
        }
        if (!formFeatures.details.subject) {
          formFeatures.errors.push({ msg: 'Please enter subject.', details: { description: '' } });
          formFeatures.error.subject = true;
        }
        if (!formFeatures.details.type) {
          formFeatures.errors.push({ msg: 'Please select notification type.', details: { description: '' } });
          formFeatures.error.type = true;
        }
        if (!formFeatures.details.bodyHtml) {
          formFeatures.errors.push({ msg: 'Please enter notification body.', details: { description: '' } });
          formFeatures.error.bodyHtml = true;
        }

        if (formFeatures.errors.length) return;
        formFeatures.details.segmentID = formFeatures.routeSegmentID;
        formFeatures.details.listNames = [formFeatures.details.type];
        iservice.API('webapp-api-admin?api=notifications&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          notifications.add(result.row);
          formFeatures.IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Notification added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }

      //delete record
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        iservice.API('webapp-api-admin?api=notifications&mode=delete', null, { notificationID: selectedID.value }).then(function (result) {

          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = formFeatures.IDs.indexOf(selectedID.value);
          if (index > -1) {
            formFeatures.IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { tabid: id } })
          iservice.SuccessMessage('Notification deleted successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {

        });
      }
      var editor = Vue.ref(null);
      var anchorStocks = Vue.ref(null);
      var featureStockResponses = Vue.reactive({ filter: '', segmentID: formFeatures.routeSegmentID, showTemplate: true });
      
      featureStockResponses.Open = function () {
        featureStockResponses.Close = iservice.components.popupHolder.Open(anchorStocks, 'stock-responses-menu', false, featureStockResponses);
      }
      featureStockResponses.PasteVar = function (text) {
        if (!editor || !editor.value) return;
        if (featureStockResponses.Close) featureStockResponses.Close();
        editor.value.PasteText(text);
      }
      featureStockResponses.PasteStock = function (html) {
        if (!editor || !editor.value) return;
        if (featureStockResponses.Close) featureStockResponses.Close();
        editor.value.PasteHtml(html);
      }
      featureStockResponses.PasteTemplate = function (html) {
        if (!editor || !editor.value) return;
        if (featureStockResponses.Close) featureStockResponses.Close();
        editor.value.PasteHtml(html);
      }
      
      return { formFeatures, tableConfig, Select, selectedIDs, selectedID, featureLoad, editor, anchorStocks, featureStockResponses };
    }
  };
  iservice.components.adminSegmentStockResponses = {
    name: 'vueapp-segment-stock-responses',
    template: '#vueapp-segment-stock-responses',
    props: ["load"],
    setup(props) {

      var featureLoad = Vue.reactive({ loaded: false, working: false });
      Vue.watchEffect(() => {
        if (!props.load || featureLoad.loaded || featureLoad.working) return;
        featureLoad.working = true;
      });


      //router object declartion
      var router = VueRouter.useRouter();

      //form data and features object decralation
      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });

      formFeatures.details = {}

      formFeatures.details.effects = {}
      var selectedID = Vue.ref(null);
      //table row select callback
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { tabid: id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      //form state change on different actions
      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;

        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { tabid: id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {}
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }

      //load stock responses
      var stockresponses = iservice.StockResponsesData();
      //table columns declaration
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(stockresponses, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            filterText: iservice.tables.SimpleFilterTextFunc(stockresponses, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Description', label: 'Description',
            filterText: iservice.tables.SimpleFilterTextFunc(stockresponses, 'description'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });

      //table configuration
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Stock Responses',
        emptyMessage: 'No stock responses',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Segment Stock Responses"
      });

      Vue.watchEffect(function () {
        if (featureLoad.loaded || !featureLoad.working) return;
        if (!stockresponses.loaded) {
          stockresponses.Load();
        }
      });

      formFeatures.routeSegmentID = Vue.computed(function () {
        return router.currentRoute.value.params.id;
      })

      //table data ids array
      formFeatures.IDs = [];
      var itemsProcessed = 0;
      tableConfig.searching = true;

      //load table records by pushing ids 
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!stockresponses.list.length) return;
        if (formFeatures.deleteStart) return;
        formFeatures.IDs = []
        stockresponses.inSegment(formFeatures.routeSegmentID).forEach(function (intprop) {
          var id = intprop.id;
          stockresponses.add(intprop);
          formFeatures.IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == stockresponses.inSegment(formFeatures.routeSegmentID).length) {
            tableConfig.searching = false;
          }
        });
        if (!stockresponses.inSegment(formFeatures.routeSegmentID).length) tableConfig.searching = false;
      });

      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { tabid: id } });
      })

      //update record
      formFeatures.Save = function () {
        iservice.API('webapp-api-admin?api=stockresponses&mode=modify', null, { stockID: selectedID.value, details: formFeatures.details }).then(function (result) {
          stockresponses.add(result.row);
          iservice.SuccessMessage('Stock Response updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      Vue.watchEffect(() => {
        if (router.currentRoute.value.params.tab != 'stock-responses') formFeatures.ShowNew = false;
      })
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.tabid && router.currentRoute.value.params.tab == 'stock-responses') {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=stockresponsedetails', null, { stockID: router.currentRoute.value.params.tabid }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.tabid;
            formFeatures.details = result.details;
            formFeatures.ChangeState('details');
            formFeatures.loading = false;
          }).then(function (result) {

          }).catch(function (errors) {

          }).finally(function () {

          });
        } else {
          selectedID.value = '';
          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          formFeatures.ShowNew = false;
          formFeatures.ShowDetails = false;
        }
      });
      formFeatures.error = {};

      //create new record
      formFeatures.Create = function () {
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;
        if (!formFeatures.details.name) {
          formFeatures.errors.push({ msg: 'Please enter name.', details: { description: '' } });
          formFeatures.error.name = true;
        }
        if (!formFeatures.details.bodyHtml) {
          formFeatures.errors.push({ msg: 'Please enter stock response body.', details: { description: '' } });
          formFeatures.error.bodyHtml = true;
        }
       
        if (formFeatures.errors.length) return;
        formFeatures.details.segmentID = formFeatures.routeSegmentID;
        iservice.API('webapp-api-admin?api=stockresponses&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          stockresponses.add(result.row);
          formFeatures.IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Stock Response added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }

      //delete record
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        iservice.API('webapp-api-admin?api=stockresponses&mode=delete', null, { stockID: selectedID.value }).then(function (result) {

          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = formFeatures.IDs.indexOf(selectedID.value);
          if (index > -1) {
            formFeatures.IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { tabid: id } })
          iservice.SuccessMessage('Stock response deleted successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {

        });
      }
      var editor = Vue.ref(null);
      var anchorStocks = Vue.ref(null);
      var featureStockResponses = Vue.reactive({ filter: '', segmentID: formFeatures.routeSegmentID });
      featureStockResponses.Open = function () {
        featureStockResponses.Close = iservice.components.popupHolder.Open(anchorStocks, 'stock-responses-menu', false, featureStockResponses);
      }
      featureStockResponses.PasteVar = function (text) {
        if (!editor || !editor.value) return;
        if (featureStockResponses.Close) featureStockResponses.Close();
        editor.value.PasteText(text);
      }
      featureStockResponses.PasteStock = function (html) {
        if (!editor || !editor.value) return;
        if (featureStockResponses.Close) featureStockResponses.Close();
        editor.value.PasteHtml(html);
      }
      return { formFeatures, tableConfig, Select, selectedIDs, selectedID, featureLoad, editor, anchorStocks, featureStockResponses };
    }
  };
  iservice.components.adminSegmentFiltersMain = {
    name: 'vueapp-segment-filters-main',
    template: '#vueapp-segment-filters-main',
    props: ["load"],
    setup(props) {

      var featureLoad = Vue.reactive({ loaded: false, working: false });
      Vue.watchEffect(() => {
        if (!props.load || featureLoad.loaded || featureLoad.working) return;
        featureLoad.working = true;
      });

      //router object declartion
      var router = VueRouter.useRouter();

      //form data and features object decralation
      var formFeatures = Vue.reactive({ errors: [], success: ''});

      formFeatures.details = {}
      var featureTabs = Vue.reactive({ tab: 'filters' });
      featureTabs.TabClass = function (tab) { return { 'active': tab == featureTabs.tab } }
      featureTabs.TabClick = function (tab) {
        featureTabs.tab = tab;
        if(tab == 'filter-groups')
          router.push({ params: { tab: 'filter-groups', tabid: '' } });
        if(tab == 'filters')
          router.push({ params: { tab: 'filters', tabid: '' } });
      }
      if (router.currentRoute.value.params.tab == 'filter-groups') {
        featureTabs.tab = 'filter-groups';
      }
      //page access have right 
      formFeatures.haveRight = iservice.HaveRight('Tab.Segments.Filters');

      return { formFeatures, featureLoad, featureTabs };
    }
  };
  iservice.components.adminSegmentFilters = {
    name: 'segment-filters',
    template: '#segment-filters',
    props: [],
    setup(props) {

      //router object declartion
      var router = VueRouter.useRouter();

      //form data and features object decralation
      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [], stepType:'' });

      formFeatures.details = {
        action: { steps: [] } };

      formFeatures.details.effects = {}
      var selectedID = Vue.ref(null);
      //table row select callback
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { tabid: id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      //form state change on different actions
      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;

        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { tabid: id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            action: { steps: [] }
          }
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }

      //load stock responses
      var filters = iservice.FilterData();
      //table columns declaration
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(filters, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Name', label: 'Filter Name',
            filterText: iservice.tables.SimpleFilterTextFunc(filters, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Description', label: 'Description',
            filterText: iservice.tables.SimpleFilterTextFunc(filters, 'description'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Expression', label: 'Expression',
            filterText: iservice.tables.SimpleFilterTextFunc(filters, 'expression'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Match In', label: 'Match In',
            filterText: iservice.tables.SimpleFilterMatchInTextFunc(filters),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-filter-match-in', shown: true
          }),
          Vue.reactive({
            name: 'Action Steps', label: 'Action Steps',
            filterText: iservice.tables.SimpleFilterActionStepsTextFunc(filters),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-filter-action-steps', shown: true
          })];

        return columns;
      });

      //table configuration
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Filters',
        emptyMessage: 'No Filters',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Segment Filters"
      });
      if (!filters.loaded) {
        filters.Load();
      }

      formFeatures.routeSegmentID = Vue.computed(function () {
        return router.currentRoute.value.params.id;
      })

      //table data ids array
      formFeatures.IDs = [];
      var itemsProcessed = 0;
      tableConfig.searching = true;

      //load table records by pushing ids 
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!filters.list.length) return;
        if (formFeatures.deleteStart) return;
        formFeatures.IDs = []
        filters.segmentSimple(formFeatures.routeSegmentID).forEach(function (filter) {
          var id = filter.id;
          filters.add(filter);
          formFeatures.IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == filters.segmentSimple(formFeatures.routeSegmentID).length) {
            tableConfig.searching = false;
          }
        });
        if (!filters.segmentSimple(formFeatures.routeSegmentID).length) tableConfig.searching = false;
      });

      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { tabid: id } });
      })

      //update record
      formFeatures.Save = function () {
        var steps = {};
        formFeatures.details.action.steps.forEach(function (step, key) {
          var stepExists = false;          
          step.stepType = step.stepType.replace('actionstep-', '');

          formFeatures.actions.forEach(function (action, index) {
            if (action[step.stepType] && action[step.stypetype] !== null) {
              stepExists = true
              for (var key in step) {
                if (step.hasOwnProperty(key)) {
                  if (key !== 'stepType')
                    action[step.stepType][key] = step[key];
                }
              }
            }
          });
          if (!stepExists) {
            steps[step.stepType] = {};
            for (var key in step) {
              if (step.hasOwnProperty(key)) {
                if (key !== 'stepType')
                  steps[step.stepType][key] = step[key];
              }
            }
          }
        });
        formFeatures.details.action.steps = [];
        formFeatures.actions.forEach(function (action) {
          formFeatures.details.action.steps.push(action);
        })
        
        formFeatures.details.action.steps.push(steps);
     
        formFeatures.details.action.steps = formFeatures.details.action.steps.filter(element => {
          if (Object.keys(element).length !== 0) {
            return true;
          }
          return false;
        });
        iservice.API('webapp-api-admin?api=filters&mode=modify', null, { filterID: selectedID.value, details: formFeatures.details }).then(function (result) {
          filters.add(result.row);
          var steps = [];
          result.details.action.steps.forEach(function (step) {
            for (let key in step) {
              if (step[key] !== null) {
                var obj = {
                  stepType: 'actionstep-' + key
                }
                for (let key2 in step[key]) {
                  obj[key2] = step[key][key2];
                }
                steps.push(obj);
              }
            }
          });
          formFeatures.details.action.steps = steps;
          iservice.SuccessMessage('Filter updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.tabid && router.currentRoute.value.params.tab == 'filters') {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=filterdetails', null, { filterID: router.currentRoute.value.params.tabid }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.tabid;
            var steps = [];
            result.details.action.steps.forEach(function (step) {
              for (let key in step) {
                if (step[key] !== null) {
                  var obj = {
                    stepType: 'actionstep-'+ key
                  }
                  for (let key2 in step[key]) {
                    obj[key2] = step[key][key2];
                  }
                  steps.push(obj);
                }
              }
            });
            formFeatures.actions = result.details.action.steps;
            formFeatures.details = result.details;
            formFeatures.details.action.steps = steps;
            formFeatures.ChangeState('details');
            formFeatures.loading = false;
          }).then(function (result) {

          }).catch(function (errors) {

          }).finally(function () {
            formFeatures.loading = false;
          });
        } else {
          selectedID.value = '';
          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          formFeatures.ShowNew = false;
          formFeatures.ShowDetails = false;
        }
      });
      formFeatures.error = {};

      //create new record
      formFeatures.Create = function () {
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;
        if (!formFeatures.details.name) {
          formFeatures.errors.push({ msg: 'Please enter name.', details: { description: '' } });
          formFeatures.error.name = true;
        }

        if (formFeatures.errors.length) return;
        formFeatures.details.segmentID = formFeatures.routeSegmentID;
        var steps = {};
        formFeatures.details.action.steps.forEach(function (step, key) {
          step.stepType = step.stepType.replace('actionstep-', '');
          steps[step.stepType] = {};
          for (var key in step) {
            if (step.hasOwnProperty(key)) {
              if(key !=='stepType')
                steps[step.stepType][key] = step[key];
            }
          }
        });
        formFeatures.details.action.steps.forEach(function (step, index) {
          for (const property in steps) {
            if (step.stepType == property) {
              step[property] = steps[property];
            }
          }
        })
        iservice.API('webapp-api-admin?api=filters&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          filters.add(result.row);
          formFeatures.IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Filter added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }

      //delete record
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        iservice.API('webapp-api-admin?api=filters&mode=delete', null, { filterID: selectedID.value }).then(function (result) {

          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = formFeatures.IDs.indexOf(selectedID.value);
          if (index > -1) {
            formFeatures.IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { tabid: id } })
          iservice.SuccessMessage('Filter deleted successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {

        });
      }

      formFeatures.AddAction = function () {
        formFeatures.details.action.steps.push({});
      };
      formFeatures.ActionMoveUp = function (actions, action) {
        for (var i = 1; i < actions.length; i++) {
          if (action !== actions[i]) continue;
          actions.splice(i, 1);
          actions.splice(i - 1, 0, action);
          return;
        }
      };
      formFeatures.ActionMoveDown = function (actions, action) {
        for (var i = 0; i < actions.length - 1; i++) {
          if (action !== actions[i]) continue;
          actions.splice(i, 1);
          if (i === actions.length - 1) actions.push(action);
          else actions.splice(i + 1, 0, action);
          return;
        }
      };
      formFeatures.ActionDelete = function (actions, action) {
        for (var i = 0; i < actions.length; i++) {
          if (action !== actions[i]) continue;
          actions.splice(i, 1);
          formFeatures.actions.splice(i, 1);
          return;
        }
      };
      formFeatures.getStepForm = function (action) {
        action.stepType = 'actionstep-' + action.stepType;
      }
      formFeatures.stepsOptions = iservice.FiltersStepsOptions;

      return { formFeatures, tableConfig, Select, selectedIDs, selectedID };
    }
  };
  iservice.components.adminSegmentFilterGroups = {
    name: 'segment-filter-groups',
    template: '#segment-filter-groups',
    props: ['load'],
    setup(props) {
      var featureLoad = Vue.reactive({ loaded: false, working: false });
      Vue.watchEffect(() => {
        if (!props.load || featureLoad.loaded || featureLoad.working) return;
        featureLoad.working = true;
      });
      //router object declartion
      var router = VueRouter.useRouter();

      //form data and features object decralation
      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });

      formFeatures.details = {};

      formFeatures.details.effects = {}
      var selectedID = Vue.ref(null);
      //table row select callback
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { tabid: id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });
      
      //form state change on different actions
      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;

        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { tabid: id } });
            
          }
        }
        if (state == 'new') {
          formFeatures.details = { childIDs: [] }
          
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
        if (state == 'new' || state == 'details') {
          setTimeout(function () {
            var el = document.getElementById('filterlistleft');
            var el2 = document.getElementById('filterlistright');
            var sortable = new Sortable(el, {
              animation: 150,
              group: 'shared',
              dataIdAttr: 'data-tab-id',
              chosenClass: "chosen",
              onUpdate: function (evt) {
                formFeatures.details.childIDs = sortable.toArray();
              },
              onRemove: function (evt) {
                formFeatures.details.childIDs = sortable.toArray();
              },
              onAdd: function (evt) {
                formFeatures.details.childIDs = sortable.toArray();
              },
            })
            var sortable2 = new Sortable(el2, {
              animation: 150,
              group: 'shared',
              chosenClass: "chosen",
              dataIdAttr: 'data-tab-id',
              onUpdate: function (evt) {
                // arraymove(formFeatures.propLists, evt.oldIndex, evt.newIndex);
              }
            })
          }, 2000);
        }
      }

      //load stock responses
      var filters = iservice.FilterData();
      if (!filters.loaded) {
        filters.Load();
      }


      formFeatures.routeSegmentID = Vue.computed(function () {
        return router.currentRoute.value.params.id;
      })


      var OtherFilterIDs = Vue.computed(function () {
        if (!filters.list.length) return;
        var filterID = [];
        filters.inSegment(formFeatures.routeSegmentID).forEach(function (item) {
          if (!formFeatures.details.childIDs.includes(item.id) && item.id != router.currentRoute.value.params.tabid) {
            filterID.push(item.id);
          }
        })
        return filterID;
      });
      //table columns declaration
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(filters, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Name', label: 'Group Name',
            filterText: iservice.tables.SimpleFilterTextFunc(filters, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Description', label: 'Description',
            filterText: iservice.tables.SimpleFilterTextFunc(filters, 'description'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Always Run All Filters', label: 'Always Run All Filters',
            filterText: iservice.tables.SimpleFilterTextFunc(filters, 'runAllChildren'),
            Save: ToggleSave,
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-group-runchildren-toggle', shown: true
          })];

        return columns;
      });

      //table configuration
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Groups',
        emptyMessage: 'No groups',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Segment Filter Groups"
      });
      if (!filters.loaded) {
        filters.Load();
      }


      //table data ids array
      formFeatures.IDs = [];
      var itemsProcessed = 0;
      tableConfig.searching = true;

      //load table records by pushing ids 
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!filters.list.length) return;
        if (formFeatures.deleteStart) return;
        formFeatures.IDs = []
        filters.segmentGroups(formFeatures.routeSegmentID).forEach(function (filter) {
          var id = filter.id;
          filters.add(filter);
          formFeatures.IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == filters.segmentGroups(formFeatures.routeSegmentID).length) {
            tableConfig.searching = false;
          }
        });
        if (!filters.segmentGroups(formFeatures.routeSegmentID).length) tableConfig.searching = false;
      });

      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { tabid: id } });
      })

      function ToggleSave(filter) {
        filter.shownRunning = true;
        iservice.API('webapp-api-admin?api=filterdetails', null, { filterID: filter.id }).then(function (result) {
          result.details.runAllChildren = filter.runAllChildren;
          return iservice.API('webapp-api-admin?api=filters&mode=modify', null, { filterID: filter.id, details: result.details }).then(function (result) {
            filters.add(result.details);
            formFeatures.details.runAllChildren = filter.runAllChildren;
            iservice.SuccessMessage('Group updated successfully.');
          }).catch(function (errors) {

          }).finally(function () {
            filter.shownRunning = false;
          });
        }).catch(function (errors) {
        }).finally(function () {
          filter.shownRunning = false;
        });
      }
      //update record
      formFeatures.Save = function () {
        iservice.API('webapp-api-admin?api=filters&mode=modify', null, { filterID: selectedID.value, details: formFeatures.details }).then(function (result) {
          filters.add(result.row);
          iservice.SuccessMessage('Group updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.tabid && router.currentRoute.value.params.tab == 'filter-groups') {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=filterdetails', null, { filterID: router.currentRoute.value.params.tabid }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.tabid;
            formFeatures.details = result.details;
            formFeatures.ChangeState('details');
            formFeatures.loading = false;
          }).then(function (result) {

          }).catch(function (errors) {

          }).finally(function () {
            formFeatures.loading = false;
          });
        } else {
          selectedID.value = '';
          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          formFeatures.ShowNew = false;
          formFeatures.ShowDetails = false;
        }
      });
      formFeatures.error = {};

      //create new record
      formFeatures.Create = function () {
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;
        if (!formFeatures.details.name) {
          formFeatures.errors.push({ msg: 'Please enter name.', details: { description: '' } });
          formFeatures.error.name = true;
        }

        if (formFeatures.errors.length) return;
        formFeatures.details.segmentID = formFeatures.routeSegmentID;
        formFeatures.details.isGroup = true;
        iservice.API('webapp-api-admin?api=filters&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          filters.add(result.row);
          formFeatures.IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Group added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }

      //delete record
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        iservice.API('webapp-api-admin?api=filters&mode=delete', null, { filterID: selectedID.value }).then(function (result) {

          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = formFeatures.IDs.indexOf(selectedID.value);
          if (index > -1) {
            formFeatures.IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { tabid: id } })
          iservice.SuccessMessage('Group deleted successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {

        });
      }
      
      return { formFeatures, tableConfig, Select, selectedIDs, selectedID, OtherFilterIDs };
    }
  };
  iservice.components.adminSegmentTopics = {
    name: 'vueapp-segment-topics',
    template: '#vueapp-segment-topics',
    props: ["load"],
    setup(props) {

      var featureLoad = Vue.reactive({ loaded: false, working: false });
      Vue.watchEffect(() => {
        if (!props.load || featureLoad.loaded || featureLoad.working) return;
        featureLoad.working = true;
      });

      //router object declartion
      var router = VueRouter.useRouter();

      //form data and features object decralation
      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDetails: false, Create: Function, Save: Function, shownToggleRunning: false, createnew: false, segmentOptions: [] });

      formFeatures.details = { skills: [], properties: [] }

      formFeatures.details.effects = {}
      var selectedID = Vue.ref(null);
      //table row select callback
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { tabid: id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      //form state change on different actions
      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { tabid: id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = { skills: [], properties: [] }
        }
      }

      //load topics
      var topics = iservice.TopicData();

      //load autoresponses
      var autoResponses = iservice.AutoResponseData();

      //load service levels
      var servicelevels = iservice.ServiceLevelData();

      //load filters levels
      var filters = iservice.FilterData();
      
      //load segments levels
      var segments = iservice.SegmentData();
      //load skills
      var skills = iservice.SkillData();

      //load interaction properties
      var intProperties = iservice.IntPropertyData();

      //load deleted topics
      var topicsDeleted = iservice.TopicDeletedData();

      var filterSkills = function (skill) {
        return skill.propertyID == "" && skill.propertyValue == "";
      }

      formFeatures.showDeleted = false;

      //table configuration
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Topics',
        emptyMessage: 'No topics',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'TopicName',
        exportName: "Segment Topics"
      });
      Vue.watchEffect(function () {
        var topicslist = formFeatures.showDeleted ? topicsDeleted : topics;
        var topicType = formFeatures.showDeleted ? 'deleted' : 'active';
        tableConfig.columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            topicType: topicType,
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(topicslist, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'TopicName', label: 'Topic Name',
            topicType: topicType,
            filterText: iservice.tables.SimpleFilterTextFunc(topicslist, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-segment-topic-name', shown: true
          }),
          Vue.reactive({
            name: 'Parent Name', label: 'Parent Name',
            topicType: topicType,
            filterText: iservice.tables.SimpleTopicParentFilterTextFunc(topicslist, 'parentID'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-segment-topic-parent-name', shown: true
          }),
          Vue.reactive({
            name: 'Visibility', label: 'Visibility',
            topicType: topicType,
            filterText: iservice.tables.SimpleFilterTextFunc(topicslist, 'visibility'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Skills', label: 'Skills',
            topicType: topicType,
            filterText: iservice.tables.SimpleFilterTextFunc(topicslist, 'skillNames'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Properties', label: 'Properties',
            topicType: topicType,
            filterText: iservice.tables.SimpleFilterTextFunc(topicslist, 'propertyNames'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Customer Ticket Filter', label: 'Customer Ticket Filter',
            topicType: topicType,
            filterText: iservice.tables.SimpleQuestionFilterTextFunc(topicslist, filters, 'askAQuestionFilterID'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-segment-topic-filter', shown: false
          }),
          Vue.reactive({
            name: 'Message Acknowledgment Notification', label: 'Message Acknowledgment Notification',
            topicType: topicType,
            filterText: iservice.tables.SimpleAutoResponseFilterTextFunc(topicslist, autoResponses, 'autoResponseID'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-segment-topic-notification', shown: false
          }),
          Vue.reactive({
            name: 'Agent Notification', label: 'Agent Notification',
            topicType: topicType,
            filterText: iservice.tables.SimpleAutoResponseFilterTextFunc(topicslist, autoResponses, 'agentNotifyID'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-segment-topic-agent-notification', shown: false
          }),
          Vue.reactive({
            name: 'Service Level', label: 'Service Level',
            topicType: topicType,
            filterText: iservice.tables.SimpleServiceLevelFilterTextFunc(topicslist, servicelevels, 'serviceLevelID'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-topic-servicelevel', shown: false
          })];
      })

      Vue.watchEffect(function () {
        if (featureLoad.loaded || !featureLoad.working) return;
        if (!topics.loaded) {
          topics.Load();
        }
        if (!topicsDeleted.loaded) {
          topicsDeleted.Load();
        }
        if (!autoResponses.loaded) {
          autoResponses.Load();
        }
        if (!servicelevels.loaded) {
          servicelevels.Load();
        }
        if (!filters.loaded) {
          filters.Load();
        }
        if (!segments.loaded) {
          segments.Load();
        }
        if (!skills.loaded) {
          skills.Load();
        }
        if (!intProperties.loaded) {
          intProperties.Load();
        }
      });

      formFeatures.routeSegmentID = Vue.computed(function () {
        return router.currentRoute.value.params.id;
      })

      var levels = Vue.reactive([{ id: '', name: '-- Segment Default --', minutes: '', intPropertyID: '', intPropertyValue: '', contactPropertyID: '', contactPropertyValue: '' }]);
      formFeatures.servicelevels = Vue.computed(function () {
        if (!servicelevels.list.length) return;
        servicelevels.list.forEach(function (level) {
          levels.push(level);
        });
        return levels;
      });
      
      var filtersData = Vue.reactive([{ id: '', name: '-- None --', option: '' }]);
      var responsesAck = Vue.reactive([{ id: '', name: '-- None --', segmentID: '', segmentName: '', option: '', listNames: '' }, { id: 'seg', name: '-- Segment Default --', segmentID: '', segmentName: '', option: '', listNames: '' }]);
      var responsesAgent = Vue.reactive([{ id: '', name: '-- None --', segmentID: '', segmentName: '', option: '', listNames: '' }, { id: 'seg', name: '-- Segment Default --', segmentID: '', segmentName: '', option: '', listNames: '' }]);
      formFeatures.filters = Vue.computed(function () {
        if (!filters.list.length) return;
        filters.inSegment(formFeatures.routeSegmentID).forEach(function (filter) {
          filtersData.push(filter);
        });
        return filtersData;
      });
      formFeatures.responsesAck = Vue.computed(function () {
        if (!autoResponses.list.length) return;
        autoResponses.inSegment(formFeatures.routeSegmentID).some(function (response) {
          if (response.listNames.includes('topicautoresponse')) {
            responsesAck.push(response);
          }
        });
        return responsesAck;
      });
      formFeatures.responsesAgent = Vue.computed(function () {
        if (!autoResponses.list.length) return;
        autoResponses.inSegment(formFeatures.routeSegmentID).some(function (response) {
          if (response.listNames.includes('agentnotification')) {
            responsesAgent.push(response);
          }
        });
        return responsesAgent;
      });
      var topicGroups = Vue.computed(() => {
        var groups = [];
        if (!segments.loaded || !topics.loaded) {
          segments.Load(); topics.Load();
        }
        var segment = segments.get(formFeatures.routeSegmentID);
        var group = Vue.reactive({ label: segment.name, options: [{ name: "None - This is the root topic for the segment.", id: "" }] });
        topics.inSegment(formFeatures.routeSegmentID).forEach(topic => {
          group.options.push({ name: topic.name, id: topic.id, level: Math.min(2, topic.depth) });
        });
        group.options.sort((l, r) => { return topics.TreeSortCompare(l.value, r.value); });
        if (group.options.length < 1) return;
        groups.push(group);
        return groups;
      });

      var otherSegments = Vue.computed(function () {
        if (!segments.loaded || !intProperties.loaded) {
          segments.Load(); intProperties.Load();
        }
        var otherSegments = [];
        segments.list.forEach(function (segment) {
          if (segment.id == formFeatures.routeSegmentID) return;
          segment.sharedProperties = [];
          intProperties.inSegment(segment.id).forEach(function (property) {
            if (property.isShared) segment.sharedProperties.push(property);
          });
          if (segment.sharedProperties.length < 1) return;
          otherSegments.push(segment);
        });
        return otherSegments;
      })

      //table data ids array
      formFeatures.IDs = [];
      formFeatures.ActiveIDs = [];
      formFeatures.DeletedIDs = [];
      var itemsProcessed = 0;
      tableConfig.searching = true;
      formFeatures.topicsData = [];
     
      //load table records by pushing ids 
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!topics.list.length) return;
        if (formFeatures.deleteStart) return;
        if (!topicsDeleted.list) return;
        formFeatures.ActiveIDs = [];
        formFeatures.DeletedIDs = [];
        formFeatures.rootTopics = [];
        //var topicsData = []
        formFeatures.topicsData = formFeatures.showDeleted ? topicsDeleted.inSegment(formFeatures.routeSegmentID) : topics.inSegment(formFeatures.routeSegmentID);
        if (formFeatures.topicsData.length) {
          var isRoot = {};
          var topicByID = {};
          var curChild = null;
          iservice.ForArray(formFeatures.topicsData, function (topic) {
            topicByID[topic.id] = topic;
            var parent = topicByID[topic.parentID];
            if (!parent) {
              isRoot[topic.id] = true;
              topic.name = topic.option;
              formFeatures.rootTopics.push(topic);
              topic.children = [];
            }
            else if (isRoot[parent.id]) {
              parent.children.push(topic);
              topic.children = [];
              curChild = topic;
            }
            else {
              curChild.children.push(topic);
            }
          });
        }
        formFeatures.topicsData.forEach(function (topic) {
          var id = topic.id;
          if (formFeatures.showDeleted) {
            if (topic.visibility != 'deleted') return;
            formFeatures.DeletedIDs.push(id);
            topicsDeleted.add(topic)
          } else {
            if (topic.visibility == 'deleted') return;
            topics.add(topic);
            formFeatures.ActiveIDs.push(id);
          }
         
          itemsProcessed++;
          if (itemsProcessed == formFeatures.topicsData.length) {
            tableConfig.searching = false;
          }
        });
        if (!formFeatures.topicsData.length) tableConfig.searching = false;
      });

      Vue.watchEffect(function () {
        formFeatures.IDs = formFeatures.showDeleted ? formFeatures.DeletedIDs : formFeatures.ActiveIDs;
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { tabid: id } });
      })
      function StoreResponses(details) {
        details.neverAutoResponse = details.autoResponseID == '';
        if (details.autoResponseID == 'seg') details.autoResponseID = '';
        details.neverAgentNotify = details.agentNotifyID == '';
        if (details.agentNotifyID == 'seg') details.agentNotifyID = '';
      }

      //update record
      formFeatures.Save = function () {
        StoreResponses(formFeatures.details)
        iservice.API('webapp-api-admin?api=topics&mode=modify', null, { topicID: selectedID.value, details: formFeatures.details }).then(function (result) {
          topics.add(result.row);
          iservice.SuccessMessage('Topic updated successfully.');
          if (formFeatures.details.visibility == 'deleted') {
            topics.remove(formFeatures.details.id)
            formFeatures.DeletedIDs.push(formFeatures.details.id);
            //topicsDeleted.add(formFeatures.details.id)
            formFeatures.showDeleted = true;
          }
          else {
            if (topicsDeleted.get(formFeatures.details.id)) {
              topicsDeleted.remove(formFeatures.details.id)
              formFeatures.showDeleted = false;
            }
          }
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      Vue.watchEffect(() => {
        if (router.currentRoute.value.params.tab != 'topics') formFeatures.ShowNew = false;
      })
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.tabid && router.currentRoute.value.params.tab == 'topics') {
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=topicdetails', null, { topicID: router.currentRoute.value.params.tabid }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.tabid;
            if (result.details.autoResponseID == '' && result.details.neverAutoResponse == false) result.details.autoResponseID = 'seg';
            if (result.details.agentNotifyID == '' && result.details.neverAgentNotify == false) result.details.agentNotifyID = 'seg';
            formFeatures.details = result.details;
            formFeatures.ChangeState('details');
            if (formFeatures.details.visibility == 'deleted') {
              formFeatures.showDeleted = true;
            }
          }).then(function (result) {

          }).catch(function (errors) {

          }).finally(function () {
            formFeatures.loading = false;
          });
        } else {
          selectedID.value = '';
          formFeatures.ChangeState('cancel');
          formFeatures.ShowNew = false;
          formFeatures.ShowDetails = false;
        }
      });
      formFeatures.error = {};

      //create new record
      formFeatures.Create = function () {
        formFeatures.errors = [];
        formFeatures.createnew = true;
        if (!formFeatures.details.name) {
          formFeatures.errors.push({ msg: 'Please enter topic name.', details: { description: '' } });
          formFeatures.error.name = true;
        }
       
        if (formFeatures.errors.length) return;
        formFeatures.details.segmentID = formFeatures.routeSegmentID;
        StoreResponses(formFeatures.details);
        iservice.API('webapp-api-admin?api=topics&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          topics.add(result.row);
          formFeatures.IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Topic added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      
      formFeatures.clickType = 'tree';
      formFeatures.openModal = function (type) {
        var bodyEl = $('.segment-topic-data .modal')[0];
        bodyEl.classList.remove('hide')
        bodyEl.classList.add('modal-open')
        formFeatures.clickType = type;
      }

      Vue.provide('selectedID', selectedID);
      return { formFeatures, tableConfig, Select, selectedIDs, selectedID, featureLoad, topicGroups, skills, segments, intProperties, filterSkills, otherSegments };
    }
  };
  iservice.components.adminSegmentTopicTreeviewModal = {
    name: 'segment-topic-treeview-modal',
    template: '#segment-topic-treeview-modal',
    props: ['load', "rootTopics", "type"],
    setup(props) {
      var formFeatures = Vue.reactive({});
      formFeatures.closeModal = function () {
        var bodyEl = $('.segment-topic-data .modal')[0];
        bodyEl.classList.add('hide')
        bodyEl.classList.remove('modal-open')
      }
      var rootTopics = Vue.computed(function () {
        return props.rootTopics;
      })
      var type = Vue.computed(function () {
        return props.type;
      })
      return { formFeatures, rootTopics, type}
    }
  }
  iservice.components.adminSegmentTopicTreeviewList = {
    name: 'segment-topic-treeview-list',
    template: '#segment-topic-treeview-list',
    props: ['topic', 'type'],
    setup(props) {
      //router object declartion
      var router = VueRouter.useRouter();
      var selectedID = Vue.inject('selectedID')
      var topic = Vue.computed(function () {
        return props.topic;
      });
      function topicSelect(topic) {
        selectedID = topic.id;
        router.push({ params: {tabid: topic.id }})
      }
      var clickType = Vue.computed(function () {
        return props.type;
      })
      return { topic, selectedID, topicSelect, clickType }
    }
  }
  iservice.components.adminSegmentMailbox = {
    name: 'vueapp-segment-mailboxes',
    template: '#vueapp-segment-mailboxes',
    props: ['load'],
    setup(props) {
      var featureLoad = Vue.reactive({ loaded: false, working: false });
      Vue.watchEffect(() => {
        if (!props.load || featureLoad.loaded || featureLoad.working) return;
        featureLoad.working = true;
      });

      //table list collapse toggle
      var ListCollapsed = Vue.reactive({ isListCollapsed: true })
      ListCollapsed.Toggle = function () {
        return ListCollapsed.isListCollapsed = !ListCollapsed.isListCollapsed;
      }

      //router object declartion
      var router = VueRouter.useRouter();

      //form data and features object decralation
      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDetails: false, Create: Function, Save: Function, shownToggleRunning: false, createnew: false, segmentOptions: [] });

      formFeatures.details = {
        name: '',
        description: '',
        bodyHtml: ''
      }
      var selectedID = Vue.ref(null);
      //table row select callback
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { tabid: id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      //form state change on different actions
      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.ShowNew = state == 'new' ? true : false;

        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { tabid: id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            name: '',
            description: '',
            bodyHtml: ''
          }
        }
      }
      //page access have right 
      formFeatures.haveRight = iservice.HaveRight('Tab.Segments.Mailboxes');

      //load mailboxes admin list
      var mailboxesadmin = iservice.MailboxAdminData();

      //load topics
      var topics = iservice.TopicData();

      //load segments
      var segments = iservice.SegmentData();
      //load filters
      var filters = iservice.FilterData();

      Vue.watchEffect(function () {
        if (featureLoad.loaded || !featureLoad.working) return;
        if (!mailboxesadmin.loaded || !topics.loaded || !filters.loaded) {
          mailboxesadmin.Load(); topics.Load(); filters.Load();
        }
      });

      formFeatures.routeSegmentID = Vue.computed(function () {
        return router.currentRoute.value.params.id;
      });

      formFeatures.topics = Vue.computed(function () {
        if (!topics.loaded || !segments.loaded) {
          topics.Load(); segments.Load();
        }
        var groups = [];
        var segment = segments.get(formFeatures.routeSegmentID);
        var group = Vue.reactive({ label: segment.name, options: [] });
        topics.inSegment(formFeatures.routeSegmentID).forEach(function (topic) {
          group.options.push({ name: topic.name, value: topic.id, level: Math.min(2, topic.depth) });
        });
        group.options.sort((l, r) => { return topics.TreeSortCompare(l.value, r.value); });
        if (group.options.length < 1) return;
        groups.push(group);
        return groups;
      });

      var filtersData = [{ id: '0', name: '-- None --', option: '' }];
      formFeatures.filters = Vue.computed(function () {
        if (!filters.list.length) return;
        filters.inSegment(formFeatures.routeSegmentID).forEach(function (filter) {
          filtersData.push(filter);
        });
        return filtersData;
      });    

      //table columns declaration
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'displayName', label: 'Display Name',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'displayName'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Reply To Address', label: 'Reply To Address',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'replyTo'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Default Topic', label: 'Default Topic',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'topicID'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-mailbox-topic', shown: true
          }),
          Vue.reactive({
            name: 'Enabled', label: 'Enabled',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'enabled'),
            Save: ToggleSave,
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-mailbox-enabled-toggle', shown: true
          }),
          Vue.reactive({
            name: 'Incoming Server Name', label: 'Incoming Server Name',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'inServer'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Incoming Protocol', label: 'Incoming Protocol',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'inProtocol'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Outgoing Protocol', label: 'Outgoing Protocol',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'outProtocol'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Incoming Username', label: 'Incoming Username',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'inUsername'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Incoming Password', label: 'Incoming Password',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'inPassword'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Incoming Port Number', label: 'Incoming Port Number',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'inPort'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Filter', label: 'Filter',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'filterID'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-mailbox-filter', shown: false
          }),
          Vue.reactive({
            name: 'Incoming User Encryption', label: 'Incoming User Encryption',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'inEncrypt'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Outgoing User Encryption', label: 'Outgoing User Encryption',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'outEncrypt'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Outgoing Server Name', label: 'Outgoing Server Name',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'outServer'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Outgoing Port Number', label: 'Outgoing Port Number',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'outPort'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Outgoing Username', label: 'Outgoing Username',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'outUsername'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Outgoing Password', label: 'Outgoing Password',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'outPassword'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Errors', label: 'Errors',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxesadmin, 'errorCount'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });

      //table configuration
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Mailboxes',
        emptyMessage: 'No mailboxes',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'displayName',
        columns: tableColumns.value,
        exportName: "Segment Mailboxes"
      });

      //table data ids array
      formFeatures.IDs = [];
      var itemsProcessed = 0;
      tableConfig.searching = true;
      //load table records by pushing ids 
      Vue.watchEffect(function () {
        if(featureLoad.loaded || !featureLoad.working) return;
        if (formFeatures.createnew) return;
        if (!mailboxesadmin.list.length) return;
        formFeatures.IDs = [];
        mailboxesadmin.inSegment(formFeatures.routeSegmentID).forEach(function (mailbox) {
          var id = mailbox.id;
          mailboxesadmin.add(mailbox);
          formFeatures.IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == mailboxesadmin.inSegment(formFeatures.routeSegmentID).length) {
            tableConfig.searching = false;
          }
        });
        if (!mailboxesadmin.inSegment(formFeatures.routeSegmentID).length) tableConfig.searching = false;
      });

      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { tabid: id } });
      })

      var mailboxErrors = iservice.MailboxErrosData();
      if (!mailboxErrors.loaded)
        mailboxErrors.Load()
      formFeatures.ErrorIDs = []
      var tableErrorsColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'Date', label: 'Date',
            filterText: iservice.tables.DateFilterTextFunc(mailboxErrors, 'timeUTC'), sortText: iservice.tables.DateSortTextFunc(mailboxErrors, 'timeUTC'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Error Message', label: 'Error Message',
            filterText: iservice.tables.SimpleFilterTextFunc(mailboxErrors, 'message'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });

      //table configuration
      var tableErrorsConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Error',
        emptyMessage: 'No errors',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Date',
        columns: tableErrorsColumns.value,
        exportName: "Mailbox Errors"
      });
      tableErrorsConfig.searching = true;
      //update record
      formFeatures.Save = function () {
        iservice.API('webapp-api-admin?api=mailboxes&mode=modify', null, { mailboxID: selectedID.value, details: formFeatures.details }).then(function (result) {
          mailboxesadmin.add(result.details);
          iservice.SuccessMessage('Mailbox updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      Vue.watchEffect(() => {
        if (router.currentRoute.value.params.tab != 'mailboxes') formFeatures.ShowNew = false;
      })
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.tabid && router.currentRoute.value.params.tab == 'mailboxes') {
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=mailboxdetails', null, { mailboxID: router.currentRoute.value.params.tabid }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.tabid;
            formFeatures.ChangeState('details');
            formFeatures.details = result.details;
            formFeatures.ErrorIDs = [];
            result.details.userErrors.forEach(function (error) {
              mailboxErrors.add(error);
              formFeatures.ErrorIDs.push(error.timeUTC);
            })
          }).then(function (result) {

          }).catch(function (errors) {

          }).finally(function () {
            formFeatures.loading = false;
            tableErrorsConfig.searching = false;
          });
        } else {
          selectedID.value = '';
          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          formFeatures.ShowNew = false;
          formFeatures.ShowDetails = false;
        }
      });
      formFeatures.error = {};

      function ToggleSave(mailbox) {
        mailbox.shownRunning = true;
        iservice.API('webapp-api-admin?api=mailboxdetails', null, { mailboxID: mailbox.id }).then(function (result) {
          result.details.enabled = mailbox.enabled;
          return iservice.API('webapp-api-admin?api=mailboxes&mode=modify', null, { mailboxID: mailbox.id, details: result.details }).then(function (result) {
            mailboxesadmin.add(result.details);
            formFeatures.details.enabled = mailbox.enabled;
            iservice.SuccessMessage('Mailbox updated.');
          }).catch(function (errors) {

          }).finally(function () {
            mailbox.shownRunning = false;
          });
        }).catch(function (errors) {
        }).finally(function () {
          mailbox.shownRunning = false;
        });
      }
      //create new record
      formFeatures.Create = function () {
        
        formFeatures.errors = [];
        formFeatures.createnew = true;
        if (!formFeatures.details.inProtocol) {
          formFeatures.errors.push({ msg: 'Please select incoming protocol.', details: { description: '' } });
          formFeatures.error.inProtocol = true;
        }
        if (formFeatures.HasEwsOAuth(formFeatures.details.inProtocol) || formFeatures.HasEwsOAuth(formFeatures.details.outProtocol)) {
          if (!formFeatures.details.ewsAppID) {
            formFeatures.errors.push({ msg: 'Please enter EWS Application ID.', details: { description: '' } });
            formFeatures.error.ewsAppID = true;
          }
          if (!formFeatures.details.ewsSecret) {
            formFeatures.errors.push({ msg: 'Please enter EWS Client Secret.', details: { description: '' } });
            formFeatures.error.ewsSecret = true;
          }
          if (!formFeatures.details.ewsTenantID) {
            formFeatures.errors.push({ msg: 'Please enter EWS Tenant ID.', details: { description: '' } });
            formFeatures.error.ewsTenantID = true;
          }
        }
        if (formFeatures.HasServer(formFeatures.details.inProtocol)) {
          if (!formFeatures.details.inServer) {
            formFeatures.errors.push({ msg: 'Please enter incoming server.', details: { description: '' } });
            formFeatures.error.inServer = true;
          }
        }
        if (formFeatures.HasUsername(formFeatures.details.inProtocol)) {
          if (!formFeatures.details.inUsername) {
            formFeatures.errors.push({ msg: 'Please enter incoming username.', details: { description: '' } });
            formFeatures.error.inUsername = true;
          }
        }
        if (formFeatures.HasUsername(formFeatures.details.outProtocol)) {
          if (!formFeatures.details.outUsername) {
            formFeatures.errors.push({ msg: 'Please enter outcoming username.', details: { description: '' } });
            formFeatures.error.outUsername = true;
          }
        }
        if (formFeatures.HasPassword(formFeatures.details.inProtocol)) {
          if (!formFeatures.details.inPassword) {
            formFeatures.errors.push({ msg: 'Please enter incoming password.', details: { description: '' } });
            formFeatures.error.inPassword = true;
          }
        }
        if (formFeatures.HasPassword(formFeatures.details.outProtocol)) {
          if (!formFeatures.details.outPassword) {
            formFeatures.errors.push({ msg: 'Please enter outcoming password.', details: { description: '' } });
            formFeatures.error.outPassword = true;
          }
        }
        if (!formFeatures.details.displayName) {
          formFeatures.errors.push({ msg: 'Please enter display name.', details: { description: '' } });
          formFeatures.error.displayName = true;
        }
       
        if (formFeatures.errors.length) return;
        formFeatures.details.ownerSegmentID = formFeatures.routeSegmentID;
        iservice.API('webapp-api-admin?api=mailboxes&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          mailboxesadmin.add(result.row);
          formFeatures.IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Mailbox added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      formFeatures.HasServer = function (protocol) {
        if (protocol == 'imap' || protocol == 'pop' || protocol == 'ews' || protocol == 'smtp' || protocol == 'smtpauth') return true;
        return false;
      }
      formFeatures.HasEncrypt = function (protocol) {
        if (protocol == 'imap' || protocol == 'pop' || protocol == 'smtp' || protocol == 'smtpauth') return true;
        return false;
      }
      formFeatures.HasPort = function (protocol) {
        if (protocol == 'imap' || protocol == 'pop' || protocol == 'smtpauth') return true;
        return false;
      }
      formFeatures.HasPassword = function (protocol) {
        if (protocol == 'imap' || protocol == 'pop' || protocol == 'smtpauth' || protocol == 'ews') return true;
        return false;
      }
      formFeatures.HasUsername = function (protocol) {
        if (protocol != 'smtp') return true;
        return false;
      }
      formFeatures.HasEwsOAuth = function (protocol) {
        if (protocol == 'ews-oauth') return true;
        return false;
      }
      formFeatures.ClearErrorsClick = function () {
        formFeatures.clearErrorsRunning = true;
        iservice.API('webapp-api-admin?api=mailboxes&mode=errors', null, { mailboxID: formFeatures.details.id }).then(function (result) {
          //modify details.
          //update record in table list
          mailboxesadmin.list.forEach(function (mailbox) {
            if (mailbox.id == formFeatures.details.id)
              mailbox.errorCount = '0';
          })
          formFeatures.details.userErrors = [];
          formFeatures.ErrorIDs = [];
          iservice.SuccessMessage('Mailbox errors cleared.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.clearErrorsRunning = false;
        });
      }
      return { formFeatures, ListCollapsed, tableConfig, Select, selectedIDs, selectedID, featureLoad, tableErrorsConfig, ToggleSave };
    }
  }

  //admin department component
  iservice.components.adminDepartments = {
    name: 'vueapp-admin-departments',
    template: '#vueapp-admin-departments',
    route() { return { path: iservice.formPath + '/admin/department/:id?', priority: 300, meta: { title: "iService | Departments" } } },
    setup(props) {

      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });
      var departmentName = Vue.ref(null);
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.Departments');
      var segments = iservice.SegmentData();
      var agents = iservice.AgentData();
      var usertypes = iservice.UserTypesData();
      var departments = iservice.DepartmentsData();
      var skills = iservice.SkillData();

      if (!segments.loaded) {
        segments.Load();
      }
      if (!agents.loaded) {
        agents.Load();
      }
      if (!usertypes.loaded) {
        usertypes.Load();
      }
      if (!departments.loaded) {
        departments.Load();
      }
      if (!skills.loaded) {
        skills.Load();
      }
            
      var ListCollapsed = Vue.reactive({ isListCollapsed: true })
      ListCollapsed.Toggle = function () {
        return ListCollapsed.isListCollapsed = !ListCollapsed.isListCollapsed;
      }
      
      var router = VueRouter.useRouter();

      formFeatures.details = {
        name: '',
        description: '',
        segmentIDs: [],
        skillIDs: []
      }
      var selectedID = Vue.ref(null);
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.hasRequiredErrors = false;
        formFeatures.errors = [];
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;
        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            name: '',
            description: '',
            segmentIDs: [],
            skillIDs: []
          }
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }

      formFeatures.removeAgent = function (agentId) {
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=agentdetails', null, { agentID: agentId }).then(function (result) {
          const index = result.details.departmentIDs.indexOf(selectedID.value);
          if (index > -1) {
            result.details.departmentIDs.splice(index, 1);
          }
          iservice.API('webapp-api-admin?api=agentmodify&mode=modify', null, {
            agentID: agentId,
            details: result.details,
            membership: result.custinfo.membership
          }).then(function (response) {
            const index = formFeatures.details.effects.agentIDs.indexOf(agentId);
            if (index > -1) {
              formFeatures.details.effects.agentIDs.splice(index, 1);
            }
            iservice.SuccessMessage('Agent removed successfully.');
          }).catch(function (errors) {
            formFeatures.errors = errors;
          }).finally(function () {
            formFeatures.loading = false;
          });
        }).catch(function (errors) {
          formFeatures.errors = errors;
          formFeatures.loading = false;
        });
      }
      Vue.watchEffect(function () {
        if (!segments.list.length) return;
        formFeatures.segmentOptions = segments.list.filter(function (segment) {
          return !segment.hidden;
        })
      })

      Vue.watchEffect(function () {
        if (!agents.list.length) return;
        if (formFeatures.details && formFeatures.details.effects && formFeatures.details.effects.agentIDs) {
          formFeatures.agentsInDepartment = agents.list.filter(function (agent) {
            return formFeatures.details.effects.agentIDs.includes(agent.id);
          });
        }
      })

      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(departments, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'DepartmentName', label: 'Department Name',
            filterText: iservice.tables.SimpleFilterTextFunc(departments, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Segments', label: 'Segments',
            filterText: iservice.tables.SimpleFilterTextFunc(departments, 'segmentnames'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Skills', label: 'Skills',
            filterText: iservice.tables.SimpleFilterTextFunc(departments, 'skillnames'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Departments',
        emptyMessage: 'No departments',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'ID',
        columns: tableColumns.value,
        exportName: "Departments"
      });
      var IDs = Vue.reactive([]);
      var itemsProcessed = 0;
      tableConfig.searching = true;
      var loaded = false;
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!departments.list.length) return;
        if (loaded) return;
        departments.list.forEach(function (agent) {
          var id = agent.id;
          departments.add(agent);
          IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == departments.list.length) {
            tableConfig.searching = false;
            loaded = true;
          }
        });
      });
      
      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { id } });
      });
      formFeatures.Save = function () {
        if (!formFeatures.details.name) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!departmentName || !departmentName.value || !departmentName.value.focus) return;
            departmentName.value.focus();
          });
          return;
        }
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=departments&mode=modify', null, { departmentID: selectedID.value, details: formFeatures.details }).then(function (result) {
          departments.add(result.row);
          iservice.SuccessMessage('Department updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }
      
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.id) {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=departmentdetails', null, { departmentID: router.currentRoute.value.params.id }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.id;
            formFeatures.ChangeState('details');
            formFeatures.details = result.details;
            formFeatures.loading = false;
          }).catch(function (errors) {
            formFeatures.errors = errors;
          }).finally(function () {
            formFeatures.loading = false;
          });
        }
      });
      formFeatures.error = {};
      formFeatures.Create = function () {
        if(!formFeatures.details.name) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!departmentName || !departmentName.value || !departmentName.value.focus) return;
            departmentName.value.focus();
          });
          return;
        }
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;

        if (formFeatures.errors.length) return;
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=departments&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          departments.add(result.row);
          IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Department added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=departments&mode=delete', null, { departmentID: selectedID.value }).then(function (result) {
          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = IDs.indexOf(selectedID.value);
          if (index > -1) {
            IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { id } })
          iservice.SuccessMessage('Department removed successfully.');
          formFeatures.deleteStart = false;
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }

      return { formFeatures, departmentName, ListCollapsed, segments, departments, skills, tableConfig, IDs, Select, selectedIDs, selectedID };
    }
  };

  //admin List component
  iservice.components.adminLists = {
    name: 'vueapp-admin-lists',
    template: '#vueapp-admin-lists',
    route() { return { path: iservice.formPath + '/admin/list/:id?', priority: 300, meta: { title: "iService | Lists" } } },
    setup(props) {

      var formFeatures = Vue.reactive({ errors: [], success: '', value: null, ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });
      var listName = Vue.ref(null);
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.AdditionalDetails');
      var lists = iservice.ListsData();
      var intProperties = iservice.IntPropertyData();
      var contactProperties = iservice.ContactPropertyData();
      var router = VueRouter.useRouter();
      if (!lists.loaded) {
        lists.Load();
      }
      if (!intProperties.loaded) {
        intProperties.Load();
      }
      if (!contactProperties.loaded) {
        contactProperties.Load();
      }

      var ListCollapsed = Vue.reactive({ isListCollapsed: true })
      ListCollapsed.Toggle = function () {
        return ListCollapsed.isListCollapsed = !ListCollapsed.isListCollapsed;
      }

      formFeatures.details = {
        name: '',
        description: '',
        values: []
      }
      var selectedID = Vue.ref(null);
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.hasRequiredErrors = false;
        formFeatures.errors = [];
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;
        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            name: '',
            description: '',
            values: []
          }
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }

      formFeatures.ValueAdd = function (value) {
        formFeatures.value = null;
        formFeatures.details.values.push(value);
      }
      formFeatures.ValueRemove = function (index) {
        formFeatures.details.values.splice(index, 1);
      }

      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(lists, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'List Name', label: 'List Name',
            filterText: iservice.tables.SimpleFilterTextFunc(lists, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })
          //,Vue.reactive({
          //  name: 'Description', label: 'Description',
          //  filterText: iservice.tables.SimpleFilterTextFunc(lists, 'description'),
          //  componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          //})
        ];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Lists',
        emptyMessage: 'No lists',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'ID',
        columns: tableColumns.value,
        exportName: "Lists"
      });
      var IDs = Vue.reactive([]);
      var itemsProcessed = 0;
      tableConfig.searching = true;
      var loaded = false;
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!lists.list.length) return;
        if (loaded) return;
        lists.list.forEach(function (agent) {
          var id = agent.id;
          lists.add(agent);
          IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == lists.list.length) {
            tableConfig.searching = false;
            loaded = true;
          }
        });
      });

      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { id } });
      });
      formFeatures.Save = function () {
        if (!formFeatures.details.name) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!listName || !listName.value || !listName.value.focus) return;
            listName.value.focus();
          });
          return;
        }
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=listsadmin&mode=modify', null, { listID: selectedID.value, details: formFeatures.details }).then(function (result) {
          lists.add(result.row);
          iservice.SuccessMessage('List updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }

      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.id) {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=listdetails', null, { listID: router.currentRoute.value.params.id }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.id;
            formFeatures.ChangeState('details');
            formFeatures.details = result.details;
            var segmentByID = {};
            var segments = [];
            [formFeatures.details.effects.contactValues,
            formFeatures.details.effects.contactDescriptions,
            formFeatures.details.effects.interactionValues,
            formFeatures.details.effects.interactionDescriptions].forEach(function (proplist) {
              proplist.sort(function (l, r) {
                return l.name.localeCompare(r.name);
              });
              proplist.forEach(function (prop) {
                prop["link"] = "";
                var segment = segmentByID[prop.segmentID];
                if (!segment) {
                  segment = { id: prop.segmentID, name: prop.segmentName, properties: [], propertyByID: {} };
                  segmentByID[prop.segmentID] = segment;
                  segments.push(segment);
                }
                if (!segment.propertyByID[prop.propertyID]) {
                  segment.propertyByID[prop.propertyID] = prop;
                  segment.properties.push(prop);
                }
              });
            });
            segments.sort(function (l, r) {
              return l.name.localeCompare(r.name);
            });
            segments.forEach(function (segment) {
              segment.properties.sort(function (l, r) {
                return l.name.localeCompare(r.name);
              });
            });
            formFeatures.details.effects.segments = segments;
          }).catch(function (errors) {
            formFeatures.errors = errors;
          }).finally(function () {
            formFeatures.loading = false;
          });
        }
      });
      Vue.watchEffect(() => {
        if (!intProperties.loaded || !contactProperties.loaded || !formFeatures.details.effects) return;
        formFeatures.details.effects.segments.forEach(function (segment) {
          segment.properties.forEach(function (prop) {
            if (intProperties.list.filter(x => x.id == prop.propertyID && x.segmentID == prop.segmentID).length > 0) {
              prop.link = iservice.formPath + "/admin/segment/" + prop.segmentID + "/intproperty/" + prop.propertyID;
            }
            if (contactProperties.list.filter(x => x.id == prop.propertyID && x.segmentID == prop.segmentID).length > 0) {
              prop.link = iservice.formPath + "/admin/segment/" + prop.segmentID + "/contactproperty/" + prop.propertyID;
            }
          });
        });
      });
      formFeatures.error = {};
      formFeatures.Create = function () {
        if (!formFeatures.details.name) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!listName || !listName.value || !listName.value.focus) return;
            listName.value.focus();
          });
          return;
        }
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;

        if (formFeatures.errors.length) return;
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=listsadmin&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          lists.add(result.row);
          IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('List added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=listsadmin&mode=delete', null, { listID: selectedID.value }).then(function (result) {
          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = IDs.indexOf(selectedID.value);
          if (index > -1) {
            IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { id } })
          iservice.SuccessMessage('List removed successfully.');
          formFeatures.deleteStart = false;
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }

      return { formFeatures, listName, ListCollapsed, lists, tableConfig, IDs, Select, selectedIDs, selectedID };
    }
  };

  //admin Open ID component
  iservice.components.adminOpenId = {
    name: 'vueapp-admin-openid',
    template: '#vueapp-admin-openid',
    route() { return { path: iservice.formPath + '/admin/openid', priority: 300, meta: { title: "iService | Open ID" } } },
    setup(props) {

      var formFeatures = Vue.reactive({ errors: [], success: '', Save: Function });
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.OpenID');

      formFeatures.details = {
        azureClientID: '',
        azureTenantID: '',
        googleClientID: []
      }

      formFeatures.Save = function () {
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=openidset', null, { details: formFeatures.details }).then(function (result) {
          formFeatures.details = result;
          iservice.SuccessMessage('Saved successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }

      function Init() {
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=openiddetails', null, null).then(function (result) {
          formFeatures.details = result;
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }
      Init();

      return { formFeatures };
    }
  };

  //admin Service Level component
  iservice.components.adminServiceLevels = {
    name: 'vueapp-admin-servicelevels',
    template: '#vueapp-admin-servicelevels',
    route() { return { path: iservice.formPath + '/admin/servicelevel/:id?', priority: 300, meta: { title: "iService | Service Levels" } } },
    setup(props) {

      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });
      var name = Vue.ref(null);
      var minutes = Vue.ref(null);
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.ServiceLevels');
      var serviceLevels = iservice.ServiceLevelData();
      var intProperties = iservice.IntPropertyData();
      var contactProperties = iservice.ContactPropertyData();
      var topics = iservice.TopicData();
      var router = VueRouter.useRouter();
      if (!serviceLevels.loaded) {
        serviceLevels.Load();
      }
      if (!intProperties.loaded) {
        intProperties.Load();
      }
      if (!contactProperties.loaded) {
        contactProperties.Load();
      }
      if (!topics.loaded) {
        topics.Load();
      }
      var ListCollapsed = Vue.reactive({ isListCollapsed: true })
      ListCollapsed.Toggle = function () {
        return ListCollapsed.isListCollapsed = !ListCollapsed.isListCollapsed;
      }
      formFeatures.details = {
        name: '',
        minutes: '',
        propertyType: '',
        propertyValue: '',
        propertyName: '',
        intPropertyID: '',
        intPropertyValue: '',
        contactPropertyID: '',
        contactPropertyValue: ''
      }
      Vue.watchEffect(function () { formFeatures.contactProperties = contactProperties.list; });
      Vue.watchEffect(function () { formFeatures.intProperties = intProperties.list; });
      var selectedID = Vue.ref(null);
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.hasRequiredErrors = false;
        formFeatures.errors = [];
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;
        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            name: '',
            minutes: '',
            propertyType: '',
            propertyValue: '',
            propertyName: '',
            intPropertyID: '',
            intPropertyValue: '',
            contactPropertyID: '',
            contactPropertyValue: ''
          }
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }
      
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(serviceLevels, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Service Level Name', label: 'Service Level Name',
            filterText: iservice.tables.SimpleFilterTextFunc(serviceLevels, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Minutes', label: 'Minutes',
            filterText: iservice.tables.SimpleFilterTextFunc(serviceLevels, 'minutes'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Property Type', label: 'Property Type',
            filterText: iservice.tables.SimpleFilterTextFunc(serviceLevels, 'propertyType'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Property Name', label: 'Property Name',
            filterText: iservice.tables.SimpleFilterTextFunc(serviceLevels, 'propertyName'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Property Value', label: 'Property Value',
            filterText: iservice.tables.SimpleFilterTextFunc(serviceLevels, 'propertyValue'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Service Level',
        emptyMessage: 'No Service Level',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'ID',
        columns: tableColumns.value,
        exportName: "Service Level"
      });
      var IDs = Vue.reactive([]);
      var itemsProcessed = 0;
      tableConfig.searching = true;
      var loaded = false;
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!serviceLevels.list.length) return;
        if (!intProperties.loaded) return;
        if (!contactProperties.loaded) return;
        if (loaded) return;
        serviceLevels.list.forEach(function (serviceLevel) {
          var id = serviceLevel.id;
          serviceLevel.propertyType = printPropertyType(serviceLevel);
          serviceLevel.propertyValue = printPropertyValue(serviceLevel);
          serviceLevel.propertyName = '';
          if (serviceLevel.contactPropertyID) {
            serviceLevel.propertyName = contactProperties.get(serviceLevel.contactPropertyID) && contactProperties.get(serviceLevel.contactPropertyID).option;
          }
          if (serviceLevel.intPropertyID) {
            serviceLevel.propertyName = intProperties.get(serviceLevel.intPropertyID) && intProperties.get(serviceLevel.intPropertyID).option;
          }
          serviceLevels.add(serviceLevel);
          IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == serviceLevels.list.length) {
            tableConfig.searching = false;
            loaded = true;
          }
        });
      });
      function printPropertyType(row) {
        if (row) {
          if (row.contactPropertyID) return "Contact";
          if (row.intPropertyID) return "Interaction";
        }
        return "";
      }

      function printPropertyValue(row) {
        if (row) {
          if (row.contactPropertyID) return row.contactPropertyValue;
          if (row.intPropertyID) return row.intPropertyValue;
        }
        return "";
      }
      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { id } });
      });
      formFeatures.Save = function () {
        formFeatures.hasRequiredErrors = false;
        if (!formFeatures.details.minutes) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!minutes || !minutes.value || !minutes.value.focus) return;
            minutes.value.focus();
          });
        }
        if (!formFeatures.details.name) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!name || !name.value || !name.value.focus) return;
            name.value.focus();
          });
        }
        if (formFeatures.hasRequiredErrors) return;

        if (formFeatures.details.propertyType == "Contact") {
          formFeatures.details.intPropertyID = "";
          formFeatures.details.intPropertyValue = "";
        }
        if (formFeatures.details.propertyType == "Interaction") {
          formFeatures.details.contactPropertyID = "";
          formFeatures.details.contactPropertyValue = "";
        }

        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=servicelevels&mode=modify', null, { servicelevelID: selectedID.value, details: formFeatures.details }).then(function (result) {
          serviceLevels.add(result.row);
          iservice.SuccessMessage('Service Level updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }

      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.id && contactProperties.loaded && intProperties.loaded) {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=serviceleveldetails', null, { servicelevelID: router.currentRoute.value.params.id }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.id;
            formFeatures.ChangeState('details');
            formFeatures.details = result.details;
            formFeatures.details.propertyType = printPropertyType(formFeatures.details);
            formFeatures.details.propertyValue = printPropertyValue(formFeatures.details);
            formFeatures.details.propertyName = '';
            if (formFeatures.details.contactPropertyID) {
              formFeatures.details.propertyName = contactProperties.get(formFeatures.details.contactPropertyID) && contactProperties.get(formFeatures.details.contactPropertyID).option;
            }
            if (formFeatures.details.intPropertyID) {
              formFeatures.details.propertyName = intProperties.get(formFeatures.details.intPropertyID) && intProperties.get(formFeatures.details.intPropertyID).option;
            }
            formFeatures.defaultSegments = formFeatures.details.effects.segments;
          }).catch(function (errors) {
            formFeatures.errors = errors;
          }).finally(function () {
            formFeatures.loading = false;
          });
        }
      });

      formFeatures.segments = Vue.computed(function () {
        if (!topics.loaded) {
          topics.Load();
        }
        if (!topics.list.length) return [];
        var segmentByID = {};
        var segments = [];
        var propid = formFeatures.details.contactPropertyID || formFeatures.details.intPropertyID;
        if (propid) {
          topics.list.forEach(function (topic) {
            if (topic.propertyIDs.includes(propid)) {
              var segment = segmentByID[topic.segmentID];
              if (!segment) {
                segment = { id: topic.segmentID, name: topic.segmentName, topics: [], topicByID: {} };
                segmentByID[topic.segmentID] = segment;
                segments.push(segment);
              }
              if (!segment.topicByID[topic.id]) {
                var getTopic = topics.get(topic.parentID);
                let obj = { id: topic.id, name: topic.name, parentName: topic.parentID ? getTopic.name : '' }
                segment.topicByID[topic.id] = obj;
                segment.topics.push(obj);
              }
            }
          });
          segments.sort(function (l, r) {
            return l.name.localeCompare(r.name);
          });
          segments.forEach(function (segment) {
            segment.topics.sort(function (l, r) {
              return l.name.localeCompare(r.name);
            });
          });
        }
        return segments;
      });
            
      formFeatures.topicRemove = function (id) {
        formFeatures.loading = true;
        var propid = formFeatures.details.contactPropertyID || formFeatures.details.intPropertyID;
        iservice.API('webapp-api-admin?api=topicdetails', null, { topicID: id }).then(function (result) {
          const index = result.details.properties.indexOf(propid);
          if (index > -1) {
            result.details.properties.splice(index, 1);
          }
          iservice.API('webapp-api-admin?api=topics&mode=modify', null, {
            topicID: id,
            details: result.details
          }).then(function (response) {
            formFeatures.segments.forEach(function (segment) {
              const index = segment.topics.findIndex(x => x.id == id);
              if (index > -1) {
                segment.topics.splice(index, 1);
              }
            });
            iservice.SuccessMessage('Topic removed successfully.');
          }).catch(function (errors) {
            formFeatures.errors = errors;
          }).finally(function () {
            formFeatures.loading = false;
          });
        }).catch(function (errors) {
          formFeatures.errors = errors;
          formFeatures.loading = false;
        });
      }
      formFeatures.segmentRemove = function (id) {
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=segmentdetails', null, { segmentID: id }).then(function (result) {
          result.details.servicelevelID = "";
          iservice.API('webapp-api-admin?api=segments&mode=modify', null, {
            segmentID: id,
            details: result.details
          }).then(function (response) {
            const index = formFeatures.details.effects.segments.findIndex(x => x.segmentID == id);
            if (index > -1) {
              formFeatures.details.effects.segments.splice(index, 1);
            }
            iservice.SuccessMessage('Segment Default removed successfully.');
          }).catch(function (errors) {
            formFeatures.errors = errors;
          }).finally(function () {
            formFeatures.loading = false;
          });
        }).catch(function (errors) {
          formFeatures.errors = errors;
          formFeatures.loading = false;
        });
      }
      formFeatures.error = {};
      formFeatures.Create = function () {
        formFeatures.hasRequiredErrors = false;
        if (!formFeatures.details.minutes) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!minutes || !minutes.value || !minutes.value.focus) return;
            minutes.value.focus();
          });
        }
        if (!formFeatures.details.name) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!name || !name.value || !name.value.focus) return;
            name.value.focus();
          });
        }
        if (formFeatures.hasRequiredErrors) return;
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;

        if (formFeatures.errors.length) return;
        if (formFeatures.details.propertyType == "Contact") {
          formFeatures.details.intPropertyID = "";
          formFeatures.details.intPropertyValue = "";
        }
        if (formFeatures.details.propertyType == "Interaction") {
          formFeatures.details.contactPropertyID = "";
          formFeatures.details.contactPropertyValue = "";
        }
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=servicelevels&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          serviceLevels.add(result.row);
          IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Service Level added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }
      Vue.watchEffect(function () {
        if (!intProperties.loaded) return;
        if (!contactProperties.loaded) return;
        serviceLevels.list.forEach(function (serviceLevel) {
          serviceLevel.propertyType = printPropertyType(serviceLevel);
          serviceLevel.propertyValue = printPropertyValue(serviceLevel);
          serviceLevel.propertyName = '';
          if (serviceLevel.contactPropertyID) {
            serviceLevel.propertyName = contactProperties.get(serviceLevel.contactPropertyID) && contactProperties.get(serviceLevel.contactPropertyID).option;
          }
          if (serviceLevel.intPropertyID) {
            serviceLevel.propertyName = intProperties.get(serviceLevel.intPropertyID) && intProperties.get(serviceLevel.intPropertyID).option;
          }
        });
      });
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=servicelevels&mode=delete', null, { servicelevelID: selectedID.value }).then(function (result) {
          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = IDs.indexOf(selectedID.value);
          if (index > -1) {
            IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { id } })
          iservice.SuccessMessage('Service Level removed successfully.');
          formFeatures.deleteStart = false;
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }
      formFeatures.onlyNumber = function ($event) {
        let keyCode = ($event.keyCode ? $event.keyCode : $event.which);
        if ((keyCode < 48 || keyCode > 57) && keyCode !== 46) { // 46 is dot
          $event.preventDefault();
        }
      }
      return { formFeatures, name, minutes, intProperties, contactProperties, ListCollapsed, serviceLevels, tableConfig, IDs, Select, selectedIDs, selectedID };
    }
  };

  //admin Skills component
  iservice.components.adminSkills = {
    name: 'vueapp-admin-skills',
    template: '#vueapp-admin-skills',
    route() { return { path: iservice.formPath + '/admin/skill/:id?', priority: 300, meta: { title: "iService | Skills" } } },
    setup(props) {

      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });
      var name = Vue.ref(null);
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.Skills');
      var skills = iservice.SkillData();
      var intProperties = iservice.IntPropertyData();
      var topics = iservice.TopicData();
      var router = VueRouter.useRouter();
      if (!skills.loaded) {
        skills.Load();
      }
      if (!intProperties.loaded) {
        intProperties.Load();
      }
      
      if (!topics.loaded) {
        topics.Load();
      }
      var ListCollapsed = Vue.reactive({ isListCollapsed: true })
      ListCollapsed.Toggle = function () {
        return ListCollapsed.isListCollapsed = !ListCollapsed.isListCollapsed;
      }
      formFeatures.details = {
        name: '',
        propertyValue: '',
        propertyName: '',
        propertyID: ''
      }
      Vue.watchEffect(function () { formFeatures.intProperties = intProperties.list; });
      var selectedID = Vue.ref(null);
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      formFeatures.propertyType = Vue.computed(() => {
        let type = "text";
        if (formFeatures.details.propertyID && formFeatures.intProperties) {
          type = formFeatures.intProperties.find(x => x.id == formFeatures.details.propertyID);
          if (type) {
            type = (type.isNumber ? 'number' : (type.isDate ? 'date' : (type.isInteger ? 'integer' : 'text')));
          }
          return type;
        }
        return type;
      });
      formFeatures.adminPath = Vue.computed(() => {
        return iservice.formPath + '/admin/agent/';
      });
      formFeatures.departmentPath = Vue.computed(() => {
        return iservice.formPath + '/admin/department/';
      });
      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.hasRequiredErrors = false;
        formFeatures.errors = [];
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;
        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            name: '',
            propertyValue: '',
            propertyName: '',
            propertyID: ''
          }
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }

      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(skills, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Skill Name', label: 'Skill Name',
            filterText: iservice.tables.SimpleFilterTextFunc(skills, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Property Name', label: 'Property Name',
            filterText: iservice.tables.SimpleFilterTextFunc(skills, 'propertyName'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Property Value', label: 'Property Value',
            filterText: iservice.tables.SimpleFilterTextFunc(skills, 'propertyValue'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Skills',
        emptyMessage: 'No Skills',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'ID',
        columns: tableColumns.value,
        exportName: "Skills"
      });
      var IDs = Vue.reactive([]);
      var itemsProcessed = 0;
      tableConfig.searching = true;
      var loaded = false;
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!skills.list.length) return;
        if (!intProperties.loaded) return;
        if (loaded) return;
        skills.list.forEach(function (skill) {
          var id = skill.id;
          skill.propertyValue = skill.propertyValue;
          skills.add(skill);
          IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == skills.list.length) {
            tableConfig.searching = false;
            loaded = true;
          }
        });
      });

      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { id } });
      });
      formFeatures.Save = function () {
        formFeatures.hasRequiredErrors = false;
        if (!formFeatures.details.name) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!name || !name.value || !name.value.focus) return;
            name.value.focus();
          });
        }
        if (formFeatures.hasRequiredErrors) return;

        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=skills&mode=modify', null, { skillID: selectedID.value, details: formFeatures.details }).then(function (result) {
          skills.add(result.row);
          iservice.SuccessMessage('Skill updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }

      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.id && intProperties.loaded) {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=skilldetails', null, { skillID: router.currentRoute.value.params.id }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.id;
            formFeatures.details = null;
            formFeatures.details = result.details;
            formFeatures.details.propertyName = '';
            if (formFeatures.details.propertyID) {
              formFeatures.details.propertyName = intProperties.get(formFeatures.details.propertyID) && intProperties.get(formFeatures.details.propertyID).option;
            }
            formFeatures.ChangeState('details');
          }).catch(function (errors) {
            formFeatures.errors = errors;
          }).finally(function () {
            formFeatures.loading = false;
          });
        }
      });

      formFeatures.segments = Vue.computed(function () {
        if (!topics.loaded) {
          topics.Load();
        }
        if (!topics.list.length) return [];
        var segmentByID = {};
        var segments = [];
        var istopic = formFeatures.details && formFeatures.details.effects && formFeatures.details.effects.topics.length;
        if (istopic) {
          formFeatures.details.effects.topics.forEach(function (topic) {
            var segment = segmentByID[topic.segmentID];
            if (!segment) {
              segment = { id: topic.segmentID, name: topic.segmentName, topics: [], topicByID: {} };
              segmentByID[topic.segmentID] = segment;
              segments.push(segment);
            }
            if (!segment.topicByID[topic.topicID]) {
              var getTopic = topics.get(topic.parentID);
              let obj = { id: topic.topicID, name: topic.name, parentName: topic.parentID ? getTopic.name : '' }
              segment.topicByID[topic.topicID] = obj;
              segment.topics.push(obj);
            }
          });
          segments.sort(function (l, r) {
            return l.name.localeCompare(r.name);
          });
          segments.forEach(function (segment) {
            segment.topics.sort(function (l, r) {
              return l.name.localeCompare(r.name);
            });
          });
        }
        return segments;
      });

      formFeatures.agentRemove = function (agentId) {
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=agentdetails', null, { agentID: agentId }).then(function (result) {
          const index = result.details.skillIDs.indexOf(selectedID.value);
          if (index > -1) {
            result.details.skillIDs.splice(index, 1);
          }
          iservice.API('webapp-api-admin?api=agentmodify&mode=modify', null, {
            agentID: agentId,
            details: result.details, settings: result.settings, custinfo: result.custinfo,
            membership: result.custinfo.membership
          }).then(function (response) {
            const index = formFeatures.details.effects.agents.findIndex(x => x.contactID == agentId);
            if (index > -1) {
              formFeatures.details.effects.agents.splice(index, 1);
            }
            iservice.SuccessMessage('Agent removed successfully.');
          }).catch(function (errors) {
            formFeatures.errors = errors;
          }).finally(function () {
            formFeatures.loading = false;
          });
        }).catch(function (errors) {
          formFeatures.errors = errors;
          formFeatures.loading = false;
        });
      }
      formFeatures.topicRemove = function (id) {
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=topicdetails', null, { topicID: id }).then(function (result) {
          const index = result.details.skills.indexOf(selectedID.value);
          if (index > -1) {
            result.details.skills.splice(index, 1);
          }
          iservice.API('webapp-api-admin?api=topics&mode=modify', null, {
            topicID: id,
            details: result.details
          }).then(function (response) {
            formFeatures.segments.forEach(function (segment, index, object) {
              const topicIndex = segment.topics.findIndex(x => x.id == id);
              if (topicIndex > -1) {
                segment.topics.splice(topicIndex, 1);
              }
              if (!segment.topics.length) {
                object.splice(index, 1);
              }
            });
            
            iservice.SuccessMessage('Topic removed successfully.');
          }).catch(function (errors) {
            formFeatures.errors = errors;
          }).finally(function () {
            formFeatures.loading = false;
          });
        }).catch(function (errors) {
          formFeatures.errors = errors;
          formFeatures.loading = false;
        });
      }
      formFeatures.departmentRemove = function (id) {
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=departmentdetails', null, { departmentID: id }).then(function (result) {
          const index = result.details.skillIDs.indexOf(selectedID.value);
          if (index > -1) {
            result.details.skillIDs.splice(index, 1);
          }
          iservice.API('webapp-api-admin?api=departments&mode=modify', null, {
            departmentID: id,
            details: result.details
          }).then(function (response) {
            const index = formFeatures.details.effects.departments.findIndex(x => x.departmentID == id);
            if (index > -1) {
              formFeatures.details.effects.departments.splice(index, 1);
            }
            iservice.SuccessMessage('Department removed successfully.');
          }).catch(function (errors) {
            formFeatures.errors = errors;
          }).finally(function () {
            formFeatures.loading = false;
          });
        }).catch(function (errors) {
          formFeatures.errors = errors;
          formFeatures.loading = false;
        });
      }
      formFeatures.error = {};
      formFeatures.Create = function () {
        formFeatures.hasRequiredErrors = false;
        if (!formFeatures.details.name) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!name || !name.value || !name.value.focus) return;
            name.value.focus();
          });
        }
        if (formFeatures.hasRequiredErrors) return;
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;

        if (formFeatures.errors.length) return;
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=skills&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          skills.add(result.row);
          IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
          iservice.SuccessMessage('Skill added successfully.');
        });
      }
      Vue.watchEffect(function () {
        skills.list.forEach(function (skill) {
          skill.propertyName = null;
          if (skill.propertyID) {
            skill.propertyName = intProperties.get(skill.propertyID) && intProperties.get(skill.propertyID).option;
          }
        });
      });
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=skills&mode=delete', null, { skillID: selectedID.value }).then(function (result) {
          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = IDs.indexOf(selectedID.value);
          if (index > -1) {
            IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { id } })
          iservice.SuccessMessage('Skill removed successfully.');
          formFeatures.deleteStart = false;
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }


      return { formFeatures, name, intProperties, ListCollapsed, skills, tableConfig, IDs, Select, selectedIDs, selectedID };
    }
  };

  //admin User Types component
  iservice.components.adminUserType = {
    name: 'vueapp-admin-usertypes',
    template: '#vueapp-admin-usertypes',
    route() { return { path: iservice.formPath + '/admin/usertype/:id?', priority: 300, meta: { title: "iService | User Type" } } },
    setup(props) {

      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, rights: [] });
      var name = Vue.ref(null);
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.UserTypes');
      var userTypes = iservice.UserTypesData();
      var router = VueRouter.useRouter();
      if (!userTypes.loaded) {
        userTypes.Load();
      }

      var ListCollapsed = Vue.reactive({ isListCollapsed: true })
      ListCollapsed.Toggle = function () {
        return ListCollapsed.isListCollapsed = !ListCollapsed.isListCollapsed;
      }
      formFeatures.details = {
        name: '',
        count: '',
        rightIDs: []
      }
      var selectedID = Vue.ref(null);
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.hasRequiredErrors = false;
        formFeatures.errors = [];
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;
        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            name: '',
            count: '',
            rightIDs: []
          }
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }

      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(userTypes, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Skill Name', label: 'User Type Name',
            filterText: iservice.tables.SimpleFilterTextFunc(userTypes, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Property Name', label: 'User Count',
            filterText: iservice.tables.SimpleFilterTextFunc(userTypes, 'count'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter User Types',
        emptyMessage: 'No User Types',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'ID',
        columns: tableColumns.value,
        exportName: "User Types"
      });
      var IDs = Vue.reactive([]);
      var itemsProcessed = 0;
      tableConfig.searching = true;
      var loaded = false;
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!userTypes.list) return;
        if (loaded) return;
        userTypes.list.forEach(function (userType) {
          var id = userType.id;
          userTypes.add(userType);
          IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == userTypes.list.length) {
            tableConfig.searching = false;
            loaded = true;
          }
        });
      });

      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { id } });
      });
      formFeatures.Save = function () {
        formFeatures.hasRequiredErrors = false;
        if (!formFeatures.details.name) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!name || !name.value || !name.value.focus) return;
            name.value.focus();
          });
        }
        if (formFeatures.hasRequiredErrors) return;

        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=usertypes&mode=modify', null, { usertypeID: selectedID.value, details: formFeatures.details }).then(function (result) {
          userTypes.add(result.row);
          iservice.SuccessMessage('User Type updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }

      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.id) {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=usertypedetails', null, { usertypeID: router.currentRoute.value.params.id }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.id;
            formFeatures.ChangeState('details');
            formFeatures.details = result.details;
          }).catch(function (errors) {
            formFeatures.errors = errors;
          }).finally(function () {
            formFeatures.loading = false;
          });
        }
      });

      formFeatures.error = {};
      formFeatures.Create = function () {
        formFeatures.hasRequiredErrors = false;
        if (!formFeatures.details.name) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!name || !name.value || !name.value.focus) return;
            name.value.focus();
          });
        }
        if (formFeatures.hasRequiredErrors) return;
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;

        if (formFeatures.errors.length) return;
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=usertypes&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          userTypes.add(result.row);
          IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('User Type added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=usertypes&mode=delete', null, { usertypeID: selectedID.value }).then(function (result) {
          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = IDs.indexOf(selectedID.value);
          if (index > -1) {
            IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { id } })
          iservice.SuccessMessage('User Type removed successfully.');
          formFeatures.deleteStart = false;
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }

      function Init() {
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=rightsall', null, null).then(function (result) {
          formFeatures.rights = result.rights;
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }

      Init();

      return { formFeatures, name, ListCollapsed, userTypes, tableConfig, IDs, Select, selectedIDs, selectedID };
    }
  };

  //admin websites component
  iservice.components.adminWebsites = {
    name: 'vueapp-admin-websites',
    template: '#vueapp-admin-websites',
    route() { return { path: iservice.formPath + '/admin/website/:id?', priority: 300, meta: { title: "iService | Websites" } } },
    setup(props) {

      //toggle table list panel
      var ListCollapsed = Vue.reactive({ isListCollapsed: true })
      ListCollapsed.Toggle = function () {
        return ListCollapsed.isListCollapsed = !ListCollapsed.isListCollapsed;
      }

      //declare router object
      var router = VueRouter.useRouter();

      //declare form data object and features object
      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });

      formFeatures.details = {
        name: '',
        segmentIDs: [],
        domains: []
      }
      var selectedID = Vue.ref(null);
      //select table row callback
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      //change forms state 
      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;
        
        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            name: '',
            description: '',
            segmentIDs: [],
            domains: []
          }
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }
      //if have right to access page
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.Websites');

      //load segments
      var segments = iservice.SegmentData();

      //load mailboxes
      var mailboxes = iservice.MailboxData();

      //load websites
      var websites = iservice.WebsitesData();

      //load autoresponses
      var autoResponses = iservice.AutoResponseData();

      if (!segments.loaded) {
        segments.Load(); //if not loaded then load
      }
      if (!websites.loaded) {
        websites.Load(); //if not loaded then load
      }
      formFeatures.mailboxes = Vue.computed(function () {
        if (!mailboxes.loaded || !segments.loaded) {
          mailboxes.Load(); segments.Load(); return;
        }
        var mailboxData = []
        segments.list.forEach(seg => {
          var group = { id: seg.id, label: seg.name, options: [] };
          mailboxes.inSegment(seg.id).forEach(mailbox => {
            var option = {
              value: mailbox.id,
              name: mailbox.name,
              label: mailbox.segmentName + ' -- '+ mailbox.name,
              email: mailbox.replyTo,
              search: mailbox.name + '\n' + mailbox.replyTo
            };
            group.options.push(option);
          });
          if (group.options.length < 1) return;
          group.options.sort((l, r) => { return mailboxes.SortCompare(l.value, r.value); });
          mailboxData.push(group);
        });
        mailboxData.sort((l, r) => { return segments.SortCompare(l.id, r.id); });
        return mailboxData;
      })
      
      var passwordTemp = Vue.ref(null)
      formFeatures.computePasswordNotificationTemplateList = function (details) {
        var load = false;
        Vue.watchEffect(function () {
          if (load) return;
          if (!autoResponses.loaded || !segments.loaded || !mailboxes.loaded) {
            autoResponses.Load(); segments.Load(); mailboxes.Load(); return;
          }
          load = true;
          formFeatures.autoResponsesData = []
          var allowedSegments = {};
          var mailbox = mailboxes.get(details.passwordResetMailboxID);
          if (mailbox) {
            allowedSegments[mailbox.segmentID] = true;
          }
          else {
            details.segmentIDs.forEach(function (id) {
              allowedSegments[id] = true;
            });
          }
          autoResponses.list.forEach(function (response) {
            if (!response.listNames.includes('passwordresetnotification')) return;
            if (allowedSegments[response.segmentID] != true) return;
            segments.list.forEach(seg => {
              if (response.segmentID != seg.id) return;
              var group = { id: seg.id, label: seg.name, options: [] };
              var option = {
                value: response.id,
                name: response.name,
                label: '('+ response.segmentName+') ' + response.name,
                search: response.name
              };
              group.options.push(option);
              if (group.options.length < 1) return;
              group.options.sort((l, r) => { return autoResponses.SortCompare(l.value, r.value); });
              formFeatures.autoResponsesData.push(group);
            });
            formFeatures.autoResponsesData.sort((l, r) => { return segments.SortCompare(l.id, r.id); });
          });
        })
      }
      //get standard segments only
      Vue.watchEffect(function () {
        if (!segments.list.length) return;
        formFeatures.segmentOptions = segments.list.filter(function (segment) {
          return !segment.hidden;
        })
        if (!passwordTemp.value) return;
        if (!autoResponses.list) return;
        var option = {};
        var response = autoResponses.get(formFeatures.details.passwordResetNotificationID);
        if (!response) return
        option.value = response.id;
        option.name = response.name;
        option.label = response.segmentName;
        option.search = response.name;
        passwordTemp.value.select(option);
      })

      //table columns declaration
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(websites, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            filterText: iservice.tables.SimpleFilterTextFunc(websites, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Segments', label: 'Segments',
            filterText: iservice.tables.SimpleFilterTextFunc(websites, 'segmentnames'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Domains', label: 'Domains',
            filterText: iservice.tables.SimpleFilterTextFunc(websites, 'domainsnames'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Websites',
        emptyMessage: 'No websites',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Websites"
      });

      //Row ids object declartion
      var IDs = Vue.reactive([]);


      var itemsProcessed = 0;
      tableConfig.searching = true;
      var loaded = false;

      //load data in table list
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!websites.list.length) return;
        if (formFeatures.shownToggleRunning) return;
        if (loaded) return;
        websites.list.forEach(function (website) {
          var id = website.id;
          websites.add(website);
          IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == websites.list.length) {
            tableConfig.searching = false;
            loaded = true;
          }
        });
      });
      
      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { id } });
      })
      //update record
      formFeatures.Save = function () {
        iservice.API('webapp-api-admin?api=websites&mode=modify', null, { websiteID: selectedID.value, details: formFeatures.details }).then(function (result) {
          websites.add(result.row);
          iservice.SuccessMessage('Website updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.id) {
          formFeatures.ShowDeleteButton = true;
          iservice.API('webapp-api-admin?api=websitedetails', null, { websiteID: router.currentRoute.value.params.id }).then(function (result) {
            formFeatures.computePasswordNotificationTemplateList(result.details);
            selectedID.value = router.currentRoute.value.params.id;
            formFeatures.ChangeState('details');
            formFeatures.details = result.details;
          }).then(function (result) {

          }).catch(function (errors) {

          }).finally(function () {

          });
        }
      });
      formFeatures.error = {};

      //create new record
      formFeatures.Create = function () {
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;
        if (!formFeatures.details.name) {
          formFeatures.errors.push({ msg: 'Please enter website name.', details: { description: '' } });
          formFeatures.error.name = true;
        }
        if (!formFeatures.details.segmentIDs.length) {
          formFeatures.errors.push({ msg: 'Please select atleast one segment.', details: { description: '' } });
          formFeatures.error.segment = true;
        }
        if (!formFeatures.details.rootUrl) {
          formFeatures.errors.push({ msg: 'Please enter website root URL.', details: { description: '' } });
          formFeatures.error.rootUrl = true;
        }
        if (!formFeatures.details.passwordResetMailboxID) {
          formFeatures.errors.push({ msg: 'Please select outbound mailbox.', details: { description: '' } });
          formFeatures.error.passwordResetMailboxID = true;
        }
        if (!formFeatures.details.passwordResetNotificationID) {
          formFeatures.errors.push({ msg: 'Please select password reset template.', details: { description: '' } });
          formFeatures.error.passwordResetNotificationID = true;
        }
        if (formFeatures.errors.length) return;
        iservice.API('webapp-api-admin?api=websites&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          websites.add(result.row);
          IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Website added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      //delete record
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        iservice.API('webapp-api-admin?api=websites&mode=delete', null, { websiteID: selectedID.value }).then(function (result) {

          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = IDs.indexOf(selectedID.value);
          if (index > -1) {
            IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { id } })
          iservice.SuccessMessage('Website deleted successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          
        });
      }
      formFeatures.DomainAdd = function (domainToAdd) {
        formFeatures.details.domains.push(domainToAdd);
        formFeatures.details.domainToAdd = '';
      }
      formFeatures.DomainRemove = function (domain) {
        const index = formFeatures.details.domains.indexOf(domain);
        if (index > -1) {
          formFeatures.details.domains.splice(index, 1);
        }
      }
      formFeatures.placeholderGroup = 'custom';

      formFeatures.component = 'admin-website-details-placeholder-custom';
      formFeatures.PlaceholderShow = function (group) {
        formFeatures.placeholderGroup = group;
        if (group == 'custom') {
          formFeatures.component = 'admin-website-details-placeholder-custom'
        } else {
          formFeatures.component = 'admin-website-details-placeholder-builtin'
        }
      }
      formFeatures.PlaceholderCustomClass = function () {
        return formFeatures.placeholderGroup == 'custom' ? 'active btn-primary' : 'btn-default';
      }
      formFeatures.PlaceholderBuiltinClass = function () {
        return formFeatures.placeholderGroup == 'builtin' ? 'active btn-primary' : 'btn-default';
      }


      return { formFeatures, ListCollapsed, segments, tableConfig, IDs, Select, selectedIDs, selectedID, passwordTemp };
    }
  };

  //admin Alert component
  iservice.components.adminAlerts = {
    name: 'vueapp-admin-alerts',
    template: '#vueapp-admin-alerts',
    route() { return { path: iservice.formPath + '/admin/alert/:id?', priority: 300, meta: { title: "iService | Alerts" } } },
    setup(props) {

      var formFeatures = Vue.reactive({ errors: [], success: '', value: null, ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [], frequencyTimeType: "Minutes", ageTimeType: "Minutes", actions: [] });
      var alertName = Vue.ref(null);
      var frequency = Vue.ref(null);
      var question = Vue.ref(null);
      var topicIDs = Vue.ref(null);
      var actions = Vue.ref(null);
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.AdditionalDetails');
      formFeatures.stepsOptions = iservice.AlertsStepsOptions;
      var alerts = iservice.AlertsData();
      var segments = iservice.SegmentData();
      var topics = iservice.TopicData();
      var agents = iservice.AgentData();
      var router = VueRouter.useRouter();
      if (!alerts.loaded) {
        alerts.Load();
      }
      if (!topics.loaded) {
        topics.Load();
      }
      if (!agents.loaded) {
        agents.Load();
      }
      var ListCollapsed = Vue.reactive({ isListCollapsed: true })
      ListCollapsed.Toggle = function () {
        return ListCollapsed.isListCollapsed = !ListCollapsed.isListCollapsed;
      }

      formFeatures.details = {
        name: '',
        ageMinutes: '',
        frequencyMinutes: '',
        topicIDs: [],
        action: { steps: [] },
        enabled: false
      }
      var selectedID = Vue.ref(null);
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.hasRequiredErrors = false;
        formFeatures.errors = [];
        if (state == 'new') {
          for (const topic in featureTopics.selectedMap) {
            featureTopics.selectedMap[topic] = false;
          }
        }
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;
        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            name: '',
            ageMinutes: '',
            frequencyMinutes: '',
            topicIDs: [],
            action: { steps: [] },
            enabled: false
          }
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }
      function onToggle(alert) {
        alert.shownRunning = true;
        iservice.API('webapp-api-admin?api=alertdetails', null, { alertID: alert.id }).then(function (result) {
          result.details.enabled = alert.enabled;
          return iservice.API('webapp-api-admin?api=alerts&mode=modify', null, { alertID: alert.id, details: result.details }).then(function (result) {
            iservice.SuccessMessage('Alert list saved.');
            formFeatures.details.enabled = alert.enabled;
            alerts.add(result.details);
          }).catch(function (errors) {
            formFeatures.errors = errors;
          }).finally(function () {
            alert.shownRunning = false;
          });
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          alert.shownRunning = false;
        });
      }
      var featureTopics = Vue.reactive({ showMine: true, segments: [], list: [], selectedMap: {}, collapsedMap: {}, selectAll: true, collapsed: false });

      Vue.watchEffect(() => {
        if (!segments.loaded) segments.Load();
        if (!topics.loaded) topics.Load();
        if (!agents.loaded) agents.Load();
        featureTopics.segments.length = 0;
        var map = {};
        featureTopics.list.length = 0;
        segments.list.forEach(seg => {
          var segmentID = seg.id;
          var segment = Vue.reactive({
            name: seg.name,
            topics: []
          });
          topics.inSegment(segmentID).forEach(topic => {
            var item = map[topic.id] = Vue.reactive({
              id: topic.id,
              name: topic.name,
              visibility: topic.visibility,
              children: []
            });
            featureTopics.list.push(item);
          });
          topics.inSegment(segmentID).forEach(topic => {
            var row = map[topic.id];
            if (!row) return;
            var parentID = topic.parentID;
            var parent = map[parentID];
            while (!parent) {
              if (!parentID) break;
              parentID = topics.get(parentID).parentID;
              parent = map[parentID];
            }
            (parent ? parent.children : segment.topics).push(row);
          });
          if (segment.topics.length < 1) return;
          featureTopics.segments.push(segment);
        });
        function SortRow(lrow, rrow) { return topics.TreeSortCompare(lrow.id, rrow.id); }
        featureTopics.segments.sort(SortRow);
        featureTopics.list.forEach(row => {
          row.children.sort(SortRow);
        });
      });
      
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(alerts, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Alert Name', label: 'Alert Name',
            filterText: iservice.tables.SimpleFilterTextFunc(alerts, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Frequency', label: 'Frequency',
            filterText: iservice.tables.SimpleFilterTextFunc(alerts, 'frequencyMinutes'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Question Age', label: 'Question Age',
            filterText: iservice.tables.SimpleFilterTextFunc(alerts, 'ageMinutes'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Topics', label: 'Topics',
            filterText: iservice.tables.SimpleFilterTextFunc(alerts, 'topicsName'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Action Steps', label: 'Action Steps',
            filterText: iservice.tables.SimpleFilterActionStepsTextFunc(alerts),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-alert-action-steps', shown: true
          }),
          Vue.reactive({
            name: 'Enabled', label: 'Enabled',
            Save: onToggle,
            filterText: iservice.tables.SimpleFilterTextFunc(alerts, 'enabled'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-alert-toggle', shown: true
          })
        ];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Alerts',
        emptyMessage: 'No Alerts',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'ID',
        columns: tableColumns.value,
        exportName: "Alerts"
      });
      var IDs = Vue.reactive([]);
      var itemsProcessed = 0;
      tableConfig.searching = true;
      var loaded = false;
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!alerts.loaded || !topics.loaded) return;
        if (loaded) return;
        if (alerts.list.length) {
          alerts.list.forEach(function (alert) {
            let id = alert.id;
            let topicsName = [];
            if (alert.topicIDs.length > 0) {
              alert.topicIDs.forEach(x => {
                let topic = topics.get(x);
                if (topic) topicsName.push(topic.name);
              });
              alert["topicsName"] = topicsName.join(',');
            }
            alert["actionsName"] = "";
            alerts.add(alert);
            IDs.push(id);
            itemsProcessed++;
            if (itemsProcessed == alerts.list.length) {
              tableConfig.searching = false;
              loaded = true;
            }
          });
        } else {
          tableConfig.searching = false;
          loaded = true;
        }
      });
      Vue.watchEffect(function () {
        if (!alerts.loaded || !topics.loaded) return;
        alerts.list.forEach(function (alert) {
          let topicsName = [];
          if (alert.topicIDs && alert.topicIDs.length > 0) {
            alert.topicIDs.forEach(x => {
              let topic = topics.get(x);
              if (topic) topicsName.push(topic.name);
            });
            alert["topicsName"] = topicsName.join(',');
          }
          alert["actionsName"] = "";
          alerts.add(alert);
        });
      });
      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { id } });
      });
      
      formFeatures.Save = function () {
        formFeatures.errors = [];
        
        validate();
        if (formFeatures.hasRequiredErrors === true) return;
        if (formFeatures.frequencyTimeType != "Minutes") {
          let value = formFeatures.frequencyTimeType == "Hours" ? 30 : 1440;
          formFeatures.details.frequencyMinutes = formFeatures.details.frequencyMinutes * value;
        }
        if (formFeatures.ageTimeType != "Minutes") {
          let value = formFeatures.ageMinutes == "Hours" ? 30 : 1440;
          formFeatures.details.ageMinutes = formFeatures.details.ageMinutes * value;
        }
        formFeatures.formatPayloadAction();
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=alerts&mode=modify', null, { alertID: selectedID.value, details: formFeatures.details }).then(function (result) {
          formFeatures.frequencyTimeType = formFeatures.ageTimeType = "Minutes";
          alerts.add(result.details);
          formFeatures.formatDisplayAction(result.details.action);
          iservice.SuccessMessage('Alert updated successfully.');
        }).catch(function (errors) {
          formFeatures.formatDisplayAction(formFeatures.details.action);
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }

      function validate() {
        if (!formFeatures.details.name) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!alertName || !alertName.value || !alertName.value.focus) return;
            alertName.value.focus();
          });
          return;
        }
        
        if (!formFeatures.details.frequencyMinutes) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!frequency || !frequency.value || !frequency.value.focus) return;
            frequency.value.focus();
          });
          return;
        }
        if (formFeatures.details.ageMinutes == null || formFeatures.details.frequencyMinutes == "") {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!question || !question.value || !question.value.focus) return;
            question.value.focus();
          });
          return;
        }
        if (formFeatures.details.topicIDs.length == 0) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!topicIDs || !topicIDs.value) return;
            topicIDs.value.scrollIntoView();
          });
          return;
        }
        if (formFeatures.details.action.steps.length == 0) {
          formFeatures.hasRequiredErrors = true;
          setTimeout(() => {
            if (!actions || !actions.value) return;
            actions.value.scrollIntoView();
          });
          return;
        }
      }
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.id) {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=alertdetails', null, { alertID: router.currentRoute.value.params.id }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.id;
            formFeatures.details = result.details;
            formFeatures.formatDisplayAction(result.details.action);
            for (const topic in featureTopics.selectedMap) {
              featureTopics.selectedMap[topic] = false;
            }
            formFeatures.details.topicIDs.forEach((x) => {
              featureTopics.selectedMap[x] = true;
            });
            formFeatures.ChangeState('details');
          }).catch(function (errors) {
            formFeatures.errors = errors;
          }).finally(function () {
            formFeatures.loading = false;
          });
        }
      });
      Vue.provide('selectedMap', featureTopics.selectedMap);
      Vue.provide('collapsedMap', featureTopics.collapsedMap);
      featureTopics.onTopicChange = function (selectedMap) {
        console.log("test 1");
        setTimeout(function () {
          formFeatures.details.topicIDs = [];
          for (const topic in selectedMap) {
            if (selectedMap[topic] === true) {
              formFeatures.details.topicIDs.push(topic);
            }
          }
          console.log("test 2", formFeatures.details.topicIDs);
        }, 100);
      }
      formFeatures.handleTagRemove = function (option, event) {
        let index = formFeatures.details.topicIDs.indexOf(option.value);
        if (index !== -1) formFeatures.details.topicIDs.splice(index, 1);
      }
      formFeatures.error = {};
      formFeatures.Create = function () {
        validate();
        if (formFeatures.hasRequiredErrors === true) return;
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;

        if (formFeatures.frequencyTimeType != "Minutes") {
          let value = formFeatures.frequencyTimeType == "Hours" ? 30 : 1440;
          formFeatures.details.frequencyMinutes = formFeatures.details.frequencyMinutes * value;
        }
        if (formFeatures.ageTimeType != "Minutes") {
          let value = formFeatures.ageMinutes == "Hours" ? 30 : 1440;
          formFeatures.details.ageMinutes = formFeatures.details.ageMinutes * value;
        }
        formFeatures.loading = true;
        formFeatures.details.action.steps.forEach(function (step, key) {
          var steps = {};
          step.stepType = step.stepType.replace('actionstep-', '');
          steps[step.stepType] = {};
          for (var key in step) {
            if (step.hasOwnProperty(key)) {
              if (key !== 'stepType')
                steps[step.stepType][key] = step[key];
            }
          }
          for (const property in steps) {
            if (step.stepType == property) {
              step[property] = steps[property];
            }
          }
        });
        iservice.API('webapp-api-admin?api=alerts&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          alerts.add(result.row);
          formFeatures.frequencyTimeType = formFeatures.ageTimeType = "Minutes";
          IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Alert added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
          formFeatures.formatDisplayAction(formFeatures.details.action)
        }).finally(function () {
          formFeatures.loading = false;
        });
      }
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        formFeatures.loading = true;
        iservice.API('webapp-api-admin?api=alerts&mode=delete', null, { alertID: selectedID.value }).then(function (result) {
          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = IDs.indexOf(selectedID.value);
          if (index > -1) {
            IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { id } })
          iservice.SuccessMessage('Alert removed successfully.');
          formFeatures.deleteStart = false;
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formFeatures.loading = false;
        });
      }
      formFeatures.AddAction = function () {
        formFeatures.details.action.steps.push({});
      };
      formFeatures.ActionMoveUp = function (actions, action) {
        let stepType = action.stepType.replace("actionstep-", "");
        let index = formFeatures.actions.findIndex(x => x.hasOwnProperty(stepType) && x[stepType] !== null);
        if (index !== -1) {
          let obj = formFeatures.actions[index];
          formFeatures.actions.splice(index, 1);
          formFeatures.actions.splice(index - 1, 0, obj);
        }
        for (var i = 1; i < actions.length; i++) {
          if (action !== actions[i]) continue;
          actions.splice(i, 1);
          actions.splice(i - 1, 0, action);
          return;
        }
      };
      formFeatures.ActionMoveDown = function (actions, action) {
        let stepType = action.stepType.replace("actionstep-", "");
        let index = formFeatures.actions.findIndex(x => x.hasOwnProperty(stepType) && x[stepType] !== null);
        if (index !== -1) {
          let obj = formFeatures.actions[index];
          formFeatures.actions.splice(index, 1);
          if (index === formFeatures.actions.length - 1) formFeatures.actions.push(obj);
          else formFeatures.actions.splice(index + 1, 0, obj);
        }
        for (var i = 0; i < actions.length - 1; i++) {
          if (action !== actions[i]) continue;
          actions.splice(i, 1);
          if (i === actions.length - 1) actions.push(action);
          else actions.splice(i + 1, 0, action);
          return;
        }
      };
      formFeatures.ActionDelete = function (actions, action) {
        let stepType = action.stepType.replace("actionstep-", "");
        let index = formFeatures.actions.findIndex(x => x.hasOwnProperty(stepType) && x[stepType] !== null);
        if (index !== -1) formFeatures.actions.splice(index, 1);
        for (var i = 0; i < actions.length; i++) {
          if (action !== actions[i]) continue;
          actions.splice(i, 1);
          return;
        }
      };
      formFeatures.getStepForm = function (action) {
        action.stepType = 'actionstep-' + action.stepType;
      }
      formFeatures.formatDisplayAction = function (action) {
        var steps = [];
        if (action) {
          action.steps.forEach(function (step) {
            for (let key in step) {
              if (step[key] !== null) {
                var obj = {
                  stepType: 'actionstep-' + key
                }
                for (let key2 in step[key]) {
                  obj[key2] = step[key][key2];
                }
                steps.push(obj);
              }
            }
          });
          formFeatures.actions = action.steps;
          formFeatures.details.action.steps = steps;
        } else {
          formFeatures["actions"] = [];
          formFeatures.details.action = { steps: [] };
        }
      }
      formFeatures.formatPayloadAction = function () {
        formFeatures.details.action.steps.forEach(function (step, key) {
          var steps = {};
          var stepExists = false;
          step.stepType = step.stepType.replace('actionstep-', '');
          formFeatures.actions.forEach(function (action, index) {
            if (action[step.stepType] && action[step.stypetype] !== null) {
              stepExists = true
              for (var key in step) {
                if (step.hasOwnProperty(key)) {
                  if (key !== 'stepType')
                    action[step.stepType][key] = step[key];
                }
              }
            }
          });
          if (!stepExists) {
            steps[step.stepType] = {};
            for (var key in step) {
              if (step.hasOwnProperty(key)) {
                if (key !== 'stepType')
                  steps[step.stepType][key] = step[key];
              }
            }
            let obj = formFeatures.actions.length > 0 ? Object.assign({}, formFeatures.actions[0]) : {};
            for (key in obj) {
              obj[key] = null;
            }
            obj[step.stepType] = steps[step.stepType];
            formFeatures.actions.push(obj);
          }
        });
        formFeatures.details.action.steps = [];
        formFeatures.actions.forEach(function (action) {
          formFeatures.details.action.steps.push(action);
        })
        formFeatures.details.action.steps = formFeatures.details.action.steps.filter(element => {
          if (Object.keys(element).length !== 0) {
            return true;
          }
          return false;
        });
      }
      
      return { formFeatures, featureTopics, alertName, frequency, question, topicIDs, actions, ListCollapsed, alerts, tableConfig, IDs, Select, selectedIDs, selectedID, onToggle, topics };
    }
  };
  iservice.components.alertTopicRow = {
    name: 'alert-topic-row',
    template: '#alert-topic-row',
    props: ['topic'],
    emits: ['onTopicChange'],
    setup(props) {
      var selectedMap = Vue.inject('selectedMap');
      var collapsedMap = Vue.inject('collapsedMap');
      var collapseClass = Vue.computed(() => {
        if (collapsedMap[props.topic.id]) return 'fa-plus-circle';
        return 'fa-minus-circle';
      });
      
      function CollapseClick() {
        collapsedMap[props.topic.id] = !collapsedMap[props.topic.id];
      }

      return { selectedMap, collapsedMap, collapseClass, CollapseClick };
    }
  }
  iservice.components.adminAlertToggle = {
    name: 'iservice-table-cell-alert-toggle',
    template: '#iservice-table-cell-alert-toggle',
    props: ['itemid', 'column'],
    setup(props) {
      var alerts = iservice.AlertsData();
      var Alert = Vue.computed(() => {
        var alert = alerts.get(props.itemid);
        if (!alert) return '';
        return alert;
      });
      var onToggle = Vue.computed(function () {
        return props.column.Save;
      });
      return { Alert, onToggle };
    }
  };

  iservice.components.adminAlertActionStepsColumn = {
    name: 'iservice-table-cell-alert-action-steps',
    template: '#iservice-table-cell-alert-action-steps',
    props: ['itemid'],
    setup(props) {
      var alerts = iservice.AlertsData();
      var actionStepsData = Vue.computed(() => {
        var alert = alerts.get(props.itemid);
        if (!alert) return '';
        var actionStepsString = [];
        if (alert.action) {
          alert.action.steps.forEach(function (step, key) {
            for (const item in step) {
              if (step[item]) actionStepsString.push(item);
            }
          });
          return actionStepsString.join(', ')
        } else {
          return '';
        }

      });
      return { actionStepsData };
    }
  };
  iservice.components.adminWebsitesPlaceholderCustom = {
    name: 'admin-website-details-placeholder-custom',
    template: '#admin-website-details-placeholder-custom',
    props: ['details'],
    setup(props) {
      var websites = iservice.WebsitesData();
      var details = Vue.computed(function () {
        return props.details;
      })

      function FilterCustom(placeholder) {
        return placeholder.defaultValue === null ? true : false;
      }

      function DeletePlateholderStart(placeholder) {
        placeholder.isDeleting = true;
      }
      function DeletePlateholderConfirm(placeholder) {
        var index = details.value.placeholders.findIndex(x => x.name === placeholder.name);
        if (index > -1) {
          details.value.placeholders.splice(index, 1);
        }
      }
      function DeletePlateholderCancel(placeholder) {
        placeholder.isDeleting = false;
      }
      function AddPlaceholder() {
        details.value.placeholders.unshift({ name: "", value: "", defaultValue: null });
      }
      return { DeletePlateholderStart, DeletePlateholderConfirm, DeletePlateholderCancel, AddPlaceholder, details, FilterCustom };

    }
  }
  iservice.components.adminWebsitesPlaceholderBuiltIn = {
    name: 'admin-website-details-placeholder-builtin',
    template: '#admin-website-details-placeholder-builtin',
    props: ['details'],
    setup(props) {
      var placeholders = iservice.PlaceholdersData();
      var intProperties = iservice.IntPropertyData();
      if (!intProperties.loaded) {
        intProperties.Load();
      }
      var details = Vue.computed(function () {
        return props.details;
      });

      function FilterBuiltIn(placeholder) {
        return placeholder.defaultValue === null ? false : true;
      }

      //table columns declaration
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'Name', label: 'Placeholder Name',
            filterText: iservice.tables.SimpleFilterTextFunc(placeholders, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'BulitInName', label: 'Form ID/Builtin Name',
            filterText: iservice.tables.SimpleFilterTextFunc(placeholders, 'value'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-placeholder-simple', shown: true
          }),
          Vue.reactive({
            name: 'edit', hidable: false,
            filterText: function () { },
            componentHead: 'iservice-table-head-empty', componentCell: 'iservice-table-cell-website-builtin-edit', shown: true
          })];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Placeholder Names',
        emptyMessage: 'No placeholders',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Built In Placeholders"
      });
      var IDs = Vue.reactive([]);
      var builtInPlaceholders = details.value.placeholders.filter(FilterBuiltIn);
      builtInPlaceholders.forEach(function (placeholder) {
        placeholders.add(placeholder)
        IDs.push(placeholder.name)
      });
      var feature = Vue.reactive({ errors: [] });
      feature.showMoreToggle = function () {
        feature.showmore = !feature.showmore;
      }
      feature.UpdateRow = function (placeholder,state) {
        var hasBeenReadExist, donotreplyExist, deletedExist, archivedExist;
        var error = false;
        feature.requiredPropertySetup = false;
        if ((placeholder.name == 'myqueue-answer-actions') && (placeholder.value == 'ngappbuiltin-myqueue-answer-actions-secure-message-portal' || placeholder.value == 'ngappbuiltin-myqueue-answer-actions-secure-message-portal-notification')) {
          hasBeenReadExist = intProperties.getByName('HasBeenRead') ? true : false;
          donotreplyExist = intProperties.getByName('DoNotReply') ? true : false;
          deletedExist = intProperties.getByName('Deleted') ? true : false;
          archivedExist = intProperties.getByName('Archived') ? true : false;
          if (!hasBeenReadExist || !donotreplyExist || !deletedExist || !archivedExist) {
            feature.requiredPropertySetup = true;
            error = true;
            return false;
          }
        }

        if (!error) {
          details.value.placeholders.forEach(function (item) {
            if (item.name == placeholder.name) {
              item.value = placeholder.value;
            }
          })
          iservice.API('webapp-api-admin?api=websites&mode=modify', null, { websiteID: details.value.id, details: details.value }).then(function (result) {
            iservice.SuccessMessage('Website updated successfully.');
            state(placeholder.name)
          }).catch(function (errors) {

          });
        }
      }
      return { tableConfig, IDs, feature };

    }
  }
  iservice.components.adminMailingList = {
    name: 'vueapp-admin-mailinglists',
    template: '#vueapp-admin-mailinglists',
    route() { return { path: iservice.formPath + '/admin/mailing-lists/:id?', priority: 300, meta: { title: "iService | Mailing Lists" } } },
    setup(props) {

      var ListCollapsed = Vue.reactive({ isListCollapsed: true })
      ListCollapsed.Toggle = function () {
        return ListCollapsed.isListCollapsed = !ListCollapsed.isListCollapsed;
      }
      var featureTabs = Vue.reactive({ tab: 'details' });
      featureTabs.TabClass = function (tab) { return { 'active': tab == featureTabs.tab } }
      featureTabs.TabClick = function (tab) { featureTabs.tab = tab; }

      var router = VueRouter.useRouter();
      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });

      formFeatures.details = {
        name: '',
        description: '',
        segmentIDs: []
      }
      var selectedID = Vue.ref(null);
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;
        
        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            name: '',
            description: '',
            segmentIDs: []
          }
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.Mailings');
      var segments = iservice.SegmentData();
      var masslists = iservice.MasslistData();

      if (!segments.loaded) {
        segments.Load();
      }
      if (!masslists.loaded) {
        masslists.Load();
      }
      Vue.watchEffect(function () {
        if (!segments.list.length) return;
        formFeatures.segmentOptions = segments.list.filter(function (segment) {
          return !segment.hidden;
        })
      })

      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(masslists, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            filterText: iservice.tables.SimpleFilterTextFunc(masslists, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Description', label: 'Description',
            filterText: iservice.tables.SimpleFilterTextFunc(masslists, 'description'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Segments', label: 'Segments',
            filterText: iservice.tables.SimpleFilterTextFunc(masslists, 'segments'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Shown In My Account', label: 'Shown In My Account',
            Save: ShownSave,
            filterText: iservice.tables.SimpleFilterTextFunc(masslists, 'shown'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-masslist-toggle', shown: true
          }),
          Vue.reactive({
            name: 'Subscribers', label: 'Subscribers',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(masslists, 'subCount'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Unsubscribers', label: 'Unsubscribers',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(masslists, 'unsubCount'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Last Mailing', label: 'Last Mailing', sortIncreasing: false,
            filterText: iservice.tables.DateFilterTextFunc(masslists, 'lastMail'), sortText: iservice.tables.DateSortTextFunc(masslists, 'lastMail'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Mailing Lists',
        emptyMessage: 'No Mailing List',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Mailing Lists"
      });
      var IDs = Vue.reactive([]);
      var itemsProcessed = 0;
      tableConfig.searching = true;
      var loaded = false;
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!masslists.list.length) return;
        if (formFeatures.shownToggleRunning) return;
        if (loaded) return;
        masslists.list.forEach(function (masslist) {
          var id = masslist.id;
          masslists.add(masslist);
          IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == masslists.list.length) {
            tableConfig.searching = false;
            loaded = true;
          }
        });
      });
      
      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { id } });
      })

      formFeatures.Save = function () {
        iservice.API('webapp-api-admin?api=masslists&mode=modify', null, { masslistID: selectedID.value, details: formFeatures.details }).then(function (result) {
          masslists.add(result.row);
          iservice.SuccessMessage('Mailing List updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.id) {
          formFeatures.ShowDeleteButton = true;
          iservice.API('webapp-api-admin?api=masslistdetails', null, { masslistID: router.currentRoute.value.params.id }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.id;
            formFeatures.ChangeState('details');
            formFeatures.details = result.details;
            /*
            return API('webapp-api-admin?api=masslists&mode=modify', idPrefix, 'MasslistModify', { masslistID: masslist.id, details: result.details }).catch(function (errors) {
              if (errors && errors.length) errors[0].msg = 'Error modifying mailing list. ' + errors[0].msg;
              return $q.reject(errors);
            });*/
          }).then(function (result) {
           /* $scope.messages.toggleSuccess = 'Mailing List updated.'
            if (masslist.details) masslist.details.shown = masslist.shown;*/
          }).catch(function (errors) {
            //$scope.messages.toggleErrors = errors;
          }).finally(function () {
           // masslist.shownRunning = false;
          });
        }
      });

      function ShownSave(masslist) {
        masslist.shownRunning = true;
        iservice.API('webapp-api-admin?api=masslistdetails', null, { masslistID: masslist.id }).then(function (result) {
          result.details.shown = masslist.shown;
          return iservice.API('webapp-api-admin?api=masslists&mode=modify', null, { masslistID: masslist.id, details: result.details }).then(function (result) {
            iservice.SuccessMessage('Mass list saved.');
            formFeatures.details.shown = masslist.shown;
          }).catch(function (errors) {

          }).finally(function () {
            masslist.shownRunning = false;
          });
        }).catch(function (errors) {
        }).finally(function () {
          masslist.shownRunning = false;
        });

      }
      formFeatures.error = {};
      formFeatures.Create = function () {
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;
        if (!formFeatures.details.name) {
          formFeatures.errors.push({ msg: 'Please enter masslist name.', details: { description: '' } });
          formFeatures.error.name = true;
        }
        if (!formFeatures.details.segmentIDs.length) {
          formFeatures.errors.push({ msg: 'Please select atleast one segment.', details: { description: '' } });
          formFeatures.error.segment = true;
        }
        if (formFeatures.errors.length) return;
        iservice.API('webapp-api-admin?api=masslists&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          masslists.add(result.row);
          IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Mailing List added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        iservice.API('webapp-api-admin?api=masslists&mode=delete', null, { masslistID: selectedID.value }).then(function (result) {

          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = IDs.indexOf(selectedID.value);
          if (index > -1) {
            IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { id } })
          iservice.SuccessMessage('Mailing List deleted successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          
        });
      }

      return { formFeatures, ListCollapsed, segments, tableConfig, IDs, Select, selectedIDs, selectedID, featureTabs, ShownSave };
    }
  };
  iservice.components.adminMassCampaigns = {
    name: 'vueapp-admin-masscampaign',
    template: '#vueapp-admin-masscampaign',
    route() { return { path: iservice.formPath + '/admin/mailing-campaigns/:id?', priority: 300, meta: { title: "iService | Mailing Campaigns" } } },
    setup(props) {

      var ListCollapsed = Vue.reactive({ isListCollapsed: true })
      ListCollapsed.Toggle = function () {
        return ListCollapsed.isListCollapsed = !ListCollapsed.isListCollapsed;
      }
      var featureTabs = Vue.reactive({ tab: 'details' });
      featureTabs.TabClass = function (tab) { return { 'active': tab == featureTabs.tab } }
      featureTabs.TabClick = function (tab) { featureTabs.tab = tab; }

      var router = VueRouter.useRouter();
      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });

      formFeatures.details = {
        name: '',
        description: '',
        segmentIDs: [],
        events: []
      }
      var selectedID = Vue.ref(null);
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;
        
        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            name: '',
            description: '',
            segmentIDs: [],
            events: []
          }
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.Mailings');
      var segments = iservice.SegmentData();
      var masscampaigns = iservice.MassCampaignsData();
      var massmessages = iservice.MassMessagesData();
      var mailboxes = iservice.MailboxData();
      var topics = iservice.TopicData();

      if (!mailboxes.loaded) mailboxes.Load();

      if (!segments.loaded) {
        segments.Load();
      }
      if (!masscampaigns.loaded) {
        masscampaigns.Load();
      }
      if (!massmessages.loaded) {
        massmessages.Load();
      }
      if (!topics.loaded) {
        topics.Load();
      }
      formFeatures.massmessage = massmessages.list;
      Vue.watchEffect(function () {
        if (!segments.list.length) return;
        formFeatures.segmentOptions = segments.list.filter(function (segment) {
          return !segment.hidden;
        })
      });

      formFeatures.onChangeMessage = function (event) {
        event.mailboxes = [];
        event.mailboxID = '';
        var message = massmessages.get(event.messageID);
        var topic = topics.get(message.topicID);
        var segment = segments.get(topic.segmentID);
        var group = { id: segment.id, label: segment.name, options: [] };
        mailboxes.inSegment(segment.id).forEach(mailbox => {
          var option = {
            value: mailbox.id,
            name: mailbox.name,
            email: mailbox.replyTo,
            search: mailbox.name + '\n' + mailbox.replyTo
          };
          group.options.push(option);
        });
        if (group.options.length < 1) return;
        group.options.sort((l, r) => { return mailboxes.SortCompare(l.value, r.value); });
        event.mailboxes.push(group);
      }
      Vue.watchEffect(() => {
        if (!mailboxes.loaded || !segments.loaded || !massmessages.loaded || !topics.loaded) {
          mailboxes.Load(); segments.Load(); massmessages.Load(); topics.Load(); return;
        }
        formFeatures.details.events.forEach(function (event) {
          event.mailboxes = []
          var message = massmessages.get(event.messageID);
          var topic = topics.get(message.topicID);
          var segment = segments.get(topic.segmentID);
          var group = { id: segment.id, label: segment.name, options: [] };
          mailboxes.inSegment(segment.id).forEach(mailbox => {
            var option = {
              value: mailbox.id,
              name: mailbox.name,
              email: mailbox.replyTo,
              search: mailbox.name + '\n' + mailbox.replyTo
            };
            group.options.push(option);
          });
          if (group.options.length < 1) return;
          group.options.sort((l, r) => { return mailboxes.SortCompare(l.value, r.value); });
          event.mailboxes.push(group);
        })
        
      })

      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(masscampaigns, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            filterText: iservice.tables.SimpleFilterTextFunc(masscampaigns, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Description', label: 'Description',
            filterText: iservice.tables.SimpleFilterTextFunc(masscampaigns, 'description'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Segments', label: 'Segments',
            filterText: iservice.tables.SimpleFilterTextFunc(masscampaigns, 'segments'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Shown In My Account', label: 'Shown In My Account',
            Save: ShownSave,
            filterText: iservice.tables.SimpleFilterTextFunc(masscampaigns, 'shown'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-masscampaign-toggle', shown: true
          }),
          Vue.reactive({
            name: 'Subscribers', label: 'Subscribers',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(masscampaigns, 'subCount'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Unsubscribers', label: 'Unsubscribers',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(masscampaigns, 'unsubCount'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Campaigns',
        emptyMessage: 'No campaigns',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Mailing Campaigns"
      });
      var IDs = Vue.reactive([]);
      var itemsProcessed = 0;
      tableConfig.searching = true;
      var loaded = false;
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!masscampaigns.list.length) return;
        if (formFeatures.shownToggleRunning) return;
        if (loaded) return;
        masscampaigns.list.forEach(function (masslist) {
          var id = masslist.id;
          masscampaigns.add(masslist);
          IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == masscampaigns.list.length) {
            tableConfig.searching = false;
            loaded = true;
          }
        });
      });
      
      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { id } });
      })

      formFeatures.Save = function () {
        formFeatures.details.events.forEach(function (event) {
          delete event.mailboxes;
        });
        iservice.API('webapp-api-admin?api=masscampaigns&mode=modify', null, { masscampaignID: selectedID.value, details: formFeatures.details }).then(function (result) {
          masscampaigns.add(result.row);
          iservice.SuccessMessage('Mailing Campaign updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }

      function ShownSave(masscampaign) {
        masscampaign.shownRunning = true;
        iservice.API('webapp-api-admin?api=masscampaigndetails', null, { masscampaignID: masscampaign.id }).then(function (result) {
          result.details.shown = masscampaign.shown;
          return iservice.API('webapp-api-admin?api=masscampaigns&mode=modify', null, { masscampaignID: masscampaign.id, details: result.details }).then(function (result) {
            iservice.SuccessMessage('Campaign saved.');
            formFeatures.details.shown = masscampaign.shown;
          }).catch(function (errors) {

          }).finally(function () {
            masscampaign.shownRunning = false;
          });
        }).catch(function (errors) {
        }).finally(function () {
          masscampaign.shownRunning = false;
        });

      }
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.id) {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=masscampaigndetails', null, { masscampaignID: router.currentRoute.value.params.id }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.id;
            formFeatures.ChangeState('details');
            formFeatures.details = result.details;
            /*
            return API('webapp-api-admin?api=masslists&mode=modify', idPrefix, 'MasslistModify', { masscampaignID: masslist.id, details: result.details }).catch(function (errors) {
              if (errors && errors.length) errors[0].msg = 'Error modifying mailing list. ' + errors[0].msg;
              return $q.reject(errors);
            });*/
          }).then(function (result) {
           /* $scope.messages.toggleSuccess = 'Mailing List updated.'
            if (masslist.details) masslist.details.shown = masslist.shown;*/
          }).catch(function (errors) {
            //$scope.messages.toggleErrors = errors;
          }).finally(function () {
            formFeatures.loading = false;
           // masslist.shownRunning = false;
          });
        }
      });
      formFeatures.error = {};
      formFeatures.Create = function () {
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;
        if (!formFeatures.details.name) {
          formFeatures.errors.push({ msg: 'Please enter campaign name.', details: { description: '' } });
          formFeatures.error.name = true;
        }
        if (!formFeatures.details.segmentIDs.length) {
          formFeatures.errors.push({ msg: 'Please select atleast one segment.', details: { description: '' } });
          formFeatures.error.segment = true;
        }
        if (formFeatures.errors.length) return;
        iservice.API('webapp-api-admin?api=masscampaigns&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          masscampaigns.add(result.row);
          IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Mailing Campaign added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        iservice.API('webapp-api-admin?api=masscampaigns&mode=delete', null, { masscampaignID: selectedID.value }).then(function (result) {

          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = IDs.indexOf(selectedID.value);
          if (index > -1) {
            IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { id } })
          iservice.SuccessMessage('Mailing Campaign deleted successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          
        });
      }
      formFeatures.NewEvent = function (details) {
        details.addEvent = true;
        details.newEvent = { dayOffset: 0 };
      }
      formFeatures.EditEvent = function (event) {
        event.editing = true;
        event.original = { dayOffset: event.dayOffset, messageID: event.messageID, mailboxID: event.mailboxID };
      }
      formFeatures.CancelCreateEvent = function (details) {
        details.addEvent = false;
      }
      formFeatures.SaveEvent = function (event) {
        event.editing = false;
        formFeatures.Save();
      }
      formFeatures.CancelSaveEvent = function (event) {
        event.editing = false;
        $.extend(event, event.original);
      }
      formFeatures.CreateEvent = function (details) {
        details.events.push(details.newEvent);
        details.addEvent = false;
      }
      formFeatures.DeleteEvent = function (details, event) {
        details.events = details.events.filter(function (item) {
          return item !== event;
        });
      }
      return { formFeatures, ListCollapsed, segments, tableConfig, IDs, Select, selectedIDs, selectedID, featureTabs, massmessages, mailboxes, ShownSave };
    }
  };
  iservice.components.adminMassMessages = {
    name: 'vueapp-admin-massmessages',
    template: '#vueapp-admin-massmessages',
    route() { return { path: iservice.formPath + '/admin/mailing-messages/:id?', priority: 300, meta: { title: "iService | Mailing Messages" } } },
    setup(props) {

      var ListCollapsed = Vue.reactive({ isListCollapsed: true })
      ListCollapsed.Toggle = function () {
        return ListCollapsed.isListCollapsed = !ListCollapsed.isListCollapsed;
      }

      var router = VueRouter.useRouter();
      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });

      formFeatures.details = {
        name: '',
        description: '',
        subject: '',
        topicID: '',
        addRefNum: false,
        body: '',
        bodyHtml: ''
      }
      var selectedID = Vue.ref(null);
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      formFeatures.ChangeState = function (state = 'new', details = '') {
        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;
        
        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            name: '',
            description: '',
            subject: '',
            topicID: '',
            addRefNum: false,
            body: '',
            bodyHtml: ''
          }
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.Mailings');
      var segments = iservice.SegmentData();
      var massmessages = iservice.MassMessagesData();
      var topics = iservice.TopicData();

      if (!segments.loaded) {
        segments.Load();
      }
      if (!topics.loaded) {
        topics.Load();
      }
      if (!massmessages.loaded) {
        massmessages.Load();
      }
      formFeatures.massmessage = massmessages.list;

      var topicGroups = Vue.computed(() => {
        var groups = [];
        if (!segments.loaded || !topics.loaded) {
          segments.Load(); topics.Load();
        }
        segments.list.forEach(segment => {
          var group = Vue.reactive({ label: segment.name, options: [] });
          topics.inSegment(segment.id).forEach(topic => {
            group.options.push({ name: topic.name, value: topic.id, level: Math.min(2, topic.depth) });
          });
          group.options.sort((l, r) => { return topics.TreeSortCompare(l.value, r.value); });
          if (group.options.length < 1) return;
          groups.push(group);
        });
        return groups;
      });

      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(massmessages, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            filterText: iservice.tables.SimpleFilterTextFunc(massmessages, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Description', label: 'Description',
            filterText: iservice.tables.SimpleFilterTextFunc(massmessages, 'description'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Topic', label: 'Topic',
            filterText: iservice.tables.SimpleFilterTextFunc(massmessages, 'topicID'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-topic-with-segment', shown: true
          }),
          Vue.reactive({
            name: 'Subject Line', label: 'Subject Line',
            filterText: iservice.tables.SimpleFilterTextFunc(massmessages, 'subject'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Include Ref', label: 'Include Ref',
            Save: ShownSave,
            filterText: iservice.tables.SimpleFilterTextFunc(massmessages, 'addRefNum'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-massmessages-toggle', shown: true
          }),
          Vue.reactive({
            name: 'Last Mailing', label: 'Last Mailing', sortIncreasing: false,
            filterText: iservice.tables.DateFilterTextFunc(massmessages, 'lastMail'), sortText: iservice.tables.DateSortTextFunc(massmessages, 'lastMail'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Mailing Messages',
        emptyMessage: 'No messages',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Mailing Messages"
      });
      var IDs = Vue.reactive([]);
      var itemsProcessed = 0;
      tableConfig.searching = true;
      var loaded = false;
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!massmessages.list.length) return;
        if (formFeatures.shownToggleRunning) return;
        if (loaded) return;
        massmessages.list.forEach(function (massmessage) {
          var id = massmessage.id;
          massmessages.add(massmessage);
          IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == massmessages.list.length) {
            tableConfig.searching = false;
            loaded = true;
          }
        });
      });
      
      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { id } });
      })

      formFeatures.Save = function () {
        iservice.API('webapp-api-admin?api=massmessages&mode=modify', null, { massmessageID: selectedID.value, details: formFeatures.details }).then(function (result) {
          massmessages.add(result.row);
          iservice.SuccessMessage('Mailing Message updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      function ShownSave(massmessage) {
        massmessage.shownRunning = true;
        iservice.API('webapp-api-admin?api=massmessagedetails', null, { massmessageID: massmessage.id }).then(function (result) {
          result.details.addRefNum = massmessage.addRefNum;
          return iservice.API('webapp-api-admin?api=massmessages&mode=modify', null, { massmessageID: massmessage.id, details: result.details }).then(function (result) {
            iservice.SuccessMessage('Mass message saved.');
            formFeatures.details.addRefNum = massmessage.addRefNum;
          }).catch(function (errors) {

          }).finally(function () {
            massmessage.shownRunning = false;
          });
        }).catch(function (errors) {
        }).finally(function () {
          massmessage.shownRunning = false;
        });

      }
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (formFeatures.ShowNew) return;
        if (router.currentRoute.value.params.id) {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=massmessagedetails', null, { massmessageID: router.currentRoute.value.params.id }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.id;
            formFeatures.ChangeState('details');
            formFeatures.details = result.details;
            /*
            return API('webapp-api-admin?api=masslists&mode=modify', idPrefix, 'MasslistModify', { masscampaignID: masslist.id, details: result.details }).catch(function (errors) {
              if (errors && errors.length) errors[0].msg = 'Error modifying mailing list. ' + errors[0].msg;
              return $q.reject(errors);
            });*/
          }).then(function (result) {
           /* $scope.messages.toggleSuccess = 'Mailing List updated.'
            if (masslist.details) masslist.details.shown = masslist.shown;*/
          }).catch(function (errors) {
            //$scope.messages.toggleErrors = errors;
          }).finally(function () {
            formFeatures.loading = false;
           // masslist.shownRunning = false;
          });
        }
      });
      formFeatures.error = {};
      formFeatures.Create = function () {
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;
        if (!formFeatures.details.name) {
          formFeatures.errors.push({ msg: 'Please enter message name.', details: { description: '' } });
          formFeatures.error.name = true;
        }
        if (!formFeatures.details.subject) {
          formFeatures.errors.push({ msg: 'Please enter message subject.', details: { description: '' } });
          formFeatures.error.subject = true;
        }
        if (!formFeatures.details.topicID) {
          formFeatures.errors.push({ msg: 'Please select topic.', details: { description: '' } });
          formFeatures.error.topicID = true;
        }
        if (!formFeatures.details.body) {
          formFeatures.errors.push({ msg: 'Please enter plain body.', details: { description: '' } });
          formFeatures.error.body = true;
        }
        if (!formFeatures.details.bodyHtml) {
          formFeatures.errors.push({ msg: 'Please enter body Html.', details: { description: '' } });
          formFeatures.error.bodyHtml = true;
        }
        if (formFeatures.errors.length) return;
        iservice.API('webapp-api-admin?api=massmessages&mode=new', null, { details: formFeatures.details }).then(function (result) {
          //add new row to the list.
          massmessages.add(result.row);
          IDs.push(result.row.id);
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Mailing message added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        iservice.API('webapp-api-admin?api=massmessages&mode=delete', null, { massmessageID: selectedID.value }).then(function (result) {

          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          const index = IDs.indexOf(selectedID.value);
          if (index > -1) {
            IDs.splice(index, 1);
          }
          selectedID.value = '';
          var id = '';
          router.push({ params: { id } })
          iservice.SuccessMessage('Mailing message deleted successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          
        });
      }
      var featureStockResponses = Vue.reactive({ filter: '', segmentID: '' });
     
      featureStockResponses.PasteVar = function (text) {
        var plainTextArea = $('#BodyPlain');
        if (!plainTextArea) return;
        plainTextArea.focus();
        plainTextArea.replaceSelectedText(text, "collapseToEnd");
      }
      featureStockResponses.PasteStock = function (html) {
        var plainTextArea = $('#BodyPlain');
        if (!plainTextArea) return;
        plainTextArea.focus();
        plainTextArea.replaceSelectedText(html, "collapseToEnd");
      }

      var editor = Vue.ref(null);
      var featureStockResponses2 = Vue.reactive({ filter: '', segmentID: '' });
    
      featureStockResponses2.PasteVar = function (text) {
        if (!editor || !editor.value) return;
        editor.value.PasteText(text);
      }
      featureStockResponses2.PasteStock = function (html) {
        if (!editor || !editor.value) return;
        editor.value.PasteHtml(html);
      }
      Vue.watchEffect(function () {
        if (!formFeatures.details.topicID) return;
        if (!topics.list.length) return;
        var topic = topics.get(formFeatures.details.topicID);
        featureStockResponses.segmentID = topic.segmentID;
        featureStockResponses2.segmentID = topic.segmentID;
      })

      return { formFeatures, ListCollapsed, tableConfig, IDs, Select, selectedIDs, selectedID, topicGroups, featureStockResponses, featureStockResponses2, editor, ShownSave  };
    }
  };
  iservice.components.adminMailingCriteria = {
    name: 'vueapp-admin-mailingcriteria',
    template: '#vueapp-admin-mailingcriteria',
    route() { return { path: iservice.formPath + '/admin/mailing-criteria/:id?', priority: 300, meta: { title: "iService | Mailing Criteria" } } },
    setup(props) {

      var ListCollapsed = Vue.reactive({ isListCollapsed: true })
      ListCollapsed.Toggle = function () {
        return ListCollapsed.isListCollapsed = !ListCollapsed.isListCollapsed;
      }

      var router = VueRouter.useRouter();
      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [] });

      formFeatures.details = {
        name: '',
        description: '',
        segmentIDs: [],
        fields:[]
      }
      var fieldGroups = Vue.reactive({});
      var searchLists = Vue.reactive({ currentSearch: {} });
      searchLists.showWhereList = function (field) {
        return true;
      }
      searchLists.splitGroup = function (group, field) {
        fieldGroups.groups = [];
        for (var i = 0, len = formFeatures.details.fields.length; i < len; i++) {
          var cur = formFeatures.details.fields[i];

          if (cur !== group)
            fieldGroups.groups.push(cur);
          else {
            var partial = Vue.reactive([]);

            fieldGroups.groups.push(partial);

            for (var f = 0; f < group.length; f++) {
              partial.push(group[f]);

              if (group[f] === field) {
                partial = [];
                fieldGroups.groups.push(partial);
              }
            }
          }
        }
        formFeatures.details.fields = fieldGroups.groups;
      }
      searchLists.addGroup = function () {
        formFeatures.details.fields.push([{ where: 'anywhere', fieldID: 'all', searchString: '' }]);
      }
      searchLists.removeField = function (field) {
        fieldGroups.groups = [];

        for (var g = 0; g < formFeatures.details.fields.length; g++) {
          var group = null;

          for (var f = 0, len = formFeatures.details.fields[g].length; f < len; f++) {
            var cur = formFeatures.details.fields[g][f];

            if (cur !== field) {
              if (!group)
                group = [];

              group.push(cur);
            }
          }

          if (group)
            fieldGroups.groups.push(group);
        }
        formFeatures.details.fields = fieldGroups.groups;
      }
      searchLists.mergeGroup = function (group) {
        fieldGroups.groups = [];

        for (var i = 0, len = formFeatures.details.fields.length; i < len; i++) {
          var cur = formFeatures.details.fields[i];

          fieldGroups.groups.push(cur);

          if (cur === group) {
            var next = formFeatures.details.fields[i + 1];
            for (var f = 0; f < next.length; f++)
              cur.push(next[f]);

            i++;
          }
        }
        formFeatures.details.fields = fieldGroups.groups;
      }
      var selectedID = Vue.ref(null);
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      formFeatures.ChangeState = function (state = 'new', details = '') {

        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;
        
        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            name: '',
            description: '',
            segmentIDs: [],
            fields: []
          }
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.Mailings');
      var segments = iservice.SegmentData();
      var masscriterias = iservice.MassCriteriaData();

      if (!segments.loaded) {
        segments.Load();
      }
      if (!masscriterias.loaded) {
        masscriterias.Load();
      }
      Vue.watchEffect(function () {
        if (!segments.list.length) return;
        formFeatures.segmentOptions = segments.list.filter(function (segment) {
          return !segment.hidden;
        })
      })

      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(masscriterias, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            filterText: iservice.tables.SimpleFilterTextFunc(masscriterias, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Description', label: 'Description',
            filterText: iservice.tables.SimpleFilterTextFunc(masscriterias, 'description'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Segments', label: 'Segments',
            filterText: iservice.tables.SimpleFilterTextFunc(masscriterias, 'segments'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Mailing Criteria',
        emptyMessage: 'No Mailing Criterias',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Mailing Criteria"
      });
      var IDs = Vue.reactive([]);
      var itemsProcessed = 0;
      tableConfig.searching = true;
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!masscriterias.list.length) return;
        if (!tableConfig.searching) return;
        if (formFeatures.shownToggleRunning) return;
        masscriterias.list.forEach(function (masslist) {
          var id = masslist.id;
          masscriterias.add(masslist);
          IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed == masscriterias.list.length) tableConfig.searching = false;
        });

      });
      
      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { id } });
      });

      formFeatures.Save = function () {
        var params = collectParameters()
        var details = {
          "name": formFeatures.details.name,
          "description": formFeatures.details.description,
          "segmentIDs": formFeatures.details.segmentIDs,
          "fields": params
        }
        iservice.API('webapp-api-admin?api=masscriterias&mode=modify', null, { masscriteriaID: selectedID.value, details: details }).then(function (result) {
          masscriterias.add(result.row);
          iservice.SuccessMessage('Criteria updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (router.currentRoute.value.params.id === '0') {
          formFeatures.fromMassMailing = true;
          formFeatures.ChangeState('new');
          return;
        }
        if (router.currentRoute.value.params.id) {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=masscriteriadetails', null, { masscriteriaID: router.currentRoute.value.params.id }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.id
            formFeatures.ChangeState('details');
            var fields = [];
            formFeatures.details = result.details;
            result.details.fields.forEach(function (item) {
              fields.push(item.fields);
            })
            formFeatures.details.fields = fields;
          }).then(function (result) {
          }).catch(function (errors) {
          }).finally(function () {
            formFeatures.loading = false;
          });
        }
      });
      formFeatures.error = {}
      formFeatures.Create = function () {
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;
        var params = collectParameters()
        var details = {
          "name": formFeatures.details.name,
          "description": formFeatures.details.description,
          "segmentIDs": formFeatures.details.segmentIDs,
          "fields": params
        }
        if (!formFeatures.details.name) {
          formFeatures.errors.push({ msg: 'Please enter criteria name.', details: { description: '' } });
          formFeatures.error.name = true;
        }
        if (!formFeatures.details.segmentIDs.length) {
          formFeatures.errors.push({ msg: 'Please select atleast one segment.', details: { description: '' } });
          formFeatures.error.segment = true;
        }
        if (formFeatures.errors.length) return;
        iservice.API('webapp-api-admin?api=masscriterias&mode=new', null, { details: details }).then(function (result) {
          if (formFeatures.fromMassMailing) localStorage.masscriterias = JSON.stringify(result.row);
          iservice.data.masscriteria.add(result.row)
          IDs.push(result.row.id)
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Criteria added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        iservice.API('webapp-api-admin?api=masscriterias&mode=delete', null, { masscriteriaID: selectedID.value }).then(function (result) {

          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          var index = IDs.indexOf(selectedID.value);
          if (index == -1) return;
          IDs.splice(index, 1);
          selectedID.value = '';
          var id = '';
          router.push({ params: { id } })
          iservice.SuccessMessage('Criteria deleted successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        })
      }
      function collectParameters() {
        var collectData = [];
        for (var g = 0, numGroup = formFeatures.details.fields.length; g < numGroup; g++) {
          var group = Vue.reactive({
            fields: []
          });
          collectData.push(group)
          //params.push(group);

          for (var f = 0, numField = formFeatures.details.fields[g].length; f < numField; f++) {
            var field = formFeatures.details.fields[g][f];

            group.fields.push({
              where: field.where,
              fieldID: field.fieldID,
              searchString: field.searchString
            });
          }
        }
        return collectData;
      }

      return { formFeatures, ListCollapsed, segments, tableConfig, IDs, Select, selectedIDs, selectedID, searchLists, fieldGroups };
    }
  };
  iservice.components.adminMailings = {
    name: 'vueapp-admin-mailings',
    template: '#vueapp-admin-mailings',
    route() { return { path: iservice.formPath + '/admin/mailings/:id?', priority: 300 } },
    setup(props) {

      var ListCollapsed = Vue.reactive({ isListCollapsed: true })
      ListCollapsed.Toggle = function () {
        return ListCollapsed.isListCollapsed = !ListCollapsed.isListCollapsed;
      }
     
      var segments = iservice.SegmentData();
      var massmailings = iservice.MassMailingsData();
      var masslists = iservice.MasslistData();
      var massmessages = iservice.MassMessagesData();
      var topics = iservice.TopicData();
      if (!topics.loaded) topics.Load();
      var masscriterias = iservice.MassCriteriaData();
      if (!masscriterias.loaded) masscriterias.Load();
      var mailboxes = iservice.MailboxData();

      var mailList = Vue.ref(null);
      var message = Vue.ref(null);
      var mailbox = Vue.ref(null);
      
      if (!mailboxes.loaded) mailboxes.Load();
      if (!masslists.loaded) masslists.Load();
      if (!massmessages.loaded) massmessages.Load();

      if (!segments.loaded) segments.Load();
      
      if (!massmailings.loaded) massmailings.Load();
      
      var router = VueRouter.useRouter();
      var formFeatures = Vue.reactive({ errors: [], success: '', ChangeState: Function, ShowNew: false, ShowDelete: false, ShowDetails: false, ShowDeleteButton: false, Create: Function, Delete: Function, CancelDelete: Function, Save: Function, shownToggleRunning: false, createnew: false, deleteStart: false, segmentOptions: [], mailboxes: [], massmessages: [], masslists: [], masscriterias: [], topicName: '', sendMailingRight: '' });
      formFeatures.createCriteriaLink = Vue.computed(() => { return iservice.formPath + '/admin/masscriteria/0' });
      var formSend = Vue.reactive({ SendConfirm: Function, SendCheck: Function });
      formFeatures.sendMailingRight = iservice.HaveRight('Tab.Mailings.Mailings.Send');

      formFeatures.onStorageUpdate = function (event) {
        if (event.key === "masscriterias") {
          try {
            let obj = JSON.parse(event.newValue);
            if (obj) masscriterias.add(obj);
          } catch (ex) {
            console.log(ex);
          }
        }
      }
      window.addEventListener("storage", formFeatures.onStorageUpdate);
      Vue.onUnmounted(() => {
        window.removeEventListener("storage", formFeatures.onStorageUpdate);
      });
      Vue.watchEffect(function () {
        if (!masslists.list.length) return;
        if (!massmessages.list.length) return;
        if (!masscriterias.list.length) return;
        if (!mailboxes.list.length) return;
        formFeatures.masslists = masslists.list;
        formFeatures.massmessages = massmessages.list;
        formFeatures.masscriterias = masscriterias.list;
        
        formFeatures.masslists.sort((l, r) => { return masslists.SortCompare(l.id, r.id); });
        formFeatures.massmessages.sort((l, r) => { return massmessages.SortCompare(l.id, r.id); });
        formFeatures.masscriterias.sort((l, r) => { return masscriterias.SortCompare(l.id, r.id); });
      })
      formFeatures.details = {
        name: '',
        description: ''
      }
     
      var selectedID = Vue.ref(null);
      function Select(id) {
        selectedID.value = id;
        formFeatures.ShowNew = false;
        router.push({ params: { id } }); //update route paramater on selecting table row 
      }
      var selectedIDs = Vue.computed(() => {
        if (selectedID.value) return [selectedID.value];
        return [];
      });

      formFeatures.ChangeState = function (state = 'new', details = '') {

        formFeatures.ShowNew = state == 'new' ? true : false;
        formFeatures.ShowDelete = state == 'delete' ? true : false;
        
        formFeatures.ShowDetails = state == 'details' ? true : false;
        if (state == 'details') {
          if (details) {
            var id = details.id;
            selectedID.value = id;
            router.push({ params: { id } });
          }
        }
        if (state == 'new') {
          formFeatures.details = {
            name: '',
            description: ''
          }
        }
        if (state == 'cancel') {
          formFeatures.ShowDeleteButton = false;
        }
      }
      formFeatures.haveRight = iservice.HaveRight('Tab.Admin.Mailings');
      
      Vue.watchEffect(function () {
        if (!segments.list.length) return;
        formFeatures.segmentOptions = segments.list.filter(function (segment) {
          return !segment.hidden;
        })
      })

      formFeatures.mailboxes = Vue.computed(() => {
        let list = [];
        if (!mailboxes.loaded || !segments.loaded) {
          mailboxes.Load(); segments.Load(); return list;
        }
        if (mailboxes.list.length) {
          segments.list.forEach(seg => {
            if (formFeatures.details.topicID) {
              let topic = topics.get(formFeatures.details.topicID);
              if (!topic) return;
              if (seg.id != topic.segmentID) return;
            }
            var group = { id: seg.id, label: seg.name, options: [] };
            mailboxes.inSegment(seg.id).forEach(mailbox => {
              var option = {
                value: mailbox.id,
                name: mailbox.name,
                email: mailbox.replyTo
              };
              group.options.push(option);
            });
            if (group.options.length < 1) return list;
            group.options.sort((l, r) => { return mailboxes.SortCompare(l.value, r.value); });
            list.push(group);
          });
        }
        return list;
      });

      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(massmailings, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            filterText: iservice.tables.SimpleFilterTextFunc(massmailings, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Description', label: 'Description',
            filterText: iservice.tables.SimpleFilterTextFunc(massmailings, 'description'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Topic', label: 'Topic',
            filterText: iservice.tables.SimpleFilterTextFunc(massmailings, 'topicID'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-topic', shown: true
          }),
          Vue.reactive({
            name: 'List', label: 'List',
            filterText: iservice.tables.SimpleFilterTextFunc(massmailings, 'listID'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-masslist', shown: true
          }),
          Vue.reactive({
            name: 'Message', label: 'Message',
            filterText: iservice.tables.SimpleFilterTextFunc(massmailings, 'messageID'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-massmessage', shown: true
          }),
          Vue.reactive({
            name: 'Mailbox', label: 'Mailbox',
            filterText: iservice.tables.SimpleFilterTextFunc(massmailings, 'mailboxID'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-mailbox', shown: true
          }),
          Vue.reactive({
            name: 'Last Mailing', label: 'Last Mailing', sortIncreasing: false,
            filterText: iservice.tables.DateFilterTextFunc(massmailings, 'lastMail'), sortText: iservice.tables.DateSortTextFunc(massmailings, 'lastMail'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Mailings',
        emptyMessage: 'No Mailings',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Last Mailing',
        columns: tableColumns.value,
        exportName: "Mass Mailings"
      });
      var IDs = Vue.reactive([]);

      tableConfig.searching = true;
      var itemsProcessed = 0;
      Vue.watchEffect(function () {
        if (formFeatures.createnew) return;
        if (!massmailings.list.length) return;
        if (!tableConfig.searching) return;
        if (formFeatures.shownToggleRunning) return;
        
        massmailings.list.forEach(function (massmailing) {
          var id = massmailing.id;
          massmailings.add(massmailing);
          IDs.push(id);
          itemsProcessed++;
          if (itemsProcessed === massmailings.list.length) {
            tableConfig.searching = false;
          }
        });

      });
      
      Vue.watchEffect(function () {
        if (!formFeatures.ShowNew) return;
        var id = '';
        selectedID.value = '';
        router.push({ params: { id } });
      });

      formFeatures.Save = function () {
        formFeatures.hasRequiredErrors = false;
        if (!formFeatures.details.mailboxID) {
          formFeatures.hasRequiredErrors = true;
          mailbox.value.handleFocus();
        }
        if (!formFeatures.details.messageID) {
          formFeatures.hasRequiredErrors = true;
          message.value.handleFocus();
        }
        if (!formFeatures.details.listID) {
          formFeatures.hasRequiredErrors = true;
          mailList.value.handleFocus();
        }
        if (formFeatures.hasRequiredErrors) return;
        var details = {
          "name": formFeatures.details.name,
          "description": formFeatures.details.description,
          "listID": formFeatures.details.listID,
          "mailboxID": formFeatures.details.mailboxID,
          "messageID": formFeatures.details.messageID,
          "topicID": formFeatures.details.topicID
        }
        iservice.API('webapp-api-admin?api=massmailings&mode=modify', null, { massmailingID: selectedID.value, details: details }).then(function (result) {
          massmailings.add(result.row);
          iservice.SuccessMessage('Mailing updated successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      //check route params change effect and load details
      Vue.watchEffect(() => {
        if (!topics.list.length) return;
        if (router.currentRoute.value.params.id) {
          formFeatures.ShowDeleteButton = true;
          formFeatures.loading = true;
          iservice.API('webapp-api-admin?api=massmailingdetails', null, { massmailingID: router.currentRoute.value.params.id }).then(function (result) {
            selectedID.value = router.currentRoute.value.params.id
            formFeatures.ChangeState('details');
            formFeatures.details = result.details;
            var topic = topics.get(result.details.topicID);
            formFeatures.topicName =  "(" + topic.segmentName + ") " + topic.name
          }).then(function (result) {
          }).catch(function (errors) {
          }).finally(function () {
            formFeatures.loading = false;
          });
        }
      });
      formFeatures.error = {};
      formFeatures.Create = function () {
        formFeatures.errors = [];
        formFeatures.deleteStart = false;
        formFeatures.createnew = true;
        var details = {
          "name": formFeatures.details.name,
          "description": formFeatures.details.description,
          "listID": formFeatures.details.listID,
          "mailboxID": formFeatures.details.mailboxID,
          "messageID": formFeatures.details.messageID,
          "topicID": formFeatures.details.topicID
        }
        if (!formFeatures.details.name) {
          formFeatures.errors.push({ msg: 'Please enter mailing name.', details: { description: '' } });
          formFeatures.error.name = true;
        }
        if (formFeatures.errors.length) return;
        iservice.API('webapp-api-admin?api=massmailings&mode=new', null, { details: details }).then(function (result) {

          iservice.data.massmailings.add(result.row)
          IDs.push(result.row.id)
          formFeatures.ChangeState('details', result.row);
          iservice.SuccessMessage('Mailing added successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        });
      }
      formFeatures.Delete = function () {
        formFeatures.deleteStart = true;
        iservice.API('webapp-api-admin?api=massmailings&mode=delete', null, { massmailingID: selectedID.value }).then(function (result) {

          formFeatures.ChangeState('cancel');
          formFeatures.ShowDeleteButton = false;
          var index = IDs.indexOf(selectedID.value);
          if (index == -1) return;
          IDs.splice(index, 1);
          selectedID.value = '';
          var id = '';
          router.push({ params: { id } })
          iservice.SuccessMessage('Mailing deleted successfully.');
        }).catch(function (errors) {
          formFeatures.errors = errors;
        })
      }
      function Reset() {
        formSend.send = {
          mailingID: router.currentRoute.value.params.id,
          criteriaID: '',
          checkCount: '',
          running: false
        }
      }
      Reset();
      formSend.SendCheck = function () {
        formSend.running = true;
        formSend.send.checkCount = '';
        formSend.send.mailingID = router.currentRoute.value.params.id;
        iservice.API('webapp-api-mailing?api=send&mode=check', null, { details: formSend.send }).then(function (result) {
          formSend.send.checkCount = result.count;
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formSend.running = false;
        });
      }
      formSend.SendConfirm = function () {
        formSend.running = true;
        formSend.send.checkCount = '';
        formSend.send.mailingID = router.currentRoute.value.params.id;
        iservice.API('webapp-api-mailing?api=send&mode=send', null, { details: formSend.send }).then(function (result) {
          iservice.SuccessMessage('Mailing sent to ' + result.count + ' contact' + (result.count == '1' ? '' : 's') + '.');
          Reset();
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {
          formSend.running = false;
        });
      }
      
      return { formFeatures, ListCollapsed, segments, tableConfig, IDs, Select, selectedIDs, selectedID, massmailings, masslists, topics, mailboxes, masscriterias, formSend, massmessages, mailList, message, mailbox };
    }
  };

  iservice.components.adminCampaignSubscribers = {
    name: 'campaign-subscribers',
    template: '#campaign-subscribers',
    props: ['load', 'itemid'],
    setup(props) {
      var featureLoad = Vue.reactive({ loaded: false, working: false });
      Vue.watchEffect(() => {
        if (!props.load || featureLoad.loaded || featureLoad.working) return;
        featureLoad.working = true;
      });
      var contacts = iservice.ContactsData();

      var formFeatures = Vue.reactive({ errors: [], success: '', tab: '', mode: '', StartAdd: Function, StartRemove: Function, StopModify: Function, ContactSearchClick: Function, SubscribeSelectedClick: Function, SubscribeAllClick: Function, IDs: [], numContacts: '', searchGroups: [], currentIDs: [], searchIDs: [], selectedIDs: [], checkbox: false, searching: false, showsearch: false });
      formFeatures.showMoreToggle = function () {
        formFeatures.showmore = !formFeatures.showmore;
      }
      formFeatures.mode = 'show';
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contact-name-linked', shown: true
          }),
          Vue.reactive({
            name: 'Email', label: 'Email',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'email'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contact-email-linked', shown: true
          }),
          Vue.reactive({
            name: 'Company', label: 'Company',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'company'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Phone', label: 'Phone',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'phone'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];
        return columns;
      });
      var tableColumnsSearch = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'checkbox', hidable: false,
            filterText: function () { },
            componentHead: 'iservice-table-head-select-all', componentCell: 'iservice-table-cell-select', shown: true
          }),
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contact-name-linked', shown: true
          }),
          Vue.reactive({
            name: 'Email', label: 'Email',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'email'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contact-email-linked', shown: true
          }),
          Vue.reactive({
            name: 'Company', label: 'Company',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'company'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Phone', label: 'Phone',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'phone'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];
        return columns;
      });

      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Contacts',
        emptyMessage: 'No matching results',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Mailing Subscribers"
      });
      var tableConfigSearch = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Contacts',
        emptyMessage: 'No matching results',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumnsSearch.value,
        checkAllMode: 'visible'
      });
      var fieldGroups = Vue.reactive({});
      fieldGroups.searchGroups = [[{
        where: 'anywhere',
        field: 'all',
        text: ''
      }]];
      var searchLists = Vue.reactive({ currentSearch: {} });
      searchLists.showWhereList = function (field) {
        return true;
      }
      searchLists.splitGroup = function (group, field) {
        fieldGroups.groups = [];
        for (var i = 0, len = fieldGroups.searchGroups.length; i < len; i++) {
          var cur = fieldGroups.searchGroups[i];

          if (cur !== group)
            fieldGroups.groups.push(cur);
          else {
            var partial = Vue.reactive([]);

            fieldGroups.groups.push(partial);

            for (var f = 0; f < group.length; f++) {
              partial.push(group[f]);

              if (group[f] === field) {
                partial = [];
                fieldGroups.groups.push(partial);
              }
            }
          }
        }
        fieldGroups.searchGroups = fieldGroups.groups;
      }
      searchLists.addGroup = function () {
        fieldGroups.searchGroups.push([{ where: 'anywhere', field: 'all', text: '' }]);
      }
      searchLists.removeField = function (field) {
        fieldGroups.groups = [];

        for (var g = 0; g < fieldGroups.searchGroups.length; g++) {
          var group = null;

          for (var f = 0, len = fieldGroups.searchGroups[g].length; f < len; f++) {
            var cur = fieldGroups.searchGroups[g][f];

            if (cur !== field) {
              if (!group)
                group = [];

              group.push(cur);
            }
          }

          if (group)
            fieldGroups.groups.push(group);
        }
        fieldGroups.searchGroups = fieldGroups.groups;
      }
      searchLists.mergeGroup = function (group) {
        fieldGroups.groups = [];

        for (var i = 0, len = fieldGroups.searchGroups.length; i < len; i++) {
          var cur = fieldGroups.searchGroups[i];

          fieldGroups.groups.push(cur);

          if (cur === group) {
            var next = fieldGroups.searchGroups[i + 1];
            for (var f = 0; f < next.length; f++)
              cur.push(next[f]);

            i++;
          }
        }
        fieldGroups.searchGroups = fieldGroups.groups;
      }

      Vue.watchEffect(() => {
        if (featureLoad.loaded || !featureLoad.working) return;
        formFeatures.mode = 'show';
        formFeatures.showsearch = false;
        formFeatures.IDs = [];
        tableConfig.searching = true;
        iservice.API('webapp-api-custinfo?api=search', null, {
          fields: {
            groups: [{
              fields: [{
                where: 'entire',
                fieldID: 'subscribed',
                searchString: 'campaign-' + props.itemid
              }]
            }]
          }
        }).then(function (data) {
          formFeatures.numContacts = data.resultCount;
          data.contacts.forEach(item => {
            var id = item.id;
            contacts.add(item);
            formFeatures.IDs.push(id);
          });

        }).catch(function (errors) {

        }).finally(function () {
          tableConfig.searching = false;
        });
      });

      formFeatures.StartAdd = function () {
        formFeatures.selectedIDs = [];
        formFeatures.mode = 'add';
        formFeatures.searchIDs = [];
        fieldGroups.searchGroups = [[{
          where: 'anywhere',
          field: 'all',
          text: ''
        }]];
      }
      formFeatures.StartRemove = function () {
        formFeatures.selectedIDs = [];
        formFeatures.mode = 'remove';
        formFeatures.searchIDs = [];
        fieldGroups.searchGroups = [[{
          where: 'anywhere',
          field: 'all',
          text: ''
        }]];
      }
      formFeatures.StopModify = function () {
        formFeatures.searchIDs = [];
        formFeatures.selectedIDs = [];
        formFeatures.mode = 'show';
        formFeatures.showsearch = false;
      }

      formFeatures.ContactSearchClick = function () {
        tableConfigSearch.searching = true;
        formFeatures.searching = true;
        formFeatures.searchIDs = [];
        tableConfig.searching = true;
        var search = Vue.reactive({ groups: [] });
        collectParameters(search);
        if (formFeatures.mode == 'add') search.groups.push({ fields: [{ where: 'entire', fieldID: 'subscribed-not', searchString: 'campaign-' + props.itemid }] });

        if (formFeatures.mode == 'remove') search.groups.push({ fields: [{ where: 'entire', fieldID: 'subscribed', searchString: 'campaign-' + props.itemid }] });

        iservice.API('webapp-api-custinfo?api=search', null, { fields: search }).then(function (data) {
          data.contacts.forEach(item => {
            var id = item.id;
            contacts.add(item);
            formFeatures.searchIDs.push(id);
          });
          formFeatures.showsearch = true;
        }).catch(function () {

        }).finally(function () {
          tableConfigSearch.searching = false;
          tableConfig.searching = false;
        });
      }
      function collectParameters(params) {
        for (var g = 0, numGroup = fieldGroups.searchGroups.length; g < numGroup; g++) {
          var group = Vue.reactive({
            fields: []
          });

          params.groups.push(group);

          for (var f = 0, numField = fieldGroups.searchGroups[g].length; f < numField; f++) {
            var field = fieldGroups.searchGroups[g][f];

            group.fields.push({
              where: field.where,
              fieldID: field.field,
              searchString: field.text
            });
          }
        }
      }
      function DoAdd(ids) {
        iservice.API('webapp-api-admin?api=masssubscriptions&mode=add', null, { contactIDs: ids, masscampaignID: props.itemid }).then(function (result) {
          iservice.SuccessMessage('Added contacts to the campaign.');
          formFeatures.StopModify();
          DoSearch();
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {

        });
      }
      formFeatures.SubscribeSelectedClick = function () {
        DoAdd(formFeatures.selectedIDs);
      }
      formFeatures.SubscribeAllClick = function () {
        DoAdd(formFeatures.searchIDs);
      }
      function DoRemove(ids) {
        iservice.API('webapp-api-admin?api=masssubscriptions&mode=remove', null, { contactIDs: ids, masscampaignID: props.itemid }).then(function (result) {
          iservice.SuccessMessage('Removed contacts from the Campaign.');
          formFeatures.StopModify();
          DoSearch();
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {

        });
      }
      formFeatures.RemoveSelectedClick = function () {
        DoRemove(formFeatures.selectedIDs);
      }
      formFeatures.RemoveAllClick = function () {
        DoRemove(formFeatures.searchIDs);
      }
      function Clear() {
        formFeatures.numContacts = null;
      }

      return { formFeatures, tableConfig, tableConfigSearch, featureLoad, fieldGroups, searchLists, Clear };
    }
  };
  iservice.components.adminMailingSubscribers = {
    name: 'mailing-subscribers',
    template: '#mailing-subscribers',
    props: ['load', 'itemid'],
    setup(props) {
      var featureLoad = Vue.reactive({ loaded: false, working: false });
      Vue.watchEffect(() => {
        if (!props.load || featureLoad.loaded || featureLoad.working) return;
        featureLoad.working = true;
      });
      var contacts = iservice.ContactsData();
      
      var formFeatures = Vue.reactive({ errors: [], success: '', tab: '', mode: '', StartAdd: Function, StartRemove: Function, StopModify: Function, ContactSearchClick: Function, SubscribeSelectedClick: Function, SubscribeAllClick: Function, IDs: [], numContacts: '', searchGroups: [], currentIDs: [], searchIDs: [], selectedIDs: [], checkbox: false, searching: false, showsearch: false });
      formFeatures.showMoreToggle = function () {
        formFeatures.showmore = !formFeatures.showmore;
      }
      formFeatures.mode = 'show';
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contact-name-linked', shown: true
          }),
          Vue.reactive({
            name: 'Email', label: 'Email',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'email'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contact-email-linked', shown: true
          }),
          Vue.reactive({
            name: 'Company', label: 'Company',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'company'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Phone', label: 'Phone',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'phone'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];
        return columns;
      });
      var tableColumnsSearch = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'checkbox', hidable: false,
            filterText: function () { },
            componentHead: 'iservice-table-head-select-all', componentCell: 'iservice-table-cell-select', shown: true
          }),
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contact-name-linked', shown: true
          }),
          Vue.reactive({
            name: 'Email', label: 'Email',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'email'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contact-email-linked', shown: true
          }),
          Vue.reactive({
            name: 'Company', label: 'Company',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'company'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Phone', label: 'Phone',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'phone'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];
        return columns;
      });

      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Contacts',
        emptyMessage: 'No matching results',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Mailing Subscribers"
      });
      var tableConfigSearch = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Contacts',
        emptyMessage: 'No matching results',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumnsSearch.value,
        checkAllMode: 'visible'
      });
      var fieldGroups = Vue.reactive({});
      fieldGroups.searchGroups = [[{
        where: 'anywhere',
        field: 'all',
        text: ''
      }]];
      var searchLists = Vue.reactive({ currentSearch: {} });
      searchLists.showWhereList = function (field) {
        return true;
      }
      searchLists.splitGroup = function (group, field) {
        fieldGroups.groups = [];
        for (var i = 0, len = fieldGroups.searchGroups.length; i < len; i++) {
          var cur = fieldGroups.searchGroups[i];

          if (cur !== group)
            fieldGroups.groups.push(cur);
          else {
            var partial = Vue.reactive([]);

            fieldGroups.groups.push(partial);

            for (var f = 0; f < group.length; f++) {
              partial.push(group[f]);

              if (group[f] === field) {
                partial = [];
                fieldGroups.groups.push(partial);
              }
            }
          }
        }
        fieldGroups.searchGroups = fieldGroups.groups;
      }
      searchLists.addGroup = function () {
        fieldGroups.searchGroups.push([{ where: 'anywhere', field: 'all', text: '' }]);
      }
      searchLists.removeField = function (field) {
        fieldGroups.groups = [];

        for (var g = 0; g < fieldGroups.searchGroups.length; g++) {
          var group = null;

          for (var f = 0, len = fieldGroups.searchGroups[g].length; f < len; f++) {
            var cur = fieldGroups.searchGroups[g][f];

            if (cur !== field) {
              if (!group)
                group = [];

              group.push(cur);
            }
          }

          if (group)
            fieldGroups.groups.push(group);
        }
        fieldGroups.searchGroups = fieldGroups.groups;
      }
      searchLists.mergeGroup = function (group) {
        fieldGroups.groups = [];

        for (var i = 0, len = fieldGroups.searchGroups.length; i < len; i++) {
          var cur = fieldGroups.searchGroups[i];

          fieldGroups.groups.push(cur);

          if (cur === group) {
            var next = fieldGroups.searchGroups[i + 1];
            for (var f = 0; f < next.length; f++)
              cur.push(next[f]);

            i++;
          }
        }
        fieldGroups.searchGroups = fieldGroups.groups;
      }

      
      Vue.watchEffect(() => {
        if (featureLoad.loaded || !featureLoad.working) return;
        formFeatures.mode = 'show';
        formFeatures.showsearch = false;
        formFeatures.IDs = [];
        tableConfig.searching = true;
        iservice.API('webapp-api-custinfo?api=search', null, {
          fields: {
            groups: [{
              fields: [{
                where: 'entire',
                fieldID: 'subscribed',
                searchString: props.itemid
              }]
            }]
          }
        }).then(function (data) {
          formFeatures.numContacts = data.resultCount;
          data.contacts.forEach(item => {
            var id = item.id;
            contacts.add(item);
            formFeatures.IDs.push(id);
          });

        }).catch(function (errors) {

        }).finally(function () {
          tableConfig.searching = false;
        });
      });
      
      formFeatures.StartAdd = function () {
        formFeatures.selectedIDs = [];
        formFeatures.mode = 'add';
        formFeatures.searchIDs = [];
        fieldGroups.searchGroups = [[{
          where: 'anywhere',
          field: 'all',
          text: ''
        }]];
      }
      formFeatures.StartRemove = function () {
        formFeatures.selectedIDs = [];
        formFeatures.mode = 'remove';
        formFeatures.searchIDs = [];
        fieldGroups.searchGroups = [[{
          where: 'anywhere',
          field: 'all',
          text: ''
        }]];
      }
      formFeatures.StopModify = function () {
        formFeatures.searchIDs = [];
        formFeatures.selectedIDs = [];
        formFeatures.mode = 'show';
        formFeatures.showsearch = false;
      }
      
      formFeatures.ContactSearchClick = function () {
        tableConfigSearch.searching = true;
        formFeatures.searching = true;
        formFeatures.searchIDs = [];
        tableConfig.searching = true;
        var search = Vue.reactive({ groups: [] });
        collectParameters(search);
        if (formFeatures.mode == 'add') search.groups.push({ fields: [{ where: 'entire', fieldID: 'subscribed-not', searchString: props.itemid }] });

        if (formFeatures.mode == 'remove') search.groups.push({ fields: [{ where: 'entire', fieldID: 'subscribed', searchString: props.itemid }] });

        iservice.API('webapp-api-custinfo?api=search', null, { fields: search }).then(function (data) {
          data.contacts.forEach(item => {
            var id = item.id;
            contacts.add(item);
            formFeatures.searchIDs.push(id);
          });
          formFeatures.showsearch = true;
        }).catch(function () {

        }).finally(function () {
          tableConfigSearch.searching = false;
          tableConfig.searching = false;
        });
      }
      function collectParameters(params) {
        for (var g = 0, numGroup = fieldGroups.searchGroups.length; g < numGroup; g++) {
          var group = Vue.reactive({
            fields: []
          });

          params.groups.push(group);

          for (var f = 0, numField = fieldGroups.searchGroups[g].length; f < numField; f++) {
            var field = fieldGroups.searchGroups[g][f];

            group.fields.push({
              where: field.where,
              fieldID: field.field,
              searchString: field.text
            });
          }
        }
      }
      function DoAdd(ids) {
        iservice.API('webapp-api-admin?api=masssubscriptions&mode=add', null, { contactIDs: ids, masslistID: props.itemid }).then(function (result) {
          iservice.SuccessMessage('Added contacts to the mailing list.');
          formFeatures.StopModify();
          DoSearch();
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {

        });
      }
      formFeatures.SubscribeSelectedClick = function () {
        DoAdd(formFeatures.selectedIDs);
      }
      formFeatures.SubscribeAllClick = function () {
        DoAdd(formFeatures.searchIDs);
      }
      function DoRemove(ids) {
        iservice.API('webapp-api-admin?api=masssubscriptions&mode=remove', 'MassUnsubscribe', { contactIDs: ids, masslistID: props.itemid }).then(function (result) {
          iservice.SuccessMessage('Removed contacts from the mailing list.');
          formFeatures.StopModify();
          DoSearch();
        }).catch(function (errors) {
          formFeatures.errors = errors;
        }).finally(function () {

        });
      }
      formFeatures.RemoveSelectedClick = function () {
        DoRemove(formFeatures.selectedIDs);
      }
      formFeatures.RemoveAllClick = function () {
        DoRemove(formFeatures.IDs);
      }
      function Clear() {
        formFeatures.numContacts = null;
      }
      
      return { formFeatures, tableConfig, tableConfigSearch, featureLoad, fieldGroups, searchLists, Clear };
    }
  };
  iservice.components.adminMailingUnsubscribers = {
    name: 'mailing-unsubscribers',
    template: '#mailing-unsubscribers',
    props: ['load', 'itemid'],
    setup(props) {
      var featureLoad = Vue.reactive({ loaded: false, working: false });
      Vue.watchEffect(() => {
        if (!props.load || featureLoad.loaded || featureLoad.working) return;
        featureLoad.working = true;
      });
      var contacts = iservice.ContactsData();
      
      var formFeatures = Vue.reactive({ errors: [], success: '', IDs: [] });
      formFeatures.showMoreToggle = function () {
        formFeatures.showmore = !formFeatures.showmore;
      }
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contact-name-linked', shown: true
          }),
          Vue.reactive({
            name: 'Email', label: 'Email',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'email'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contact-email-linked', shown: true
          }),
          Vue.reactive({
            name: 'Company', label: 'Company',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'company'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Phone', label: 'Phone',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'phone'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Contacts',
        emptyMessage: 'No Contacts',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Mailing Unsubscribers"
      });
      

      Vue.watchEffect(() => {
        if (featureLoad.loaded || !featureLoad.working) return;
        tableConfig.searching = true;
        formFeatures.IDs = [];
        iservice.API('webapp-api-custinfo?api=search', null, {
          fields: {
            groups: [{
              fields: [{
                where: 'entire',
                fieldID: 'opted-out',
                searchString: props.itemid
              }]
            }]
          }
        }).then(function (data) {
       
         formFeatures.numContacts = data.resultCount;
          data.contacts.forEach(item => {
            var id = item.id;
            contacts.add(item);
            formFeatures.IDs.push(id);
          });

        }).catch(function (errors) {

        }).finally(function () {
          tableConfig.searching = false;
        });
      });
      function Clear() {
        formFeatures.numContacts = null;
      }
      
      return { formFeatures, tableConfig, featureLoad, Clear };
    }
  };
  iservice.components.adminCampaignsUnsubscribers = {
    name: 'campaign-unsubscribers',
    template: '#campaign-unsubscribers',
    props: ['load', 'itemid'],
    setup(props) {
      var featureLoad = Vue.reactive({ loaded: false, working: false });
      Vue.watchEffect(() => {
        if (!props.load || featureLoad.loaded || featureLoad.working) return;
        featureLoad.working = true;
      });
      var contacts = iservice.ContactsData();

      var formFeatures = Vue.reactive({ errors: [], success: '', IDs: [] });
      formFeatures.showMoreToggle = function () {
        formFeatures.showmore = !formFeatures.showmore;
      }
      var tableColumns = Vue.computed(() => {
        var columns = [
          Vue.reactive({
            name: 'ID', label: 'ID',
            type: 'number',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'id'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: false
          }),
          Vue.reactive({
            name: 'Name', label: 'Name',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'name'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contact-name-linked', shown: true
          }),
          Vue.reactive({
            name: 'Email', label: 'Email',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'email'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-contact-email-linked', shown: true
          }),
          Vue.reactive({
            name: 'Company', label: 'Company',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'company'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          }),
          Vue.reactive({
            name: 'Phone', label: 'Phone',
            filterText: iservice.tables.SimpleFilterTextFunc(contacts, 'phone'),
            componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
          })];

        return columns;
      });
      var tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        filterLabel: 'Filter Contacts',
        emptyMessage: 'No Contacts',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Name',
        columns: tableColumns.value,
        exportName: "Mailing Unsubscribers"
      });


      Vue.watchEffect(() => {
        if (featureLoad.loaded || !featureLoad.working) return;
        tableConfig.searching = true;
        formFeatures.IDs = [];
        tableConfig.searching = true;
        iservice.API('webapp-api-custinfo?api=search', null, {
          fields: {
            groups: [{
              fields: [{
                where: 'entire',
                fieldID: 'opted-out',
                searchString: 'campaign-' + props.itemid
              }]
            }]
          }
        }).then(function (data) {

          formFeatures.numContacts = data.resultCount;
          data.contacts.forEach(item => {
            var id = item.id;
            contacts.add(item);
            formFeatures.IDs.push(id);
          });

        }).catch(function (errors) {

        }).finally(function () {
          tableConfig.searching = false;
        });
      });
      function Clear() {
        formFeatures.numContacts = null;
      }

      return { formFeatures, tableConfig, featureLoad, Clear };
    }
  };
  iservice.components.iserviceTableCellUserType = {
    name: 'iservice-table-cell-user-type',
    template: '#iservice-table-cell-user-type',
    props: ['itemid'],
    setup(props) {
      var usertypes = iservice.UserTypesData();
      var agents = iservice.AgentData();

      var typeID = Vue.computed(() => {
        var agent = agents.get(props.itemid);
        if (!agent) return '';
        return agent.typeID;
      });
      var UserType = Vue.computed(() => {
        var usertype = usertypes.get(typeID.value);
        if (!usertype) return '';
        return usertype.name;
      });
      return { UserType };
    }
  }
  iservice.components.iserviceTableCellLoggedIn = {
    name: 'iservice-table-cell-logged-in',
    template: '#iservice-table-cell-logged-in',
    props: ['itemid'],
    setup(props) {
      var agents = iservice.AgentData();
      var isLoggedIn = Vue.computed(() => {
        var agent = agents.get(props.itemid);
        if (!agent) return '';
        return agent.isLoggedIn;
      });
      return { isLoggedIn };
    }
  }
  iservice.components.iserviceTableCellChatAvailable = {
    name: 'iservice-table-cell-chat-available',
    template: '#iservice-table-cell-chat-available',
    props: ['itemid'],
    setup(props) {
      var agents = iservice.AgentData();
      var isAvailable = Vue.computed(() => {
        var agent = agents.get(props.itemid);
        if (!agent) return '';
        return agent.isAvailable;
      });
      return { isAvailable };
    }
  }
  iservice.components.iserviceTableCellInactivity = {
    name: 'iservice-table-cell-inactivity',
    template: '#iservice-table-cell-inactivity',
    props: ['itemid'],
    setup(props) {
      var agents = iservice.AgentData();
      var TimeOut = Vue.computed(() => {
        var agent = agents.get(props.itemid);
        if (!agent) return '';
        return agent.timeout;
      });
      return { TimeOut };
    }
  }
  iservice.components.adminAgentReceiveNotificationToggle = {
    name: 'iservice-table-cell-receive-notification-toggle',
    template: '#iservice-table-cell-receive-notification-toggle',
    props: ['itemid', 'column'],
    setup(props) {
      var agents = iservice.AgentData();
      var Agent = Vue.computed(() => {
        var agent = agents.get(props.itemid);
        if (!agent) return '';
        return agent;
      });
      var ShownSave = Vue.computed(function () {
        return props.column.Save;
      })
      return { Agent, ShownSave };
    }
  };
  iservice.components.adminAgentEmptyInboxToggle = {
    name: 'iservice-table-cell-empty-inbox-toggle',
    template: '#iservice-table-cell-empty-inbox-toggle',
    props: ['itemid', 'column'],
    setup(props) {
      var agents = iservice.AgentData();
      var Agent = Vue.computed(() => {
        var agent = agents.get(props.itemid);
        if (!agent) return '';
        return agent;
      });
      var ShownSave = Vue.computed(function () {
        return props.column.Save;
      })
      return { Agent, ShownSave };
    }
  };
  iservice.components.adminMasslistToggle = {
    name: 'iservice-table-cell-masslist-toggle',
    template: '#iservice-table-cell-masslist-toggle',
    props: ['itemid', 'column'],
    setup(props) {
      var masslists = iservice.MasslistData();
      var Masslist = Vue.computed(() => {
        var masslist = masslists.get(props.itemid);
        if (!masslist) return '';
        return masslist;
      });
      var ShownSave = Vue.computed(function () {
        return props.column.Save;
      });
      return { Masslist, ShownSave };
    }
  };
  iservice.components.adminMassCampaignToggle = {
    name: 'iservice-table-cell-masscampaign-toggle',
    template: '#iservice-table-cell-masscampaign-toggle',
    props: ['itemid', 'column'],
    setup(props) {
      var masscampaigns = iservice.MassCampaignsData();
      var Masscampaign = Vue.computed(() => {
        var masscampaign = masscampaigns.get(props.itemid);
        if (!masscampaign) return '';
        return masscampaign;
      });
      var ShownSave = Vue.computed(function () {
        return props.column.Save;
      });
      return { Masscampaign, ShownSave };
    }
  };
  iservice.components.adminMassMessagesToggle = {
    name: 'iservice-table-cell-massmessages-toggle',
    template: '#iservice-table-cell-massmessages-toggle',
    props: ['itemid', 'column'],
    setup(props) {
      var massmessages = iservice.MassMessagesData();
      var MassMessage = Vue.computed(() => {
        var massmessage = massmessages.get(props.itemid);
        if (!massmessage) return '';
        return massmessage;
      });
      
      var ShownSave = Vue.computed(function () {
        return props.column.Save;
      })
      return { MassMessage, ShownSave };
    }
  };
  iservice.components.adminVariableStockPicker = {
    name: 'admin-variable-stock-responses',
    template: '#admin-variable-stock-responses',
    props: ['params'],
    setup(props) {
      var featureTabs = Vue.reactive({ tab: 'responses' });
      featureTabs.TabClass = function (tab) { return { 'active': tab == featureTabs.tab } }
      featureTabs.TabClick = function (tab) { featureTabs.tab = tab; }
      var allVariables = iservice.VariablePickerData();
      var allStocks = iservice.StockResponsesData();
      var feature = Vue.computed(() => { return props.params; });

      function PassedFilter(str) {
        if (!feature.value.filter || feature.value.filter.length < 1) return true;
        if (str.toLocaleLowerCase().indexOf(feature.value.filter.toLocaleLowerCase()) == -1) return false;
        return true;
      }
      function StockTitle(text) {
        if (!text) return '';
        if (text.length > 100) {
          return text.substring(0, 100) + '...';
        }
        return text;
      }
      var variables = Vue.computed(() => {
        if (!allVariables.loaded) allVariables.Load();
        var sections = [];
        allVariables.sections.forEach(section => {
          var filtered = {
            label: section.label,
            vars: [],
            segments: []
          };
          section.vars.forEach(v => {
            if (!PassedFilter(v.label)) return;
            filtered.vars.push(v);
          });
          section.segments.forEach(seg => {
            var segment = { label: seg.label, vars: [] };
            seg.vars.forEach(v => {
              if (!PassedFilter(v.label)) return;
              segment.vars.push(v);
            });
            if (segment.vars.length > 0) filtered.segments.push(segment);
          });
          if (filtered.vars.length > 0 || filtered.segments.length > 0) sections.push(filtered);
        });
        return sections;
      });
      var stocks = Vue.computed(() => {
        if (!allStocks.loaded) allStocks.Load();
        var segment = [];
        allStocks.inSegment(feature.value.segmentID).forEach(stock => {
          if (PassedFilter(stock.name) || PassedFilter(stock.description) || PassedFilter(stock.bodyPreview)) {
            segment.push({ id: stock.id, name: stock.name, title: StockTitle(stock.bodyPreview) });
          }
        });
        var agent = [];
        allStocks.ofMine().forEach(stock => {
          if (PassedFilter(stock.name) || PassedFilter(stock.description) || PassedFilter(stock.bodyPreview)) {
            agent.push({ id: stock.id, name: stock.name, title: StockTitle(stock.bodyPreview) });
          }
        });
        return { segment, agent };
      });
      var pasting = false;
      function PasteStock(item) {
        if (pasting) return;
        var stock = allStocks.get(item.id);
        if (!stock.bodyHtml) {
          pasting = item.working = true;
          iservice.API('webapp-api-mq-myqueue?api=stock', null, { stockID: item.id }).then(data => {
            allStocks.add(data);
            feature.value.PasteStock(stock.bodyHtml);
          }).finally(() => {
            pasting = item.working = false;
          });
        }
        else {
          feature.value.PasteStock(stock.bodyHtml);
        }
      }

      return { allVariables, allStocks, featureTabs, variables, stocks, PasteStock, feature };
    }
  };
  iservice.components.adminMailingTopicName = {
    name: 'iservice-table-cell-topic',
    template: '#iservice-table-cell-topic',
    props: ['itemid'],
    setup(props) {
      var massmailings = iservice.MassMailingsData();
      var topicID = Vue.computed(() => {
        var massmailing = massmailings.get(props.itemid);
        if (!massmailing) return '';
        return massmailing.topicID;
      });
      var topics = iservice.TopicData();
      var topicName = Vue.computed(() => {
        var topic = topics.get(topicID.value);
        if (!topic) return '';
        return topic.name;
      });
      return { topicName };
    }
  };
  iservice.components.adminMailboxTopicName = {
    name: 'iservice-table-cell-mailbox-topic',
    template: '#iservice-table-cell-mailbox-topic',
    props: ['itemid'],
    setup(props) {
      var mailboxesadmin = iservice.MailboxAdminData();
      var topicID = Vue.computed(() => {
        var mailbox = mailboxesadmin.get(props.itemid);
        if (!mailbox) return '';
        return mailbox.topicID;
      });
      var topics = iservice.TopicData();
      var topicName = Vue.computed(() => {
        var topic = topics.get(topicID.value);
        if (!topic) return '';
        return topic.name;
      });
      return { topicName };
    }
  };
  iservice.components.adminMailboxFilterName = {
    name: 'iservice-table-cell-mailbox-filter',
    template: '#iservice-table-cell-mailbox-filter',
    props: ['itemid'],
    setup(props) {
      var mailboxesadmin = iservice.MailboxAdminData();
      var filterID = Vue.computed(() => {
        var mailbox = mailboxesadmin.get(props.itemid);
        if (!mailbox) return '';
        return mailbox.filterID;
      });
      var filters = iservice.FilterData();
      var filterName = Vue.computed(() => {
        var filter = filters.get(filterID.value);
        if (!filter) return '';
        return filter.name;
      });
      return { filterName };
    }
  };
  iservice.components.adminTopicsName = {
    name: 'iservice-table-cell-segment-topic-name',
    template: '#iservice-table-cell-segment-topic-name',
    props: ['itemid', 'column'],
    setup(props) {
      var feature = Vue.reactive({ topics: '' })
      Vue.watchEffect(function () {
        feature.topics = props.column.topicType == 'active' ? iservice.TopicData() : iservice.TopicDeletedData();
      })
      var Topic = Vue.computed(() => {
        var topic = feature.topics.get(props.itemid);
        if (!topic) return '';
        return topic;
      });
      return { Topic };
    }
  };
  iservice.components.adminTopicsParentName = {
    name: 'iservice-table-cell-segment-topic-parent-name',
    template: '#iservice-table-cell-segment-topic-parent-name',
    props: ['itemid', 'column'],
    setup(props) {
      var feature = Vue.reactive({ topics: '' })
      Vue.watchEffect(function () {
        feature.topics = props.column.topicType == 'active' ? iservice.TopicData() : iservice.TopicDeletedData();
      })
      var parentID = Vue.computed(() => {
        var topic = feature.topics.get(props.itemid);
        if (!topic) return '';
        return topic.parentID;
      });
      var allTopics = iservice.TopicData();
      var parentTopicName = Vue.computed(() => {
        var parentTopic = allTopics.get(parentID.value);
        if (!parentTopic) return '';
        return parentTopic.name ? parentTopic.name : "None - This is the root topic for the segment." ;
      });
      return { parentTopicName };
    }
  };
  iservice.components.adminTopicsFilterName = {
    name: 'iservice-table-cell-segment-topic-filter',
    template: '#iservice-table-cell-segment-topic-filter',
    props: ['itemid', 'column'],
    setup(props) {
      var topics = props.column.topicType == 'active' ? iservice.TopicData() : iservice.TopicDeletedData();
      var AAQfilterID = Vue.computed(() => {
        var topic = topics.get(props.itemid);
        if (!topic) return '';
        return topic.askAQuestionFilterID;
      });
      var filters = iservice.FilterData();
      var filterName = Vue.computed(() => {
        var filter = filters.get(AAQfilterID.value);
        if (!filter) return '';
        return filter.name;
      });
      return { filterName };
    }
  };
  iservice.components.adminTopicsNotificationName = {
    name: 'iservice-table-cell-segment-topic-notification',
    template: '#iservice-table-cell-segment-topic-notification',
    props: ['itemid', 'column'],
    setup(props) {
      var topics = props.column.topicType == 'active' ? iservice.TopicData() : iservice.TopicDeletedData();
      var notifyID = Vue.computed(() => {
        var topic = topics.get(props.itemid);
        if (!topic) return '';
        return topic.autoResponseID;
      });
      var neverAutoResponse = Vue.computed(() => {
        var topic = topics.get(props.itemid);
        if (!topic) return '';
        return topic.neverAutoResponse;
      });
      var agentNotifyEmpty = '';
      var autoResponses = iservice.AutoResponseData();
      var responseName = Vue.computed(() => {
        var autoresponse = autoResponses.get(notifyID.value);
        if (notifyID.value == '' && neverAutoResponse.value == false) agentNotifyEmpty = 'Segment Default';
        if (!autoresponse) return agentNotifyEmpty;
        return autoresponse.name;
      });
      return { responseName };
    }
  };
  iservice.components.adminTopicsAgentNotificationName = {
    name: 'iservice-table-cell-segment-topic-agent-notification',
    template: '#iservice-table-cell-segment-topic-agent-notification',
    props: ['itemid', 'column'],
    setup(props) {
      var topics = props.column.topicType == 'active' ? iservice.TopicData() : iservice.TopicDeletedData();
      var agentnotifyID = Vue.computed(() => {
        var topic = topics.get(props.itemid);
        if (!topic) return '';
        return topic.agentNotifyID;
      });
      var neverAgentNotify = Vue.computed(() => {
        var topic = topics.get(props.itemid);
        if (!topic) return '';
        return topic.neverAgentNotify;
      });

      var agentNotifyEmpty = '';
      var autoResponses = iservice.AutoResponseData();
      var agentNotificationName = Vue.computed(() => {
        var autoresponse = autoResponses.get(agentnotifyID.value);
        if (agentnotifyID.value == '' && neverAgentNotify.value == false) agentNotifyEmpty = 'Segment Default';
        if (!autoresponse) return agentNotifyEmpty;
        return autoresponse.name;
      });
      return { agentNotificationName };
    }
  };
  iservice.components.adminTopicsServiceLevelName = {
    name: 'iservice-table-cell-topic-servicelevel',
    template: '#iservice-table-cell-topic-servicelevel',
    props: ['itemid', 'column'],
    setup(props) {
      var topics = props.column.topicType == 'active' ? iservice.TopicData() : iservice.TopicDeletedData();
      var serviceLevelID = Vue.computed(() => {
        var topic = topics.get(props.itemid);
        if (!topic) return '';
        return topic.serviceLevelID;
      });
      var serviceLevels = iservice.ServiceLevelData();
      var serviceLevelName = Vue.computed(() => {
        var serviceLevel = serviceLevels.get(serviceLevelID.value);
        if (!serviceLevel) return '';
        return serviceLevel.name;
      });
      return { serviceLevelName };
    }
  };
  iservice.components.adminInteractionPropValuetype = {
    name: 'iservice-table-cell-intproperty-type',
    template: '#iservice-table-cell-intproperty-type',
    props: ['itemid'],
    setup(props) {
      var intProperties = iservice.IntPropertyData();
      var typeID = Vue.computed(() => {
        var property = intProperties.get(props.itemid);
        if (!property) return '';
        return property.type;
      });
      var propertytypes = iservice.PropertyTypeData();
      var typeName = Vue.computed(() => {
        var type = propertytypes.get(typeID.value);
        if (!type) return '';
        return type.name;
      });
      return { typeName };
    }
  };
  iservice.components.adminContactPropValuetype = {
    name: 'iservice-table-cell-contactproperty-type',
    template: '#iservice-table-cell-contactproperty-type',
    props: ['itemid'],
    setup(props) {
      var contactProperties = iservice.ContactPropertyData();
      var typeID = Vue.computed(() => {
        var property = contactProperties.get(props.itemid);
        if (!property) return '';
        return property.type;
      });
      var propertytypes = iservice.PropertyTypeData();
      var typeName = Vue.computed(() => {
        var type = propertytypes.get(typeID.value);
        if (!type) return '';
        return type.name;
      });
      return { typeName };
    }
  };
  iservice.components.adminInteractionPropertyToggle = {
    name: 'iservice-table-cell-intproperty-toggle',
    template: '#iservice-table-cell-intproperty-toggle',
    props: ['itemid', 'column'],
    setup(props) {
      var intProperties = iservice.IntPropertyData();
      var column = Vue.computed(function () {
        return props.column;
      });
      var intProperty = Vue.computed(() => {
        var property = intProperties.get(props.itemid);
        if (!property) return '';
        return property;
      });
      var ToggleSave = Vue.computed(function () {
        return props.column.Save;
      })
      return { column, intProperty, ToggleSave};
    }
  };
  iservice.components.adminContactPropertyToggle = {
    name: 'iservice-table-cell-contactproperty-toggle',
    template: '#iservice-table-cell-contactproperty-toggle',
    props: ['itemid', 'column'],
    setup(props) {
      var contactProperties = iservice.ContactPropertyData();
      var column = Vue.computed(function () {
        return props.column;
      });
      var contactProperty = Vue.computed(() => {
        var property = contactProperties.get(props.itemid);
        if (!property) return '';
        return property;
      });
      var ToggleSave = Vue.computed(function () {
        return props.column.Save;
      })
      return { column, contactProperty, ToggleSave};
    }
  };
  iservice.components.adminMailboxEnableToggle = {
    name: 'iservice-table-cell-mailbox-enabled-toggle',
    template: '#iservice-table-cell-mailbox-enabled-toggle',
    props: ['itemid', 'column'],
    setup(props) {
      var mailboxesadmin = iservice.MailboxAdminData();
      var Mailbox = Vue.computed(() => {
        var mailbox = mailboxesadmin.get(props.itemid);
        if (!mailbox) return '';
        return mailbox;
      });
      var Save = Vue.computed(function () {
        return props.column.Save;
      })
      
      return { Mailbox, Save };
    }
  };
  iservice.components.adminFilterGroupToggle = {
    name: 'iservice-table-cell-group-runchildren-toggle',
    template: '#iservice-table-cell-group-runchildren-toggle',
    props: ['itemid', 'column'],
    setup(props) {
      var filters = iservice.FilterData();
      var Filter = Vue.computed(() => {
        var filter = filters.get(props.itemid);
        if (!filter) return '';
        return filter;
      });
      var Save = Vue.computed(function () {
        return props.column.Save;
      })
      
      return { Filter, Save };
    }
  };
  iservice.components.adminNotificationNoReplyToggle = {
    name: 'iservice-table-cell-use-no-reply-toggle',
    template: '#iservice-table-cell-use-no-reply-toggle',
    props: ['itemid', 'column'],
    setup(props) {
      var autoresponses = iservice.AutoResponseData();
      var Notification = Vue.computed(() => {
        var notification = autoresponses.get(props.itemid);
        if (!notification) return '';
        return notification;
      });
      var Save = Vue.computed(function () {
        return props.column.Save;
      })
      
      return { Notification, Save };
    }
  };
  iservice.components.adminNotificationTypesColumn = {
    name: 'iservice-table-cell-notification-types',
    template: '#iservice-table-cell-notification-types',
    props: ['itemid', 'column'],
    setup(props) {
      var autoresponses = iservice.AutoResponseData();
      var notificationtypes = iservice.notificationtypes;

      var listNames = Vue.computed(function () {
        var notificationNames = [];
        var notification = autoresponses.get(props.itemid);
        var notificationsTypes = notificationtypes.filter(function (item) {
          return notification.listNames.includes(item.value);
        });
        notificationsTypes.forEach(function (type) {
          notificationNames.push(type.name);
        });
        return notificationNames.join(', ');
      });

      return { listNames };
    }
  };
  iservice.components.adminTopicNameWithSegment = {
    name: 'iservice-table-cell-topic-with-segment',
    template: '#iservice-table-cell-topic-with-segment',
    props: ['itemid'],
    setup(props) {
      var massmessages = iservice.MassMessagesData();
      var topicID = Vue.computed(() => {
        var massmessage = massmessages.get(props.itemid);
        if (!massmessage) return '';
        return massmessage.topicID;
      });
      var topics = iservice.TopicData();
      var topicName = Vue.computed(() => {
        var topic = topics.get(topicID.value);
        if (!topic) return '';
        return '('+topic.segmentName+') '+topic.name;
      });
      return { topicName };
    }
  };
  iservice.components.adminMassListName = {
    name: 'iservice-table-cell-masslist',
    template: '#iservice-table-cell-masslist',
    props: ['itemid'],
    setup(props) {
      var massmailings = iservice.MassMailingsData();
      var listID = Vue.computed(() => {
        var massmailing = massmailings.get(props.itemid);
        if (!massmailing) return '';
        return massmailing.listID;
      });
      var masslists = iservice.MasslistData();
      var massListName = Vue.computed(() => {
        var masslist = masslists.get(listID.value);
        if (!masslist) return '';
        return masslist.name;
      });
      return { massListName };
    }
  };
  iservice.components.adminMassMessageName = {
    name: 'iservice-table-cell-massmessage',
    template: '#iservice-table-cell-massmessage',
    props: ['itemid'],
    setup(props) {
      var massmailings = iservice.MassMailingsData();
      var messageID = Vue.computed(() => {
        var massmailing = massmailings.get(props.itemid);
        if (!massmailing) return '';
        return massmailing.messageID;
      });
      var massmessages = iservice.MassMessagesData();

      var massMessageName = Vue.computed(() => {
        var massmessage = massmessages.get(messageID.value);
        if (!massmessage) return '';
        return massmessage.name;
      });
      return { massMessageName };
    }
  };
  iservice.components.adminMailboxName = {
    name: 'iservice-table-cell-mailbox',
    template: '#iservice-table-cell-mailbox',
    props: ['itemid'],
    setup(props) {
      var massmailings = iservice.MassMailingsData();
      var mailboxID = Vue.computed(() => {
        var massmailing = massmailings.get(props.itemid);
        if (!massmailing) return '';
        return massmailing.messageID;
      });
      var mailboxes = iservice.MailboxData();
      var mailboxName = Vue.computed(() => {
        var mailbox = mailboxes.get(mailboxID.value);
        if (!mailbox) return '';
        return mailbox.name;
      });
      return { mailboxName };
    }
  };
  iservice.components.segmentFilterMatchInColumn = {
    name: 'iservice-table-cell-filter-match-in',
    template: '#iservice-table-cell-filter-match-in',
    props: ['itemid'],
    setup(props) {
      var filters = iservice.FilterData();
      var matchInData = Vue.computed(() => {
        var filter = filters.get(props.itemid);
        if (!filter) return '';
        var matchInString = [];
        if (filter.matchSubject) matchInString.push('Subject');
        if (filter.matchBody) matchInString.push('Body');
        if (filter.matchTo) matchInString.push('Mailbox Name');
        if (filter.matchFrom) matchInString.push('From');
        if (filter.matchContactProperty) matchInString.push('Contact Properties');
        if (filter.matchAttachments) matchInString.push('Text Attachments');
        return matchInString.join(', ');
      });
      return { matchInData };
    }
  };
  iservice.components.segmentFilterActionStepsColumn = {
    name: 'iservice-table-cell-filter-action-steps',
    template: '#iservice-table-cell-filter-action-steps',
    props: ['itemid'],
    setup(props) {
      var filters = iservice.FilterData();
      var actionStepsData = Vue.computed(() => {
        var filter = filters.get(props.itemid);
        if (!filter) return '';
        var actionStepsString = [];
        if (filter.action) {
          filter.action.steps.forEach(function (step, key) {
            for (const item in step) {
              if (step[item]) actionStepsString.push(item);
            }
          });
          return actionStepsString.join(', ')
        } else {
          return '';
        }
       
      });
      return { actionStepsData };
    }
  };
  iservice.components.adminFilterList= {
    name: 'filter-list',
    template: '#filter-list',
    props: ['ids'],
    setup(props) {
      var filters = iservice.FilterData();
      if (!filters.loaded) {
        filters.Load();
      }
      var filterIDs = Vue.computed(function () {
        return props.ids;
      })

      var filtersData = Vue.computed(function () {
        if (!filters.loaded) {
          filters.Load();
        }
        if (!filters.list.length) return;
        var filterArr = [];
        if (filterIDs.value) {
          filterIDs.value.forEach(function (id) {
            var filter = filters.get(id);
            filterArr.push(filter);
          });
        }
        return filterArr;
      });
      return { filtersData, filterIDs };
    }
  };

  iservice.components.smtpoutModify = {
    name: 'smtpout-modify',
    template: '#smtpout-modify',
    props: ['itemid', 'tableIDs'],
    setup(props) {
      var featureModify = Vue.reactive({});
      var featureSmtpOut = Vue.inject('featureSmtpOut');
      var ShowDetails = Vue.inject('ShowDetails');
      function DelayHour() {
        
      }
      function DelayDay() {

      }
      function Delete() {
        if (featureModify.working) return;
        featureModify.working = true;
        featureModify.errors = null;
        iservice.API('webapp-api-admin?api=smtpoutmodify', null, { mode: 'remove', messageID: props.itemid }).then(() => {
          featureModify.success = 'Message removed.';
        }).catch(errors => {
          featureModify.erros = errors;
        }).finally(() => {
          featureModify.working = false;
        });
      }
      return { featureModify, DelayHour, DelayDay, Delete };
    }
  };

  iservice.components.adminMonitor = {
    name: 'admin-monitor',
    template: '#admin-monitor',
    route() { return { path: iservice.formPath + '/admin/server-process-management', priority: 300 } },
    setup() {
      var tenants = Vue.reactive([]);
      var tenantMap = Vue.reactive({});
      var smtpout = iservice.SmtpOutData();

      var featureMonitor = Vue.reactive({ working: false, loaded: false, loading: true });

      var featureTabs = Vue.reactive({ activeTab: 'smtpout' });
      featureTabs.LinkClass = function (name) {
        return (name == featureTabs.activeTab) ? 'active' : '';
      }
      featureTabs.PaneClass = function (name) {
        return (name == featureTabs.activeTab) ? 'active' : '';
      }
      featureTabs.TabClick = function (name) {
        featureTabs.activeTab = name;
      }

      var featurePurge = Vue.reactive({});
      featurePurge.ConfigStart = function (tenant) {
        tenant.interactionPurge.configure = true;
        tenant.interactionPurge.configDays = tenant.interactionPurge.days || 180;
      }
      featurePurge.ConfigCancel = function (tenant) {
        tenant.interactionPurge.configure = false;
      }
      featurePurge.ConfigStop = function (tenant) {
        if (featureMonitor.working) return;
        featureMonitor.working = true;
        featureMonitor.errors = null;
        iservice.API('webapp-api-admin?api=processessave', null, { items: [{ tenantID: tenant.id, processName: 'interactionPurge', enabled: false }] }).then(() => {
          tenant.interactionPurge.enabledInteractionPurge = false;
          tenant.interactionPurge.configure = false;
        }).catch(errors => {
          featureMonitor.erros = errors;
        }).finally(() => {
          featureMonitor.working = false;
        });
      }
      featurePurge.ConfigSave = function (tenant) {
        if (featureMonitor.working) return;
        featureMonitor.working = true;
        featureMonitor.errors = null;
        if (tenant.interactionPurge.configDays < 180) return;
        iservice.API('webapp-api-admin?api=configurationsave', null, { application: 'backend', tenantID: tenant.id, items: [{ name: 'interactionPurge', data: JSON.stringify({ days: tenant.interactionPurge.configDays }) }] }).then(() => {
          tenant.interactionPurge.days = tenant.interactionPurge.configDays;
          return iservice.API('webapp-api-admin?api=processessave', null, { items: [{ tenantID: tenant.id, processName: 'interactionPurge', enabled: true }] });
        }).then(() => {
          tenant.interactionPurge.enabledInteractionPurge = true;
          tenant.interactionPurge.configure = false;
          featureMonitor.success = 'Interaction purge enabled.';
        }).catch(errors => {
          featureMonitor.erros = errors;
        }).finally(() => {
          featureMonitor.working = false;
        });
      }
      Vue.watchEffect(() => {
        tenants.forEach(tenant => {
          if (!tenant.interactionPurge) return;
          tenant.interactionPurge.running = tenant.interactionPurge.enabledInteractionPurge && tenant.interactionPurge.days >= 180;
        });
      });

      var timesList = Vue.reactive([]);
      var timeStamps = Vue.computed(() => {
        var map = {};
        timesList.length = 0;
        tenants.forEach(tenant => {
          var item = {};
          function process(value, name) {
            if (value) {
              timesList.push(value);
              item[name] = moment(value).format('YYYY-MM-DD hh:mm:ss A');
            }
            else item[name] = '';
          }
          process(tenant?.agentInactivity?.lastAgentInactivityUtc, 'agentInactivity');
          process(tenant?.interactionPurge?.lastInteractionPurgeUtc, 'interactionPurge');
          process(tenant?.interactionPurge?.lastSearchUtc, 'interactionPurgeSearch');
          process(tenant?.interactionPurge?.cutoffUtc, 'interactionPurgeCutoff');
          map[tenant.name] = item;
        });
        return map;
      });

      var timesSince = Vue.reactive({});
      setInterval(() => {
        timesList.forEach(time => {
          var diff = moment().diff(moment(time));
          var duration = moment.duration(diff);
          var years = duration.years(), months = duration.months(), weeks = duration.weeks(), days = duration.days(), hours = duration.hours(), minutes = duration.minutes(), seconds = duration.seconds();
          var since;
          if (years > 0) since = 'years ago';
          else if (months > 0) since = 'months ago';
          else if (weeks > 0) since = 'weeks ago';
          else if (days > 0) since = 'days ago';
          else if (hours > 0) since = (hours == 1 ? '1 hour, ' : hours + ' hours, ') + (minutes == 1 ? '1 minute, ' : minutes + ' minutes, ') + (seconds == 1 ? '1 second' : seconds + ' seconds') + ' ago';
          else if (minutes > 0) since = (minutes == 1 ? '1 minute, ' : minutes + ' minutes, ') + (seconds == 1 ? '1 second' : seconds + ' seconds') + ' ago';
          else since = (seconds == 1 ? '1 second' : seconds + ' seconds') + ' ago';
          timesSince[time] = since;
        });
      }, 100);

      function TenantData(data) {
        if (!data || !data.name) return;
        var tenant = tenantMap[data.name];
        if (!tenant) {
          tenant = Vue.reactive(data);
          tenant.isCollapsed = false;
          tenantMap[data.name] = tenant;
          tenants.push(tenant);
        }
        function copy(groupName, names) {
          if (!data[groupName]) return;
          var group = tenant[groupName];
          if (!group) {
            group = Vue.reactive({});
            tenant[groupName] = group;
          }
          names.forEach(member => {
            if (data[groupName][member] !== undefined) {
              if (Array.isArray(data[groupName][member])) {
                if (Array.isArray(group[member])) group[member].length = 0;
                else group[member] = Vue.reactive([]);
                data[groupName][member].forEach(item => { group[member].push(item); });
              }
              else group[member] = data[groupName][member];
            }
          })
        }
        copy('agentInactivity', ['enabledAgentInactivity', 'lastAgentInactivityUtc', 'lastAgentInactivityMessage']);
        copy('interactionPurge', ['enabledInteractionPurge', 'lastInteractionPurgeUtc', 'days', 'lastSearchUtc', 'interactionCount', 'fileCount', 'numPerTick', 'totalMinutes', 'totalDeleted', 'totalDeletedFiles', 'cutoffUtc']);
      }

      var featureSmtpOut = Vue.reactive({ IDs: [] });
      Vue.provide('featureSmtpOut', featureSmtpOut);
      featureSmtpOut.tableConfig = Vue.reactive({
        componentControls: 'iservice-table-controls-standard',
        componentBody: 'iservice-table-body',
        componentStatus: 'iservice-table-status',
        componentRow: 'iservice-table-row-expandable',
        componentExpanded: 'smtpout-modify',
        filterLabel: 'Filter SMTP Out',
        emptyMessage: 'There are no SMTP messages .',
        pageSize: 5,
        expandable: true,
        searching: false,
        initialSort: 'Intended',
        exportName: "My Inbox Messages"
      });
      featureSmtpOut.tableConfig.columns = [
        Vue.reactive({
          name: 'gear', hidable: false,
          filterText: function () { },
          componentHead: 'iservice-table-head-empty', componentCell: 'iservice-table-cell-gear', shown: true
        }),
        Vue.reactive({
          name: 'Intended', label: 'Send Time', sortIncreasing: true,
          filterText: iservice.tables.DateFilterTextFunc(smtpout, 'intendedUtc'), sortText: iservice.tables.SimpleFilterTextFunc(smtpout, 'intendedUtc'),
          componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-date-from-now', shown: true
        }),
        Vue.reactive({
          name: 'Message', label: 'Message ID',
          filterText: iservice.tables.SimpleFilterTextFunc(smtpout, 'id'),
          componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
        }),
        Vue.reactive({
          name: 'Interaction', label: 'Interaction ID',
          filterText: iservice.tables.SimpleFilterTextFunc(smtpout, 'interactionID'),
          componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
        }),
        Vue.reactive({
          name: 'To', label: 'To',
          filterText: iservice.tables.SimpleFilterTextFunc(smtpout, 'to'),
          componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-smtpout-email-linked', shown: true
        }),
        Vue.reactive({
          name: 'Subject', label: 'Subject',
          filterText: iservice.tables.SimpleFilterTextFunc(smtpout, 'subject'),
          componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
        }),
        Vue.reactive({
          name: 'Errors', label: 'Errors',
          filterText: iservice.tables.SimpleFilterTextFunc(smtpout, 'numberErrors'),
          componentHead: 'iservice-table-head-sortable-label', componentCell: 'iservice-table-cell-simple', shown: true
        })];
      var smtpIDs = Vue.computed(() => {
        var list = [];
        for (var id in smtpout.map) {
          list.push(id);
        }
        return list;
      });
      Vue.watchEffect(() => {
        featureSmtpOut.IDs = smtpIDs.value;
      });

      var monitorUnsub = null;
      var stmpUnsub = null;
      function WebsyncClear() {
        if (monitorUnsub) monitorUnsub();
        monitorUnsub = null;
        if (stmpUnsub) stmpUnsub();
        stmpUnsub = null;
      }
      Vue.onUnmounted(() => {
        WebsyncClear();
      });
      iservice.WatchLoginChange(() => {
        WebsyncClear();
        monitorUnsub = websync.subscribe(iservice.HaveRight('Tab.Admin.Monitor.All') ? '/mailmonitor/_' : '/mailmonitor/' + loggedIn.tenantID, MonitorReceive);
        stmpUnsub = websync.subscribe('/smtpout/' + loggedIn.tenantID, SmtpOutReceive);
      });
      function MonitorReceive(msg) {
        var message = msg.getData();
        TenantData(message);
      }
      function SmtpOutReceive(msg) {
        var message = msg.getData();
        smtpout.add(message);
      }

      iservice.API('webapp-api-admin?api=processes').then(data => {
        data.processes.forEach(tenant => {
          TenantData(tenant);
        });
        smtpout.clear();
        data.smtpout.messages.forEach(message => {
          smtpout.add(message);
        });
      }).finally(() => {
        featureMonitor.loaded = true;
        featureMonitor.loading = false;
      });;

      function Save(tenant, name, enabled) {
        if (tenant.working) return;
        tenant.working = true;
        tenant.errors = null;
        iservice.API('webapp-api-admin?api=processessave', null, { items: [{ tenantID: tenant.id, processName: name, enabled }] }).then(() => {

        }).catch(errors => {
          tenant.erros = errors;
        }).finally(() => {
          tenant.working = false;
        });
      }

      return { featureMonitor, tenants, timeStamps, timesSince, Save, featureTabs, featurePurge, featureSmtpOut }
    }
  };

  iservice.components.adminVueappCustomize = {
    name: 'admin-vueapp-customize',
    template: '#admin-vueapp-customize',
    route() {
      return {
        path: iservice.formPath + '/admin/customize-ui/:tab?', priority: 300,
        myformsUrl: iservice.formPath + '/admin/customize-ui', myformsLinkLabel: 'Customize UI', myformsLinkClass: 'fa fa-globe',
        canAccess() {
          return iservice.HaveRight('Tab.Admin.Websites');
        },
        meta: { title:'iService | Customize UI'}
      }
    },
    setup() {
      var tabs = Vue.reactive({ currentTab: 'tabAnswer' });
      tabs["values"] = { 'answer-panel-buttons': 'tabAnswer', 'question-color-coding-by-age': 'tabQuestion', 'dashboard-settings': 'tabDashboard' };
      var router = VueRouter.useRouter();

      Vue.watchEffect(() => {
        let routTab = router.currentRoute.value.params.tab;
        if (routTab && tabs.values[routTab]) {
          tabs.currentTab = tabs.values[routTab] || 'tabAnswer';
        }
      });
      Vue.watchEffect(() => {
        let newTab = tabs.currentTab;
        for (tab in tabs.values) {
          if (tabs.values[tab] == newTab) {
            router.push({ params: { tab } });
          }
        }
      });
      return { tabs }
    }
  };
  iservice.components.adminVueappCustomizePortal = {
    name: 'admin-vueapp-customize-customer-portal',
    template: '#admin-vueapp-customize-customer-portal',
    route() {
      return {
        path: iservice.formPath + '/admin/customer-portal-ui-customization/:tab?/:subtab?', priority: 300,
        myformsUrl: iservice.formPath + '/admin/customer-portal-ui-customization', myformsLinkLabel: 'Customer Portal UI Customization', myformsLinkClass: 'fa fa-globe',
        canAccess() {
          return iservice.HaveRight('Tab.Admin.Websites');
        },
        meta: { title: 'iService | Customize Customer Portal' }
      }
    },
    setup() {
      var tabs = Vue.reactive({ currentTab: 'treeview' });
      var subTabs = Vue.reactive({ currentSubTab: 'tree-content-settings' });
      var router = VueRouter.useRouter();

      function changeTab(tab, subtab) {
        tabs.currentTab = tab;
        var tabname = 'tabs-';
        if (tab == 'treeview') tabname = 'tree-';
        subtab = subtab.replace(tabname, '');
        subTabs.currentSubTab = subtab
        router.push({ params: { tab: tab, subtab: subtab } });
      }
      Vue.watchEffect(() => {
        let routTab = router.currentRoute.value.params.tab;
        let subTab = router.currentRoute.value.params.subtab;
        if (routTab) {
          tabs.currentTab = routTab;
        }
        if (subTab) {
          var tabname = 'tabs-';
          if (routTab == 'treeview') tabname = 'tree-';
          subTabs.currentSubTab = tabname + subTab || 'tree-content-settings';
        }
      });
      return { tabs, subTabs, changeTab }
    }
  };
  iservice.components.adminVueappCustomizePortalTreeviewContent = {
    name: 'admin-vueapp-customize-portal-treeview-content',
    template: '#admin-vueapp-customize-portal-treeview-content',
    setup(props) {
      var CustomerPortalConfig = Vue.reactive({ treeview: {}, working: true });
      CustomerPortalConfig.config = [];
      CustomerPortalConfig.treeview = {
        contentSettings: {},
        pageComponent: {},
        styleSelection: {},
        customCssCode: {}
      }

      CustomerPortalConfig.Save = function () {
        if (CustomerPortalConfig.working) return;
        CustomerPortalConfig.config.push(CustomerPortalConfig.treeview);
        iservice.API('webapp-api-admin?api=configurationsave', null, { application: 'agentapp', items: [{ name: 'CustomerPortalTreeview', websiteID: '', data: JSON.stringify(CustomerPortalConfig.config) }] }).then(data => {
          iservice.SuccessMessage('Configuration saved.');
        }).catch(errors => {
          CustomerPortalConfig.errors = true;
        }).finally(() => {
          CustomerPortalConfig.working = false;
        });
      }
      iservice.API('webapp-api-admin?api=configuration', null, { application: 'agentapp', name: 'CustomerPortalTreeview' }).then(data => {
        if (data.items.length > 0) {
          data.items[0].data.forEach(name => {
            CustomerPortalConfig.treeview = data.items[0].data[0];
          })
        }
      }).catch(function (errors) {
        CustomerPortalConfig.errors = true;
      }).finally(function () {
        CustomerPortalConfig.working = false;
      })
      return { CustomerPortalConfig }
    }
  }
  iservice.components.adminVueappCustomizePortal = {
    name: 'admin-vueapp-customize-customer-portal',
    template: '#admin-vueapp-customize-customer-portal',
    route() {
      return {
        path: iservice.formPath + '/admin/customer-portal-ui-customization/:tab?', priority: 300,
        myformsUrl: iservice.formPath + '/admin/customer-portal-ui-customization', myformsLinkLabel: 'Customer Portal UI Customization', myformsLinkClass: 'fa fa-globe',
        canAccess() {
          return iservice.HaveRight('Tab.Admin.Websites');
        },
        meta: { title: 'iService | Customize Customer Portal' }
      }
    },
    setup() {
      var tabs = Vue.reactive({ currentTab: 'treeview' });
      var router = VueRouter.useRouter();

      function changeTab(tab) {
        tabs.currentTab = tab;
        router.push({ params: { tab: tab } });
      }
      Vue.watchEffect(() => {
        let routTab = router.currentRoute.value.params.tab ? router.currentRoute.value.params.tab: 'treeview';
        changeTab(routTab)
        if (routTab) {
          tabs.currentTab = routTab;
        }
      });
      return { tabs, changeTab }
    }
  };
  iservice.components.adminVueappCustomizePortalTreeviewContent = {
    name: 'admin-vueapp-customize-portal-treeview-content',
    template: '#admin-vueapp-customize-portal-treeview-content',
    setup(props) {
      var CustomerPortalConfig = Vue.reactive({ treeview: {}, working: true });
      var feature = Vue.reactive({});
      CustomerPortalConfig.config = [];
      CustomerPortalConfig.treeview = {
        contentSettings: {},
        pageComponent: {},
        styleSelection: {},
        customCssCode: {}
      }
      CustomerPortalConfig.treeview.styleSelection.theme = 'theme1';
      var treeviewTabs = Vue.reactive({ tab: 'contentsettings' });
      treeviewTabs.TabClass = function (tab) { return { 'active': tab == treeviewTabs.tab } }
      treeviewTabs.TabClick = function (tab) {
        treeviewTabs.tab = tab;
      }

      Vue.watchEffect(function () {
        if (!CustomerPortalConfig.treeview.styleSelection.theme) return;
        if (CustomerPortalConfig.treeview.styleSelection.theme == 'theme1') feature.themeImage = '/images/theme-1.png';
        if (CustomerPortalConfig.treeview.styleSelection.theme == 'theme2') feature.themeImage = '/images/theme-2.png';
        if (CustomerPortalConfig.treeview.styleSelection.theme == 'theme3') feature.themeImage = '/images/theme-3.png';
        if (CustomerPortalConfig.treeview.styleSelection.theme == 'theme4') feature.themeImage = '/images/theme-4.png';
      });
      CustomerPortalConfig.Save = function () {
        if (CustomerPortalConfig.working) return;
        CustomerPortalConfig.config.push(CustomerPortalConfig.treeview);
        iservice.API('webapp-api-admin?api=configurationsave', null, { application: 'agentapp', items: [{ name: 'CustomerPortalTreeview', websiteID: '', data: JSON.stringify(CustomerPortalConfig.config) }] }).then(data => {
          iservice.SuccessMessage('Configuration saved.');
          CustomerPortalConfig.config = [];
        }).catch(errors => {
          CustomerPortalConfig.errors = true;
        }).finally(() => {
          CustomerPortalConfig.working = false;
        });
      }
      iservice.API('webapp-api-admin?api=configuration', null, { application: 'agentapp', name: 'CustomerPortalTreeview' }).then(data => {
        if (data.items.length > 0) {
          data.items[0].data.forEach(name => {
            CustomerPortalConfig.treeview = data.items[0].data[0];
            if (!CustomerPortalConfig.treeview.styleSelection.theme) CustomerPortalConfig.treeview.styleSelection.theme = 'theme1';
          })
        }
      }).catch(function (errors) {
        CustomerPortalConfig.errors = true;
      }).finally(function () {
        CustomerPortalConfig.working = false;
      })
      return { CustomerPortalConfig, treeviewTabs, feature }
    }
  }
  iservice.components.adminVueappCustomizePortalTabsContent = {
    name: 'admin-vueapp-customize-portal-tabs-content',
    template: '#admin-vueapp-customize-portal-tabs-content',
    setup(props) {
      var topics = iservice.TopicData();
      var segments = iservice.SegmentData();
      if (!topics.loaded || !segments.loaded) {
        topics.Load(); segments.Load();
      }
      var CustomerPortalConfig = Vue.reactive({ tabs: {}, working: true });
      var feature = Vue.reactive({});
      CustomerPortalConfig.config = [];
      CustomerPortalConfig.tabs = {
        homePage: {},
        pageComponent: {},
        styleSelection: {
          menuBackgroundColor: '#000000',
          menuColor: '#000000',
          buttonColor: '#000000',
          buttonFontColor: '#000000',

        },
        customCssCode: {}
      }
      CustomerPortalConfig.tabs.pageComponent.faqTopics = [];
      var tabsviewTabs = Vue.reactive({ tab: 'homepage' });
      tabsviewTabs.TabClass = function (tab) { return { 'active': tab == tabsviewTabs.tab } }
      tabsviewTabs.TabClick = function (tab) {
        tabsviewTabs.tab = tab;
      }

      var topicGroups = Vue.computed(() => {
        var groups = [];
        if (!segments.loaded || !topics.loaded) {
          segments.Load(); topics.Load();
        }
        segments.list.forEach(function (segment) {
          var group = Vue.reactive({ label: segment.name, options: [] });
          topics.inSegment(segment.id).forEach(topic => {
            group.options.push({ name: topic.name, id: topic.id, level: Math.min(2, topic.depth) });
          });
          group.options.sort((l, r) => { return topics.TreeSortCompare(l.value, r.value); });
          if (group.options.length < 1) return;
          groups.push(group);
        });

        return groups;
      });
      CustomerPortalConfig.Save = function () {
        if (CustomerPortalConfig.working) return;
        CustomerPortalConfig.config.push(CustomerPortalConfig.tabs);
        iservice.API('webapp-api-admin?api=configurationsave', null, { application: 'agentapp', items: [{ name: 'CustomerPortalTabsview', websiteID: '', data: JSON.stringify(CustomerPortalConfig.config) }] }).then(data => {
          iservice.SuccessMessage('Configuration saved.');
          CustomerPortalConfig.config = [];
        }).catch(errors => {
          CustomerPortalConfig.errors = true;
        }).finally(() => {
          CustomerPortalConfig.working = false;
        });
      }
      iservice.API('webapp-api-admin?api=configuration', null, { application: 'agentapp', name: 'CustomerPortalTabsview' }).then(data => {
        if (data.items.length > 0) {
          data.items[0].data.forEach(name => {
            CustomerPortalConfig.tabs = data.items[0].data[0];
            if (!CustomerPortalConfig.tabs.styleSelection.menuBackgroundColor && !CustomerPortalConfig.tabs.styleSelection.menuColor && !CustomerPortalConfig.tabs.styleSelection.buttonColor && !CustomerPortalConfig.tabs.styleSelection.buttonFontColor) {
              CustomerPortalConfig.tabs.styleSelection = {
                menuBackgroundColor: '#000000',
                menuColor: '#000000',
                buttonColor: '#000000',
                buttonFontColor: '#000000',
              }
            }
          })
        }
      }).catch(function (errors) {
        CustomerPortalConfig.errors = true;
      }).finally(function () {
        CustomerPortalConfig.working = false;
      })
      var colpicker1, colpicker2, colpicker3, colpicker4 = false;
      return { CustomerPortalConfig, feature, tabsviewTabs, topicGroups, colpicker1, colpicker2, colpicker3, colpicker4 }
    }
  }
  iservice.components.adminVueappCustomizeActions = {
    name: 'admin-vueapp-customize-actions',
    template: '#admin-vueapp-customize-actions',
    buttonsStandard: ['answerButtonStandardSend', 'answerButtonStandardSubmit', 'answerButtonStandardReject', 'answerButtonStandardResolve', 'answerButtonStandardForward', 'answerButtonStandardSave', 'answerButtonStandardTopic', 'answerButtonStandardSpam'],
    buttonsSecurePortalNoEmail: ['answerButtonPortalSend', 'answerButtonPortalForward', 'answerButtonStandardSave', 'answerButtonStandardTopic'],
    buttonsSecurePortalNoNotification: ['answerButtonSecurePortalSend', 'answerButtonSecurePortalResolve', 'answerButtonPortalForward', 'answerButtonStandardSaveDraft', 'answerButtonStandardTopic', 'answerButtonStandardPrivateNote'],
    buttonsSecurePortalWithNotification: ['answerButtonSecureNotificationSend', 'answerButtonSecureNotificationResolve', 'answerButtonPortalForward', 'answerButtonStandardSaveDraft', 'answerButtonStandardTopic', 'answerButtonStandardPrivateNote'],

    setup() {
      var stubActions = Vue.reactive({});
      stubActions.SubmitAnswer = stubActions.CheckAnswerProperties = stubActions.CheckQuestionProperties = stubActions.CheckCaseProperties = function () { return true; };
      var stubAnswer = {};
      var buttonsMap = Vue.reactive({});
      var stubInteraction = Vue.ref(null);
      for (var name in iservice.components) {
        var component = iservice.components[name];
        if (!component || !component.answerAction) continue;
        var feature = component.answerAction(stubInteraction, stubAnswer, stubActions);
        buttonsMap[name] = { component, feature };
      }

      var featureConfig = Vue.reactive({ working: true, config: [], type: '' });
      var Buttons = Vue.computed(function () {
        var list = [];
        let names = iservice.components.adminVueappCustomizeActions[featureConfig.type];
        if (names && names.length > 0) {
          for (var name of names) {
            var item = buttonsMap[name];
            if (item) list.push(item);
          }
        }
        return list;
      });
      featureConfig.Save = function () {
        let buttons = iservice.components.adminVueappCustomizeActions[featureConfig.type];
        if (featureConfig.working) return;
        featureConfig.working = true;
        featureConfig.config.length = 0;
        buttons.forEach(button => { featureConfig.config.push(button); });
        iservice.API('webapp-api-admin?api=configurationsave', null, { application: 'agentapp', items: [{ name: 'answerActions', websiteID: '', data: JSON.stringify(featureConfig.config) }] }).then(data => {
          iservice.SuccessMessage('Configuration saved.');
        }).catch(errors => {
          featureConfig.errors = true;
        }).finally(() => {
          featureConfig.working = false;
        });
      }
      iservice.components.adminVueappCustomizeActions.buttonsStandard.forEach(button => { featureConfig.config.push(button); });
      iservice.API('webapp-api-admin?api=configuration', null, { application: 'agentapp', name: 'answerActions' }).then(data => {
        var standard = 0;
        var portal = 0;
        var secureportalnonotification = 0;
        var secureportalwithnotification = 0;
        if (data.items.length > 0) {
          featureConfig.config.length = 0;
          data.items[0].data.forEach(name => {
            if (iservice.components.adminVueappCustomizeActions.buttonsStandard.find(x => x == name)) {
              standard++;
            }
            if (iservice.components.adminVueappCustomizeActions.buttonsSecurePortalNoEmail.find(x => x == name)) {
              portal++; 
            }
            if (iservice.components.adminVueappCustomizeActions.buttonsSecurePortalNoNotification.find(x => x == name)) {
              secureportalnonotification++; 
            }
            if (iservice.components.adminVueappCustomizeActions.buttonsSecurePortalWithNotification.find(x => x == name)) {
              secureportalwithnotification++; 
            }
            featureConfig.config.push(name);
          });
          if (standard == iservice.components.adminVueappCustomizeActions.buttonsStandard.length) {
            featureConfig.type = "buttonsStandard";
          }
          if (portal == iservice.components.adminVueappCustomizeActions.buttonsSecurePortalNoEmail.length) {
            featureConfig.type = "buttonsSecurePortalNoEmail";
          }
          if (secureportalnonotification == iservice.components.adminVueappCustomizeActions.buttonsSecurePortalNoNotification.length) {
            featureConfig.type = "buttonsSecurePortalNoNotification";
          }
          if (secureportalwithnotification == iservice.components.adminVueappCustomizeActions.buttonsSecurePortalWithNotification.length) {
            featureConfig.type = "buttonsSecurePortalWithNotification";
          }
        }
      }).catch(errors => {
        featureConfig.errors = errors;
      }).finally(() => {
        featureConfig.working = false;
      });

      return { featureConfig, Buttons };
    }
  };
  iservice.components.adminVueappCustomizeDashboard = {
    name: 'admin-vueapp-customize-dashboard',
    template: '#admin-vueapp-customize-dashboard',
    setup() {

      var featureConfig = Vue.reactive({ working: true, config: [] });
      featureConfig.RowAdd = function () {
        featureConfig.config.push({ cells: [{ class: 'col-md-12', component: '' }] });
      }
      featureConfig.RowUp = function (rowi) {
        var row = featureConfig.config[rowi];
        featureConfig.config.splice(rowi, 1);
        featureConfig.config.splice(rowi - 1, 0, row);
      }
      featureConfig.RowDown = function (rowi) {
        var row = featureConfig.config[rowi];
        featureConfig.config.splice(rowi, 1);
        featureConfig.config.splice(rowi + 1, 0, row);
      }
      featureConfig.RowRemove = function (rowi) {
        featureConfig.config.splice(rowi, 1);
      }
      featureConfig.CellAdd = function (rowi) {
        var row = featureConfig.config[rowi];
        row.cells.push({ class: 'col-md-6', component: '' });
      }
      featureConfig.CellLeft = function (row, celli) {
        var cell = row.cells[celli];
        row.cells.splice(celli, 1);
        row.cells.splice(celli - 1, 0, cell);
      }
      featureConfig.CellRight = function (row, celli) {
        var cell = row.cells[celli];
        row.cells.splice(celli, 1);
        row.cells.splice(celli + 1, 0, cell);
      }
      featureConfig.CellRemove = function (row, celli) {
        row.cells.splice(celli, 1);
      }
      featureConfig.Default = function () {
        featureConfig.config.length = 0;
        iservice.components.dashboard.defaultConfig.forEach(row => { featureConfig.config.push(Vue.reactive(row)); });
      }
      featureConfig.Save = function () {
        if (featureConfig.working) return;
        featureConfig.working = true;
        iservice.API('webapp-api-admin?api=configurationsave', null, { application: 'agentapp', items: [{ name: 'dashboard', websiteID: '', data: JSON.stringify(featureConfig.config) }] }).then(data => {
          iservice.SuccessMessage('Configuration saved.');
        }).catch(errors => {
          featureConfig.errors = true;
        }).finally(() => {
          featureConfig.working = false;
        });
      }
      iservice.API('webapp-api-admin?api=configuration', null, { application: 'agentapp', name: 'dashboard' }).then(data => {
        featureConfig.config.length = 0;
        var rows = data?.items?.[0]?.data;
        if (!rows) rows = iservice.components.dashboard.defaultConfig;
        rows.forEach(row => { featureConfig.config.push(Vue.reactive(row)); });
      }).catch(errors => {
        featureConfig.errors = errors;
      }).finally(() => {
        featureConfig.working = false;
      });

      return { featureConfig };
    }
  };
  const color1 = ["#81B5D4", "#F1948A", "#F7DC6F", "#5AD6F5", "#00C0EF", "#00A7D0", "#5A6E83", "#001F3F", "#001A35", "#7FDEDE", "#39CCCC", "#30BBBB", "#5AC594", "#00A65A", "#008D4C", "#9896C7", "#605CA8", "#555299", "#F7BF66", "#F39C12", "DB8B0B", "#FFB06B", "#FF851B", "#FF7701", "#E98B7F", "#DD4B39", "#D33724", "#E66B98", "#D81B60", "#CA195A", "#E2E4EA", "#D2D6DE", "#B5BBC8", "#656565", "#111111", "#000000", "#e0e0e0",];

  iservice.components.adminVueappCustomizeColors = {
    name: 'admin-vueapp-customize-colors',
    template: '#admin-vueapp-customize-colors',
    data: function () {
      return {
        segment3: false,
        segment4: false,
        segment5: false,
        segment12: false,
        showColorCodesDetails: false,
        value: true,
        active_el: '',
        colEmail: false,
        createNewColorCodes: false,
        showAlertColorCodes: false,
        color: '#e0e0e0',
        colpicker1: false,
        colorindex: 0
      }

    },
    methods: {
      toggleSegmentCollapsedStateDahboard(i) {
        this['segment' + i] = !this['segment' + i]
      },
      showMessageDashboardDetails(type, row) {
        if (previousrowVal == row) {
          this.showColorCodesDetails = !this.showColorCodesDetails;
          if (!this.showColorCodesDetails) {
            this.active_el = '';
          } else {
            this.active_el = row;
          }

        } else {
          this.showColorCodesDetails = this.showColorCodesDetails;
          this.active_el = row;
        }
        previousrowVal = row;

        this.showColorCodesDetails = true;
        this.createNewColorCodes = false;

        //this.emitter.emit("show-message-details", {displayType:type, showColorCodesDetails : this.showColorCodesDetails});

      },
      updateColor(event, row, pcolor, rowindex) {
        row.color = pcolor;
        var x = document.getElementById('colorpicker' + rowindex);
        x.style.display = "none";
        this.colpicker1 = false;
        event.preventDefault;
      },
      selectFromColorIndex(e, row) {
        if (this.colorindex == color1.length) {
          this.colorindex = 0;
        }
        row.color = color1[this.colorindex];
        this.colpicker1 = false;
        this.colorindex++;
      }
    },
    setup() {
      var featureColorCodes= Vue.reactive({});
      
      featureColorCodes.colorRows = [{ minutes: '5', color: '#000000'}];
      featureColorCodes.AddRow = function () {
        featureColorCodes.colorRows.push({ minutes: '5', color: '#000000' });
      }
      featureColorCodes.RemoveRow = function (index) {
        if (featureColorCodes.colorRows.length == 1) return;
        featureColorCodes.colorRows.splice(index, 1);
      }
      function sortByKey(array, key) {
        return array.sort((a, b) => {
          let x = a[key];
          let y = b[key];

          return ((x < y) ? -1 : ((x > y) ? 1 : 0));
        });
      }
      var featureConfig = Vue.reactive({ working: true, errors: [] });
      featureConfig.Save = function () {
        featureConfig.errors = [];
        if (featureConfig.working) return;
        featureConfig.working = true;
        sortByKey(featureColorCodes.colorRows, 'minutes');
        var valueArr = featureColorCodes.colorRows.map(function (item) {
          return item.minutes.toString()
        });
        var isDuplicate = valueArr.some(function (item, idx) {
          return valueArr.indexOf(item) != idx
        });
        if (isDuplicate) {
          featureConfig.errors = ['Duplicate question age is not allowed.'];
          featureConfig.working = false;
        }
        if (featureConfig.errors.length) return;
        iservice.API('webapp-api-admin?api=configurationsave', null, { application: 'agentapp', items: [{ name: 'colorCodes', websiteID: '', data: JSON.stringify(featureColorCodes.colorRows) }] }).then(data => {
          iservice.SuccessMessage('Configuration saved.');
        }).catch(errors => {
          featureConfig.errors = true;
        }).finally(() => {
          featureConfig.working = false;
        });
      }
      var checkDuplicate = function (row, index) {
        row.duplicate = false;
        featureColorCodes.colorRows.forEach(function (item, key) {
          if (key !== index) {
            if (item.minutes.toString() == row.minutes.toString()) {
              row.duplicate = true;
            }
          }
        })
      }
      iservice.API('webapp-api-admin?api=configuration', null, { application: 'agentapp', name: 'colorCodes' }).then(data => {
        var rows = data?.items?.[0]?.data;
        if (rows.length > 0) featureColorCodes.colorRows.length = 0;
        rows.forEach(row => { featureColorCodes.colorRows.push(Vue.reactive(row)); });
      }).catch(errors => {
        featureConfig.errors = errors;
      }).finally(() => {
        featureConfig.working = false;
      });

      const palatecolors = ['#edf5e0', '#e0e0e0', '#C5DEF5', '#BFD4F2', '#e6ccfc', '#D4C5F9', '#b7e4ff', '#a2dbdb', '#BFDADC'];
      const palatecolors2 = ['#e1f99d', '#daf2b0', '#FEF2C0', '#F7DC6F', '#FBCA04', '#f7e0dc', '#F9D0C4', '#E99695', '#F1948A'];
      var ShowPicker = function (index) {
        var x = document.getElementById('colorpicker' + index);
        if (window.getComputedStyle(x).display === "none") {
          x.style.display = "block";
        } else {
          x.style.display = "none";
        }
      }

      return { featureColorCodes, featureConfig, palatecolors, palatecolors2, ShowPicker, checkDuplicate}
    }
  };

})(iservice);